      PROGRAM HLPHTML
C---
C Read .hlp file output a corresponding .html hierarchy
C Currently both input and output files need to be in current directory.
C tip, add to *.shtml file to do includes
C <!--#include file="clist.html"-->
C---
C Logical Unit assignments:
C  1     Input .hlp file
C  3     Use to read foot.txt
C 10     Top level html file
C 11     nex level html file
C---
C 2005-May-02 - Based on hlptohtml by A.Daviel [AFT]
C---
      INTEGER   ITAB
      PARAMETER (ITAB=9)
      INTEGER   LENACT
C
      CHARACTER cfile*256, chtml*256, cout*256
      CHARACTER cline*132, ctmp*132
      CHARACTER cword*80
      CHARACTER cbgcol*32, cpart*32, ctitle*32, ctok*32
      INTEGER   icol, ier, ifig, ifirst, ios, ipartn, iotab, itag
      INTEGER   k, kp, j, lbgcol, lbase, level, levprev, lfile, lhtml
      INTEGER   lline, lpart, ltitle, ltok, luncur, lword, nl
C---
   11 FORMAT(A)
C---
  100 CONTINUE
      CALL GTBUF('Enter Help file prefix:',ier)
      CALL GTCHAR(cfile, lfile)
      IF ( lfile.LE.0 ) GOTO 950
      lbase = LENACT(cfile)
      CALL XTEND(cfile, 'hlp')
      lfile = LENACT(cfile)
      OPEN(UNIT=1,FILE=cfile,STATUS='old',IOSTAT=IOS)
      IF ( IOS.NE.0 ) THEN
         WRITE(*,*) 'Unable to open file: ',cfile(:lfile)
         GOTO 100
      END IF
C
      ifig = 0
      CALL XTEND(cfile,'.fig')
      OPEN(UNIT=3,FILE=cfile,STATUS='old',IOSTAT=IOS)
      ltitle=0
      cbgcol='#ECFCFF'
      lbgcol=7
      IF ( IOS.EQ.0 ) THEN
         ifig = 1
  110    CONTINUE
         READ(3,11,END=120) cline
         lline = LENACT(cline)
         kp = 0
         CALL alf(cline, lline, kp, ctok, ltok)
         CALL UPC(ctok)
         IF ( ctok.EQ.'BGCOLOR' ) THEN
            CALL alf(cline, lline, kp, cbgcol, lbgcol)
         ELSE IF ( ctok(1:4).EQ.'FOOT' ) THEN
            GOTO 120
         ELSE IF ( ctok.EQ.'TITLE' ) THEN
            CALL alf(cline, lline, kp, ctitle, ltitle)
         ELSE
            WRITE(*,*) 'Unknown command--',ctok(:ltok)
         END IF
         GOTO 110
  120    CONTINUE
      END IF
C
C Create base file
      chtml = cfile
      CALL XTEND(chtml, '.html')
      lhtml = LENACT(chtml)
      CALL OPHTML(10, cfile, lbase, chtml, lhtml)
      ifirst = 1
      luncur = 0
      level = 0
      ipartn = 0
      iotab = 0
C---
C Main loop to read next line of HLP file.
  200 CONTINUE
      READ(1,11,END=900) cline
      lline = LENACT(cline)
      nl = nl + 1
C
C Blank lines start new paragraph.
      IF ( lline.EQ.0 .OR. cline.EQ.' ' ) THEN
C Paragraph
         IF ( luncur.GT.0 ) THEN
            WRITE(luncur,11) '<P>'
         END IF
         GOTO 200
      END IF
C
C New topic line
      IF ( (cline(1:1).LT.'1' .OR.  cline(1:1).GT.'9') .OR.
     &     (cline(2:2).NE.' ' .AND. cline(2:2).NE.CHAR(ITAB)) ) GOTO 300
      READ(cline,221,ERR=300) level
 221  FORMAT(bn,i1)
C
      cword = cline(2:lline)
      lword = lline - 1
      CALL SQUASH(cword, lword)
      IF ( level.GT.levprev+1 ) PRINT *,
     &     'ERROR - skipped level in HELP file',level,levprev
      IF( level.EQ.1 ) THEN
C Write keyword in parent file as href and list item
         IF ( luncur.GT.10 ) THEN
            WRITE(luncur,11) '<HR><P><A HREF="'//cfile(:lbase)//
     &       '.html"> Return to '//cfile(:lbase)//' main page.</A></P>'
            WRITE(luncur,11) '</BODY>'
            WRITE(luncur,11) '</HTML>'
            CLOSE(UNIT=luncur)
            luncur = 0
         END IF
         ipartn = ipartn + 1
         WRITE(cpart,231) cfile(:lbase), ipartn
 231     FORMAT (a,'_',i3)
         CALL SQUASH(cpart, lpart)
         IF ( ifirst.NE.0 ) THEN
C The first topic always goes to top file.
            ifirst = 0
            luncur = 10
            IF ( ltitle.GT.0 ) THEN
               WRITE(luncur,261) level, ctitle(:ltitle), level
  261          FORMAT('<H',I1,' ALIGN=CENTER>',A,'</H',I1,'>')
            ELSE
               WRITE(luncur,261) level, cfile(:lbase), level
            END IF
         ELSE
C Open and initialize a subtopic file
            chtml = cpart
            CALL XTEND(chtml, '.html')
            lhtml = LENACT(chtml)
            luncur = 11
            CALL OPHTML(luncur, cword, lword, chtml, lhtml)
            WRITE(luncur,261) level, cword(1:lword), level
            IF ( iotab.EQ.0 ) THEN
               iotab = 1
               WRITE(10,11) '<P><TABLE bgcolor="'//cbgcol(:lbgcol)//
     &   '" align=CENTER border="0" cellpadding="0" cellspacing="0">'
               WRITE(10,11) '<TR>'
               icol = 0
            END IF
            icol = icol + 1
            IF ( icol.GT.10 ) THEN
               icol = 1
               WRITE(10,11) '</TR><TR>'
            END IF
            IF ( lword.LE.10 ) THEN
               WRITE(10,11) '<TD WIDTH="80"><A HREF="' //
     &   chtml(1:lhtml) // '">' // cword(1:lword) // '</A></TD>'
            ELSE
C Long winded topics span two columns
               icol = icol+2
               WRITE(10,11) '<TD WIDTH="80" COLSPAN="2"><A HREF="' //
     &   chtml(1:lhtml) // '">' // cword(1:lword) // '</A></TD>'
            END IF
         END IF
      ELSE
         WRITE(luncur,271) level, cword(1:lword), level
  271    FORMAT('<H',I1,'>',A,'</H',I1,'>')
      END IF
      levprev = level
      GOTO 200
C
C Continue to read/write a topic.
 300  CONTINUE
      IF ( level.LT.0 ) GOTO 200
C Support for pre-conditioning of HLP file formatting
C Quote HTML reserved characters
      j = 0
      itag = 0
      DO k = 1, lline
         IF ( cline(k:k).EQ.'&' ) THEN
            cout(j+1:j+5) = '&amp;'
            j = j + 5
         ELSE IF ( cline(k:k).EQ.'<' ) THEN
            ctmp = cline(k:)
            CALL UPC(ctmp)
            IF ( ctmp(1:4).EQ.'<BR>' .OR.
     &   ctmp(1:5).EQ.'<PRE>' .OR. ctmp(1:6).EQ.'</PRE>' ) THEN
               itag = 1
               j = j + 1
               cout(j:j) = cline(k:k)
            ELSE
               cout(j+1:j+5) = '&lt;'
               j = j + 4
            END IF
         ELSE IF ( cline(k:k).EQ.'>' ) THEN
            IF ( itag.GT.0 ) THEN
               itag = 0
               j = j + 1
               cout(j:j) = cline(k:k)
            ELSE
               cout(j+1:j+5) = '&gt;'
               j = j + 4
            END IF
         ELSE
            j = j + 1
            cout(j:j) = cline(k:k)
         END IF
      END DO
      WRITE(luncur,11) cout(1:j)
      GOTO 200
C---
C Close files in reverse order.
 900  CONTINUE
      WRITE(10,11) '</TR></TABLE>'
      WRITE(luncur,11) '<HR><P><A HREF="'//cfile(:lbase)//
     &       '.html"> Return to '//cfile(:lbase)//' main page.</A></P>'
      IF ( ifig.GT.0 ) THEN
  910    CONTINUE
         READ(3,11,END=920) cline
         WRITE(10,11) cline(:LENACT(cline))
         GOTO 910
  920    CONTINUE
         CLOSE(3)
      END IF
      DO k=1,0,-1
         WRITE(10+k,11) '</BODY>'
         WRITE(10+k,11) '</HTML>'
C Close all intermediate level files
         CLOSE(UNIT=10+k)
      END DO
      CLOSE(1)
C---
  950 CONTINUE
      CALL EDICOM('OFF',3)
      END
C*********
      SUBROUTINE SQUASH(Cword, Lword)
      CHARACTER Cword*(*)
      INTEGER   Lword
C---
C Remove whitespace from char. string
C---
      INTEGER ITAB
      PARAMETER (ITAB=9)
C
      INTEGER   nr, k, j
C---
      j = 0
      nr = LEN(Cword)
      DO k=1, nr
         IF ( Cword(k:k).NE.' ' .AND. Cword(k:k).NE.CHAR(ITAB) ) THEN
            j = j + 1
            Cword(j:j) = Cword(k:k)
         END IF
      END DO
      Cword(j+1:) = ' '
      Lword = j
      RETURN
      END
C*********
      SUBROUTINE OPHTML(Lun, Ctopic, Ltopic, Cfile, Lfile)
      INTEGER   Lun, Lfile, Ltopic
      CHARACTER Cfile*(*), Ctopic*(*)
C---
C Open HTML output file and write standard header.
C---
C Lun     I    Logical Unit to open
C Cfile   I/O  Name of file actually opened
C Lfile   I/O  Actual size of Cfile
C---
      INTEGER   LENACT
C
      CHARACTER ctop*32
      CHARACTER ctmp*1
      INTEGER   i, ibad, ltop
      SAVE ctop, ltop
      DATA ltop/0/
C---
   11 FORMAT(A)
C
      ibad = 0
      DO i=1, Ltopic
         ctmp = Ctopic(:Ltopic)
         CALL LOCASE(ctmp)
         IF ( ctmp.LT.'a' .OR. ctmp.GT.'z' ) ibad = 1
      END DO
      IF ( ibad.EQ.0 ) THEN
         cfile = Ctopic(:Ltopic)
         CALL LOCASE(cfile)
         CALL XTEND(cfile,'html')
         lfile = LENACT(cfile)
      END IF
      WRITE(*,*) 'Creating file ', Cfile(1:Lfile)
      OPEN (UNIT=lun,FILE=Cfile(:Lfile),STATUS='new')
C     &   CARRIAGECONTROL='list')
C Write header for new file
      WRITE(lun,11) '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 '//
     &   'Transitional//EN">'
      WRITE(lun,11) '<HTML>'
      WRITE(lun,11) '<HEAD>'
      IF ( ltop.EQ.0 ) THEN
         WRITE(lun,171) '<META name="keywords" content="',
     &      Ctopic(1:Ltopic),'">'
  171    FORMAT(A,A,A)
         ctop = ctopic(:ltopic)
         ltop = ltopic
      ELSE
         WRITE(lun,181) '<META name="keywords" content="',
     &      ctop(:ltop),',',Ctopic(1:Ltopic),'">'
  181    FORMAT(5A)
      END IF
      WRITE(lun,171) '<TITLE>',Ctopic(1:Ltopic),'</TITLE>'
      WRITE(lun,11) '</HEAD>'
      WRITE(lun,11) '<BODY>'

      RETURN
      END
