C Program afaddcol--Allyn's faddcol
C faddcol will not overwrite existing columns.
C This program only overwrites existing columns.
C---
C 2005-07-20 - From nears [AFT]
C---
      CHARACTER ccat*256, cobj*256, ctmp*64
      CHARACTER ccol*16, ckey*16
      DOUBLE PRECISION dnul, drobj
      INTEGER   naxes(99)
      INTEGER   ibits, iblk, icinp, icout
      INTEGER   ier, iext, igcnt, ipcnt, irow, istat
      INTEGER   lcat, lkey, lobj, luni, luno
      INTEGER   naxis, ninp, nfield, nout
      LOGICAL   qbad, qsimp, qxtend
C---
   11 FORMAT(A)
C---
      luno = 1
      luni = 3
  100 CONTINUE
      CALL GTBUF('Update, from, colnames:', ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(cobj, lobj)
      IF ( lobj.LE.0 ) GOTO 900
      CALL GTCHAR(ccat, lcat)
      IF ( lcat.LE.0 ) GOTO 900
C
      istat = 0
      CALL FTOPEN(luno, cobj(:lobj), 1, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',cobj(:lobj),', istat=',istat
         GOTO 100
      END IF
      CALL FTOPEN(luni, ccat(:lcat), 0, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',ccat(:lcat),', istat=',istat
         GOTO 100
      END IF
C---
C Read keywords from primary header
C
      istat = 0
      CALL FTGHPR(luno,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( naxis.NE.0 .OR. .NOT.qxtend ) THEN
         WRITE(*,*) 'Not a binary table FITS file.', naxis,qxtend
         GOTO 100
      END IF
C
      CALL FTGHPR(luni,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( naxis.NE.0 .OR. .NOT.qxtend ) THEN
         WRITE(*,*) 'Not a binary table FITS file.', naxis,qxtend
         GOTO 100
      END IF
C
C Assume data is in first extension.  Note, reading NAXIS2 works for
C both FITS binary and ASCII tables.
C
      istat = 0
      CALL FTMAHD(luno, 2, iext, istat)
      CALL FTGKYJ(luno,'NAXIS2',nout,ctmp,istat)
      CALL FTGKYJ(luno,'TFIELDS',nfield,ctmp,istat)
      CALL FTMAHD(luni, 2, iext, istat)
      CALL FTGKYJ(luni,'NAXIS2',ninp,ctmp,istat)
      IF ( nout.NE.ninp) THEN
         WRITE(*,*) 'Sizes don''t match:', nout, ninp
         GOTO 900
      END IF
C
C We are now at the EVENTS extension.  Scan TTYPE keywords until
C we find the columns we need.
  200 CONTINUE
      CALL GTCHAR(ckey, lkey)
      IF ( lkey.LE.0 ) GOTO 900
      istat = 0
      CALL FTGCNN(luni, .FALSE., ckey,  ccol, icinp, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Input file does not contain ',ckey(:lkey)
         GOTO 900
      END IF
      CALL FTGCNN(luno, .FALSE., ckey,  ccol, icout, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Output file does not contain ',ckey(:lkey)
         GOTO 900
      END IF
      DO irow=1,ninp
         CALL FTGCVD(luni,icinp,irow,1,1,dnul,drobj,qbad,istat)
         CALL FTPCLD(luno,icout,irow,1,1, drobj, istat)
      END DO
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Status=',istat
      END IF
      GOTO 200
C
C---
C Get some results
C---
  900 CONTINUE
      istat = 0
      CALL FTCLOS(luno, istat)
      CALL FTCLOS(luni, istat)
      CALL EDICOM('OFF',3)
      END
