C Program aflookup,  Allyn's (ftools) lookup.
C---
C 2001-08-21 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXNAX
      PARAMETER (MXNAX=99)
      INTEGER   LENACT
C
      CHARACTER cnam*256, cbuf*256
      CHARACTER ctmp*64, cnul*64, cvalue*64, cwant*64
      CHARACTER ccol*16, cicol*16, ckey*16, cfind*16
      REAL      fnul, yval
      INTEGER   naxes(MXNAX)
      INTEGER   i, ibits, iblk, icol
      INTEGER   ier, iext, lfind, igcnt, iicol, ipcnt, irow, istat
      INTEGER   lbuf, lkey, lnam, lun, lvalue, lwant
      INTEGER   naxis, nrows
      LOGICAL   qbad, qsimp, qxtend
C---
      lun = 3
  100 CONTINUE
      CALL GTBUF('Input FITS file, index=string, reply:', ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(cnam, lnam)
      IF ( lnam.LE.0 ) GOTO 900
C
      istat = 0
      CALL FTOPEN(Lun, cnam(:lnam), 0, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',cnam(:lnam),', istat=',istat
         GOTO 100
      END IF
C
C Read keywords from primary header
C
      istat = 0
      CALL FTGHPR(lun,MXNAX,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( naxis.NE.0 .OR. .NOT.qxtend ) THEN
         WRITE(*,*) 'Not a binary table FITS file.', naxis,qxtend
         GOTO 100
      END IF
C---
C Go to 2nd HDU.
      istat = 0
      CALL FTMAHD(lun, 2, iext, istat)
      CALL FTGKYJ(lun, 'NAXIS2', nrows, ctmp, istat)
C
      CALL GTCHAR(cbuf, lbuf)
      lkey = INDEX(cbuf,'=')
      IF ( lkey.LE.0 ) THEN
         STOP 'aflookup--No index key.'
      END IF
      lkey = lkey-1
      ckey = cbuf(:lkey)
      CALL UPC(ckey)
      istat = 0
C      ckey ='Name'
      CALL FTGCNN(lun, .FALSE., ckey(:lkey), cicol, iicol, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'aflookup--Unable to find index=',ckey(:lkey), istat
         GOTO 950
      END IF
C
      cfind = cbuf(lkey+2:)
      lfind = LENACT(cfind)
      CALL UPC(cfind(:lfind))
      cnul = ' '
      DO i=1,nrows
         CALL FTGCVS(lun,iicol,i,1,1,cnul,cvalue,qbad,istat)
         lvalue = LENACT(cvalue)
         CALL UPC(cvalue(:lvalue))
         IF ( cfind(:lfind).EQ.cvalue(:lvalue) ) THEN
            irow = i
            GOTO 300
         END IF
      END DO
      WRITE(*,*) 'aflookup--Unable to find key value=',cfind(:lfind)
      STOP
C
  300 CONTINUE
      cbuf= ' '
      lbuf = 0
      istat = 0
      fnul = NO
      DO i=1,999
         CALL GTCHAR(cwant, lwant)
         IF ( lwant.LE.0 ) GOTO 900
         CALL FTGCNN(lun, .FALSE., cwant(:lwant), ccol, icol, istat)
         IF ( istat.NE.0 ) THEN
            WRITE(*,*) 'aflookup--Unable to find column=',cwant(:lwant)
            STOP
         END IF
         CALL FTKEYN('TFORM',icol,ckey,istat)
         CALL FTGKYS(lun,ckey,cvalue,ctmp,istat)
         CALL UPC(cvalue)
         IF ( INDEX(cvalue,'A').NE.0 ) THEN
            CALL FTGCVS(lun,icol,irow,1,1,cnul,cvalue,qbad,istat)
            lvalue = LENACT(cvalue)
            cbuf(lbuf+1:lbuf+1+lvalue) = ' '//cvalue(:lvalue)
            lbuf = lbuf + lvalue + 1
         ELSE
            CALL FTGCVE(lun,icol,irow,1,1,fnul,yval,qbad,istat)
            CALL CRAMFF(yval,10,3,cbuf,lbuf)
         END IF
      END DO
C
C---
  900 CONTINUE
      WRITE(*,*) cbuf(:lbuf)
  950 CONTINUE
      istat = 0
      CALL FTCLOS(lun, istat)
      CALL EDICOM('OFF',3)
      END
