C Program afplot, Allyn's fplot.
C---
C 2000-04-04 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXCOL, MXROW, MXNAX
      PARAMETER (MXCOL=16, MXROW=2500000, MXNAX=200)
      INTEGER   MXCMD
      PARAMETER (MXCMD=32)
      DOUBLE PRECISION sla_DTT
      INTEGER   LENACT
C
      CHARACTER cmd(MXCMD)*64
      CHARACTER cnam*256, ctmp*64, cvalue*64, cwant*64
      CHARACTER ckey*16
      DOUBLE PRECISION days, dmjd0, dnul, doff, dsec, dval
      REAL      ydat(MXROW, MXCOL)
      REAL      fnul, yval
      INTEGER   naxes(MXNAX), iery(MXCOL), icnum(MXCOL), itdat(MXCOL)
      INTEGER   i, ibits, iblk, icol
      INTEGER   ier, iext, igcnt, ipcnt, is1, is2, istat
      INTEGER   lcmd, lnam, ltmp, lun, lvalue, lwant
      INTEGER   naxis, ncmd, ncols, nrows
      LOGICAL   qbad, qsimp, qxtend
C---
      lun = 3
  100 CONTINUE
      CALL GTBUF('Input FITS file:', ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(cnam, lnam)
      IF ( lnam.LE.0 ) GOTO 900
C
      istat = 0
      CALL FTOPEN(Lun, cnam(:lnam), 0, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',cnam(:lnam),', istat=',istat
         GOTO 100
      END IF
C
C Read keywords from primary header
C
      istat = 0
      CALL FTGHPR(lun,MXNAX,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( naxis.NE.0 .OR. .NOT.qxtend ) THEN
         WRITE(*,*) 'Not a binary table FITS file.', naxis,qxtend
         GOTO 100
      END IF
C Go to 2nd HDU.
      istat = 0
      CALL FTMAHD(lun, 2, iext, istat)
C Get Observation start day
      CALL MJDOBS(lun, days, dsec, is1)
      Days = INT(Days)
C Get the reference time
      CALL MJDREF(lun, dmjd0, is2)
      IF ( is1.EQ.0 .AND. is2.EQ.0 ) THEN
         doff = (days-dmjd0)*86400.
         istat = 0
         cvalue = ' '
         CALL FTGKYS(Lun,'TIMESYS',cvalue,ctmp,istat)
         CALL UPC(cvalue)
         IF ( cvalue(1:2).NE.'TT' .AND. cvalue(1:3).NE.'TDB') THEN
C If the column name is TIME and TIMESYS is neither TT nor TDB, then we
C are likely dealing with UTC and need to correct for leap seconds.
            doff = doff+sla_DTT(Days)-sla_DTT(dmjd0)
         END IF
         WRITE(*,311) doff
 311     FORMAT(' Doff (time offset)   :', F14.3)
      ELSE
         doff = 0.0D0
      END IF
      istat = 0
      CALL FTGKYJ(lun, 'NAXIS2', nrows, ctmp, istat)
      write(*,*) 'nrows=',nrows
      nrows = MIN(nrows, MXROW)
C
      DO icol=1,MXCOL
         icnum(icol) = 0
         itdat(icol) = 0
         iery(icol) = 0
      END DO
      ncols = 0
      ncmd = 1
      cmd(ncmd) = 'LAB F '//cnam
C
C Now get column names.
      WRITE(*,*) 'Enter a blank line to end.'
  150 CONTINUE
      CALL GTBUF('Column name:', ier)
      IF ( ier.LT.0 ) GOTO 100
      CALL GTCHAR(cwant, lwant)
      IF ( lwant.LE.0 ) GOTO 200
      CALL UPC(cwant)
C
      istat = 0
      DO i=1,999
C Construct keyword name
         CALL FTKEYN('TTYPE',i,ckey,istat)
C Search for keyword value
         CALL FTGKYS(lun,ckey,cvalue,ctmp,istat)
         IF ( istat.GT.0 ) GOTO 180
         IF ( cwant.EQ.'?' ) THEN
            WRITE(*,161) i,cvalue
  161       FORMAT(1X,I5,2X,A)
         ELSE
            ctmp = cvalue
            CALL UPC(ctmp)
            IF ( ctmp.EQ.cwant ) THEN
               ncols = ncols + 1
               icnum(ncols) = i
               ncmd = ncmd + 1
               cmd(ncmd) = 'LAB G'
               lcmd = 5
               CALL CRAMI(ncols, cmd(ncmd), lcmd)
               cmd(ncmd)(lcmd+1:)=' '//cvalue
               lcmd = LENACT(cmd(ncmd))
               IF ( INDEX(ctmp,'TIME').GT.0 .AND.
     &               ctmp.NE.'LIVETIME') THEN
                  itdat(ncols) = 1
                  CALL OBSLAB(days, ctmp, ltmp)
                  cmd(ncmd)(lcmd+1:) = ctmp(:ltmp)
               ELSE
                  CALL FTKEYN('TUNIT',i,ckey,istat)
                  istat = 0
                  CALL FTGKYS(lun,ckey,cvalue,ctmp,istat)
                  IF ( istat.EQ.0 ) THEN
                     lvalue = LENACT(cvalue)
                     cmd(ncmd)(lcmd+1:) = ' ('//cvalue(:lvalue)//')'
                  ELSE
                     istat = 0
                  END IF
               END IF
               IF ( ncols.LT.MXCOL ) GOTO 150
               GOTO 200
            END IF
         END IF
      END DO
  180 CONTINUE
      IF ( cwant.NE.'?' ) THEN
         WRITE(*,*) 'Unable to find column ',cwant
      END IF
      GOTO 150
C
C Read the data for the selected columns
  200 CONTINUE
      IF ( ncols.LE.0 ) THEN
         WRITE(*,*) 'No data to plot.'
         GOTO 900
      END IF
      dnul = NO
      fnul = NO
      DO i=1,nrows
         istat = 0
         DO icol=1,ncols
            IF ( itdat(icol).GT.0 ) THEN
               CALL FTGCVD(lun,icnum(icol),i,1,1,dnul,dval,qbad,istat)
               yval = dval - doff
            ELSE
               CALL FTGCVE(lun,icnum(icol),i,1,1,fnul,yval,qbad,istat)
            END IF
            ydat(i,icol) = yval
         END DO
      END DO
C
C Do the plot
      CALL PLT(ydat,iery,MXROW,nrows,ncols,cmd,ncmd,ier)
C---
  900 CONTINUE
      istat = 0
      CALL FTCLOS(lun, istat)
      CALL EDICOM('OFF',3)
      END
