C Program fnddup.  Find duplicate (similar RA/DEC) entries in FITS catalogs.
C---
C 2005-03-23 - From near2 [AFT]
C---
      INTEGER   MXCAT
      PARAMETER (MXCAT=100000)
      INTEGER   LENACT
C
      CHARACTER ccat*256, cout*256
      CHARACTER cvalue*64, ctmp*64, ckey*16, cnam1*16, cnam2*16, cnul*16
      DOUBLE PRECISION dde(MXCAT), dra(MXCAT)
      DOUBLE PRECISION dnul
      REAL      r2cur, r2max, rcos, rmax, rtd, s1, s2
      INTEGER   naxes(99)
      INTEGER   i, ibad, ibits, iblk, icdcat, icnam, icrcat, icsest
      INTEGER   ier, iext, igcnt
      INTEGER   ipcnt, irow, istat
      INTEGER   jbad, jrow
      INTEGER   lcat, lnam1, lnam2, lout, ltmp, lunc, luno
      INTEGER   naxis, ncats, ndup
      LOGICAL   qbad, qsimp, qxtend
      DATA  rtd/57.2957795/
C---
   11 FORMAT(A)
C---
      lunc = 3
      luno = 4
      ndup = 0
  100 CONTINUE
      CALL GTBUF('Catalog, [out]:', ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(ccat, lcat)
      IF ( lcat.LE.0 ) GOTO 900
      CALL GTCHAR(cout, lout)
C
      istat = 0
      CALL FTOPEN(lunc, ccat(:lcat), 0, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',ccat(:lcat),', istat=',istat
         GOTO 100
      END IF
C
      IF ( lout.GT.0 ) THEN
         CALL XTEND(cout, 'txt')
         CALL OPENWR(luno,cout,'NEW',' ',' ',0,0,ier)
         IF ( ier.NE.0 ) THEN
            WRITE(*,*) 'Unable to open:',cout(:lout)
            lout = 0
         END IF
      END IF
C---
C Read keywords from primary header
C
      istat = 0
      CALL FTGHPR(lunc,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( naxis.NE.0 .OR. .NOT.qxtend ) THEN
         WRITE(*,*) 'Not a binary table FITS file.', naxis,qxtend
         GOTO 100
      END IF
C
C Assume data is in first extension.  Note, reading NAXIS2 works for
C both FITS binary and ASCII tables.
C
      istat = 0
      CALL FTMAHD(lunc, 2, iext, istat)
      CALL FTGKYJ(lunc,'NAXIS2',ncats,ctmp,istat)
C
  200 CONTINUE
      istat = 0
      icrcat = 0
      icdcat = 0
      icnam = 0
      DO i=1,99
C Construct keyword name
         CALL FTKEYN('TTYPE',i,ckey,istat)
C Search for keyword value
         CALL FTGKYS(lunc,ckey,cvalue,ctmp,istat)
         IF (istat .GT. 0) GOTO 240
C
         CALL UPC(cvalue)
         IF ( cvalue(1:2).EQ.'RA' ) THEN
            icrcat = i
         ELSE IF ( cvalue(1:2).EQ.'DE' ) THEN
            icdcat = i
         ELSE IF ( cvalue(1:4).EQ.'NAME' ) THEN
            icnam = i
         ELSE IF ( cvalue(1:4).EQ.'SEST' ) THEN
            icsest = i
         END IF
      END DO
C
  240 CONTINUE
      WRITE(*,*) 'Columns:'
      WRITE(*,*) 'Catalog:  RA   =',icrcat,', DEC  =',icdcat
      IF ( icrcat.LE.0 .OR. icdcat.LE.0 ) GOTO 900
C
C Now read selected data for each event and process.
      WRITE(*,*) '! ',ncats,' in ',ccat(:lcat)
      rmax = 0.2
  300 CONTINUE
      WRITE(ctmp, 311) rmax
  311 FORMAT('Maximum radius(',F10.1,'):')
      CALL GTBUF(ctmp, ier)
      CALL GTREAL(rmax, ier)
C
      istat = 0
      DO irow=1,ncats
         istat = 0
         CALL FTGCVD(lunc,icrcat,irow,1,1,dnul,dra(irow), qbad,istat)
         CALL FTGCVD(lunc,icdcat,irow,1,1,dnul,dde(irow), qbad,istat)
      END DO
      WRITE(*,*)
      r2max = (rmax/3600.)**2
      jbad = 0
      cnul = ' '
      DO irow=1,ncats-1
         rcos = COS(dde(irow)/rtd)
         DO jrow=irow+1,ncats
            r2cur=rcos*rcos*(dra(irow)-dra(jrow))**2 +
     &         (dde(irow)-dde(jrow))**2
            IF ( r2cur.LT.r2max ) THEN
               cnam1 = ' '
               cnam2 = ' '
               istat = 0
               IF ( icnam.NE.0 ) THEN
                  CALL FTGCVS(lunc,icnam,irow,1,1,cnul,cnam1,qbad,istat)
                  CALL FTGCVS(lunc,icnam,jrow,1,1,cnul,cnam2,qbad,istat)
                  WRITE(*,*) 'Dup',irow,' (',cnam1(:LENACT(cnam1)),')',
     &             jrow,' (',cnam2(:LENACT(cnam2)),')',3600.*SQRT(r2cur)
               ELSE
                  WRITE(*,*) 'Dup',irow,jrow,3600.*SQRT(r2cur)
               END IF
               IF ( jbad.NE.0 ) THEN
                  ctmp = '#row.NE.'
                  ltmp = LENACT(ctmp)
                  CALL CRAMI(jbad, ctmp, ltmp)
                  ctmp(ltmp+1:ltmp+5) = '.AND.'
                  ltmp = ltmp + 5
                  IF ( lout.GT.0 ) WRITE(luno, 11) ctmp(:ltmp)
               END IF
               IF ( icsest.GT.0 ) THEN
                  CALL FTGCVE(lunc,icsest,irow,1,1,dnul,s1, qbad,istat)
                  CALL FTGCVE(lunc,icsest,jrow,1,1,dnul,s2, qbad,istat)
                  IF ( s1.GT.s2 ) THEN
                     jbad = jrow
                  ELSE
                     jbad = irow
                  END IF
               ELSE
                  jbad = jrow
               END IF
               ndup = ndup + 1
            END IF
         END DO
      END DO
      IF ( jbad.NE.0 ) THEN
         ctmp = '#row.NE.'
         ltmp = LENACT(ctmp)
         CALL CRAMI(jbad, ctmp, ltmp)
         IF ( lout.GT.0 ) WRITE(luno, 11) ctmp(:ltmp)
      END IF
C
      WRITE(*,*) 'Found ',ndup,' duplicates.'
C---
C Get some results
C---
  900 CONTINUE
      istat = 0
      CALL FTCLOS(lunc, istat)
      IF ( ndup.GT.0 ) THEN
         CLOSE(UNIT=luno)
      ELSE
         CLOSE(UNIT=luno, DISPOSE='DELETE')
      END IF
      CALL EDICOM('OFF',3)
      END
