C Program lookfv look for variability.  Assumes there is column containing
C nsigma
C---
C 2000-04-04 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXCOL, MXROW
      PARAMETER (MXCOL=2, MXROW=200000)
      INTEGER   LENACT
C
      CHARACTER cnam*256, ctmp*64, cvalue*64, cwant*64
      CHARACTER ckey*16
      REAL      ydat(MXROW, MXCOL)
      REAL      fchi, fdel, fmax, fnul, yval
      INTEGER   naxes(99), icnum(MXCOL)
      INTEGER   i, ibits, iblk, icol
      INTEGER   ier, iext, igcnt, imax, ipcnt, istat
      INTEGER   lnam, ltmp, lun, lvalue, lwant
      INTEGER   naxis, ncols, ndel, nrows
      LOGICAL   qbad, qsimp, qxtend
C---
      lun = 3
  100 CONTINUE
      CALL GTBUF('Input FITS file:', ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(cnam, lnam)
      IF ( lnam.LE.0 ) GOTO 900
C
      istat = 0
      CALL FTOPEN(Lun, cnam(:lnam), 0, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',cnam(:lnam),', istat=',istat
         GOTO 100
      END IF
C
C Read keywords from primary header
C
      istat = 0
      CALL FTGHPR(lun,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( naxis.NE.0 .OR. .NOT.qxtend ) THEN
         WRITE(*,*) 'Not a binary table FITS file.', naxis,qxtend
         GOTO 100
      END IF
C Go to 2nd HDU.
      istat = 0
      CALL FTMAHD(lun, 2, iext, istat)
      istat = 0
      CALL FTGKYJ(lun, 'NAXIS2', nrows, ctmp, istat)
      write(*,*) 'nrows=',nrows
      nrows = MIN(nrows, MXROW)
C
      DO icol=1,MXCOL
         icnum(icol) = 0
      END DO
      ncols = 0
C
C Now get column names.
      WRITE(*,*) 'Enter a blank line to end.'
  150 CONTINUE
      CALL GTBUF('Column name:', ier)
      IF ( ier.LT.0 ) GOTO 100
      CALL GTCHAR(cwant, lwant)
      IF ( lwant.LE.0 ) GOTO 200
      CALL UPC(cwant)
C
      istat = 0
      DO i=1,99
C Construct keyword name
         CALL FTKEYN('TTYPE',i,ckey,istat)
C Search for keyword value
         CALL FTGKYS(lun,ckey,cvalue,ctmp,istat)
         IF ( istat.GT.0 ) GOTO 180
         IF ( cwant.EQ.'?' ) THEN
            WRITE(*,161) i,cvalue
  161       FORMAT(1X,I5,2X,A)
         ELSE
            ctmp = cvalue
            CALL UPC(ctmp)
            IF ( ctmp.EQ.cwant ) THEN
               ncols = ncols + 1
               icnum(ncols) = i
               CALL FTKEYN('TUNIT',i,ckey,istat)
               istat = 0
               CALL FTGKYS(lun,ckey,cvalue,ctmp,istat)
                IF ( istat.EQ.0 ) THEN
                  lvalue = LENACT(cvalue)
               ELSE
                  istat = 0
               END IF
               GOTO 200
            END IF
         END IF
      END DO
  180 CONTINUE
      IF ( cwant.NE.'?' ) THEN
         WRITE(*,*) 'Unable to find column ',cwant
      END IF
      GOTO 150
C
C Read the data for the selected columns
  200 CONTINUE
      fnul = NO
      fchi = 0.0
      DO i=1,nrows
         istat = 0
         icol=1
         CALL FTGCVE(lun,icnum(icol),i,1,1,fnul,yval,qbad,istat)
         ydat(i,icol) = yval*yval
         fchi = fchi + yval*yval
      END DO
C
      fdel = 0.0
      ndel =0
      imax = 0
      fmax = 0.0
C
      WRITE(*,291)
  291 FORMAT(' Npts     chi^2    itoss    del-chi')
C
  300 CONTINUE
      WRITE(*,301) nrows-ndel,fchi-fdel,imax,fmax
  301 FORMAT(1X,I4,F10.2,5X,I4,1X,F10.2)
      IF ( fchi-fdel.GT.nrows-ndel ) THEN
         imax = 0
         fmax = 0.0
         DO i=1,nrows
            IF ( ydat(i,1).GT.fmax ) THEN
               fmax = ydat(i,1)
               imax = i
            END IF
         END DO
         fdel = fdel + fmax
         ndel = ndel + 1
         ydat(imax,1) = 0.0
         GOTO 300
      END IF
C
C---
  900 CONTINUE
      istat = 0
      CALL FTCLOS(lun, istat)
      CALL EDICOM('OFF',3)
      END
