C Reads XTE files containing phase folded pulse profiles and makes
C a 2D FITS image.
C---
      INTEGER   MXCOL, MXSCOL
      PARAMETER (MXCOL=32, MXSCOL=9)
C
      CHARACTER ctypes(MXCOL)*16, cform(MXCOL)*16, cunit(MXCOL)*16
      CHARACTER cnam*256, cvalue*64, ctmp*64
      CHARACTER ccol*16, cext*16
      INTEGER   ifpix(3), ilpix(3), naxes(3)
      INTEGER   i, iblk, ibits, iblock, ier, iext, igcnt
      INTEGER   ipcnt, istat, itmp, ixcol
      INTEGER   lnam, luni, luno, naxis, nfield, nrows, nx, ny
      INTEGER*2 i2map(81,128)
      INTEGER*2 i2nul
      LOGICAL   qbad, qsimp, qxtend
C---
   11 FORMAT(A)
C---
      luni = 1
      luno = 2
  100 CONTINUE
      CALL GTBUF('Input file:', ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(cnam, lnam)
      IF ( lnam.LE.0 ) GOTO 100
C
      istat = 0
      CALL FTOPEN(luni, cnam(:lnam), 0, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to open ',cnam(:lnam),', istat=',istat
         GOTO 100
      END IF
C
C Read extension header records looking for EVENTS data.
C
      istat = 0
      DO i=2,20
         IF ( istat.EQ.0 ) THEN
            CALL FTMAHD(luni, i, iext, istat)
            itmp = 0
            CALL FTGKYS(luni, 'EXTNAME', cvalue, ctmp, itmp)
            IF ( cvalue(1:6).EQ.'XTE_SA' ) GOTO 200
         END IF
      END DO
      WRITE (*,*) 'RFHEAD--Cannot find XTE_SA data.'
      CALL FTCLOS(luni,istat)
      GOTO 900
C
C
  200 CONTINUE
      CALL FTGHBN(luni,MXCOL,nrows,nfield,ctypes,cform,cunit,cext,
     &                  ipcnt,istat)
      CALL FTGCNN(luni, .FALSE., 'XePer', ccol, ixcol, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'Unable to find X columns.'
         WRITE(*,*) 'ccol=',ccol, ixcol, istat
         GOTO 900
      END IF
C---
C
      nx = 81
      ny =128
  250 CONTINUE
      WRITE(*,251) nx, ny
  251 FORMAT (' To create',I5,' by',I5,' map, please enter')
      cnam = ' '
      CALL GTBUF('Fits file name:',ier)
      IF ( ier.NE.0 ) GOTO 250
      CALL GTCHAR(cnam, lnam)
      IF ( lnam.LE.0 ) GOTO 900
C
      CALL XTEND(cnam,'fit')
      CALL GETLUN(luno)
      iblock = 1
      istat = 0
      CALL FTINIT(luno, cnam, iblock, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'FITSIO error =',istat
         lnam = 0
         GOTO 250
      END IF
      qsimp  = .TRUE.
      ibits  =  16
      naxis  = 3
      naxes(1) = nx
      naxes(2) = ny
      naxes(3) = nrows
      ipcnt = 0
      igcnt = 1
      qxtend = .FALSE.
      CALL FTPHPR(luno,qsimp,ibits,naxis,naxes,
     &               ipcnt,igcnt,qxtend,istat)
      CALL FTPDEF(luno,ibits,naxis,naxes,ipcnt,igcnt,istat)
C Standard header keywords
      CALL FTPKYS(luno,'ORIGIN','XANADU',
     &         'X-ray ANalysis And Data Utilization software',istat)
      IF ( istat.NE.0 ) WRITE(*,*) 'FITSIO output status=',istat
C---
C Read the data and write the images
      i2nul = 0
      DO i=1, nrows
         istat = 0
         CALL FTGCVI(luni,ixcol,i,1,81*128,i2nul,i2map,qbad,istat)
C         CALL FTP2DI(luno,0,81,81,128,I2map,istat)
         ifpix(1) = 1
         ilpix(1) = 81
         ifpix(2) = 1
         ilpix(2) = 128
         ifpix(3) = i
         ilpix(3) = i
         CALL FTPSSI(luno,0,naxis,naxes,ifpix,ilpix,I2map,istat)
      END DO
      write(*,*) 'istat=',istat
C---
  900 CONTINUE
      istat = 0
      CALL FTCLOS(luni, istat)
      CALL FTCLOS(luno, istat)
      CALL EDICOM('OFF',3)
      END
