      SUBROUTINE ASKPOS(Qplot, Qend)
      LOGICAL   Qplot, Qend
C---
C General purpose subroutine to ask user for a position to be defined either
C by interactive use of the cursor or by typing in the coordinates in either
C detector space or RA and dec.
C---
C Qplot    I    =.T. if plot device is active
C Qend       O  User answered with e-o-f
C
C Global:
C  Xdet,Ydet      position in detector coordinates
C  Nrow, Ncol
C---
C 10/10/85 - kaa
C---
      INCLUDE 'mapdef.inc'
      INCLUDE 'posdef.inc'
      INTEGER LENACT
      DOUBLE PRECISION DPNUM
      REAL    FPNUM
C
      CHARACTER cprom*72, ctmp*64, ctok*64, cok*8, cdecd*3
      CHARACTER cans, cold
      DOUBLE PRECISION ddec, dra
      REAL      rras, rdecs
      INTEGER   ier, ihms, imx, imy, isn, itmp
      INTEGER   irah, iram, idecd, idecm
      INTEGER   kp, lans, lprom, ltmp, ltok
C
      DATA cans/'P'/
C
C Assume we fail
C
      Qend = .TRUE.
C
C Request position to be interrogated
C
 100  CONTINUE
      IF ( Iwcs.NE.0 ) THEN
         IF ( Qplot ) THEN
            cprom = 'Cursor, Pixels or WCS'
            cok = 'CPW-'
         ELSE
            cprom = 'Pixels or World'
            cok = 'PW-'
         END IF
      ELSE
         IF ( Qplot ) THEN
            cprom = 'Cursor, or Pixels'
            cok = 'CP-'
         ELSE
            cprom = 'Pixels'
            cok = 'P-'
         END IF
      END IF
      lprom = LENACT(cprom)
      cprom(lprom+1:) = ' (' // cans // ')?'
C
      cold = cans
 120  CONTINUE
      ctmp = ' '
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.LE.0 ) THEN
         CALL GTBUF(cprom, ier)
         IF ( ier.NE.0 ) GOTO 999
      END IF
      CALL GTCHAR(cans, lans)
      IF ( lans.LE.0 ) cans = cold
      CALL UPC(cans)
      IF ( INDEX(cok,cans(1:1)).EQ.0 ) THEN
         WRITE (*,*) 'Try again.'
         CALL GTREST(ctmp, ltmp)
         GOTO 120
      END IF
C
C Now process the user's request.
C
      IF ( cans.EQ.'-' ) THEN
         GOTO 999
      ELSE IF ( cans.EQ.'C' ) THEN
C Cursor position
         IF ( .NOT.Qplot ) GOTO 100
         CALL GTCURS(Qend)
         IF ( Qend ) GOTO 999
      ELSE IF ( cans.EQ.'M' ) THEN
C Map position
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE (cprom,211) imx, imy
 211        FORMAT ('Map position (',I5,',',I5,'):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTINT(imx,ier)
         CALL GTINT(imy,ier)
         CALL POS_MAP_DET(imx, imy, Xdet, Ydet)
      ELSE IF ( cans.EQ.'P' ) THEN
C Pixel position
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE (cprom,221) Xdet, Ydet
 221        FORMAT ('Pixel position (',F8.1,',',F8.1,'):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTREAL(Xdet,ier)
         CALL GTREAL(Ydet,ier)
      ELSE IF ( cans.EQ.'W' ) THEN
C RA/Dec position
         CALL POS_DT_RA(Xdet, Ydet, dra, ddec)
         CALL POS_DEG_HMS(dra,ddec,irah,iram,rras,cdecd,idecm,rdecs)
 250     CONTINUE
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE (cprom,251) irah, iram, rras
 251        FORMAT ('R.A. (',I3,',',I3,',',F5.2,'):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(ctmp, ltmp)
         CALL POS_HMS(ihms)
         IF ( INDEX(ctmp,'.').GT.0 .OR. ihms.EQ.0 ) THEN
C Decimal degrees
            dra = DPNUM(ctmp, ltmp, ier)
         ELSE
C Hours, mins, sec
            itmp = FPNUM(ctmp, ltmp, ier)
            IF ( ier.EQ.0 ) irah = itmp
            CALL GTINT(iram,ier)
            CALL GTREAL(rras,ier)
            CALL POS_HMS_DEG(irah,iram,rras,isn,idecd,idecm,rdecs,
     &         dra,ddec)
         END IF
C
C Now for the Dec
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE (cprom,261) cdecd, idecm, rdecs
 261        FORMAT ('Dec. (',A3,',',I3,',',F4.1,') :')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 250
         END IF
         CALL GTCHAR(ctmp, ltmp)
         IF ( INDEX(ctmp,'.').GT.0 .OR. ihms.EQ.0 ) THEN
C Decimal degrees
            ddec = DPNUM(ctmp, ltmp, ier)
         ELSE
C Degrees, mins, sec
            IF ( ltmp.EQ.0 ) THEN
               ctmp=cprom(INDEX(cprom,'(')+1:INDEX(cprom,')')-1)
               ltmp=LENACT(ctmp)
            END IF
            kp=0
            CALL ALFSKS(ctmp,ltmp,kp)
            CALL ALF(ctmp, ltmp, kp, ctok, ltok)
            IF ( ctok(1:1).EQ.'-' ) THEN
               isn=-1
            ELSE
               isn=+1
            END IF
            itmp = FPNUM(ctok, ltok, ier)
            IF ( ier.EQ.0 ) idecd = itmp
            CALL GTINT(idecm,ier)
            CALL GTREAL(rdecs,ier)
            CALL POS_HMS_DEG(irah,iram,rras,isn,idecd,idecm,rdecs,
     &         dra,ddec)
         END IF
         CALL POS_RA_DT(dra, ddec, Xdet, Ydet)
      ELSE
C Illegal request
         GOTO 100
      END IF
      Qend = .FALSE.
C---
 999  CONTINUE
      END
