C---
C This file contains all the routines that deal with the 'source selection
C bounds'.
C---
      FUNCTION INBOU(Xpos, Ypos)
      INTEGER   INBOU,  BOUDEF, BOUDIS
      INTEGER   BOUQD, BOUQIB, BOUQOB, BOUSTR
      REAL      Xpos, Ypos
C Entry DEFine BOUnds
      LOGICAL   Qbound, Qplot, Qfail
C Entry BOUnds Outer/Inner BouNDs min/max
      REAL      Xdetl, Ydetl, Xdeth, Ydeth
C Entry BOUnd DISplay
      INTEGER   Istyle
C Entry BOUQD
      INTEGER   Ireg, Idef
C Entry BOUSTR
      CHARACTER Cbuf*(*)
C Entry BOUXY
      INTEGER   BOUXY
      REAL      Xr, Yr
C---
C Returns 1 if photon is in inner (source) region, -1 if photon is in
C outer (background) region, 0 otherwise.
C---
      INTEGER   MXPAR
      PARAMETER (MXPAR=512)
      INTEGER   LENACT, INPOLY
C
      CHARACTER cprom*72, ctmp*10
      CHARACTER cans*10, cdef
      REAL      rtd
      SAVE      rtd
      REAL      rdist2, tmp1, tmp2, tmp3, tmp4, xc, yc
      INTEGER   i, ier, k, lans, lbuf, ltmp
C
      REAL      regi, rego
      INTEGER   Iityp, iotyp, nipar, nopar
      COMMON /BOUNDS/ Iityp, iotyp, nipar, nopar,
     &      regi(MXPAR), rego(MXPAR)
      SAVE /BOUNDS/
C
      DATA cans/'N'/, rtd/57.2957795/
C---
      INBOU = 0
      IF ( Iotyp.EQ.1 ) THEN
C Rectangle
         IF ( rego(1).LE.Xpos .AND. Xpos.LE.rego(3) .AND.
     &        rego(2).LE.Ypos .AND. Ypos.LE.rego(4) ) INBOU = -1
      ELSE IF ( Iotyp.EQ.2 ) THEN
C Circle
         rdist2 = (Xpos-rego(1))*(Xpos-rego(1)) +
     &            (Ypos-rego(2))*(Ypos-rego(2))
         IF ( rdist2.LE.rego(4) ) INBOU = -1
      ELSE IF ( Iotyp.EQ.3 ) THEN
C Box (unrotate the box)
         xc = rego(5)*(Xpos-rego(1))+rego(6)*(Ypos-rego(2))
         yc =-rego(6)*(Xpos-rego(1))+rego(5)*(Ypos-rego(2))
         IF ( ABS(xc).LE.rego(3).AND.ABS(yc).LE.rego(4) ) INBOU=-1
      ELSE IF ( Iotyp.EQ.4 ) THEN
C Ellipse (unrotate the ellipse)
         xc = rego(5)*(Xpos-rego(1))+rego(6)*(Ypos-rego(2))
         yc =-rego(6)*(Xpos-rego(1))+rego(5)*(Ypos-rego(2))
         IF ( ((xc/rego(3))**2+(yc/rego(4))**2).LE.1.0 ) INBOU=-1
      ELSE IF ( Iotyp.EQ.5 ) THEN
         INBOU=-INPOLY(Xpos, Ypos, nopar/2, rego)
      ELSE IF ( Iotyp.NE.0 ) THEN
         WRITE(*,*) 'INBOU--error, iotyp=',Iotyp
      END IF
C
      IF ( Iityp.EQ.1 ) THEN
         IF ( regi(1).LE.Xpos .AND. Xpos.LE.regi(3) .AND.
     &        regi(2).LE.Ypos .AND. Ypos.LE.regi(4) ) INBOU = +1
      ELSE IF ( Iityp.EQ.2 ) THEN
C Circle
         rdist2 = (Xpos-regi(1))*(Xpos-regi(1)) +
     &            (Ypos-regi(2))*(Ypos-regi(2))
         IF ( rdist2.LE.regi(4) ) INBOU = +1
      ELSE IF ( Iityp.EQ.3 ) THEN
C Box
         xc = regi(5)*(Xpos-regi(1))+regi(6)*(Ypos-regi(2))
         yc =-regi(6)*(Xpos-regi(1))+regi(5)*(Ypos-regi(2))
         IF ( ABS(xc).LE.regi(3).AND.ABS(yc).LE.regi(4) ) INBOU=+1
      ELSE IF ( Iityp.EQ.4 ) THEN
C Ellipse (unrotate the ellipse)
         xc = regi(5)*(Xpos-regi(1))+regi(6)*(Ypos-regi(2))
         yc =-regi(6)*(Xpos-regi(1))+regi(5)*(Ypos-regi(2))
         IF ( ((xc/regi(3))**2+(yc/regi(4))**2).LE.1.0 ) INBOU=+1
      ELSE IF ( Iityp.EQ.5 ) THEN
         INBOU=INPOLY(Xpos, Ypos, nipar/2, regi)
      ELSE
         WRITE(*,*) 'INBOU--error, iityp=',iityp
      END IF
      RETURN
C*********
      ENTRY BOUDEF(Qplot, Qbound, Qfail)
C---
C LEXTRCT routine to define a region of interest.
C---
C Qplot   I    Image plotting device flag
C Qbound    O  .TRUE. if bounds are defined.
C Qfail     O  failure flag
C---
      BOUDEF = 0
 100  CONTINUE
      CALL RGGET(Qplot, MXPAR, iityp, regi, nipar, Qfail)
      IF ( Qfail ) RETURN
C
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.LE.0 ) THEN
         cdef = cans
         cprom = 'Do you wish to define an outer box (' // cdef // ')?'
         CALL GTBUF(cprom,ier)
         IF ( ier.NE.0 ) THEN
            CALL PTBUF(' ',-1)
            CALL PTBUF('Redefine inner box:',-1)
            GOTO 100
         END IF
      END IF
      CALL GTCHAR(cans,lans)
      CALL UPC(cans)
      IF ( lans.LE.0 ) cans = cdef
C
      IF ( cans(1:1).EQ.'Y' .OR. cans(1:1).EQ.'-') THEN
C Define outer box
         CALL RGGET(Qplot, MXPAR, Iotyp, rego, nopar, Qfail)
         IF ( Qfail ) RETURN
      ELSE
C No outer box
         Iotyp = 0
         rego(1) = -1.
         rego(2) = -1.
         rego(3) = -1.
         rego(4) = -1.
      END IF
C
      Qbound = .TRUE.
      RETURN
C*********
      ENTRY BOUDIS(Istyle)
C---
C Subroutine to display the selected region using given line-style
C---
      BOUDIS = 0
C
C First draw the inner box
      CALL RGDRAW(Iityp, regi, nipar, Istyle)
C
C and then the outer box if it exists.
      CALL RGDRAW(Iotyp, rego, nopar, Istyle)
      RETURN
C*********
      ENTRY BOUQD(Ireg, Idef)
C---
C REG Query defined?
C---
C Ireg    I    =0 for outer box, =1 for inner
C Idef      O  =0 not defined, =1 defined
C---
      BOUQD = 0
      Idef = 0
      IF ( Ireg.EQ.0 ) THEN
C Outer box?
         IF ( Iotyp.GT.0 ) Idef = 1
      ELSE IF ( Ireg.EQ.1 ) THEN
C Inner box?
         IF ( Iityp.GT.0 ) Idef = 1
      ELSE
         CALL PTBUF('BOUQD--Programmer error.',-1)
      END IF
      RETURN
C*********
      ENTRY BOUQIB(Xdetl,Ydetl,Xdeth,Ydeth)
C---
C REGion Query Inner Bound.
C Return the maximum (X,Y) that bounds the inner region.
C---
      BOUQIB = 0
      IF ( Iityp.EQ.1 ) THEN
         Xdetl = regi(1)
         Ydetl = regi(2)
         Xdeth = regi(3)
         Ydeth = regi(4)
      ELSE IF ( Iityp.EQ.2 ) THEN
         Xdetl = regi(1) - regi(3)
         Ydetl = regi(2) - regi(3)
         Xdeth = regi(1) + regi(3)
         Ydeth = regi(2) + regi(3)
      ELSE IF ( Iityp.EQ.3 .OR. Iityp.EQ.4) THEN
C Rotated box or ellipse (both use the outer corners of the bounding box).
         tmp1 = regi(1)+regi(5)*regi(3)-regi(6)*regi(4)
         tmp2 = regi(1)-regi(5)*regi(3)-regi(6)*regi(4)
         tmp3 = regi(1)-regi(5)*regi(3)+regi(6)*regi(4)
         tmp4 = regi(1)+regi(5)*regi(3)+regi(6)*regi(4)
         Xdetl = MIN(tmp1,tmp2,tmp3,tmp4)
         Xdeth = MAX(tmp1,tmp2,tmp3,tmp4)

         tmp1 = regi(2)+regi(6)*regi(3)+regi(5)*regi(4)
         tmp2 = regi(2)-regi(6)*regi(3)+regi(5)*regi(4)
         tmp3 = regi(2)-regi(6)*regi(3)-regi(5)*regi(4)
         tmp4 = regi(2)+regi(6)*regi(3)-regi(5)*regi(4)
         Ydetl = MIN(tmp1,tmp2,tmp3,tmp4)
         Ydeth = MAX(tmp1,tmp2,tmp3,tmp4)
      ELSE IF ( Iityp.EQ.5 ) THEN
C Polygon
            Xdetl=regi(1)
            Xdeth=regi(1)
            Ydetl=regi(2)
            Ydeth=regi(2)
            DO i=1,nipar/2-1
               Xdetl=MIN(Xdetl,regi(2*i+1))
               Xdeth=MAX(Xdeth,regi(2*i+1))
               Ydetl=MIN(Ydetl,regi(2*i+2))
               Ydeth=MAX(Ydeth,regi(2*i+2))
            END DO
      ELSE
         WRITE(*,*) 'BOUQIB--error, Iityp=',Iityp
      END IF
      RETURN
C*********
      ENTRY BOUQOB(Xdetl, Ydetl, Xdeth, Ydeth)
C---
C REGion Query Outer Bound.
C Return the maximum (X,Y) that bounds both the inner and outer regions.
C---
      BOUQOB = 0
      IF ( Iotyp.GT.0 ) THEN
         IF ( Iotyp.EQ.1 ) THEN
C Rectangle
            Xdetl = rego(1)
            Ydetl = rego(2)
            Xdeth = rego(3)
            Ydeth = rego(4)
         ELSE IF ( Iotyp.EQ.2 ) THEN
C Circle
            Xdetl = rego(1) - rego(3)
            Ydetl = rego(2) - rego(3)
            Xdeth = rego(1) + rego(3)
            Ydeth = rego(2) + rego(3)
         ELSE IF ( Iotyp.EQ.3 .OR. Iotyp.EQ.4) THEN
C Rotated box or ellipse (both use the outer corners of the bounding box).
            tmp1 = rego(1)+rego(5)*rego(3)-rego(6)*rego(4)
            tmp2 = rego(1)-rego(5)*rego(3)-rego(6)*rego(4)
            tmp3 = rego(1)-rego(5)*rego(3)+rego(6)*rego(4)
            tmp4 = rego(1)+rego(5)*rego(3)+rego(6)*rego(4)
            Xdetl = MIN(tmp1,tmp2,tmp3,tmp4)
            Xdeth = MAX(tmp1,tmp2,tmp3,tmp4)

            tmp1 = rego(2)+rego(6)*rego(3)+rego(5)*rego(4)
            tmp2 = rego(2)-rego(6)*rego(3)+rego(5)*rego(4)
            tmp3 = rego(2)-rego(6)*rego(3)-rego(5)*rego(4)
            tmp4 = rego(2)+rego(6)*rego(3)-rego(5)*rego(4)
            Ydetl = MIN(tmp1,tmp2,tmp3,tmp4)
            Ydeth = MAX(tmp1,tmp2,tmp3,tmp4)
         ELSE IF ( Iotyp.EQ.5 ) THEN
C Polygon
            Xdetl=rego(1)
            Xdeth=rego(1)
            Ydetl=rego(2)
            Ydeth=rego(2)
            DO i=1,nopar/2-1
               Xdetl=MIN(Xdetl,rego(2*i+1))
               Xdeth=MAX(Xdeth,rego(2*i+1))
               Ydetl=MIN(Ydetl,rego(2*i+2))
               Ydeth=MAX(Ydeth,rego(2*i+2))
            END DO
         ELSE
            CALL PTBUF('BOUQOB--error',-1)
         END IF
      ELSE
         IF ( Iityp.EQ.1 ) THEN
            Xdetl = regi(1)
            Ydetl = regi(2)
            Xdeth = regi(3)
            Ydeth = regi(4)
         ELSE IF ( Iityp.EQ.2 ) THEN
            Xdetl = regi(1) - regi(3)
            Ydetl = regi(2) - regi(3)
            Xdeth = regi(1) + regi(3)
            Ydeth = regi(2) + regi(3)
         ELSE IF ( Iityp.EQ.3 .OR. Iityp.EQ.4 ) THEN
            tmp1 = regi(1)+regi(5)*regi(3)-regi(6)*regi(4)
            tmp2 = regi(1)-regi(5)*regi(3)-regi(6)*regi(4)
            tmp3 = regi(1)-regi(5)*regi(3)+regi(6)*regi(4)
            tmp4 = regi(1)+regi(5)*regi(3)+regi(6)*regi(4)
            Xdetl = MIN(tmp1,tmp2,tmp3,tmp4)
            Xdeth = MAX(tmp1,tmp2,tmp3,tmp4)

            tmp1 = regi(2)+regi(6)*regi(3)+regi(5)*regi(4)
            tmp2 = regi(2)-regi(6)*regi(3)+regi(5)*regi(4)
            tmp3 = regi(2)-regi(6)*regi(3)-regi(5)*regi(4)
            tmp4 = regi(2)+regi(6)*regi(3)-regi(5)*regi(4)
            Ydetl = MIN(tmp1,tmp2,tmp3,tmp4)
            Ydeth = MAX(tmp1,tmp2,tmp3,tmp4)
         ELSE IF ( Iityp.EQ.5 ) THEN
C Polygon
            Xdetl=regi(1)
            Xdeth=regi(1)
            Ydetl=regi(2)
            Ydeth=regi(2)
            DO i=1,nipar/2-1
               Xdetl=MIN(Xdetl,regi(2*i+1))
               Xdeth=MAX(Xdeth,regi(2*i+1))
               Ydetl=MIN(Ydetl,regi(2*i+2))
               Ydeth=MAX(Ydeth,regi(2*i+2))
            END DO
         ELSE
            CALL PTBUF('BOUQOB--error',-1)
         END IF
      END IF
      RETURN
C*********
      ENTRY BOUSTR(Cbuf)
C---
C Write description of region into a string.
C---
      BOUSTR = 0
      IF ( Iityp.EQ.1 ) THEN
         WRITE(Cbuf,311) (regi(k),k=1,4)
 311     FORMAT('Rect  P ',F8.1,',',F8.1,'  P ',F8.1,',',F8.1)
      ELSE IF ( Iityp.EQ.2 ) THEN
         WRITE(Cbuf,321) (regi(k),k=1,3)
 321     FORMAT('Circle P',F8.1,',',F8.1,',',F8.1)
      ELSE IF ( Iityp.EQ.3 ) THEN
         WRITE(Cbuf,331) 'Box ',regi(1),regi(2),2*regi(3),2*regi(4),
     &            rtd*acos(regi(5))
 331     FORMAT(A5,' P',F8.1,',',F8.1,',',F8.1,F8.1,F8.3)
      ELSE IF ( Iityp.EQ.4 ) THEN
         WRITE(Cbuf,331) 'Ellip',regi(1),regi(2),regi(3),regi(4),
     &            rtd*acos(regi(5))
      ELSE IF ( Iityp.EQ.5 ) THEN
         WRITE(Cbuf,341) (regi(k),k=1,4)
 341     FORMAT('Poly P',F8.1,',',F8.1,' P',F8.1,',',F8.1,' ...')
      ELSE
         CALL PTBUF('BOUSTR--error',-1)
      END IF
C
      IF ( Iotyp.GT.0 ) THEN
         lbuf = LENACT(Cbuf)
         Cbuf(lbuf+1:lbuf+2) = ' -'
         lbuf = lbuf + 2
         IF ( Iotyp.EQ.1 ) THEN
            WRITE(Cbuf(lbuf+1:),311) (rego(k),k=1,4)
         ELSE IF ( Iotyp.EQ.2 ) THEN
            WRITE(Cbuf(Lbuf+1:),321) (rego(k),k=1,3)
         ELSE IF ( Iotyp.EQ.3 ) THEN
            WRITE(Cbuf,331) 'Box ',rego(1),rego(2),2*rego(3),2*rego(4),
     &            rtd*acos(rego(5))
         ELSE IF ( Iotyp.EQ.4 ) THEN
            WRITE(Cbuf,331) 'Ellip',rego(1),rego(2),rego(3),rego(4),
     &            rtd*acos(rego(5))
         ELSE IF ( Iityp.EQ.5 ) THEN
            WRITE(Cbuf,341) (rego(k),k=1,4)
         ELSE
            CALL PTBUF('BOUSTR--error',-1)
         END IF
      END IF
      RETURN
C*********
      ENTRY BOUXY(Xpos, Ypos, Xr, Yr)
C---
C Returns (Xr, Yr) in region coordinates for the 1st region.
C---
C assume fail
      BOUXY=0
      IF ( Iityp.EQ.1 ) THEN
C Rectangle
      ELSE IF ( Iityp.EQ.2 ) THEN
C Circle
      ELSE IF ( Iityp.EQ.3 ) THEN
C Box (unrotate the box)
         Xr = regi(5)*(Xpos-regi(1))+regi(6)*(Ypos-regi(2))
         Yr =-regi(6)*(Xpos-regi(1))+regi(5)*(Ypos-regi(2))
         BOUXY=1
      ELSE IF ( Iityp.EQ.4 ) THEN
C Ellipse (unrotate the ellipse)
         Xr = regi(5)*(Xpos-regi(1))+regi(6)*(Ypos-regi(2))
         Yr =-regi(6)*(Xpos-regi(1))+regi(5)*(Ypos-regi(2))
         BOUXY=1
      ELSE IF ( Iityp.NE.0 ) THEN
         WRITE(*,*) 'BOUXY--error, irtyp=',Iityp
      END IF
      RETURN
C
      END
