      SUBROUTINE CPHEAD(Lun, Ievent, Mxhead, Nhead, Chead)
      INTEGER   Lun, Ievent, Mxhead, Nhead
      CHARACTER chead(MXHEAD)*(*)
C---
C LEXTRCT routine to read fits files.
C---
C Lun     I    Logical unit number of open FITS file
C Ievent  I    Header number containing EVENTS extension
C Mxhead  I
C Nhead   I/O
C Chead     O
C---
C 1998-Feb-26 - New routine [AFT].
C---
      INTEGER   MXBADF, MXBADA
      PARAMETER (MXBADF=14, MXBADA=16)
      INTEGER   LENACT
C
      CHARACTER comm*64, cvalue*64
      CHARACTER cbadf(MXBADF)*8, cbada(MXBADA)*8
      CHARACTER ckey*8
      INTEGER   i, iext, istat, j, ltmp
C This should all be revised for the new FITS file, therefore
C make sure we don't copy them and thus get multiple and/or
C incorrect values.
      DATA cbadf/'SIMPLE','BITPIX','PCOUNT','GCOUNT','END',
     &     'BZERO','BSCALE','XTENSION','EXTNAME', 'TFIELDS',
     &     'LIVETIME', 'ORIGIN', 'DATASUM', 'CHECKSUM'/
      DATA cbada/'NAXIS', 'TTYPE', 'TFORM', 'TLMIN', 'TLMAX',
     &      'TCTYP', 'TCDLT', 'TCRPX', 'TCRVL',
     &      'CTYPE', 'CRVAL', 'CRPIX', 'CD1_', 'CD2_',
     &      'CDELT', 'CUNIT'/
C
C Double check input paramteres
      IF ( nhead.GE.MXHEAD ) GOTO 900
C Go to correct header
      istat = 0
      CALL FTMAHD(Lun, Ievent, iext, istat)
C
C and read all the FITS keywords one at a time.  If the
      DO 180 i=1,999
         istat = 0
         CALL FTGKYN(lun, i, ckey, cvalue, comm, istat)
         IF ( istat.NE.0 ) GOTO 900
C Should not be needed, but you never know...
         CALL UPC(ckey)
C Check list of keywords where you should match the full string
         DO j=1,MXBADF
            IF ( cbadf(j).EQ.ckey ) GOTO 180
         END DO
C Check list of keywords where you only need to match the abbreviation.
         DO j=1,MXBADA
            ltmp = LENACT(cbada(j))
            IF ( cbada(j).EQ.ckey(:ltmp) ) GOTO 180
         END DO
         nhead = nhead + 1
         CALL FTGREC(lun, i, chead(nhead), istat)
         IF ( nhead.GE.MXHEAD ) GOTO 900
  180 CONTINUE
C
  900 CONTINUE
      RETURN
      END
