      SUBROUTINE CROSSC(Mxrow,Nrow,Ncol,Rmap,Back,Nccf,Resp,
     &   Mxcmd, Cmd, Ncmd)
      INTEGER   Mxrow, Nrow, Ncol, Nccf, Mxcmd, Ncmd
      REAL      Rmap(Mxrow,*), Back(Mxrow,*)
      REAL      Resp(-Nccf:Nccf,-Nccf:Nccf)
      CHARACTER cmd(Mxcmd)*(*)
C---
C Calculates the 2D Cross Correlation function.
C---
C Box       O  Region of interest.
C---
C 1996-Feb-19 - [AFT]
C---
      REAL      SYSMIN, SYSMAX
      PARAMETER (SYSMIN=-1.E32,SYSMAX=1.E32)
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   LENACT
      INTEGER   MXRAY
      PARAMETER (MXRAY=2048)
C
      DOUBLE PRECISION dsumb1, dsumb2, dsumd1, dsumd2
      REAL      bitmp(4), box(4)
      REAL      aveb, aved, rd, rdmin, rdmax, varb, vard
      INTEGER   iery(MXRAY)
      INTEGER   i, icntb, icntd, ier, imap, imxl,imyl, imxh, imyh, itmp
      INTEGER   j, jmap, l, l0, lhi, llo, m, m0, mhi, mlo
C
      CALL PTBUF('Cross correlate.',-1)
      CALL BOUQOB(box(1),box(2),box(3),box(4))
      CALL BOUQIB(bitmp(1),bitmp(2),bitmp(3),bitmp(4))
      box(1) = MIN(box(1), bitmp(1))
      box(2) = MIN(box(2), bitmp(2))
      box(3) = MAX(box(3), bitmp(3))
      box(4) = MAX(box(4), bitmp(4))
C Find corners of analysis box in map coordinates
      CALL POS_DT_IM(Box(1),Box(2),imxl,imyl)
      imxl = MIN(MAX(1,imxl),Nrow)
      imyl = MIN(MAX(1,imyl),Ncol)
      CALL POS_DT_IM(Box(3),Box(4),imxh,imyh)
      imxh = MIN(MAX(1,imxh),Nrow)
      imyh = MIN(MAX(1,imyh),Ncol)
C
      dsumb1=0.0d0
      dsumb2=0.0d0
      dsumd1=0.0d0
      dsumd2=0.0d0
      icntb=0
      icntd=0
      DO imap=imxl, imxh
         DO 180 jmap=imyl, imyh
            Resp(imap,jmap)=0.0
            IF ( Rmap(imap,jmap).NE.NO ) THEN
               dsumd1=dsumd1+Rmap(imap,jmap)
               dsumd2=dsumd2+Rmap(imap,jmap)*Rmap(imap,jmap)
               icntd=icntd+1
            END IF
            IF ( Back(imap,jmap).NE.NO ) THEN
               dsumb1=dsumb1+Back(imap,jmap)
               dsumb2=dsumb2+Back(imap,jmap)*Back(imap,jmap)
               icntb=icntb+1
            END IF
  180    CONTINUE
      END DO
      aved=dsumd1/icntd
      vard=SQRT(DBLE(icntd)*(dsumd2/icntd-aved*aved))
      aveb=dsumb1/icntb
      varb=SQRT(DBLE(icntb)*(dsumb2/icntb-aveb*aveb))
      write(*,*) 'aveb=',aveb,icntb
      write(*,*) 'aved=',aved,icntd
C
      DO imap=imxl, imxh
         DO 220 jmap=imyl, imyh
            IF ( Rmap(imap,jmap).EQ.NO ) GOTO 220
            llo = MAX(imap-Nccf,imxl)
            lhi = MIN(imap+Nccf,imxh)
            rd=(Rmap(imap,jmap)-aved)/vard
            DO l=llo, lhi
               l0 = l-imap
               mlo = MAX(jmap-Nccf,imyl)
               mhi = MIN(jmap+Nccf,imyh)
               DO m=mlo, mhi
                  m0 = m-jmap
                  IF ( Back(l,m).NE.NO ) THEN
                     Resp(l0,m0)=Resp(l0,m0)+rd*(Back(l,m)-aveb)/varb
                  END IF
               END DO
            END DO
  220    CONTINUE
      END DO
C
      Rdmax = SYSMIN
      Rdmin = SYSMAX
      DO i = -Nccf, Nccf
         DO j = -Nccf, Nccf
            rdmin=MIN(rdmin,Resp(i,j))
            rdmax=MAX(rdmax,Resp(i,j))
         END DO
      END DO
      write(*,*) 'Resp(0,0)=',Resp(0,0),rdmin,rdmax
C
      DO i=1, MXRAY
         iery(i) = 0
      END DO
      cmd(Ncmd+1)='ADJ ON'
      cmd(Ncmd+2)='COL OFF 1..999'
      cmd(Ncmd+3)='IMA CCT 3 LIN CBAR ON'
      Ncmd=Ncmd+4
      WRITE(cmd(Ncmd),*) 'IMA MIN ',rdmin,' MAX ',rdmax
      Ncmd=Ncmd+1
      WRITE(cmd(Ncmd),*) 'XAX LIN ',-nccf,' 1'
      Ncmd=Ncmd+1
      WRITE(cmd(Ncmd),*) 'YAX LIN ',-nccf,' 1'
      Ncmd=Ncmd+1
      WRITE(cmd(Ncmd),*) 'R ',-nccf-0.5,nccf+0.5,-nccf-0.5,nccf+0.5
      itmp=2*nccf+1
      CALL PLT(Resp,iery,itmp,itmp,itmp,Cmd,Ncmd,ier)
      RETURN
C
      END
