      SUBROUTINE GETANG(Xdpos,Ydpos,Xdref,Ydref,Angdeg)
      REAL      Xdpos, Ydpos, Xdref, Ydref
      REAL      Angdeg
C---
C Work out the position angle of two pixels (Xdpos,Ydpos) wrt (Xdref, Ydref)
C as Angdeg.
C---
C Xpos    I    X position
C Ypos    I    Y position
C Xdref   I    X position of reference point
C Ydref   I    Y position of reference point
C Angdeg    O  The angle in degrees
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
C
      REAL      difx, dify
      REAL      rtd
      DATA  rtd/57.2957795/
C
      difx = Xdref - xdpos
      dify = Ydref - ydpos
      IF ( difx.EQ.0.0 .AND. dify.EQ.0.0 ) THEN
         Angdeg = NO
      ELSE
         Angdeg = MOD(rtd*ATAN2(dify,difx)+180.0,360.0)
      END IF
C
      END
