      SUBROUTINE GETMEX(Lunft, Tinteg, Ier)
      INTEGER   Lunft, Ier
      REAL      Tinteg
C---
C Routine to calculate the ROSAT exposure map file to get exposure time.
C---
C Lunft   I    LUN of open FITS file.
C Tinteg    O  Integration time
C Ier       O  Error flag
C---
      CHARACTER cnam*128, ctmp*64
      REAL      rdata(100)
      REAL      rnul, rscale, tot, xdeth, xdetl, ydeth, ydetl
      INTEGER   naxes(99)
      INTEGER   i, ibegin, ibits, icx, icy, igcnt, igroup, ipcnt
      INTEGER   istat, itmp, ixmax, ixmin, iymax, iymin
      INTEGER   j, lun, naxis, nread
      LOGICAL   qbad, qsimp, qxtend
C---
      INQUIRE(UNIT=Lunft, NAME=cnam)
C Try standard FITS extention
      itmp = INDEX(cnam,'.fits')
      IF ( itmp.EQ.0 ) THEN
C Old ROSAT
         itmp = INDEX(cnam,'.qp')
      END IF
C
      IF ( itmp.LE.4 ) THEN
C Not long enough to contain '_bas'.
         Ier = 1
      ELSE
         IF ( cnam(itmp-4:itmp-1).EQ.'_bas' ) itmp = itmp-4
         cnam(itmp:)='_mex.fits'
         CALL GETLUN(lun)
         istat = 0
         CALL FTOPEN(lun,cnam,0,itmp,istat)
         IF ( istat.NE.0 ) THEN
            Ier = 1
            CALL FRELUN(lun)
            RETURN
         END IF
         CALL FTGHPR(lun,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
         CALL FTGKYJ(lun,'NAXIS1',naxes(1),ctmp,istat)
         CALL FTGKYJ(lun,'NAXIS2',naxes(2),ctmp,istat)
C
         CALL RFCQPR(ixmin, ixmax, iymin, iymax)
         rscale = naxes(1)/(ixmax-ixmin+1.)
         xdetl = 0.0
         xdeth = 0.0
         ydetl = 0.0
         ydeth = 0.0
         CALL BOUQIB(xdetl, ydetl, xdeth, ydeth)
         IF (xdeth.EQ.0. .OR. ydeth.EQ.0. ) THEN
            xdetl = 0.0
            xdeth = ixmax
            ydetl = 0.0
            ydeth = iymax
         END IF
C Note, 1 is added to convert from detector (start at 0) to map (start at 1)
C coordinates.
         icx = 1 + (xdetl+xdeth)*rscale/2.
         icx = MIN(MAX(2,icx),naxes(1)-1)
         icy = 1 + (ydetl+ydeth)*rscale/2.
         icy = MIN(MAX(2,icy),naxes(2)-1)
         write(*,*) 'GETMEX: location=',icx,icy
C
C Simple FITS image
C
         ibegin = 1 + naxes(1)*(icy-2)
         igroup = 0
         rnul = 0.
         tot = 0.
         nread = 3
         DO i = 1, 3
            CALL FTGPVE(lun,igroup,ibegin+icx-2,nread,rnul,
     &            rdata,qbad,istat)
            DO j = 1, 3
               tot = tot + rdata(j)
            END DO
            ibegin = ibegin + naxes(1)
         END DO
         Tinteg = tot/9.
      END IF
      RETURN
      END
