C*GRLDIT -- load image transfer function
C%void cpgldit(int iop, float *rlev, int nlev);
C+
      SUBROUTINE GRLDIT (iop, rlev, nlev)
      INTEGER   iop, nlev
      REAL      rlev(*)
C
C Load an Image Transfer Function for subsequent images drawn by
C PGIMAG, PGGRAY, or PGWEDG.  The Image Transfer Function is used
C to map array values into the available range of color indices
C specified with routine PGSCIR or (for PGGRAY on some devices)
C into dot density.
C
C Argument:
C  ITF    (input)  : type of transfer function:
C                      ITF = 0 : linear
C                      ITF = 1 : logarithmic
C                      ITF = 2 : square-root
C--
C 1995-Jan-13 - new routine [AFT].
C-----------------------------------------------------------------------
C
      INTEGER   MXTAB
      PARAMETER (MXTAB=257)
C
      REAL      RSAVE(MXTAB)
      SAVE      RSAVE
      INTEGER   I, ICIHI, ICILO
      SAVE      I, ICIHI, ICILO
C
      IF ( IOP.EQ.0 ) THEN
C Save table for future use
         CALL PGQCIR(ICILO, ICIHI)
         IF ( icilo+nlev.LE.icihi+1 ) THEN
            ICIHI = ICILO + NLEV
         END IF
C
         IF ( icihi+1.GT.MXTAB ) THEN
            CALL GRWARN('GRLDIT: table overflow.')
            icihi = MXTAB
         END IF
C
         DO I=ICILO, ICIHI+1
            RSAVE(I) = RLEV(I-ICILO+1)
         END DO
         I = (icilo+icihi)/2
      ELSE
C Look up level in saved table.
  200    CONTINUE
         IF ( I.GT.ICILO ) THEN
            IF ( rlev(1).LT.rsave(i) ) THEN
               I = I - 1
               GOTO 200
            END IF
         END IF
C
  250    CONTINUE
         IF ( I.LT.ICIHI ) THEN
            IF ( rlev(1).GT.rsave(i+1) ) THEN
               I = I + 1
               GOTO 250
            END IF
         END IF
C Return the color index that includes the input value
         nlev = i

      END IF

      END
