      SUBROUTINE IHISTO(Rmap, Mxrow, Nrow, Ncol, Smin, Smax,
     &      Cmd, Mxcmd, Ncmd)
      INTEGER   Mxrow, Nrow, Ncol, Mxcmd, Ncmd
      REAL      Rmap(Mxrow,*), Smin, Smax
      CHARACTER Cmd(Mxcmd)*(*)
C---
C Compute and display image histogram.
C---
C Rmap    I
C Mxrow   I
C Nrow    I
C Ncol    I
C Smin    I
C Smax    I
C Cmd     I/O
C Mxcmd   I
C Ncmd    I/O
C---
C 1992-Apr-21 - new routine [AFT]
C---
      INCLUDE 'scrat.inc'
C
      CHARACTER ctmp*80
      REAL      xdeth, xdetl, ydetl, ydeth
      INTEGER   iery(3)
      INTEGER   i, ier, imxh, imxl, imyh, imyl, ltmp
      INTEGER   nbin
      SAVE      nbin
      DATA nbin/512/
C
 100  CONTINUE
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.EQ.0 ) THEN
         WRITE (ctmp,111) smin, smax, nbin
 111     FORMAT (' Histo min and max (',1PG11.3,',',G11.3,
     :   '), NBINS(',I4,'):')
         CALL GTBUF(ctmp,ier)
         IF ( ier.NE.0 ) GOTO 100
      END IF
      CALL GTREAL(smin,ier)
      CALL GTREAL(smax,ier)
      CALL GTINT(nbin, ier)
      IF ( nbin.GT.MXSR*MXSC/2 ) THEN
         WRITE(*,*) 'Maximum number of bins is',MXSR*MXSC/2
         GOTO 100
      END IF
C---
      CALL BOUQOB(xdetl,ydetl,xdeth,ydeth)
      CALL POS_DT_IM(xdetl,ydetl,imxl,imyl)
      imxl = MIN(MAX(1,imxl),Nrow)
      imyl = MIN(MAX(1,imyl),Ncol)
      CALL POS_DT_IM(xdeth,ydeth,imxh,imyh)
      imxh = MIN(MAX(1,imxh),Nrow)
      imyh = MIN(MAX(1,imyh),Ncol)
C
      CALL MKHIST(Rmap, Mxrow, imxl, imxh, imyl, imyh,
     &            Smin, Smax, Rscrat, nbin)
C
C Integrate
      Rscrat(nbin+1) = Rscrat(1)
      DO i=2,nbin
         Rscrat(nbin+i) = Rscrat(nbin+i-1) + Rscrat(i)
      END DO
C Normalize
      DO i=1,nbin
         Rscrat(nbin+i) = Rscrat(nbin+i)/Rscrat(nbin+nbin)
      END DO
C
      iery(1) = 0
      iery(2) = 0
      Ncmd = Ncmd + 1
      CALL XAXIS(Smin, (Smax-Smin)/(Nbin-1.), Cmd(Ncmd))
C
      Cmd(Ncmd+1) = 'LINE STEP'
      Cmd(Ncmd+2) = 'LAB X  Intensity'
      Cmd(Ncmd+3) = 'LAB G1 Number'
      Cmd(Ncmd+4) = 'LAB T  Image Histogram'
      Cmd(Ncmd+5) = 'ERR Y  SQ 1'
      Cmd(Ncmd+6) = 'LAB G2 Integral'
      Cmd(Ncmd+7) = 'COL OF 2'
      Ncmd = Ncmd + 7
      CALL PLT(Rscrat,iery,nbin,nbin,2,Cmd,Ncmd,ier)
C
      RETURN
      END
