      INTEGER FUNCTION inpoly(Xpos, Ypos, Npts, Poly)
      REAL      Xpos, Ypos, Poly(2,Npts)
      INTEGER   Npts
C----
C Determine if point (Dx, DY) lies withing the polygon.
C---
C Xpos   I   X position
C Ypos   I   y position
C Npts   I   Number of points in polygon
C Poly   I   The polygon
C---
C 2014-04-01 - Adapted from Pt_in_Poly.c from HEASOFT [AFT]
C---
      REAL      xdel, xnext, xprev
      REAL      ydelf, ydelp, ynext, yprev
      INTEGER   i, iflag, j, jp
C---
      xnext=Poly(1,Npts)
      ynext=Poly(2,Npts)
      iflag=0
      DO 190 i=1,Npts
         xprev=xnext
         yprev=ynext
         xnext=Poly(1,i)
         ynext=Poly(2,i)
         IF ( (Ypos.GT.yprev .and. Ypos.GE.ynext) .OR.
     &        (Ypos.LT.yprev .and. Ypos.LE.ynext) .OR.
     &        (Xpos.GT.xprev .and. Xpos.GE.xnext) ) GOTO 190
C Check to see if Xpos, Ypos lies right on the segment...
         IF ( Xpos.GE.xprev .OR. Xpos.GT.xnext ) THEN
            ydelp=Ypos-yprev
            ydelf=ynext-yprev
            IF ( ABS(ydelf).LT.1e-7 ) THEN
               IF ( ABS(ydelp).LT.1e-7 ) THEN
                  inpoly=1
                  RETURN
               ELSE
                  GOTO 190
               END IF
            END IF
         END IF
         xdel=xprev-Xpos+((xnext-xprev)/ydelf)*ydelp
         IF ( xdel.LT.-1.e-7 ) GOTO 190
         IF ( xdel.LT.1.e-7 ) THEN
            inpoly=1
            RETURN
         END IF
C We have crossed a segment.  Make sure it is not a V point
         IF ( Ypos.NE.yprev ) THEN
            iflag=1-iflag
         ELSE
            jp=i
            DO j=1,npts-1
               jp=jp-1
               IF ( jp.LE.0 ) jp=npts
               IF ( Ypos.NE.Poly(2,jp) ) GOTO 170
            END DO
  170       CONTINUE
            IF ( (ynext-Ypos)*(Ypos-Poly(2,jp)).GT.0 ) THEN
               iflag=1-iflag
            END IF
         END IF
  190 CONTINUE
      inpoly=iflag
      RETURN
      END
