      SUBROUTINE IPROJ(Rmap, Mxrow, Nrow, Ncol, Qplot)
      INTEGER   Mxrow, Nrow, Ncol
      REAL      Rmap(Mxrow,*)
      LOGICAL   Qplot
C---
C LEXTRCT routine to plot the project of the image inside the current
C bounds onto the axis.
C---
C Rmap    I
C Mxrow   I
C Nrow    I
C Ncol    I
C Qplot   I    Is there an active plot device?
C
C Global:
C  Xdet
C  Ydet
C  Iwcs
C---
C original version  tam
C modified   kaa  11/10/85
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INCLUDE 'scrat.inc'
C machine min and max
      REAL      SYSMAX, SYSMIN
      PARAMETER (SYSMAX=1.E32,SYSMIN=-1.E32)
      INTEGER   LENACT
C
      CHARACTER cbuf*80, cdecd*3
      DOUBLE PRECISION ddec, dra
      REAL      wind(4)
      REAL      tmp, xdeth, xdetl, ydeth, ydetl
      REAL      xmin, xmax, ymin, ymax
      REAL      cnt, rdecs, rras, xmode, ymode
      INTEGER   i, idecm
      INTEGER   imx, imy, imx0, imxn, imy0, imyn, irah, iram
      INTEGER   icisav, ilwsav, isky, itmp, j, lbuf, nsrow
      INTEGER   ici, ilw
C
      nsrow = nrow + ncol + 1
      itmp = Mxsr*Mxsc/7
      IF ( nsrow.GT.itmp ) THEN
         WRITE(cbuf, 111) itmp
  111    FORMAT(' IPROJ--Error: rows+colums+1 must be <', I6)
         lbuf = LENACT(cbuf)
         CALL PTBUF(cbuf,lbuf)
         RETURN
      END IF
C
      CALL PROJ(Rmap,Mxrow,Nrow,Ncol,0,nsrow,Rscrat(1),
     &   Rscrat(1+nsrow),Rscrat(1+2*nsrow),Rscrat(1+3*nsrow),cnt)
C
C If there are no counts in the box then return
C
      IF ( cnt.EQ.0. ) THEN
         CALL PTBUF(' **  No counts in box  **', -1)
         RETURN
      END IF
C
C Do most of work in map coordinates.
C
      CALL BOUQOB(xdetl, ydetl, xdeth, ydeth)
      CALL POS_DT_IM(xdetl, ydetl, imx0, imy0)
      imx0 = MIN(MAX(1,imx0),Nrow)
      imy0 = MIN(MAX(1,imy0),Ncol)
      CALL POS_DT_IM(xdeth, ydeth, imxn, imyn)
      imxn = MIN(MAX(1,imxn),Nrow)
      imyn = MIN(MAX(1,imyn),Ncol)
C
C Find min and max values
      xmax = SYSMIN
      xmin = SYSMAX
      xmode = -1
      DO i = imx0, imxn
         IF ( Rscrat(i).GT.0. ) THEN
            Rscrat(i+nsrow) = Rscrat(i+nsrow)/Rscrat(i)
            IF ( Rscrat(i+nsrow).GT.xmax ) THEN
               xmax = Rscrat(i+nsrow)
               xmode = i
            END IF
            xmin = MIN(xmin,Rscrat(i+nsrow))
         END IF
      END DO
C Replace NO data values with the center point.
      DO i = imx0, imxn
         IF ( Rscrat(i).LE.0. ) THEN
            Rscrat(i+nsrow) = (xmax + xmin)/2.
         END IF
         CALL POS_MAP_DET(i, imy0, Rscrat(i), tmp)
      END DO
C
C Normalize y-array to area and counts
C
      ymax = SYSMIN
      ymin = SYSMAX
      ymode = -1
      DO j = imy0, imyn
         IF ( Rscrat(j+2*nsrow).GT.0. ) THEN
            Rscrat(j+3*nsrow) = Rscrat(j+3*nsrow)/Rscrat(j+2*nsrow)
            IF ( Rscrat(j+3*nsrow).GT.ymax ) THEN
               ymax = Rscrat(j+3*nsrow)
               ymode = j
            END IF
            ymin = MIN(ymin,Rscrat(j+3*nsrow))
         END IF
      END DO
C Replace NO data values with the center point.
      DO j = imy0, imyn
         IF ( Rscrat(j+2*nsrow).EQ.0. ) THEN
            Rscrat(j+3*nsrow) = (ymax + ymin)/2.
         END IF
         CALL POS_MAP_DET(imx0, j, tmp, Rscrat(j+2*nsrow))
      END DO
C
C If the plot device is active, then plot the results.
      IF ( Qplot ) THEN
         CALL PGQWIN(wind(1),wind(2),wind(3),wind(4))
         CALL PGQCI(icisav)
         CALL PGQLW(ilwsav)
         CALL SSGCLW(ici, ilw)
         CALL PGSCI(ici)
         CALL PGSLW(ilw)
C
C Plot out x histogram provided there are counts.
C
         IF ( imx0.NE.imxn .AND. xmax.NE.SYSMIN ) THEN
C
            CALL PGSWIN(wind(1),wind(2),xmin,xmin+5.*(xmax-xmin))
            CALL PGLINE(imxn-imx0+1,Rscrat(imx0),Rscrat(imx0+nsrow))
            IF ( xdetl.LE.0.0 .AND. xdeth.LE.0.0 ) THEN
C Plot zero line
               Rscrat(1) = xdetl
               Rscrat(1+nsrow) = 0.
               Rscrat(2) = xdeth
               Rscrat(2+nsrow) = 0.
               CALL PGLINE(2,Rscrat,Rscrat(1+nsrow))
            END IF
C
         END IF
C
C Plot y histogram
C
         IF ( imy0.NE.imyn .AND. ymax.NE.SYSMIN ) THEN
C
            CALL PGSWIN(ymin,ymin+5.*(ymax-ymin),wind(3),wind(4))
            CALL PGLINE(imyn-imy0+1,Rscrat(imy0+3*nsrow),
     &         Rscrat(imy0+2*nsrow))
            IF ( xdetl.LE.0.0 .AND. xdeth.LE.0.0 ) THEN
C Plot zero line
               Rscrat(1+2*nsrow) = ydetl
               Rscrat(1+3*nsrow) = 0.
               Rscrat(2+2*nsrow) = ydeth
               Rscrat(2+3*nsrow) = 0.
               CALL PGLINE(2,Rscrat(1+3*nsrow),Rscrat(1+2*nsrow))
            END IF
C
         END IF
         CALL PGUPDT
         CALL PGSWIN(wind(1),wind(2),wind(3),wind(4))
         CALL PGSCI(icisav)
         CALL PGSLW(ilwsav)
      END IF
C
C If xmax or ymax are equal to their initial values then there is not enough
C information to determine the mode of the emission
C
      IF ( xmax.EQ.SYSMIN .OR. ymax.EQ.SYSMIN ) THEN
         CALL PTBUF(' **  No mode found in one direction  **', -1)
      END IF
C
C Print information on the mode of the data to the terminal. mode given in
C detector coordinates and RA and dec if possible
C
      Imx = INT(xmode+.5)
      Imy = INT(ymode+.5)
      CALL POS_MAP_DET(Imx, Imy, Xdet, Ydet)
C
      WRITE(cbuf,191) Xdet, Ydet
 191  FORMAT(' Modes- x : ',F8.1,'   y : ',F8.1)
      lbuf = LENACT(cbuf)
      CALL PTBUF(cbuf,lbuf)
C
      IF ( Iwcs.NE.0 ) THEN
         CALL POS_DT_RA(Xdet, Ydet, dra, ddec)
         CALL POS_SKY(isky)
         IF ( isky.NE.0 ) THEN
            CALL POS_DEG_HMS(dra,ddec,irah,iram,rras,
     &         cdecd,idecm,rdecs)
            WRITE(cbuf,221) irah, iram, rras, cdecd, idecm, rdecs
 221        FORMAT(' ',I4,I3,1X,F5.2,', ',A3,I3,1X,F4.1,'  (')
            lbuf = LENACT(cbuf)
            rras = dra
            CALL CRAMFF(rras, 11, 4, cbuf, lbuf)
            cbuf(lbuf+1:lbuf+1) = ','
            lbuf = lbuf + 2
            rdecs = ddec
            CALL CRAMFF(rdecs, 10, 4, cbuf, lbuf)
            cbuf(lbuf+1:lbuf+1) = ')'
            lbuf = lbuf + 1
         ELSE
            cbuf = ' Corresponding to: '
            lbuf = LENACT(cbuf)
            rras = dra
            CALL CRAMFF(rras, 10, -4, cbuf, lbuf)
            cbuf(lbuf+1:lbuf+2) = ', '
            lbuf = lbuf + 2
            rdecs = ddec
            CALL CRAMFF(rdecs, 10, -4, cbuf, lbuf)
         END IF
         CALL PTBUF(cbuf,lbuf)
      END IF
C
      RETURN
      END
