      SUBROUTINE Iscale(Rmap, Mxrow, Nrow, Ncol, Itype, Scoff, Scfac,
     &      Rdmin, Rdmax, Imx, Imy)
      INTEGER   Mxrow, Nrow, Ncol, Itype, Imx, Imy
      REAL      Rmap(Mxrow, *)
      REAL      Scoff, Scfac, Rdmin, Rdmax
C---
C LEXTRCT routine to multiply current map by a scale factor and add
C an offset.  Scoff=0.0 and Scfac=1.0 will leave current map
C unaffected, but will reset min and max values.
C---
C Rmap    I    Map containing data values
C Mxrow   I
C Nrow    I
C Ncol    I
C Itype   I    =0 no scale, =1 linear, =2 SQRT, =3 LOG
C Scoff   I
C Sfac    I
C Rdmin     O  Min value in map
C Rdmax     O  Max value in map
C Imx       O  X map coordinate of first highest pixel
C Imy       O  Y map coordinate of first highest pixel
C---
C Machine min and max
      REAL      SYSMIN, SYSMAX
      PARAMETER (SYSMIN=-1.E32,SYSMAX=1.E32)
C No data flag
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   INBOU
C
      REAL     rmnnz, xpos, ypos
      INTEGER  i, ixmn, ixmx, ixnz, iymn, iymx, iynz, j
C
      Rdmax = SYSMIN
      Rdmin = SYSMAX
      rmnnz = SYSMAX
      ixmn =0
      ixmx =0
      ixnz =0
      iymn =0
      iymx =0
      iynz =0
      DO i = 1, Ncol
         DO j = 1, Nrow
            IF ( Rmap(j,i).NE.NO ) THEN
               IF ( Itype.EQ.1 ) THEN
                  Rmap(j,i)= Scfac*(Rmap(j,i)-Scoff)
               ELSE IF ( Itype.EQ.2 ) THEN
                  Rmap(j,i)= SQRT(MAX(0.0,Scfac*(Rmap(j,i)-Scoff)))
               ELSE IF ( Itype.EQ.3 ) THEN
C                 Rmap(j,i)= LOG10(MAX(1.0,1.0+Scfac*(Rmap(j,i)-Scoff)))
                  IF ( Scfac*(Rmap(j,i)-Scoff).LE.0.0 ) THEN
                     Rmap(j,i)=NO
                  ELSE
                     Rmap(j,i)= LOG10(Scfac*(Rmap(j,i)-Scoff))
                  END IF
               ELSE IF ( Itype.EQ.4 ) THEN
                  CALL POS_MAP_DET(j,i,xpos,ypos)
                  IF ( INBOU(xpos, ypos).GT.0 ) THEN
                     Rmap(j,i) = Scfac*(Rmap(j,i)-Scoff)
                  END IF
               END IF
               IF ( Rmap(j,i).LT.Rdmin ) THEN
                  Rdmin = Rmap(j,i)
                  ixmn = j
                  iymn = i
               END IF
               IF ( Rmap(j,i).NE.0.0 .AND. Rmap(j,i).LT.rmnnz ) THEN
                  rmnnz = Rmap(j,i)
                  ixnz = j
                  iynz = i
               END IF
               IF ( Rmap(j,i).GT.Rdmax ) THEN
                  Rdmax = Rmap(j,i)
                  ixmx = j
                  iymx = i
               END IF
            END IF
         END DO
      END DO
      Imx = ixmx
      Imy = iymx
C
      END
