      SUBROUTINE LEXOPN(Lun, Inter, Cnam, Lnam, Inew, Ier)
      INTEGER   Lun, Inter, Lnam, Inew, Ier
      CHARACTER Cnam*(*)
C---
C Open either a FITS file for reading.
C---
C Lun     I    Logical unit number to be opened.
C Inter   I    =1 prompt for name, =0 use Cnam(:lnam)
C Cnam    I/O  Name of file
C Lnam    I/O  Number of valid characters in Cnam
C Inew      O  =0 if new file has same name as old, =1 different name
C Ier       O  =0 file has been opened, >0 file not opened, =-1 user
C              -entered 'none' as a filename
C---
      CHARACTER ctmp*256, cdum*4
      INTEGER   iblk, itmp, ltmp
C---
      ctmp = Cnam
      ltmp = Lnam
C If a filename was not passed in, then prompt the user for name.
      IF ( Inter.NE.0 .OR. Lnam.LE.0 ) THEN
         Ier = 0
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.EQ.0 ) THEN
            IF ( Lnam.EQ.0 ) THEN
               ctmp = 'File name ( ):'
            ELSE
               ctmp = 'File name (' // Cnam(1:Lnam) // '):'
            END IF
            CALL GTBUF(ctmp,Ier)
         END IF
         IF ( Ier.EQ.0 ) THEN
            CALL GTCHAR(ctmp,ltmp)
            IF ( ltmp.EQ.0 ) THEN
               ctmp = Cnam
               ltmp = Lnam
            END IF
         END IF
         IF ( Ier.NE.0 .OR. ltmp.EQ.0 ) THEN
C User refused to enter a file name.
            Ier = 1
            RETURN
         END IF
      END IF
C---
C Flag case where user enters none.
      IF ( ltmp.EQ.4 ) THEN
         cdum = ctmp
         call UPC(cdum)
         IF ( cdum.EQ.'NONE' ) THEN
            Ier = -1
            RETURN
         END IF
      END IF
C
C Now open the file.  First, try to open a FITS file in the default case.
      CALL XTEND(ctmp,'fit')
      Ier = 0
      CALL FTCLOS(Lun, Ier)
      Ier = 0
      CALL FTOPEN(Lun, ctmp(:ltmp), 0, iblk, Ier)
C
      IF ( Ier.NE.0 ) THEN
         CALL CONC(ctmp(:ltmp))
C Preserve ier from the original call to ftopen.
         CALL FTOPEN(Lun,ctmp(:ltmp),0,iblk,itmp)
         IF ( itmp.EQ.0 ) Ier = 0
      END IF
C
      IF ( Ier.EQ.0 ) THEN
         IF ( Cnam(:Lnam).EQ.ctmp) THEN
            Inew = 0
         ELSE
            Inew = 1
            Cnam = ctmp
            Lnam = ltmp
         END IF
      END IF
      RETURN
      END
