      SUBROUTINE Mbad(Rmap, Mxrow, Nrow, Ncol, Qplot, Icnt)
      INTEGER   Mxrow, Nrow, Ncol, Icnt
      REAL      Rmap(Mxrow,*)
      LOGICAL   Qplot
C---
C LEXTRCT routine to mark all map pixels in the inner box as NO data.
C---
C Rmap    I/O  Map containing data values
C Mxrow   I
C Nrow    I
C Ncol    I
C Qplot
C Icnt      O  The number of pixels changed
C---
C Machine min and max
      REAL      SYSMIN, SYSMAX
      PARAMETER (SYSMIN=-1.E32,SYSMAX=1.E32)
C No data flag
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INTEGER   INBOU, LENACT
C
      CHARACTER cpeek*80, ctmp*80
      CHARACTER cfile*256
      CHARACTER ccol*16
      DOUBLE PRECISION dsum, ddec, dnul, dra
      REAL      ang, ave, ca, cts, flimit, prad, psig
      REAL      r2, rhi, rhidef, rlo
      REAL      rlodef, rnul, rsig, rtot1, rtot2, sa, sigx, sigy
      REAL      tmp, xpos, xsigma, xtmp, xp, ypos, yp, ytmp
      INTEGER   naxes(99)
      INTEGER   i, i1, iblk, ibits, ifcol, idcol, idolev, ier, iext
      INTEGER   igcnt, ihi, ilo, inside, ipcnt, iccol, iecol
      INTEGER   ira, ircol, isour, istat, isxcol, isycol, ithcol
      INTEGER   itmp, ixcol, ixmap, iycol, iymap
      INTEGER   j, j1, lfile, lpeek, ltmp, luntmp, naxis, nrows, ntot
      LOGICAL   qbad, qfail, qlo, qsimp, qxtend
      REAL      rtd
      DATA  rtd/57.2957795/
C
      CALL GTPEEK(cpeek,lpeek)
      IF ( lpeek.LE.0 ) THEN
       CALL GTBUF('Bounds, Row, Column, Pixel, Lower, Above, File:',ier)
      END IF
C
      dsum = 0.0D0
      Icnt = 0
  100 CONTINUE
         CALL GTCHAR(ctmp, ltmp)
         IF ( ltmp.EQ.0 ) GOTO 900
         CALL UPC(ctmp(:ltmp))
         IF ( ctmp(1:1).EQ.'B' ) THEN
C Bounds
            CALL GTPEEK(cpeek,lpeek)
            IF ( lpeek.LE.0 ) THEN
               CALL GTBUF('Inside, Outside:', ier)
            END IF
            ctmp = ' '
            CALL GTCHAR(ctmp, ltmp)
            CALL UPC(ctmp(:ltmp))
            inside = 1
            IF ( ctmp(1:1).EQ.'O' ) THEN
               inside = 0
            ELSE IF ( ctmp(1:1).EQ.'I' ) THEN
               inside = 1
            ELSE
        CALL PTBUF(' MBAD--Must specify one of Inside or Outside.', -1)
               GOTO 900
            END IF
            DO i = 1, Ncol
               DO j = 1, Nrow
                  IF ( Rmap(j,i).NE.NO ) THEN
                     CALL POS_MAP_DET(j,i,xpos,ypos)
                     itmp = ABS(INBOU(xpos,ypos))
                     IF ( Inside.EQ.0 ) itmp = 1 - itmp
                     IF ( itmp.GT.0 .AND. Rmap(j,i).NE.NO ) THEN
                        dsum = dsum + Rmap(j,i)
                        Icnt = Icnt + 1
                        Rmap(j,i) = NO
                     END IF
                  END IF
               END DO
            END DO
         ELSE IF ( ctmp(1:1).EQ.'C' ) THEN
C Column
            CALL GTPEEK(cpeek, lpeek)
            IF ( lpeek.LE.0 ) THEN
               CALL GTBUF('Column range:', ier)
               IF ( ier.NE.0 ) GOTO 100
            END IF
            Rlodef = NO
            Rhidef = NO
            CALL GTCHAR(ctmp, ltmp)
            CALL GRANG(ctmp,ltmp,rlodef,rhidef,rlo,rhi,Ier)
            Xdet = rlo
            CALL POS_DT_IM(Xdet, Ydet, ilo, itmp)
            ilo = MIN(MAX(1,ilo),Nrow)
            Xdet = rhi
            CALL POS_DT_IM(Xdet, Ydet, ihi, itmp)
            ihi = MIN(MAX(1,ihi),Nrow)
            DO i=ilo, ihi
               DO j=1, Nrow
                  IF ( Rmap(i,j).NE.NO ) THEN
                     dsum = dsum + Rmap(i,j)
                     Icnt = Icnt + 1
                     Rmap(i,j) = NO
                  END IF
               END DO
            END DO
         ELSE IF ( ctmp(1:1).EQ.'D' ) THEN
C Diagonal - Note this was an attempt to remove cosmic rays.  Didn't
C really work.
            CALL GTPEEK(cpeek,lpeek)
            IF ( lpeek.LE.0 ) THEN
               CALL GTBUF('N_sigma:', ier)
            END IF
            ctmp = ' '
            rsig = 3.0
            CALL GTREAL(rsig, ier)
            DO i = 2, Ncol-1
               DO j = 2, Nrow-1
                  IF ( Rmap(j,i).EQ.NO ) GOTO 250
                  ntot = 0
                  rtot1 = 0.0
                  rtot2 = 0.0
                  DO i1=-1,1
                     DO j1=-1,1
                        IF ( (i1.NE.0 .OR. j1.NE.0) .AND.
     &                        Rmap(j+j1,i+i1).NE.NO ) THEN
         if ( i.eq.47 .and. j.eq.373 ) write(*,*) i1,j1,Rmap(j+j1,i+i1)
                           ntot = ntot + 1
                           rtot1 = rtot1+Rmap(j+j1,i+i1)
                           rtot2 = rtot2+Rmap(j+j1,i+i1)*Rmap(j+j1,i+i1)
                        END IF
                     END DO
                  END DO
                  ave = rtot1/ntot
                  psig = SQRT(rtot2/ntot - ave*ave)
         if ( i.eq.47 .and. j.eq.373 ) write(*,*)
     &      ntot,rtot1,rtot2,ave,psig,Rmap(j,i)
                  IF ( Rmap(j,i).GT.ave+rsig*psig ) THEN
                     dsum = dsum + Rmap(j,i)
                     Icnt = Icnt + 1
                     Rmap(j,i) = NO
                  END IF
  250             CONTINUE
               END DO
            END DO
         ELSE IF ( ctmp(1:1).EQ.'F' ) THEN
C File
            CALL GETLUN(luntmp)
            CALL GTCHAR(cfile, lfile)
            istat = 0
            CALL FTOPEN(luntmp, cfile, 0, iblk, istat)
            CALL FTGHPR(luntmp,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,
     &         qxtend,istat)
            IF ( istat.NE.0 ) THEN
               CALL PTBUF('MBAD--Failed to open file.',-1)
               CALL FRELUN(luntmp)
               GOTO 900
            END IF
            CALL GTPEEK(cpeek,lpeek)
            CALL UPC(cpeek(1:1))
            IF ( cpeek(1:1).EQ.'L' ) THEN
               idolev = 1
               CALL GTCHAR(ctmp, ltmp)
            ELSE
               idolev = 0
            END IF
            xsigma = 2.0
            CALL GTREAL(xsigma, ier)
C Go to 2nd HDU.
            istat = 0
            CALL FTMAHD(luntmp, 2, iext, istat)
            CALL FTGKYJ(luntmp, 'NAXIS2', nrows, ctmp, istat)
C
C Look for RA/Dec first, then X/Y.  If neither pair found, don't use file.
            istat = 0
            ira = 1
            CALL FTGCNN(luntmp, .FALSE., 'RA',  ccol, ircol, istat)
            CALL FTGCNN(luntmp, .FALSE., 'DEC', ccol, idcol, istat)
            IF ( istat.NE.0 ) THEN
               istat = 0
               ira = 0
C FTGCNN will match 'X' with 'XCEN', but with 'X ' this does not happen.
               CALL FTGCNN(luntmp, .FALSE., 'X ', ccol, ixcol, istat)
               CALL FTGCNN(luntmp, .FALSE., 'Y ', ccol, iycol, istat)
               IF ( istat.NE.0 ) THEN
                  istat=0
                  CALL FTCLOS(luntmp, istat)
                  CALL FRELUN(luntmp)
                  GOTO 900
               END IF
            END IF
C
C Check to see if 'SIG' or 'SIGX,SIGY,THETA' are in the file.
            iccol=0
            iecol=0
            CALL FTGCNN(luntmp, .FALSE., 'SIG', ccol, iccol, istat)
            IF ( istat.NE.0 ) THEN
               istat = 0
               CALL FTGCNN(luntmp, .FALSE., 'SIGX', ccol, isxcol, istat)
               CALL FTGCNN(luntmp, .FALSE., 'SIGY', ccol, isycol, istat)
               CALL FTGCNN(luntmp, .FALSE., 'THETA',ccol, ithcol, istat)
C Only if all three columns are defined.
               IF ( istat.EQ.0 ) iecol=1
            END IF
C
            istat = 0
            CALL FTGCNN(luntmp, .FALSE., 'SEST', ccol, ifcol, istat)
            WRITE(*,*) 'Doing',nrows,' sources.'
            DO isour=1, nrows
               istat = 0
               IF ( ira.NE.0 ) THEN
                CALL FTGCVD(luntmp,ircol,isour,1,1,dnul,dra, qbad,istat)
                CALL FTGCVD(luntmp,idcol,isour,1,1,dnul,ddec,qbad,istat)
                  CALL POS_RA_DT(dra,ddec,xtmp,ytmp)
               ELSE
                CALL FTGCVE(luntmp,ixcol,isour,1,1,rnul,xtmp,qbad,istat)
                CALL FTGCVE(luntmp,iycol,isour,1,1,rnul,ytmp,qbad,istat)
               END IF
               IF ( iccol.GT.0 ) THEN
                CALL FTGCVE(luntmp,iccol,isour,1,1,rnul,prad,qbad,istat)
                  sigx = prad
                  sigy = prad
                  ang=0.0
               ELSE IF (iecol.NE.0 ) THEN
                  istat=0
              CALL FTGCVE(luntmp,isxcol,isour,1,1,rnul,sigx,qbad,istat)
              CALL FTGCVE(luntmp,isycol,isour,1,1,rnul,sigy,qbad,istat)
              CALL FTGCVE(luntmp,ithcol,isour,1,1,rnul,ang ,qbad,istat)
               ELSE
                  CALL PSGELL(xtmp, ytmp, sigx, sigy, ang)
               END IF
               ca = COS(ang/rtd)
               sa = SIN(ang/rtd)
               IF ( sigx.LT.Ifac ) sigx = Ifac
               IF ( sigy.LT.Ifac ) sigy = Ifac
               IF ( idolev.NE.0 .AND. ifcol.NE.0 ) THEN
                CALL FTGCVE(luntmp,ifcol,isour,1,1,rnul,cts,qbad,istat)
                  r2 = 4.*((cts/xsigma)**0.25-1)
      write(*,*) isour,cts,xsigma,sqrt(r2)
               ELSE
                  r2 = xsigma*xsigma
               END IF
               DO i=1, Ncol
                  DO j=1, Nrow
                     IF ( Rmap(j,i).NE.NO ) THEN
                        CALL POS_MAP_DET(j,i,xpos,ypos)
                        xp = (xpos-xtmp)*ca + (ypos-ytmp)*sa
                        yp =-(xpos-xtmp)*sa + (ypos-ytmp)*ca
                        tmp = (xp/sigx)**2 + (yp/sigy)**2
                        IF ( tmp.LE.r2 ) THEN
                           dsum = dsum + Rmap(j,i)
                           Icnt = Icnt + 1
                           Rmap(j,i) = NO
                        END IF
                     END IF
                  END DO
               END DO
            END DO
            CALL FTCLOS(luntmp, istat)
            CALL FRELUN(luntmp)
         ELSE IF ( ctmp(1:1).EQ.'L' .OR. ctmp(1:1).EQ.'A'
     &        .OR. ctmp(1:1).EQ.'U' ) THEN
C Lower/Above limit
            IF ( ctmp(1:1).EQ.'L' ) THEN
               qlo = .TRUE.
            ELSE
               qlo = .FALSE.
            END IF
            CALL GTPEEK(cpeek,lpeek)
            IF ( lpeek.LE.0 ) THEN
               CALL GTBUF('Value:', ier)
            END IF
C get actual limit
            CALL GTREAL(flimit, ier)
            IF ( ier.NE.0 ) THEN
               CALL PTBUF('You must enter a numeric value.',-1)
               GOTO 900
            END IF
            DO i = 1, Ncol
               DO j = 1, Nrow
                  IF ( Rmap(j,i).NE.NO ) THEN
                     CALL POS_MAP_DET(j,i,xpos,ypos)
                     itmp = MAX(0, INBOU(xpos,ypos) )
                     IF ( itmp.GT.0 .AND. Rmap(j,i).NE.NO ) THEN
                        IF ( (qlo .AND. Rmap(j,i).LT.flimit) .OR.
     &                  (.NOT.qlo .AND. Rmap(j,i).GE.flimit) ) THEN
                           dsum = dsum + Rmap(j,i)
                           Icnt = Icnt + 1
                           Rmap(j,i) = NO
                        END IF
                     END IF
                  END IF
               END DO
            END DO
         ELSE IF ( ctmp(1:1).EQ.'N' ) THEN
C NANs
            DO i = 1, Ncol
               DO j = 1, Nrow
                  IF ( Rmap(j,i).NE.Rmap(j,i) ) THEN
                     Icnt = Icnt + 1
                     Rmap(j,i) = NO
                  END IF
               END DO
            END DO
         ELSE IF ( ctmp(1:1).EQ.'P' ) THEN
C Pixel
            IF ( ctmp(1:2).EQ.'PL' ) CALL PTBUF('Type - to exit.',-1)
  270       CONTINUE
            CALL ASKPOS(Qplot,qfail)
            IF ( qfail ) GOTO 100
            CALL POS_DT_IM(Xdet, Ydet, ixmap, iymap)
            IF ( ixmap.LE.0 .OR. Nrow.LT.ixmap .OR.
     &           iymap.LE.0 .OR. Ncol.LT.iymap ) THEN
               CALL PTBUF(' Pixel not on map.', -1)
               GOTO 100
            END IF
            IF ( Rmap(ixmap,iymap).NE.NO ) THEN
               dsum = dsum + Rmap(ixmap,iymap)
               Icnt = Icnt + 1
               Rmap(ixmap,iymap) = NO
            END IF
            IF ( ctmp(1:2).EQ.'PL' ) GOTO 270
         ELSE IF ( ctmp(1:1).EQ.'R' ) THEN
C Row
            CALL GTPEEK(cpeek, lpeek)
            IF ( lpeek.LE.0 ) THEN
               CALL GTBUF('Row range:', ier)
               IF ( ier.NE.0 ) GOTO 100
            END IF
            Rlodef = NO
            Rhidef = NO
            CALL GTCHAR(ctmp, ltmp)
            CALL GRANG(ctmp,ltmp,rlodef,rhidef,rlo,rhi,Ier)
            Ydet = rlo
            CALL POS_DT_IM(Xdet, Ydet, itmp, ilo)
            ilo = MIN(MAX(1,ilo),Ncol)
            Ydet = rhi
            CALL POS_DT_IM(Xdet, Ydet, itmp, ihi)
            ihi = MIN(MAX(1,ihi),Ncol)
            DO i=1, Ncol
               DO j=ilo, ihi
                  IF ( Rmap(i,j).NE.NO ) THEN
                     dsum = dsum + Rmap(i,j)
                     Icnt = Icnt + 1
                     Rmap(i,j) = NO
                  END IF
               END DO
            END DO
         ELSE
            CALL PTBUF('Unknown command.  Token='//ctmp(:ltmp), -1)
         END IF
      CALL GTPEEK(cpeek,lpeek)
      IF ( lpeek.GT.0 ) GOTO 100
C
  900 CONTINUE
      WRITE(ctmp,901) Icnt,dsum
  901 FORMAT(I9,' pixels containing ',F11.0,
     &         ' counts were marked as bad.')
      ltmp = LENACT(ctmp)
      CALL PTBUF(ctmp,ltmp)
C
      END
