      SUBROUTINE MKCOL(Rmap, Mxrow, Nrow, Ncol, Smin, Smax)
      INTEGER   Mxrow, Nrow, Ncol
      REAL      Rmap(Mxrow,*), Smin, Smax
C---
C This is an internal LEXTRCT routine that tries to set Smin, and
C Smax values so give a pleasing color table.
C---
C [AFT]
C---
      INCLUDE 'scrat.inc'
C
      REAL      frac, sum, tmp, xdeth, xdetl, ydetl, ydeth
      INTEGER   i, i1, i2, icnt, ihi, ilo, j1, j2
      INTEGER   nbin
      SAVE      nbin
      DATA nbin/512/
C
      CALL BOUQOB(xdetl,ydetl,xdeth,ydeth)
      CALL POS_DT_IM(xdetl,ydetl,i1,j1)
      i1 = MIN(MAX(1,i1),Nrow)
      j1 = MIN(MAX(1,j1),Ncol)
      CALL POS_DT_IM(xdeth,ydeth,i2,j2)
      i2 = MIN(MAX(1,i2),Nrow)
      j2 = MIN(MAX(1,j2),Ncol)
      write(*,*) Smin,Smax
C
      icnt = 0
  100 CONTINUE
      CALL MKHIST(Rmap, Mxrow, i1, i2, j1, j2,
     &            Smin, Smax, Rscrat, nbin)
C
C frac is the number of pixels that should be in the bottom and top bins.
C If fewer pixels are in these bins, then they could be noise points and
C should be ignored.
      frac = 0.5*(i2-i1+1)*(j2-j1+1)/nbin
C Check number of pixels minimum color index.
      ilo = 1
      IF ( Rscrat(1).LT.frac ) THEN
         sum = 0.0
         DO i = 1, nbin
            sum = sum + Rscrat(i)
            IF ( sum.GT.frac ) GOTO 140
            ilo = i
         END DO
  140    CONTINUE
      END IF
C
C Check number of pixels maximum color index.
      ihi = nbin
      IF ( Rscrat(nbin).LT.frac ) THEN
         sum = 0.0
         DO i = nbin,1,-1
            sum = sum + Rscrat(i)
            IF ( sum.GT.frac ) GOTO 160
            ihi = i
         END DO
  160    CONTINUE
      END IF
      write(*,*) 'ILO, IHI=',ilo,ihi
      IF ( ilo.NE.1 .OR. ihi.NE.nbin ) THEN
         tmp  = Smin + (Smax-Smin)*(ilo-1.)/(nbin-1.)
         Smax = Smin + (Smax-Smin)*(ihi-1.)/(nbin-1.)
         Smin = tmp
      write(*,*) Smin,Smax
C If there was a big adjustment, then recalculate histogram and adjustment.
         IF ( ihi-ilo+1.LT.0.9*nbin ) THEN
            icnt = icnt + 1
            IF ( icnt.LE.3 ) GOTO 100
         END IF
      END IF
      RETURN
      END
