      SUBROUTINE PCROSS(Brad, Srad, Xpos, Ypos, Qplot)
      REAL      Brad, Srad, Xpos, Ypos
      LOGICAL   Qplot
C---
C Subroutine to plot position indicators on the image.
C---
C Brad    I    Radius of background region (in units of SIG)
C Srad    I    Radius of source region (in units of SIG)
C Xysour  I    X,Y coordinates to be plotted
C Qplot   I    is plot device active?
C---
C 2000-07-31 - Update [AFT]
C kaa  15/10/85
C---
C
      REAL      xp(2), yp(2)
      REAL      rsig, rin, rout, xpoint, ypoint
C---
      IF ( Qplot ) THEN
C
         xpoint = Xpos
         ypoint = Ypos
         CALL PSFSIG(xpoint, ypoint, rsig)
C
C Draw horizontal indicator lines
         rin = srad*rsig
         rout = brad*rsig
         xp(1) = xpoint + rin
         xp(2) = xpoint + rout
         yp(1) = ypoint
         yp(2) = yp(1)
         CALL PGLINE(2,xp,yp)
C
         xp(1) = xpoint - rin
         xp(2) = xpoint - rout
         yp(1) = ypoint
         yp(2) = yp(1)
         CALL PGLINE(2,xp,yp)
C
C Draw vertical lines
         xp(1) = xpoint
         xp(2) = xp(1)
         yp(1) = ypoint + rin
         yp(2) = ypoint + rout
         CALL PGLINE(2,xp,yp)
C
         xp(1) = xpoint
         xp(2) = xp(1)
         yp(1) = ypoint - rin
         yp(2) = ypoint - rout
         CALL PGLINE(2,xp,yp)
C
         CALL PGSFS(2)
         CALL PGCIRC(Xpos, Ypos, rin)
C
         CALL PGUPDT
C
      END IF
C
      RETURN
      END
