      SUBROUTINE PDSEL(Ctype, Qnew, Qplot)
      CHARACTER Ctype*2
      LOGICAL   Qnew, Qplot
C Entry points
      LOGICAL   Qimage, Qfail
      CHARACTER Cimage*(*)
C---
C LEXTRCT can plot both images and line graphics on the PGPLOT device.
C This routine keeps track of which type was last plotted, and if
C requested type is different, calls to clear the device.  This allows
C neat effects, such as the IP command will plot on top of an existing
C image, but erase a line graphic before being plotted.
C---
C Ctype   I    Use IM or LI to select either image or line graphics.
C Qnew    I/O  If pgbegin called, set to .TRUE., otherwise not changed.
C Qplot     O  =.TRUE. if a valid plot device is open.
C---
C 1992-May-06 - [AFT]
C---
      INTEGER   PGBEGIN
C
      CHARACTER cimdev*64
      SAVE      cimdev
      INTEGER   istat
      LOGICAL   qimdef, qimact, qliact
      SAVE      qimdef, qimact, qliact
      DATA qimdef/.FALSE./, qimact/.FALSE./, qliact/.FALSE./
C
      IF ( .NOT.qimdef ) THEN
         CALL TTWRT(' Plot device has not been set.',-1)
      ELSE
         IF ( Ctype.EQ.'IM' ) THEN
C Image
            IF ( .NOT.qimact ) THEN
               istat = PGBEGIN(0, cimdev, 1, 1)
               Qnew = .TRUE.
               IF ( istat.NE.1 ) THEN
                  qimdef = .FALSE.
                  qimact = .FALSE.
                  qliact = .FALSE.
               ELSE
                  qimact = .TRUE.
                  qliact = .FALSE.
                  CALL PGASK(.FALSE.)
               END IF
            END IF
         ELSE
C Line graphics
            IF ( .NOT.qliact ) THEN
               istat = PGBEGIN(0, cimdev, 1, 1)
               Qnew = .TRUE.
               IF ( istat.NE.1 ) THEN
                  qimdef = .FALSE.
                  qimact = .FALSE.
                  qliact = .FALSE.
               ELSE
                  qimact = .FALSE.
                  qliact = .TRUE.
                  CALL PGASK(.FALSE.)
               END IF
            END IF
         END IF
      END IF
C
      Qplot = qimact .OR. qliact
C
      RETURN
C*********
      ENTRY PDDEFS(Qimage)
C---
C If Qimage=.TRUE. then the plot device has been defined.
C---
      Qimage = qimdef
      RETURN
C*********
      ENTRY PDIMAG(Cimage, Qfail)
C---
C Define the plot device.
C---
      IF ( qimact ) THEN
         CALL PGEND
         qimact = .FALSE.
      END IF
C
C Open the device to see if user gave a valid device spec.
C
      istat = PGBEGIN(0, Cimage, 1, 1)
      IF ( istat.EQ.1 ) THEN
         cimdev = Cimage
         qimdef = .TRUE.
         qimact = .FALSE.
         qliact = .FALSE.
         Qfail  = .FALSE.
         CALL PGASK(.FALSE.)
      ELSE
         Qfail  = .TRUE.
      END IF
C
      RETURN
C
      END
