      SUBROUTINE PICKAR(Iaray, Cnam, Lnam, Ier)
      INTEGER   Iaray, Lnam, Ier
      CHARACTER Cnam*(*)
C---
C Reads the current input buffer for the options, Data, Background, Response,
C Subtracted, and Corrected.  If Subtract is entered, and the background
C subtracted map has not been calculated, then this routine will do the
C subtraction.
C---
C Iaray     O  1-->5 for D, B, R, S, C; unchanged if user did not enter
C              -a valid character.
C Cnam      O  File name of selected data set
C Lnam      O  active length of Cnam
C Ier       O  <>0 if an error occured
C---
C 1996-Feb-19 - [AFT]
C---
      REAL      SYSMIN, SYSMAX
      PARAMETER (SYSMIN=-1.E32,SYSMAX=1.E32)
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'mapdef.inc'
      INTEGER   LENACT
C
      CHARACTER cbuf*128
      CHARACTER cpeek*64
      CHARACTER cfile(3)*4
      REAL      rdmin, rdmax, tcor
      INTEGER   i, ifile, ix, j, lbuf, lpeek
      DATA   cfile/'data','back','resp'/
C
C Peek at input beffer, and decode
      Ier = 0
      ifile = 0
      CALL GTPEEK(cpeek,lpeek)
      IF ( lpeek.GT.0 ) THEN
         CALL UPC(cpeek(:lpeek))
         IF ( cpeek(1:1).EQ.'D' .OR. cpeek(1:1).EQ.'C' ) THEN
C Flat Field correction currently overwrites the data.
            ifile = 1
            IF ( Ldata.LE.0 ) GOTO 990
         ELSE IF ( cpeek(1:1).EQ.'B' ) THEN
            ifile = 2
            IF ( Lback.LE.0 ) GOTO 990
         ELSE IF ( cpeek(1:1).EQ.'R' ) THEN
            ifile = 3
            IF ( Lresp.LE.0 ) GOTO 990
         ELSE IF ( cpeek(1:1).EQ.'S' ) THEN
            ifile = 1
            IF ( Ldata.LE.0 ) GOTO 990
            ifile = 2
            IF ( Lback.LE.0 ) GOTO 990
            ifile = 4
         END IF
C If user entered valid input then flush input from buffer.
         IF ( ifile.NE.0 ) THEN
            CALL GTCHAR(cpeek, lpeek)
            Iaray = ifile
         END IF
      END IF
C
      IF ( Iaray.EQ.1 ) THEN
         Cnam = Cdata
         Lnam = LData
      ELSE IF ( Iaray.EQ.2 ) THEN
         Cnam = CBack
         Lnam = LBack
      ELSE IF ( Iaray.EQ.3 ) THEN
         Cnam = CResp
         Lnam = Lresp
      ELSE IF ( Iaray.EQ.4 ) THEN
         Cnam = CData(:LData)//'-'//Cback(:Lback)
         Lnam = LENACT(Cnam)
         IF ( Tdata.NE.NO .AND. Tback.NE.NO .AND. Tback.NE.0.0 ) THEN
            tcor = Tdata/Tback
         ELSE
            tcor = 1.0
         END IF
         IF ( Ibsub.EQ.0 .OR. tcor.NE.Tdisp ) THEN
            CALL PTBUF('Subtracting background.',-1)
            IF ( Tdata.EQ.NO .OR. Tback.EQ.NO .OR. Tback.EQ.0.0 ) THEN
               CALL PTBUF('Warning--Integration time is undefined.',-1)
            END IF
            Rdmax = SYSMIN
            Rdmin = SYSMAX
            DO i = 1, Ncol
               ix = (i-1)*Mxrow
               DO j = 1, Nrow
                  ix = ix + 1
                  IF ( Rmap(ix).NE.NO .AND. Back(ix).NE.NO ) THEN
                     Rbsub(ix) = Rmap(ix) - tcor*Back(ix)
                     IF ( Rbsub(ix).LT.Rdmin ) THEN
                        rdmin = Rbsub(ix)
                     END IF
                     IF ( Rbsub(ix).GT.Rdmax ) THEN
                        rdmax = Rbsub(ix)
                     END IF
                  ELSE
                     Rbsub(ix) = NO
                  END IF
               END DO
            END DO
            WRITE(cbuf,*) 'New data minimum/maximum:',Rdmin,Rdmax
            lbuf = LENACT(cbuf)
            CALL PTBUF(cbuf,lbuf)
            Ibsub = 1
            Tdisp = tcor
         END IF
      ELSE
         Cnam = '???-Error'
         Lnam = LENACT(Cnam)
      END IF
      RETURN
C
C Error return
  990 CONTINUE
      Ier = 1
      WRITE(*,*) 'You have not read a ',cfile(ifile),' file.'
      RETURN
C
      END
