      SUBROUTINE PIMAGE(Rmap, Mxrow, Nrow, Ncol, Cmd, Mxcmd, Ncmd)
      INTEGER   Mxrow, Nrow, Ncol, Mxcmd, Ncmd
      REAL      Rmap(Mxrow,*)
      CHARACTER Cmd(Mxcmd)*(*)
C Entry points
      CHARACTER Clbl*(*)
C---
C LEXTRCT routine to produce a gray scale image on the image device.
C---
C Input:
C  Rmap           data
C  Mxrow          Physical size of array
C  Nrow, Ncol     Actual size of array
C  Cmd
C  Mxcmd
C  Ncmd
C---
C 1992-May-05 - [AFT]
C---
      INTEGER   LENACT
      INCLUDE 'scrat.inc'
      INTEGER   iery(MXSR*MXSC)
      EQUIVALENCE (Rscrat, iery)
C
      CHARACTER cctnam*128, cdisp*32
      CHARACTER cflbl*80, ctlbl*80, cxlbl*80, cylbl*80
      SAVE      cflbl, ctlbl, cxlbl, cylbl
      REAL      xdeth, xdetl, ydeth, ydetl, xscal
      REAL      xdet1, xdet2, ydet1, ydet2, yscal
      INTEGER   i, iadj, icbar, ier, iwhite
      INTEGER   lctnam, ldisp, lflbl, ltlbl, lxlbl, lylbl
      DATA lflbl, ltlbl, lxlbl, lylbl/0, 0, 0, 0/
C---
      IF ( Ncmd+10.GT.Mxcmd ) THEN
         CALL PTBUF(
     &      'Pimage--Program error, need more room in CMD array.',-1)
         WRITE(*,*) 'Mxcmd=',Mxcmd,', Need at least ',Ncmd+10
         RETURN
      END IF
      DO i=1, Ncol
         iery(i) = 0
      END DO
C
      CALL SSGTDI(cctnam, lctnam, cdisp, ldisp)
      ncmd = ncmd + 1
      cmd(ncmd)='IMAGE '//cdisp(:ldisp)//' CCT '//cctnam(:lctnam)
C
      CALL SSGADJ(iadj)
      ncmd = ncmd + 1
      IF ( iadj.EQ.0 ) THEN
         cmd(ncmd)='ADJust OF'
      ELSE
         cmd(ncmd)='ADJust ON'
      END IF
C
C Background color
      CALL SSBCOL(iwhite)
      IF ( iwhite.GT.0 ) THEN
         ncmd = ncmd + 1
         cmd(ncmd)='SCR W'
      END IF
C
      CALL BOUQOB(xdetl,ydetl,xdeth,ydeth)
      CALL POS_MAP_DET(1,1,xdet1,ydet1)
      CALL POS_MAP_DET(2,2,xdet2,ydet2)
      xscal = xdet2 - xdet1
      yscal = ydet2 - ydet1
      WRITE(Cmd(Ncmd+1), 141) 'XAX',xdet1,xscal
      WRITE(Cmd(Ncmd+2), 141) 'YAX',ydet1,yscal
 141  FORMAT(A,' LIN ',F10.3,F10.3)
      WRITE(Cmd(Ncmd+3), 161) xdetl, xdeth, ydetl, ydeth
 161  FORMAT('R ',4F9.1)
      Ncmd = Ncmd + 3
C
      IF ( ltlbl.GT.0 ) THEN
         Ncmd = Ncmd + 1
         Cmd(Ncmd) = 'LAB T ' // ctlbl
      END IF
      IF ( lxlbl.GT.0 ) THEN
         Ncmd = Ncmd + 1
         Cmd(Ncmd) = 'LAB X ' // cxlbl
      END IF
      IF ( lylbl.GT.0 ) THEN
         Ncmd = Ncmd + 1
         Cmd(Ncmd) = 'LAB Y ' // cylbl
      END IF
C
      CALL SSGTCB(icbar)
      IF ( icbar.GT.0 ) THEN
         Ncmd = Ncmd + 1
         Cmd(Ncmd) = 'IMAGE CBAR'
      END IF
      Ncmd = Ncmd + 1
      Cmd(Ncmd) = 'Gap 0.0 Errors'
C
      CALL PLT(Rmap,iery,Mxrow,Nrow,Ncol,Cmd,Ncmd,ier)
C
      RETURN
C*********
      ENTRY DIFLBL(Clbl)
      cflbl = Clbl
      lflbl = LENACT(cflbl)
      RETURN
C
      ENTRY GIFLBL(Clbl)
      Clbl = cflbl
      RETURN
C
      ENTRY DITLBL(Clbl)
      ctlbl = Clbl
      ltlbl = LENACT(ctlbl)
      RETURN
C
      ENTRY DIXLBL(Clbl)
      cxlbl = Clbl
      lxlbl = LENACT(cxlbl)
      RETURN
C
      ENTRY DIYLBL(Clbl)
      cylbl = Clbl
      lylbl = LENACT(cylbl)
      RETURN
      END
