C*PLELIP -- draw a ellipse, using fill-area attributes
C%void cpgelip(float xcent, float ycent, float rad1, float rad2, float theta);
C+
      SUBROUTINE PLELIP (XCENT, YCENT, RAD1, RAD2, THETA)
      REAL XCENT, YCENT, RAD1, RAD2, THETA
C
C Draw an ellipse.  The action of this routine depends
C on the setting of the Fill-Area Style attribute. If Fill-Area Style
C is SOLID (the default), the interior of the ellipse is solid-filled
C using the current Color Index. If Fill-Area Style is HOLLOW, the
C outline of the ellipse is drawn using the current line attributes
C (color index, line-style, and line-width).
C
C Arguments:
C  XCENT  (input)  : world x-coordinate of the center of the circle.
C  YCENT  (input)  : world y-coordinate of the center of the circle.
C  RAD1   (input)  : first radius (semi-major axis)
C  RAD2   (input)  : first radius (semi-minor axis)
C  Theta  (input)  : Rotation angle (counter-clockwise from right)
C--
C 2000-Aug-24 - Adapted from PGCIRC [AFT]
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER MAXPTS
      PARAMETER (MAXPTS=72)
C
      INTEGER NPTS,I,RADPIX
      REAL ANGLE, COST, RTD, SINT, XTMP, YTMP
      REAL X(MAXPTS), Y(MAXPTS)
      DATA RTD/57.2957795/
C
      RADPIX = NINT(RAD1*MAX(PGXSCL(PGID), PGYSCL(PGID)))
      NPTS = MAX(8, MIN(RADPIX, MAXPTS))
      SINT = SIN(THETA/RTD)
      COST = COS(THETA/RTD)
      DO 10 I=1,NPTS
         ANGLE = I*360.0/REAL(NPTS)/RTD
         XTMP = RAD1*COS(ANGLE)
         YTMP = RAD2*SIN(ANGLE)
         X(I) = XCENT + COST*XTMP - SINT*YTMP
         Y(I) = YCENT + SINT*XTMP + COST*YTMP
   10 CONTINUE
      CALL PGPOLY (NPTS,X,Y)
C      write (*,*) 'PLELIP', NPTS
C-----------------------------------------------------------------------
      END
