      SUBROUTINE PLTHIS(A,IDIM,JDIM,I1,I2,J1,J2,BLACK,WHITE)
      INTEGER   IDIM, JDIM, I1, I2, J1, J2
      REAL      A(IDIM,JDIM)
      REAL      BLACK, WHITE
C---
C This routine will create and load an Image Transformation lookup
C function, and then load it.  Currently attempts histogram equalization
C where each color index is assigned to the same number of pixels.
C-----------------------------------------------------------------------
      INTEGER  MXHIS, MXCOL
      PARAMETER (MXHIS=2048, MXCOL=257)
C
      REAL      rlev(MXCOL)
      REAL      frac, smax, smin
      INTEGER   ihisto(MXHIS)
      INTEGER   i, itot
      INTEGER   j, mnci, mxci, nci, ibin
C---
C Determine the number of color indices we can use.  Note, the actual
C number of levels is one greater since the levels set the min and
C max values for each color index.
      CALL PGQCIR(mnci, mxci)
      nci = MIN(MXCOL-1, mxci-mnci+1)
C
      CALL PTBUF('Histogram',-1)
      DO i=1,MXHIS
         ihisto(i) = 0
      END DO
      itot=0
C Construct the image histogram using a linear transform and MXHIS entries.
C Note if a pixel is <black or >white, then it is ignored.
      smin = MIN(BLACK, WHITE)
      smax = MAX(BLACK, WHITE)
      DO j=J1,J2
         DO i=I1,I2
            IF ( smin.LT.A(i,j) .AND. A(i,j).LT.smax ) THEN
C If A(i,j) .LE.smin or .GE.smax, then the color will peg no matter what.
C Here we distribute the remaining colors
               ibin=NINT(1.+(MXHIS-1.0)*(A(i,j)-BLACK)/(WHITE-BLACK))
               IF ( 1.LE.ibin .AND. ibin.LE.MXHIS ) THEN
                  itot = itot + 1
                  ihisto(ibin) = ihisto(ibin) + 1
               END IF
            END IF
         END DO
      END DO
C
C Create the integral.
      DO i=2, MXHIS
         ihisto(i) = ihisto(i) + ihisto(i-1)
      END DO
C
C Create the lookup table such that each color index will be assigned
C to roughly the same number of pixels.
C
      ibin = 1
      rlev(1) = BLACK
      DO i=2, nci
         frac = (i-1)/FLOAT(nci)
  250    CONTINUE
         IF(ihisto(ibin+1)/FLOAT(itot).LT.frac .AND. ibin.LT.MXHIS)THEN
            ibin = ibin + 1
            GOTO 250
         END IF
  260    CONTINUE
         IF ( ihisto(ibin)/FLOAT(itot).GT.frac .AND. ibin.GT.1 ) THEN
            ibin = ibin - 1
            GOTO 260
         END IF
C
C We now know that itot*frac is between ihisto(ibin) and ihisto(ibin+1)
C so we can interpolate.
         rlev(i) = BLACK+(WHITE-BLACK)*(ibin/FLOAT(MXHIS))
      END DO
      rlev(nci+1) = WHITE
C
C Load the table
      CALL PGLDIT(rlev, nci+1)
C
C Check the actual histogram
C      WRITE(*,*) 'itot=',itot
C      DO i=1,MXHIS
C         ihisto(i) = 0
C      END DO
C      DO j=J1,J2
C         DO i=I1,I2
C            CALL GRLDIT(1, A(i,j), ibin)
C            ihisto(ibin) = ihisto(ibin) + 1
C         END DO
C      END DO
C      itot = 0
C      DO i=mnci,mxci
C         itot = itot + ihisto(i)
C         write(*,*) i-mnci+1,rlev(i-mnci+1),ihisto(i),itot
C      END DO
C      write(*,*) '***',mxci-mnci+2,rlev(mxci-mnci+2)
C      WRITE(*,*) 'itot=',itot
C
      RETURN
      END
