      SUBROUTINE PROJ(Rmap,Mxrow,Nrow,Ncol,ibp,
     &      Nsrow,Xcnt,Xtot,Ycnt,Ytot,Cnt)
      INTEGER   Mxrow, Nrow, Ncol, Ibp, Nsrow
      REAL      Rmap(Mxrow,*), Xcnt(Mxrow), Xtot(Mxrow)
      REAL      Ycnt(Mxrow), Ytot(Mxrow)
      REAL      Cnt
C---
C LEXTRCT routine to plot the project of the image inside the current
C bounds onto the axis.
C Called by iproj, rcproj.
C---
C Rmap    I
C Mxrow   I
C Nrow    I
C Ncol    I
C Ibp     I    Project in rotated box coordinates.
C Nsrow   I    Length of Xcnt, Xtot, Ycnt, Ytot arrays
C Xcnt      O  Projected number of pixels
C Xtot      O  Projected sum of pixel values
C Ycnt      O
C Ytot      O
C Cnt       O  Total number of pixels used
C---
C 1997-Jan-24 - Extracted from iproj - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   INBOU
C
      INCLUDE 'posdef.inc'
C
      REAL      xdeth, xdetl, ydeth, ydetl
      REAL      xpos, ypos, xr, yr
      INTEGER   i, imx0, imxn, imy0, imyn, ix, iy, j
      INTEGER   mcol, mrow
C
C Do most of work in map coordinates.
C
      CALL BOUQOB(xdetl, ydetl, xdeth, ydeth)
      CALL POS_DT_IM(xdetl, ydetl, imx0, imy0)
      imx0 = MIN(MAX(1,imx0),Nrow)
      imy0 = MIN(MAX(1,imy0),Ncol)
      CALL POS_DT_IM(xdeth, ydeth, imxn, imyn)
      imxn = MIN(MAX(1,imxn),Nrow)
      imyn = MIN(MAX(1,imyn),Ncol)
C
C Initilize arrays.
C
      DO i = 1, Nsrow
         Xcnt(i) = 0.
         Xtot(i) = 0.
      END DO
      DO j = 1, Nsrow
         Ycnt(j) = 0.
         Ytot(j) = 0.
      END DO
      mrow=1.5*Nrow
      mcol=1.5*Ncol
C
C Sum line averages
C
      cnt = 0.
      DO j = imy0, imyn
         DO i = imx0, imxn
            IF ( Rmap(i,j).NE.NO ) THEN
               CALL POS_MAP_DET(i,j,xpos,ypos)
               IF ( INBOU(xpos,ypos).GT.0 ) THEN
                  IF ( Ibp.EQ.0 ) THEN
                     ix=i
                     iy=j
                  ELSE
                     CALL BOUXY(xpos, ypos, xr, yr)
                     ix=xr/Ifac+mrow/2
                     iy=yr/Ifac+mcol/2
      IF ( ix.LE.0 .OR. ix.GT.Nsrow .OR. iy.LE.0 .OR. iy.GT.Nsrow ) THEN
         WRITE(*,*) 'proj--ERROR-Array overflow', ix,iy
         STOP
      END IF
                  END IF
                  Xcnt(ix) = Xcnt(ix) + 1.
                  Xtot(ix) = Xtot(ix) + Rmap(i,j)
                  Ycnt(iy) = Ycnt(iy) + 1.
                  Ytot(iy) = Ytot(iy) + Rmap(i,j)
                  cnt = cnt + 1
               END IF
            END IF
         END DO
      END DO

      END
