      FUNCTION QVALID(C, Qmap, Qbound, Ievent, Iwcs)
      LOGICAL   QVALID
      CHARACTER C*20
      INTEGER   Ievent, Iwcs
      LOGICAL   Qmap, Qbound
C---
C LEXTRCT function to check whether an action code is valid given the
C current values of the status flags
C---
C C       I    action code
C Qmap    I    map defined
C Qbound  I    bounds defined
C Ievent  I    >0 if file contains events data
C Iwcs    I    <>0 if WCS matrix defined
C---
C original version  tam
C modified  kaa  15/10/85
C---
      LOGICAL   qplot, qbox
      INTEGER   BOUXY
      REAL      xr, yr
C
C Find out if a plot device has been defined.
C
      CALL PDDEFS(qplot)
      QVALID = .FALSE.
C
C
C Always valid.
C
      IF ( C(1:1).EQ.'?'  .OR. C(1:2).EQ.'CP' .OR. C(1:2).EQ.'DA' .OR.
     &     C(1:2).EQ.'EX' .OR. C(1:2).EQ.'HE' .OR. C(1:2).EQ.'IN' .OR.
     &     C(1:1).EQ.'Q'  .OR. C(1:2).EQ.'SE' .OR. C(1:2).EQ.'SH' .OR.
     &     C(1:1).EQ.'V'  .OR. C(1:1).EQ.' ' ) THEN
         QVALID = .TRUE.
C
C Valid if a plot device is defined.
C
      ELSE IF ( qplot .AND.
     &   ( C(1:2).EQ.'CB' .OR. C(1:2).EQ.'CC' .OR. C(1:2).eq.'ER' .OR.
     &     C(1:2).EQ.'CU') ) THEN
         QVALID = .TRUE.
C
C Valid if map is defined.
C
      ELSE IF ( Qmap .AND.
     &   ( C(1:2).EQ.'AP' .OR. C(1:2).EQ.'BA' .OR. C(1:2).EQ.'BO' .OR.
     &     C(1:2).EQ.'IS' .OR. C(1:2).EQ.'RE' .OR.
     &     C(1:2).EQ.'RP' .OR. C(1:2).EQ.'SF' .OR. C(1:2).EQ.'TM' .OR.
     &     C(1:1).EQ.'U'  .OR. C(1:2).EQ.'WF' .OR. C(1:2).EQ.'WI' ))THEN
         QVALID = .TRUE.
C
C Valid if map and plot device are both defined.
C
      ELSE IF ( Qmap .AND. qplot .AND.
     &   ( C(1:2).EQ.'CO' .OR. C(1:2).EQ.'CR' .OR.
     &     C(1:2).EQ.'DI' .OR. C(1:2).EQ.'DS' .OR.
     &     C(1:1).EQ.'P'  .OR. C(1:2).EQ.'RC') ) THEN
         QVALID = .TRUE.
C
C Valid if bounds defined.
C
      ELSE IF ( Qbound .AND.
     &   ( C(1:2).EQ.'DB' .OR. C(1:2).EQ.'IH' .OR.
     &     C(1:2).EQ.'IP' .OR. C(1:2).EQ.'MB' .OR. C(1:2).EQ.'SM' .OR.
     &     C(1:2).EQ.'ST' .OR. C(1:2).EQ.'XC'
     &      ) ) THEN
         QVALID = .TRUE.
C
C Valid if plot device defined and WCS keywords are defined.
C
      ELSE IF ( qplot .AND. Iwcs.NE.0 .AND.
     &   ( C(1:2).EQ.'OG' .OR. C(1:2).EQ.'OS' ) ) THEN
         QVALID = .TRUE.
C
C Valid if bounds are defined and have event data available.
C
      ELSE IF ( Qbound .AND. Ievent.GT.0 .AND.
     &   ( C(1:2).EQ.'XG' .OR. C(1:2).EQ.'XH' .OR. C(1:2).EQ.'XT'
     &      ) ) THEN
C     &     C(1:2).EQ.'Z2' ) ) THEN
         QVALID = .TRUE.
      ELSE IF ( BOUXY(1.,1.,xr,yr).NE.0 .AND.
     &   ( C(1:2).EQ.'BP' ) ) THEN
         QVALID = .TRUE.
C
      END IF
C
      RETURN
      END
