      SUBROUTINE RCPROJ(Rmap,Mxrow,Nrow,Ncol,Ibp,Qplot,Mxcmd,Ncmd,Cmd)
      INTEGER   Mxrow, Nrow, Ncol, Ibp
      REAL      Rmap(Mxrow,*)
      INTEGER   Mxcmd, Ncmd
      LOGICAL   Qplot
      CHARACTER Cmd(Mxcmd)*(*)
C---
C LEXTRCT routine to plot the project of the image inside the current
C bounds onto the axis.
C---
C Rmap    I
C Mxrow   I
C Nrow    I
C Ncol    I
C Ibp     I    Project in rotated box coordinates
C Qplot   I
C Mxcmd   I    Number of elements in Cmd array
C Ncmd    I/O  Input is number of elements already set in in CMD
C Cmd       O  Scratch array for PLT commands
C---
C 1997-Jan-27 - Extracted from iproj.f - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INCLUDE 'scrat.inc'
C
      REAL      cnts, tcnt, tmp
      INTEGER   iery(5)
      INTEGER   i, ier, itmp, j, mcol, mrow, nsrow
C
C The projected length can be up to SQRT(2).  Using 1.5 gives a pad.
      mrow=1.5*Nrow
      mcol=1.5*Ncol
      nsrow = mrow + mcol + 1
      itmp = Mxsr*Mxsc/7
      IF ( nsrow.GT.itmp ) THEN
         WRITE(*,*) 'RCPROJ--Error: rows+colums+1 must be <',itmp
         RETURN
      END IF
C
      CALL PROJ(Rmap,Mxrow,Nrow,Ncol,Ibp,nsrow,Rscrat(1+3*nsrow),
     &   Rscrat(1+4*nsrow),Rscrat(1+5*nsrow),Rscrat(1+6*nsrow),cnts)
C
C If there are no counts in the box then return
C
      IF ( cnts.EQ.0. ) THEN
         CALL PTBUF('**  No counts in box  **',-1)
         RETURN
      END IF
      CALL PTBUF('Errors based on counts!',-1)
C
      DO i = 1, mrow
         IF ( Rscrat(i+3*nsrow).GT.0. ) THEN
            Rscrat(i+nsrow) = Rscrat(i+4*nsrow)/Rscrat(i+3*nsrow)
            tcnt = ABS(Rscrat(i+4*nsrow))
            IF ( tcnt.EQ.0. ) tcnt = 1.0
            Rscrat(i+2*nsrow) = SQRT(tcnt)/Rscrat(i+3*nsrow)
            IF ( Ibp.EQ.0 ) THEN
               CALL POS_MAP_DET(i, 1, Rscrat(i), tmp)
            ELSE
               Rscrat(i)=Ifac*(i-mrow/2)
            END IF
         ELSE
            Rscrat(i+nsrow) = NO
            Rscrat(i+2*nsrow) = NO
            Rscrat(i)=NO
         END IF
      END DO
      Rscrat(mrow+1)         = NO
      Rscrat(mrow+1+nsrow)   = NO
      Rscrat(mrow+1+2*nsrow) = NO
C
C Normalize y-array to area and counts
C
      DO j = 1, mcol
         IF ( Rscrat(j+5*nsrow).GT.0. ) THEN
            Rscrat(j+1+mrow+nsrow) = Rscrat(j+6*nsrow)/Rscrat(j+5*nsrow)
            tcnt = ABS(Rscrat(j+6*nsrow))
            IF ( tcnt.EQ.0. ) tcnt = 1.0
            Rscrat(j+1+mrow+2*nsrow) = SQRT(tcnt)/Rscrat(j+5*nsrow)
            IF ( Ibp.EQ.0 ) THEN
               CALL POS_MAP_DET(1, j, tmp, Rscrat(j+1+mrow))
            ELSE
               Rscrat(j+1+mrow)=Ifac*(j-mcol/2)
            END IF
         ELSE
            Rscrat(j+1+mrow+nsrow) = NO
            Rscrat(j+1+mrow+2*nsrow) = NO
            Rscrat(j+1+mrow)=NO
         END IF
      END DO
C
C Plot.
C
      IF ( qplot ) THEN
         iery(1) = 0
         iery(2) = 1
         Cmd(ncmd+1) = 'Skip ON'
         Cmd(ncmd+2) = 'Gap Error'
         Cmd(ncmd+3) = 'P V'
         IF ( Ibp.EQ.0 ) THEN
            Cmd(ncmd+4) = 'LAB X Position'
         ELSE
            Cmd(ncmd+4) = 'LAB X Distance from center'
         END IF
         Cmd(ncmd+5) = 'LAB G1 X projection'
         Cmd(ncmd+6) = 'LAB G2 Y projection'
         Cmd(ncmd+7) = 'LIN Step'
         Cmd(ncmd+8) = 'WIN All'
         ncmd = ncmd + 8
         CALL PLT(Rscrat,iery,nsrow,nsrow,2,Cmd,ncmd,ier)
      END IF
C
      RETURN
      END
