      SUBROUTINE RDMAP(Ievent, Rmap, Mxrow, Mxcol, Nrow, Ncol,
     &         Cmap, Lmap, Tmap, Ier)
      INTEGER   Ievent, Mxrow, Mxcol, Nrow, Ncol, Lmap
      REAL      Rmap(Mxrow, Mxcol)
      CHARACTER Cmap*(*)
      REAL      Tmap
C---
C Simple routine to read a real map from an ancillary FITS file.
C Some care is needed if the orginal data were from an events list
C and we now read a FITS image.
C---
C Ievent  I    <>0 if the original data is an events list
C---
C 1993-Aug-27 - [AFT]
C---
      INCLUDE 'posdef.inc'
C
      CHARACTER ctmp
      REAL      rtmp, xdsav, ydsav
      INTEGER   ier, ienew, ifsav, inew, itmp, lunf, ncnew, nrnew
C---
      CALL GETLUN(lunf)
      CALL LEXOPN(lunf, 1, Cmap, Lmap, inew, ier)
C
      IF ( ier.LT.0 ) THEN
         Lmap = 0
         Tmap = 0
         GOTO 900
      ELSE IF ( ier.GT.0 ) THEN
         WRITE (*,*) 'Unable to open file.  Error=', ier
         GOTO 900
      END IF
C
      ifsav = Ifac
      itmp = Nrow
C
      CALL RFDS(lunf, ienew, nrnew, ncnew, ier)
      IF ( ier.NE.0 ) GOTO 900
      xdsav = xdmap1
      ydsav = ydmap1
      IF ( ienew.NE.Ievent .OR. Ievent.EQ.0 ) THEN
C Drop through here if combining event list with FITS images (or event
C lists in different numbered extensions).
         IF ( nrnew.NE.Nrow .AND. ncnew.NE.Ncol ) THEN
            WRITE(*,*) 'RDMAP--File size does not match current data.'
            Ier = 1
            GOTO 900
         END IF
         xdmap1 = 1.0
         ydmap1 = 1.0
         Ifac=1
      END IF
      ier = 0
      CALL FTGKYJ(lunf, 'NAXIS2', Nrow, ctmp, ier)
C
      CALL RFDATA(lunf, ienew, Tmap,
     &      .TRUE.,Rmap,Mxrow,Mxcol,Nrow,Ncol,
     &      0,rtmp,1,itmp, .FALSE.,rtmp,1,itmp)
      CALL FTCLOS(lunf,ier)
C
      Ifac = ifsav
      xdmap1 = xdsav
      ydmap1 = ydsav
      Ier = 0
C---
  900 CONTINUE
      CALL FRELUN(lunf)
      END
