      SUBROUTINE RFCOLS(Lun, Ievent)
      INTEGER   Lun, Ievent
C Entry RFCQxC
      INTEGER   ixcol1, iycol1, iscol1, ibcol1, iocol1, itcol1, iicol1
      INTEGER   iimin1, iimax1
C Entry RFCQxM
      INTEGER   ixmin1, ixmax1, iymin1, iymax1, ismin1, ismax1
C---
C Used by software to read FITS events lists.  This routine selects
C some default columns for X, Y, spectral, and time, and allows
C user to override.
C---
C Lun     I    Lun of open FITS events file
C Ievent  I    FITS HDU containing the EVENTS extension
C---
C 1997-Mar-21 - extracted from rfhead [AFT]
C---
      INCLUDE 'time.inc'
      DOUBLE PRECISION sla_DTT
C
      CHARACTER ccol(4)*16
      SAVE      ccol
      CHARACTER cold(4)*16
      CHARACTER cprom*72
      CHARACTER ctmp*64, cvalue*64
      CHARACTER cicol*16, ckey*16, cnew*16
      DOUBLE PRECISION dmjd0, dsec
      REAL      tmp
      INTEGER   i, ier, is1, is2, istat, ival
      INTEGER   ispri, ixpri, iypri, lnew, ltmp
C
      INTEGER   ibcol, iicol, iimax, iimin, iocol
      SAVE      ibcol, iicol, iimax, iimin, iocol
      INTEGER   iscol, itcol, ixcol, iycol
      SAVE      iscol, itcol, ixcol, iycol
      INTEGER   ixmin, iymin, ismin
      SAVE      ixmin, iymin, ismin
      INTEGER   ixmax, iymax, ismax
      SAVE      ixmax, iymax, ismax
      DATA ixmax,iymax,ismax/1024,1024,256/
C---
      DO i=1,4
         cold(i) = ccol(i)
      END DO
C---
      ibcol = 0
      iicol = 0
      iocol = 0
      itcol = 0
      ixpri = 100
      iypri = 100
      ispri = 100
      istat = 0
      DO i=1,999
C Construct keyword name
         CALL FTKEYN('TTYPE',i,ckey,istat)
C Search for keyword value
         CALL FTGKYS(Lun,ckey,cvalue,ctmp,istat)
         CALL UPC(cvalue)
         IF (istat .GT. 0) GOTO 140
C
         IF ( cvalue.EQ.cold(1) ) THEN
            Ccol(1) = cvalue
            ixcol = i
            ixpri = 1
         ELSE IF ( cvalue.EQ.'X'         .AND. ixpri.GT.2 ) THEN
            Ccol(1) = cvalue
            ixcol = i
            ixpri = 2
         ELSE IF ( cvalue(1:5).EQ.'TDETX' .AND. ixpri.GT.3) THEN
            Ccol(1) = cvalue
            ixcol = i
            ixpri = 3
         ELSE IF ( cvalue(1:4).EQ.'DETX' .AND. ixpri.GT.4 ) THEN
            Ccol(1) = cvalue
            ixcol = i
            ixpri = 4
         ELSE IF ( cvalue(1:5).EQ.'CHIPX' .AND. ixpri.GT.5) THEN
            Ccol(1) = cvalue
            ixcol = i
            ixpri = 5
         ELSE IF ((cvalue(1:4).EQ.'RAWX' .OR. cvalue(1:5).EQ.'RAW_X')
     &         .AND. ixpri.GT.6 ) THEN
            Ccol(1) = cvalue
            ixcol = i
            ixpri = 6
         END IF
C
         IF ( cvalue.EQ.cold(2) ) THEN
            Ccol(2) = cvalue
            iycol = i
            iypri = 1
         ELSE IF ( cvalue.EQ.'Y'         .AND. iypri.GT.2 ) THEN
            Ccol(2) = cvalue
            iycol = i
            iypri = 2
         ELSE IF ( cvalue(1:5).EQ.'TDETY' .AND. iypri.GT.3) THEN
            Ccol(2) = cvalue
            iycol = i
            iypri = 3
         ELSE IF ( cvalue(1:4).EQ.'DETY' .AND. iypri.GT.4 ) THEN
            Ccol(2) = cvalue
            iycol = i
            iypri = 4
         ELSE IF ( cvalue(1:5).EQ.'CHIPY' .AND. iypri.GT.5) THEN
            Ccol(2) = cvalue
            iycol = i
            iypri = 5
         ELSE IF ((cvalue(1:4).EQ.'RAWY' .OR. cvalue(1:5).EQ.'RAW_Y')
     &       .AND. iypri.GT.6 ) THEN
            Ccol(2) = cvalue
            iycol = i
            iypri = 6
         END IF
C
         IF ( cvalue.EQ.Cold(3) ) THEN
            Ccol(3) = cvalue
            itcol = i
         ELSE IF ( cvalue.EQ.'TIME' ) THEN
            Ccol(3) = cvalue
            itcol = i
         ELSE IF ( cvalue.EQ.'BARYTIME' ) THEN
            Ccol(3) = cvalue
            itcol = i
         ELSE IF ( INDEX(cvalue,'TIME').GT.0 .AND. itcol.EQ.0 ) THEN
            Ccol(3) = cvalue
            itcol = i
         END IF
C
         IF ( cvalue.EQ.cold(4) ) THEN
            Ccol(4) = cvalue
            iscol = i
            ispri = 1
         ELSE IF ( cvalue(1:4).EQ.'PI'     .AND. ispri.GT.2 ) THEN
            Ccol(4) = cvalue
            iscol = i
            ispri = 2
         ELSE IF ( cvalue(1:6).EQ.'SUMSIG' .AND. ispri.GT.3 ) THEN
            Ccol(4) = cvalue
            iscol = i
            ispri = 3
         ELSE IF ( cvalue(1:3).EQ.'PHA'    .AND. ispri.GT.4 ) THEN
            Ccol(4) = cvalue
            iscol = i
            ispri = 4
         ELSE IF ( cvalue(1:6).EQ.'ENERGY' .AND. ispri.GT.5 ) THEN
            Ccol(4) = cvalue
            iscol = i
            ispri = 5
         ELSE IF ( cvalue(1:7).EQ.'CHANNEL' .AND. ispri.GT.6 ) THEN
            Ccol(4) = cvalue
            iscol = i
            ispri = 6
         END IF
C
         IF ( cvalue.EQ.'BIAS' ) THEN
            ibcol = i
         END IF
C
         IF ( cvalue.EQ.'OVRCLK' ) THEN
            iocol = i
         END IF
C
      END DO
C
 140  CONTINUE
      CALL PTBUF(' ',-1)
      CALL PTBUF('Description Ival Key',-1)
      WRITE(*,*) 'X-axis    :   1, ',Ccol(1)
      WRITE(*,*) 'Y-axis    :   2, ',Ccol(2)
      WRITE(*,*) '  Time    :   3, ',Ccol(3)
      WRITE(*,*) 'Spectral  :   4, ',Ccol(4)
      CALL PTBUF(' ',-1)
      CALL GTBUF('To change, enter new Ival, Key:', ier)
      CALL GTPEEK(cnew, lnew)
      IF ( lnew.GT.0 .AND. cnew(1:1).EQ.'?' ) THEN
         DO i=1,999
            istat = 0
            CALL FTKEYN('TTYPE',i,ckey,istat)
            CALL FTGKYS(Lun, ckey, cvalue, ctmp, istat)
            IF ( istat.NE.0 ) GOTO 140
            CALL PTBUF(cvalue,-1)
         END DO
         GOTO 140
      END IF
      ival = 0
      CALL GTINT(ival, ier)
      IF ( ival.GT.0 .AND. ival.LE.4) THEN
C Check newkey that user entered against keywords in file.
         CALL GTCHAR(cnew, lnew)
         CALL UPC(cnew(:lnew))
         IF ( lnew.GT.0 ) THEN
            istat = 0
            DO i=1,999
               CALL FTKEYN('TTYPE',i,ckey,istat)
               CALL FTGKYS(Lun, ckey, cvalue, ctmp, istat)
               CALL UPC(cvalue)
               IF ( cvalue.EQ.cnew(1:lnew) ) THEN
                  Ccol(ival) = cvalue
                  IF ( ival.EQ.1 ) ixcol = i
                  IF ( ival.EQ.2 ) iycol = i
                  IF ( ival.EQ.3 ) itcol = i
                  IF ( ival.EQ.4 ) iscol = i
                  GOTO 140
               END IF
            END DO
      write(*,*) 'Nothing, istat=',istat
            GOTO 140
         END IF
      END IF
C---
C Get X column min/max and label
      istat = 0
      CALL FTKEYN('TLMIN',ixcol,ckey,istat)
      CALL FTGKYE(Lun, ckey, tmp, ctmp, istat)
      IF ( istat.EQ.0 ) THEN
         ixmin = NINT(tmp)
      ELSE
         ixmin = 1
      END IF
      istat = 0
      CALL FTKEYN('TLMAX',ixcol,ckey,istat)
      CALL FTGKYJ(Lun, ckey, ixmax, ctmp, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL FTKEYN('AXLEN',ixcol,ckey,istat)
         CALL FTGKYJ(Lun, ckey, ixmax, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            CALL PTBUF('Unable to determine min/max X values.',-1)
            WRITE(cprom, 221) ixmax
  221       FORMAT(' Please enter values now (',I5,'):')
            CALL GTBUF(cprom, ier)
            CALL GTINT(ixmax, ier)
C If we have a second number then first must be min.
            CALL GTPEEK(ctmp, ltmp)
            IF ( ltmp.GT.0 ) THEN
               ixmin = ixmax
               CALL GTINT(ixmax, ier)
            END IF
         END IF
      END IF
      CALL DIXLBL(ccol(1))
C
C Get Y column min/max and label
      istat = 0
      CALL FTKEYN('TLMIN',iycol,ckey,istat)
      CALL FTGKYE(Lun, ckey, tmp, ctmp, istat)
      IF ( istat.EQ.0 ) THEN
         iymin = NINT(tmp)
      ELSE
         iymin = 1
      END IF
      istat = 0
      CALL FTKEYN('TLMAX',iycol,ckey,istat)
      CALL FTGKYJ(Lun, ckey, iymax, ctmp, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL FTKEYN('AXLEN',iycol,ckey,istat)
         CALL FTGKYJ(Lun, ckey, iymax, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            CALL PTBUF('Unable to determine min/max Y values.',-1)
            WRITE(cprom, 221) iymax
            CALL GTBUF(cprom, ier)
            CALL GTINT(iymax, ier)
C If we have a second number then first must be min.
            CALL GTPEEK(ctmp, ltmp)
            IF ( ltmp.GT.0 ) THEN
               iymin = iymax
               CALL GTINT(iymax, ier)
            END IF
         END IF
      END IF
      CALL DIYLBL(ccol(2))
C---
C Get PHA column min/max and label
      IF ( ccol(4).NE.'PHAS' ) THEN
C Do not subtract bias and overclocks unless you are reading PHAS data.
         ibcol = 0
         iocol = 0
      END IF
      IF ( iscol.GT.0 ) THEN
         ismin = 1
         istat = 0
         CALL FTKEYN('TLMIN',iscol,ckey,istat)
         CALL FTGKYJ(Lun, ckey, ismin, ctmp, istat)
         istat = 0
         CALL FTKEYN('TLMAX',iscol,ckey,istat)
         CALL FTGKYJ(Lun, ckey, ismax, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTGKYJ(Lun, 'XS-CHANS', ismax, ctmp, istat)
            IF ( istat.NE.0 ) THEN
               istat = 0
               CALL FTKEYN('AXLEN',iscol,ckey,istat)
               CALL FTGKYJ(Lun, ckey, ismax, ctmp, istat)
               IF ( istat.NE.0 ) THEN
                 CALL PTBUF('Unable to determine maximum PHA value.',-1)
                  WRITE(cprom, 221) ismax
                  CALL GTBUF(cprom, ier)
                  CALL GTINT(ismax, ier)
C If we have a second number then first must be min.
                  CALL GTPEEK(ctmp, ltmp)
                  IF ( ltmp.GT.0 ) THEN
                     ismin = ismax
                     CALL GTINT(ismax, ier)
                  END IF
               END IF
            END IF
         END IF
         CALL PTBUF(' ',-1)
      END IF
C---
C Time data:
      iimin=0
      iimax=0
      IF ( itcol.GT.0 ) THEN
C Now read GTI's (only if we have a time column)
         CALL GTINEW(Lun, Ievent, itcol, Cicol)
         IF ( Cicol.NE.' ' ) THEN
C If GTI contains an INDEX column, then we must find the same
C index column in the EVENT list.
            istat = 0
            CALL FTGCNO(lun, .FALSE., Cicol, iicol, istat)
            CALL FTKEYN('TLMIN',iicol,ckey,istat)
            IF ( istat.NE.0 ) THEN
              WRITE(*,*) 'Failed to read TLMIN for ',cicol,', set to 0.'
               iimin=0
               istat=0
            END IF
            CALL FTGKYJ(Lun, ckey, iimin, ctmp, istat)
            CALL FTKEYN('TLMAX',iicol,ckey,istat)
            CALL FTGKYJ(Lun, ckey, iimax, ctmp, istat)
            IF ( istat.NE.0 ) THEN
              WRITE(*,*) 'Failed to read TLMAX for ',cicol,', set to 9.'
               iimax=9
               istat=0
            END IF
         END IF
C Get Time Zero
         istat = 0
         Dtzero = 0.0d0
         CALL FTGKYD(Lun, 'TIMEZERO',  Dtzero, ctmp, istat)
C Get Observation start day
         CALL MJDOBS(Lun, Days, dsec, is1)
         Days = INT(Days)
C Get the reference time
         CALL MJDREF(Lun, dmjd0, is2)
         IF ( is1.EQ.0 .AND. is2.EQ.0 ) THEN
C Got both an observation date and a reference date from the header,
C therefore we can compute a time offset.
            Doff = (Days-dmjd0)*86400.D0
            IF ( Ccol(3)(1:4).EQ.'TIME' ) THEN
               cvalue = ' '
               istat = 0
               CALL FTGKYS(Lun,'TIMESYS',cvalue,ctmp,istat)
               CALL UPC(cvalue)
               IF ( cvalue(1:2).NE.'TT' .AND. cvalue(1:3).NE.'TDB') THEN
C If the column name is TIME and TIMESYS is neither TT nor TDB, then we
C are likely dealing with UTC and need to correct for leap seconds.
                  Doff = Doff+sla_DTT(Days)-sla_DTT(dmjd0)
               END IF
            END IF
         ELSE
            doff = 0.0D0
         END IF
      END IF
C
  340 CONTINUE
C---
      RETURN
C*********
      ENTRY RFCINT
C Initalize the column numbers to zero (Needs to be called if we are
C reading a FITS image.)
      ixcol = 0
      iycol = 0
      iscol = 0
      iocol = 0
      itcol = 0
      RETURN
C*********
      ENTRY RFCQPC(ixcol1, iycol1)
C Query position columns
      ixcol1 = ixcol
      iycol1 = iycol
      RETURN
C*********
      ENTRY RFCQPR(ixmin1, ixmax1, iymin1, iymax1)
C Query X/Y position ranges values
      ixmin1 = ixmin
      ixmax1 = ixmax
      iymin1 = iymin
      iymax1 = iymax
      RETURN
C*********
      ENTRY RFCQSC(iscol1, ibcol1, iocol1)
C Query spectral column
      iscol1 = iscol
      ibcol1 = ibcol
      iocol1 = iocol
      RETURN
C*********
      ENTRY RFCQSR(ismin1, ismax1)
C Query spectral range
      ismin1 = ismin
      ismax1 = ismax
      RETURN
C*********
      ENTRY RFCQTC(itcol1, iicol1, iimin1, iimax1)
C Query time column
      itcol1 = itcol
      iicol1 = iicol
      iimin1 = iimin
      iimax1 = iimax
      RETURN
      END
