      SUBROUTINE RFDATA(Lun, Ievent, Tinteg,
     &      Qmap,Rmap,Mxrow,Mxcol,Nrow,Ncol,
     &      Ispec,Rspec,Mxchan,Nchan, Qtime,Rate,Mxrate,Nbins)
      INTEGER   Lun, Ievent
      REAL      Tinteg
      LOGICAL   Qmap, Qtime
      INTEGER   Mxrow, Mxcol, Nrow, Ncol
      INTEGER   Ispec, Mxchan, Nchan, Mxrate, Nbins
      REAL      Rmap(Mxrow,Mxcol), Rate(Mxrate,3)
      REAL      Rspec(Mxchan,2)
C- ENTRY RFGCCD
      INTEGER   ifill, neccd(*)
C---
C LEXTRCT routine to read data arrays from FITS files.
C---
C Lun     I    Logical unit number for opened FITS file
C Ievent  I    >0 if file contains events data
C Tinteg    O  The integration time
C Qmap    I    =.T. fill map array, =.F. ignore map array
C Rmap    I/O  If ( Qmap  ) the map array
C Mxrow   I/O  Maximum number of rows in Rmap array
C Mxcol   I/O  Maximum number of columns in Rmap array
C Nrow    I/O  Actual number of rows
C Ncol    I/O  Actual number of columns
C Ispec   I    =0 no spec, +1 histogram, -1 grating, -2 summed grating
C Rspec     O  If ( Ispec.NE.0 ) the spectral array
C Mxchan  I    Maximum size of Rspec
C Nchan     O  Number of channels actually read
C Qtime   I    =.T. fill timing array, =.F. ignore timing array
C Rate      O  If ( Qrate ) the timing array
C Mxrate  I    Maximum size of timing array
C Nbins     O  Actual size of timing array
C---
C 1992-May-13 - New routine [AFT].
C---
      INTEGER   MXGTI, MXI, MXSCOL
      PARAMETER (MXGTI=20, MXI=10000, MXSCOL=25)
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   INBOU, IPHASE
C
      INCLUDE 'time.inc'
      INCLUDE 'posdef.inc'
C
      CHARACTER ctmp*64, cvalue*64
      CHARACTER ckey*16
      DOUBLE PRECISION dnul, dtime, dtls, dtmp, dtend
      REAL      rdata(MXI)
      REAL      angle, cang, ppc, rnul, rtd, rtmp, sang
      REAL      wmax, widib, widob, wids, wtmp, xpos, ypos
      INTEGER   ifccd, igtccd(MXGTI)
      SAVE      ifccd, igtccd
      INTEGER   ibvec(MXSCOL), ipvec(MXSCOL)
      INTEGER   ibegin, ibcol, ichoff, iext, igroup, iicol, iimax, iimin
      INTEGER   imx, imy, inul
      INTEGER   ioclk(1), iccd(1)
      INTEGER   iocol, iscol, itmp, ixcol, iycol
      INTEGER   i, ibin, ibpos, icent, ichan, idcode, iflag
      INTEGER   ihi, ilo, islevel, ismax, ismin, istat, itcol, itdat
      INTEGER   iwid, ixmax, ixmin, iymax, iymin
      INTEGER   j, jhi, jlo, k, lasbin
      INTEGER   nbhist, nbch, nbgti, nbtb, nbutim, nbw, nmbad
      INTEGER   npmap, nrbin, nread, nsbck, nssrc, ntbck, ntsrc
      INTEGER   nrows, nscols, nsplit
      LOGICAL   qbad, qdogti, qmbad, qrdtim, qstab, qutim, qxy
C
      INTEGER   Islo, Ishi, Iscomp
      LOGICAL   Qdobl, Qdosl, Qdotl
      COMMON /DOLIMS/ Islo, Ishi, Iscomp, Qdobl, Qdosl, Qdotl
      DATA rtd/57.2957795/
C
      istat = 0
      IF ( Ievent.LE.0 ) THEN
         IF ( Ievent.EQ.0 ) THEN
C Go to primary header record
            CALL FTMAHD(Lun, 1, iext, istat)
         ELSE
            CALL FTMAHD(Lun, -Ievent, iext, istat)
         END IF
C Construct original array size.
         CALL FTGKYJ(Lun,'NAXIS1',ixmax,ctmp,istat)
         CALL FTGKYJ(Lun,'NAXIS2',iymax,ctmp,istat)
         CALL FTGKYJ(Lun,'NAXIS',ndim,ctmp,istat)
      ELSE
C
C Set FITS pointer to EVENTS data record.
C
         CALL FTMAHD(Lun, Ievent, iext, istat)
         CALL FTGKYJ(Lun, 'NAXIS2', nrows, ctmp, istat)
         CALL RFCQPC(ixcol, iycol)
         CALL RFCQSC(iscol, ibcol, iocol)
         ioclk(1) = 0
         CALL RFCQTC(itcol, iicol, iimin, iimax)
         IF ( iimax-iimin+1.GT.MXGTI ) THEN
            CALL PTBUF('RFDATA--Too many CCDs in data.',-1)
            iimax=MXGTI+iimin-1
         END IF
         IF ( iicol.GT.0 ) THEN
            ifccd = 1
         ELSE
            ifccd = 0
         END IF
         CALL RFCQPR(ixmin, ixmax, iymin, iymax)
      END IF
C
      IF ( Qmap ) THEN
         npmap = 0
         DO j = 1, Mxcol
            DO i = 1, Mxrow
               Rmap(i,j) = 0.0
            END DO
         END DO
         CALL POS_DT_IM(FLOAT(ixmax),FLOAT(iymax), Nrow, Ncol)
         Nrow = MIN(MAX(1, Nrow), Mxrow)
         Ncol = MIN(MAX(1, Ncol), Mxcol)
      END IF
C
      IF ( Ievent.LE.0 ) THEN
C
C Simple FITS image
C
         igroup = 0
         rnul = NO
         IF ( ixmax.GT.MXI ) THEN
            CALL PTBUF('RFDATA--Warning FITS image dimension is'//
     &          ' larger than the internal buffer',-1)
            WRITE(*,*) 'RFDATA--size of MXI (',MXI,
     :                  ').  Image will be incomplete.'
            nread = MXI
         ELSE
            nread = ixmax
         END IF
         CALL POS_MAP_DET(1, 1, xpos, ypos)
         ilo = MAX(1,NINT(xpos-ifac))
         jlo = MAX(1,NINT(ypos-ifac))
         CALL POS_MAP_DET(Mxrow, Mxcol, xpos, ypos)
         ihi = MIN(nread,NINT(xpos+ifac))
         jhi = MIN(iymax,NINT(ypos+ifac))
         ibegin = 1 + (jlo-1)*ixmax + (islice-1)*ixmax*iymax
         DO j = jlo, jhi
            CALL FTGPVE(Lun,igroup,ibegin+ilo-1,ihi-ilo+1,rnul,
     &         rdata,qbad,istat)
            DO i = ilo, ihi
               CALL POS_DT_IM(FLOAT(i), FLOAT(j), imx, imy)
               IF ( 0.LT.imx .AND. imx.LE.Mxrow .AND.
     :              0.LT.imy .AND. imy.LE.Mxcol ) THEN
                  Rmap(imx,imy) = Rmap(imx,imy) + rdata(i-ilo+1)
               END IF
            END DO
            ibegin = ibegin + ixmax
         END DO
         CALL rftint(Lun, igtccd, Tinteg)
         GOTO 999
      END IF
C----------------------------------
C Read Event data from FITS file
C
C If X/Y position is not needed then set qxy=.FALSE. to avoid calling
C FITSIO to read X/Y coordinates.  (Ispec.LT.0 indicates a grating.)
C
      IF ( ixcol.LE.0 .AND. iycol.LE.0 ) Qdobl = .FALSE.
      IF ( Qdobl .OR. Qmap .OR. Ispec.LT.0 ) THEN
         qxy = .TRUE.
      ELSE
         qxy = .FALSE.
      END IF
C
C If we are not creating a new map, but creating a spectrum or time series,
C and a valid map has been passed in, then we will use the map to MASK data.
C I.e., do not read any events that would fall into a map bin that the
C user has marked bad.
      nmbad = 0
      IF( .NOT.Qmap .AND. (Ispec.GT.0 .OR. Qtime) .AND. Nrow.GT.0
     &  .AND. Ncol.GT.0 .AND. ixcol.GT.0 .AND. iycol.GT.0 ) THEN
         qmbad = .TRUE.
      ELSE
         qmbad = .FALSE.
      END IF
C
C If no spectral limits and we are not reading a spectrum then don't
C read the spectral column.
      nbhist = 0
      IF ( .NOT.Qdosl .AND. Ispec.EQ.0 ) THEN
         iscol = 0
      ELSE
         CALL RFCQSR(ismin, ismax)
         Nchan = (ismax - ismin)/Iscomp + 1
C
C Check to see if spectral data is a vector, i.e., ACIS data.
         istat = 0
         CALL FTGTCL(Lun, iscol, idcode, nscols, iwid, istat)
         IF ( nscols.EQ.1 ) THEN
            qstab = .FALSE.
         ELSE
C Must deal with ACIS splits, etc.
            qstab = .TRUE.
            nscols = MIN(MXSCOL, nscols)
            CALL GTACIS(islevel)
C By convention if the TDIM keyword exits, then the center pixel is at
C the center of the array.  Otherwise, the center pixel is first in the
C array (ASCA convention).
            istat = 0
            CALL FTKEYN('TDIM',iscol,ckey,istat)
            CALL FTGKYS(Lun, ckey, cvalue, ctmp, istat)
            IF ( istat.EQ.0 ) THEN
               icent = (nscols+1)/2
            ELSE
               icent = 1
            END IF
         END IF
      END IF
C
C Initialize histogram array.
C
      nsplit = 0
      IF ( Ispec.NE.0 ) THEN
         nbch = 0
         nbw = 0
         nsbck = 0
         nssrc = 0
         DO i = 1, Mxchan
            Rspec(i,1) = 0.0
            Rspec(i,2) = 0.0
         END DO
         IF ( Ispec.LT.0 ) THEN
C Grating
            CALL grdat(angle, wids, widib, widob, ppc)
            wmax = MAX(wids, widob)
            cang = COS(angle/rtd)
            sang = SIN(angle/rtd)
            IF ( Ispec.EQ.-2 ) THEN
               Ichoff = 1
               Nchan = MAX((ixmax-ixmin+1),(iymax-iymin+1))/(2*ppc)
            ELSE
               Nchan = MAX(ixmax-ixmin+1,iymax-iymin+1)/ppc
C Force zero order to be in the middle of the aray
               Ichoff = Nchan/2
            END IF
         END IF
         IF ( Nchan.GT.Mxchan ) THEN
            WRITE(*, 181) Nchan, Mxchan
  181       FORMAT(' RFDATA--Number of channels=',I7,
     &            ', exceeds maximum number=',I7)
            Nchan = Mxchan
         END IF
      END IF
C
C Do we have a time column then what additional setup/processing is needed?
      DO i=1,MXGTI
         igtccd(i) = 0
      END DO
      qrdtim = .FALSE.
      nbgti  = 0
      nbutim = 0
      iccd(1) = 1
      IF ( itcol.GT.0 ) THEN
         istat = 0
         CALL FTKEYN('TTYPE',itcol,ckey,istat)
         CALL FTGKYS(Lun,ckey,cvalue,ctmp,istat)
         CALL UPC(cvalue)
C
C If user specified a start time, then it makes the start bin.
         CALL GTIQUT(qutim, dts, dtmp)
         dtls = 0.0d0
         CALL GTIQDO(qdogti)
         IF ( INDEX(cvalue,'TIME').GT.0 ) THEN
C Only columns that contain the string TIME need GTI.
            itdat = 1
            CALL GTIBEG(Lun, Ievent, Itcol, dtls)
            IF ( qutim ) THEN
               dtls = MAX(dtls, dts+doff)
            END IF
         ELSE
            qdogti=.FALSE.
            itdat = 0
            IF ( qutim ) THEN
               dtls = dts
            ELSE
               CALL FTGCVD(Lun,itcol,1,1,1,dnul,dtls,qbad,istat)
            END IF
         END IF
C
C We will read the time column if itcol<>0 and either, 1. User specified
C time limits, 2. User requested a LC, 3. file contains GTI's
         IF ( qutim .OR. Qtime .OR. qdogti ) qrdtim=.TRUE.
C
         IF ( Qtime ) THEN
C
C Initialize timing counters.
C
            ntbck = 0
            ntsrc = 0
            lasbin = 0
C Initialize data array to zeros.
            DO i = 1, Mxrate
               Rate(i,1) = 0.
               Rate(i,2) = 0.
            END DO
         END IF
      END IF
C
C Provide user with some feedback concerning what data is being read.
C
      CALL PTBUF(' ',-1)
      CALL PTBUF('All events',-1)
      IF ( Qdobl ) THEN
         CALL PTBUF('in selected bounds',-1)
      END IF
      IF ( qutim ) THEN
         CALL PTBUF('in specified times',-1)
      END IF
      IF ( qdogti ) THEN
         CALL PTBUF('in valid GTIs',-1)
      END IF
      IF ( Qdosl ) THEN
         WRITE(*,*) 'in histogram range:',Islo,Ishi
      END IF
      IF ( qmbad ) THEN
         CALL PTBUF('that have not been marked bad',-1)
      END IF
      CALL PTBUF('are now being read...',-1)
C
      inul = 0
      dnul = 0.0D0
      ibpos = 1
      istat = 0
      DO 190 i=1,nrows
C
         IF ( qxy ) THEN
            CALL FTGCVE(Lun,ixcol,i,1,1,NO,xpos,qbad,istat)
            CALL FTGCVE(Lun,iycol,i,1,1,NO,ypos,qbad,istat)
            IF ( Qdobl ) THEN
               ibpos = INBOU(xpos,ypos)
               IF ( ibpos.EQ.0 ) THEN
                  GOTO 190
               END IF
            END IF
         END IF
C
         IF ( iscol.GT.0 ) THEN
            CALL FTGCVJ(Lun,iscol,i,1,nscols,inul,ipvec,qbad,istat)
            IF ( ibcol.GT.0 ) THEN
C If there is a BIAS column, read it and subtract it.
               CALL FTGCVJ(Lun,ibcol,i,1,nscols,inul,ibvec,qbad,istat)
               IF ( iocol.GT.0 ) THEN
                  CALL FTGCVJ(Lun,iocol,i,1,1,inul,ioclk(1),qbad,istat)
               END IF
               DO j=1,nscols
                  ipvec(j) = ipvec(j) - ibvec(j) - ioclk(1)
               END DO
            END IF
            IF ( .NOT.qstab ) THEN
               ichan = ipvec(1)
            ELSE
C Sum pha vector, only include if PHA>islevel (default to 13).
               ichan = Ipvec(icent)
               iflag = 0
               DO j=1, nscols
                  IF ( j.NE.icent .AND. ipvec(j).GT.islevel ) THEN
                     ichan = ichan + ipvec(j)
                     iflag = iflag + 1
                  END IF
               END DO
               IF ( iflag.GT.0 ) nsplit = nsplit + 1
            END IF
            ichan = (ichan - ismin)/Iscomp + 1
            IF( Qdosl .AND. (ichan.LT.Islo .OR. Ishi.LT.ichan)) THEN
               nbhist = nbhist + 1
               GOTO 190
            END IF
         END IF
C
C Read the GTI "index" column
         IF ( iicol.GT.0 ) THEN
            CALL FTGCVJ(Lun,iicol,i,1,1,inul,iccd(1),qbad,istat)
            IF ( iccd(1).LT.iimin .OR. iccd(1).GT.iimax ) THEN
      write(*,*) 'bad iicol, iccd=',iicol,iccd(1),iimin,iimax
               iccd(1) = 1
            ELSE
               iccd(1) = iccd(1) - iimin + 1
            END IF
         END IF
C
C Read time if needed.
         IF ( qrdtim ) THEN
            CALL FTGCVD(Lun,itcol,i,1,1,dnul,dtime,qbad,istat)
C If we are checking GTI then do so
            IF ( qdogti ) THEN
               CALL GTIVAL(Lun, dtime, iccd(1), itmp)
               IF ( itmp.EQ.0 ) THEN
                  nbgti = nbgti + 1
                  GOTO 190
               END IF
            END IF
C and check if within user specified time limits.
            CALL GTIINU(dtime+Dtzero, itmp)
            IF ( itmp.EQ.0 ) THEN
               nbutim = nbutim + 1
               GOTO 190
            END IF
         END IF
C
C Do the bad pixel test last so the GTI test always rejects the same number.
         IF ( qmbad ) THEN
            CALL POS_DT_IM(xpos,ypos,imx,imy)
            IF ( 0.LT.imx .AND. imx.LE.Nrow .AND.
     &           0.LT.imy .AND. imy.LE.Ncol ) THEN
               IF ( Rmap(imx,imy).EQ.NO ) THEN
                  nmbad = nmbad + 1
                  GOTO 190
               END IF
            END IF
         END IF
C
C Count CCD info for events that make it to here.
         igtccd(iccd(1)) = igtccd(iccd(1)) + 1
C
C Create map
         IF ( Qmap ) THEN
            CALL POS_DT_IM(xpos,ypos,imx,imy)
            IF ( 0.LT.imx .AND. imx.LE.Nrow .AND.
     &           0.LT.imy .AND. imy.LE.Ncol ) THEN
               Rmap(imx,imy) = Rmap(imx,imy) + 1.0
               npmap = npmap + 1
            END IF
         END IF
C
C Accumulate spectrum
         IF ( Ispec.NE.0 ) THEN
            IF ( Ispec.LT.0 ) THEN
               wtmp = ABS(-sang*(xpos-Xdet)+cang*(ypos-Ydet))
               IF ( wtmp.GT.wmax ) THEN
                  nbw = nbw + 1
                  GOTO 190
               ELSE
                  rtmp = cang*(xpos-Xdet)+sang*(ypos-Ydet)
                  IF ( Ispec.EQ.-2 ) THEN
C Want energy increasing with channel
                     ichan = Nchan - INT(ABS(rtmp)/ppc)
                  ELSE
                     ichan = ichoff + rtmp/ppc
                  END IF
                  IF ( wtmp.LE.wids ) THEN
C Inside source width
                     ibpos = +1
                  ELSE IF ( wtmp.LT.widib ) THEN
C Between source and background (no man's land)
                     ibpos = 0
                     nbw = nbw + 1
                     GOTO 190
                  ELSE
C In background
                     ibpos = -1
                  END IF
               END IF
            END IF
            IF ( 0.LT.ichan .AND. ichan.LE.Nchan ) THEN
               IF ( ibpos.LT.0 ) THEN
                  Rspec(ichan,2) = Rspec(ichan,2) + 1.
                  nsbck = nsbck + 1
               ELSE
                  Rspec(ichan,1) = Rspec(ichan,1) + 1.
                  nssrc = nssrc + 1
               END IF
            ELSE
               nbch = nbch + 1
            END IF
         END IF
C
C Create lightcurve
         IF ( Qtime ) THEN
C
C Assign count to either a phase bin or a rate bin
C
            IF ( Qphase ) THEN
               ibin = IPHASE(dtime+Dtzero-Doff,Dtim0,Dnu,Dnudot,Nbins)
            ELSE
               ibin = 1 + (dtime+Dtzero-Dtls)/Dtb
            END IF
            IF ( 0.LT.ibin .AND. ibin.LE.Mxrate ) THEN
               lasbin = MAX( lasbin, ibin )
               IF ( ibpos.LT.0 ) THEN
                  Rate(ibin,2) = Rate(ibin,2) + 1.0
                  ntbck = ntbck + 1
               ELSE
                  Rate(ibin,1) = Rate(ibin,1) + 1.0
                  ntsrc = ntsrc + 1
               END IF
            END IF
         END IF
C
  190 CONTINUE
C
C Compute efficiency array.
      nbtb = 0
      IF ( Qtime ) THEN
         IF ( .NOT.Qphase ) THEN
            IF ( qdogti ) THEN
C Last point is based on end of GTI (if GTI is not defined in file, then
C GTIEND returns last point in file, which is better than last point in bounds.
C Subtract 0.10*dtb to allow for some round off error.  Besides if the
C bin is only 10% full, it's not that important...
               CALL GTIEND(Lun, dtend)
               ibin = 1 + (dtend+Dtzero-Dtls-0.10*Dtb)/Dtb
               Nbins = MIN(Mxrate, ibin)
            ELSE
               Nbins = lasbin
            END IF
         END IF
         nrbin = 0
         IF ( itdat.NE.0 ) Dts = dtls - Doff
         IF ( itdat.LE.0 .OR. Qphase ) THEN
            Nbins = lasbin
            DO i=1, Nbins
               Rate(i,3) = 1.0
               IF ( Rate(i,1).GT.0.0 ) nrbin = nrbin + 1
            END DO
         ELSE
            CALL GTIEFF(Lun, igtccd, Nbins, Rate(1,3))
            nrbin = 0
            DO i = 1, Mxrate
               IF ( Rate(i,3).GT.0. ) THEN
                  nrbin = nrbin + 1
               ELSE
                  nbtb = nbtb + Rate(i,1)
                  Rate(i,1) = NO
                  Rate(i,2) = NO
               END IF
            END DO
         END IF
      END IF
C---
      CALL PTBUF(' ',-1)
      WRITE(*,*) 'Total counts in file :',nrows
      IF ( nbgti.GT.0)  WRITE(*,*) 'Counts with bad GTI  :', nbgti
      IF ( nbhist.GT.0) WRITE(*,*) 'Counts with bad hist.:', nbhist
      IF ( nmbad.GT.0)  WRITE(*,*) 'Counts marked bad    :', nmbad
C
      IF ( Qmap ) THEN
         WRITE(*,*) 'Total counts in map  :', npmap
      END IF
C
      IF ( nbutim.GT.0 ) THEN
         WRITE(*,*) 'Counts with bad utime:', nbutim
      END IF
C---
C Get integration time
      IF ( itdat.GT.0 .OR. Ispec.NE.0 ) THEN
         IF ( iicol.GT.0 )
     &      WRITE(*,*) 'by CCD=',(igtccd(k),k=1,iimax-iimin+1)
         CALL rftint(Lun, igtccd, Tinteg)
      END IF
C
      IF ( Ispec.NE.0 ) THEN
         WRITE(*,*) 'Counts in sour spect :', nssrc
         WRITE(*,*) 'Counts in back spect :', nsbck
         IF ( nbw.NE.0 )   WRITE(*,*) 'Counts with bad width:', nbw
         IF ( nbch.NE.0 )  WRITE(*,*) 'Counts with bad chan :', nbch
         IF ( nsplit.GT.0 ) THEN
            WRITE(*,*) 'Counts with split PHA:',nsplit,
     :         ', Slevel=',islevel
         END IF
      END IF
C
      IF ( qrdtim ) THEN
         WRITE(*,311) doff
 311     FORMAT(' Doff (time offset)   :', F14.2)
         IF ( Dtzero.NE.0.0d0 ) THEN
            WRITE(*,*) 'Dtzero (correction)  :', dtzero
         END IF
      END IF
      CALL PTBUF(' ',-1)
      IF ( Qtime ) THEN
         WRITE(*,*) 'Bins with eff>0      :', nrbin
         IF ( nbtb.GT.0) WRITE(*,*) 'Counts with bad eff. :', nbtb
         WRITE(*,*) 'Last bin with events :', lasbin
         WRITE(*,*) 'Source counts in LC  :', ntsrc
         IF ( Qphase .OR. itdat.LE.0 ) THEN
            WRITE(*,*) 'Uncorrected counts per bin: ',
     &            ntsrc/FLOAT(Nbins)
         ELSE
            WRITE(*,*) 'Source rate in LC    :',ntsrc/Tinteg,' /sec'
         END IF
         WRITE(*,*) 'Back counts in LC    :', ntbck
         IF ( Qphase .OR. itdat.LE.0 ) THEN
            WRITE(*,*) 'Uncorrected counts per bin: ',
     &            ntbck/FLOAT(Nbins)
         ELSE
            WRITE(*,*) 'Back rate in LC      :',ntbck/Tinteg,' /sec'
         END IF
         CALL PTBUF(' ',-1)
      END IF
C
 999  CONTINUE
      RETURN
C*********
      ENTRY RFGCCD(ifill, neccd)
      ifill = ifccd
      DO i=1,MXGTI
         neccd(i) = igtccd(i)
      END DO
      END
