      SUBROUTINE RFDS(Lun, Ievent, Nrow, Ncol, Ier)
      INTEGER   Lun, Ievent, Nrow, Ncol, Ier
C---
C Only reads information about the data structure.  Thus can be
C used to read a background without polluting WCS for the data array.
C---
C Lun     I    Logical unit number of open FITS file
C Ievent    O  Header number containing EVENTS extension
C Nrow      O  Number of rows in FITS file
C Ncol      O  Number of columns in FITS file
C Ier       O
C---
C 2004-Apr-13 - Extracted from RFHEAD [AFT].
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXNAX
      PARAMETER (MXNAX=99)
      INTEGER   LENACT
C
      INCLUDE 'posdef.inc'
C
      CHARACTER ctmp*64, cvalue*64
      CHARACTER cext*32
      CHARACTER ckey*16
      INTEGER   naxes(MXNAX)
      INTEGER   i, ibits, icnt, iext, igcnt, ipcnt, itmp, istat
      INTEGER   ixmin, ixmax, iymin, iymax
      INTEGER   ltmp, naxis, nslice
      LOGICAL   qsimp, qxtend
C
C Assume we fail
      Ier = 1
      Ievent = 0
C
C Read keywords from primary header
C
      istat = 0
      naxes(1) = 0
      naxes(2) = 0
      CALL FTGHPR(Lun,MXNAX,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
C
      Ndim = 2
      Islice = 1
      IF ( naxis.EQ.0 .AND. qxtend ) THEN
C
C Read extension header records looking for EVENTS data.
C
  130    CONTINUE
         CALL SSGFE(cext)
         CALL UPC(cext)
         istat = 0
         icnt = 0
         DO i=1,100
            CALL FTMAHD(Lun, i, iext, istat)
            IF ( istat.NE.0 ) GOTO 140
            itmp = 0
            CALL FTGKYS(Lun, 'EXTNAME', cvalue, ctmp, itmp)
            IF ( itmp.NE.0 ) THEN
               itmp = 0
               CALL FTGKYS(Lun, 'XTENSION', cvalue, ctmp, itmp)
               IF ( ctmp(1:5).EQ.'IMAGE' ) GOTO 190
               IF ( ctmp(1:8).EQ.'BINTABLE' ) GOTO 190
            ELSE
               CALL UPC(cvalue)
               IF ( cvalue.EQ.cext ) GOTO 190
               IF ( cvalue(1:8).EQ.'FILT_EVT' ) GOTO 190
               IF ( cvalue(1:6).EQ.'STDEVT' ) GOTO 190
               icnt = icnt + 1
               ctmp = cvalue
            END IF
         END DO
  140    CONTINUE
         WRITE (*,*) 'RFHEAD--Cannot find ',cext(:LENACT(cext)),' data.'
         IF ( icnt.EQ.1 ) THEN
            ltmp = LENACT(ctmp)
            WRITE (*,*) 'RFHEAD--Using ',ctmp(:ltmp),' instead.'
            CALL SSPFE(ctmp)
            GOTO 130
         END IF
         istat = 0
         icnt = 2
  160    CONTINUE
         CALL FTMAHD(Lun, icnt, iext, istat)
         IF ( istat.EQ.0 ) THEN
            itmp = 0
            CALL FTGKYS(Lun, 'EXTNAME', cvalue, ctmp, itmp)
            CALL PTBUF(cvalue,-1)
            icnt = icnt + 1
            GOTO 160
         END IF
         CALL GTBUF('Enter extension now (blank to ignore):', itmp)
         IF ( itmp.EQ.0 ) THEN
            CALL GTCHAR(ctmp, ltmp)
            IF ( ltmp.GT.0 ) THEN
               CALL SSPFE(ctmp)
               GOTO 130
            END IF
         END IF
         CALL FTCLOS(Lun,istat)
         GOTO 999
C---
 190     CONTINUE
C Save header number containing event data
         Ievent = I
         CALL FTMAHD(Lun, i, iext, istat)
         CALL FTGKYS(Lun, 'XTENSION', cvalue, ctmp, itmp)
         CALL UPC(cvalue)
         IF ( cvalue.EQ.'IMAGE' ) Ievent = -Ievent
      END IF
C
      IF ( Ievent.GT.0 ) THEN
C Allow define the columns to be read
         CALL RFCOLS(Lun, Ievent)
         CALL RFCQPR(ixmin, ixmax, iymin, iymax)
         Nrow = ixmax - ixmin + 1
         Ncol = iymax - iymin + 1
      ELSE
C Check to see if file contains a data cube instead of just one image.
         istat = 0
         CALL FTGKYJ(Lun, 'NAXIS', ndim, ctmp, istat)
         IF ( ndim.GT.2 ) THEN
C Data contains more than two dimensions, select a slice.
            nslice = 1
            DO i=3,ndim
               ckey = 'NAXIS'//CHAR(48+i)
               istat = 0
               CALL FTGKYJ(Lun,ckey,itmp,ctmp,istat)
               IF ( istat.NE.0 ) GOTO 220
               nslice = nslice*itmp
            END DO
  220       CONTINUE
            WRITE(*,*) 'Total number of images =',nslice
            CALL GTBUF('Slice:', ier)
            CALL GTINT(islice, ier)
            IF ( islice.GT.nslice ) GOTO 220
         END IF
         istat = 0
         CALL FTGKYJ(Lun,'NAXIS1',Nrow,ctmp,istat)
         CALL FTGKYJ(Lun,'NAXIS2',Ncol,ctmp,istat)
      END IF
      write(*,*) 'Nrow, Ncol=',Nrow,Ncol
C
      Ier = 0
C
 999  CONTINUE
      RETURN
      END
