      SUBROUTINE RFHEAD(Lun, Ievent, Nrow, Ncol, Ier)
      INTEGER   Lun, Ievent, Nrow, Ncol, Ier
C---
C Reads the any and all keywords from the header that lextrct can use.
C---
C Lun     I    Logical unit number of open FITS file
C Ievent    O  Header number containing EVENTS extension
C Nrow      O  Number of rows in FITS file
C Ncol      O  Number of columns in FITS file
C Ier       O
C---
C 1992-May-13 - New routine [AFT].
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
C
      INCLUDE 'posdef.inc'
C
      CHARACTER ctmp*64, cvalue*64
      DOUBLE PRECISION dra, ddec
      REAL      roll, xpos, ypos
      INTEGER   istat
C
C Assume we fail
      Ier = 1
      Ievent = 0
C
C Read the data structure keywords.
C
      CALL RFCINT
      CALL RFDS(Lun, Ievent, Nrow, Ncol, Ier)
      IF ( Ier.NE.0 ) GOTO 999
C
C Read additional keywords.  For EVENTS data, this will be in the EVENTS
C header, for all other files, this should be the primary header.
      CALL rfwcs(Lun, Ievent)
C
      istat = 0
      CALL FTGKYD(Lun, 'RA_NOM', dra, ctmp, istat)
      CALL FTGKYD(Lun, 'DEC_NOM', ddec, ctmp, istat)
      IF ( istat.EQ.0 ) THEN
         CALL POS_RA_DT(dra, ddec, xpos, ypos)
         CALL STFWCN(xpos, ypos)
      ELSE
         CALL STFWCN(NO, NO)
      END IF
C
      istat = 0
      CALL FTGKYE(Lun, 'ROLL_NOM', roll, ctmp, istat)
      IF ( istat.EQ.0 ) THEN
         CALL PSSROL(roll)
      END IF
C
      istat = 0
      CALL FTGKYS(Lun, 'OBJECT', cvalue, ctmp, istat)
      IF ( istat.EQ.0 ) THEN
         CALL DITLBL(cvalue)
      END IF
C
C Special patch to automatically read the HRI files (1996-07-17) and
C load the PLT label
      istat = 0
      CALL FTGKYS(Lun, 'PHOTMODE', cvalue, ctmp, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL FTGKYS(Lun, 'HRI-COMM', cvalue, ctmp, istat)
      END IF
      IF ( istat.EQ.0 ) THEN
         CALL DITLBL(cvalue)
      END IF
C
      Ier = 0
C
 999  CONTINUE
      RETURN
      END
