      SUBROUTINE rftint(Lun, Igtccd, Tinteg)
      INTEGER   Lun, Igtccd(*)
      REAL      Tinteg
C---
C Read the integration time from the file.  The integration time
C is read from (in order of preference):
C 1. The exposure map
C 2. The Good Time Intervals
C 3. The FITS keywords (LIVETIME, ONTIME, or EXPTIME)
C---
C Lun     I    Unit number of open FITS file.
C Igtccd  I
C Tinteg    O
C---
C 1998-02-24 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXKEYS
      PARAMETER (MXKEYS=3)
      REAL      FPNUM
      INTEGER   LENACT
C
      CHARACTER ckeys(MXKEYS)*16
      CHARACTER ctmp*64, cvalue*64
      INTEGER   i, ier, istat, lvalue
      DATA      ckeys/'LIVETIME','ONTIME','EXPTIME'/
C
      Tinteg = 0.0
C First try reading the exposure map.
      istat = 0
      CALL GETMEX(Lun, Tinteg, istat)
      IF ( istat.EQ.0 ) THEN
         WRITE(*,*) 'Integration Time     :',Tinteg,
     &         ' (from exposure map)'
         RETURN
      END IF
C
C Next look for a GTI
      CALL GTITOT(Lun, igtccd, Tinteg)
      IF ( Tinteg.GT.0.0 ) THEN
         WRITE(*,*)'Integration Time     :',Tinteg,' (from GTI average)'
         RETURN
      END IF
C Finally some FITS keywords:
      DO i=1, MXKEYS
         istat = 0
         CALL FTGKYE(Lun, ckeys(i), Tinteg, ctmp, istat)
         IF ( istat.EQ.0 ) THEN
            WRITE(*,*) 'Integration Time     :',Tinteg,' (from ',
     &         ckeys(i)(:LENACT(ckeys(i))),')'
            RETURN
         END IF
         IF ( istat.EQ.405 ) THEN
C Special case where SDSS writes EXPTIME as a string.
            istat = 0
            CALL FTGKYS(Lun, ckeys(i), cvalue, ctmp, istat)
            lvalue = LENACT(cvalue)
            Tinteg = FPNUM(cvalue, lvalue, ier)
            IF ( Tinteg.GT.0 .AND. ier.EQ.0 ) THEN
               WRITE(*,*) 'Integration Time     :',Tinteg,' (from ',
     &          ckeys(i)(:LENACT(ckeys(i))),')'
               RETURN
            END IF
         END IF
      END DO
      CALL GTIDUR(Lun, Tinteg)
      IF ( Tinteg.GT.0.0 ) THEN
         WRITE(*,*)'Integration Time     :',Tinteg,' (first/last event)'
         RETURN
      END IF
C---
      WRITE(*,*) 'RFTINT--Unable to calculate integration time.'
      Tinteg = NO
C
      END
