      SUBROUTINE rfwcs(Lun, Ievent)
      INTEGER   Lun, Ievent
C---
C Read the WCS coordinates from the FITS header.  The keywords are
C different for FITS images and FITS binary tables.
C---
C Lun     I    Unit number of open FITS file.
C---
C 1997-11-19 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INTEGER   LENACT
C
      CHARACTER ctmp*64, cvalue*64
      CHARACTER ccol*16, ckey*16, cnul*16
      DOUBLE PRECISION dnul, dtmp
      INTEGER   i, icol, iext, iflip, ihsav, imdi, istat
      INTEGER   itmp, ixcol, iycol, ltmp
      LOGICAL   qbad
C---
C Default values (flagged as not read).
      ctype1 = ' '
      ctype2 = ' '
      Dxpix0 = NO
      Dxref = NO
      Dxdel = NO
      Dypix0 = NO
      Dyref = NO
      Dydel = NO
      Drota = 0.0D0
      Imat  = 0
      iflip = 0
      imdi=0
C
      IF ( ndim.NE.2 ) THEN
C Save the current header.
         CALL FTGHDN(Lun, ihsav)
         istat = 0
         DO i=2,20
            IF ( istat.EQ.0 ) THEN
               CALL FTMAHD(Lun, i, iext, istat)
               itmp = 0
               CALL FTGKYS(Lun, 'EXTNAME', cvalue, ctmp, itmp)
               CALL UPC(cvalue)
               IF ( INDEX(cvalue,'_CVT').GT.0 ) GOTO 150
            END IF
         END DO
C Can't find a coordinate conversion extention, use default.
         GOTO 300
C
C Reading a _CVT (coordindate conversion) extention (HST).
  150    CONTINUE
         dnul = NO
         istat = 0
         icol = 0
         CALL FTGCNN(Lun, .FALSE., 'CRVAL1', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dxref,qbad,istat)
         CALL FTGCNN(Lun, .FALSE., 'CRVAL2', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dyref,qbad,istat)
         CALL FTGCNN(Lun, .FALSE., 'CRPIX1', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dxpix0,qbad,istat)
         CALL FTGCNN(Lun, .FALSE., 'CRPIX2', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dypix0,qbad,istat)
         CALL FTGCNN(Lun, .FALSE., 'ORIENTAT', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,drota,qbad,istat)
         drota = -drota
         CALL FTGCNN(Lun, .FALSE., 'CTYPE1', ccol, icol, istat)
         cnul = ' '
         CALL FTGCVS(Lun,icol,islice,1,1,cnul,cvalue,qbad,istat)
         IF ( istat.NE.0 ) THEN
            ctype1 = '-POS'
         ELSE
            ltmp = LENACT(cvalue)
            ctype1 = cvalue(ltmp-3:ltmp)
            CALL UPC(cvalue)
            IF ( cvalue(1:3).EQ.'DEC' ) iflip=iflip+1
         END IF
         CALL FTGCNN(Lun, .FALSE., 'CTYPE2', ccol, icol, istat)
         cnul = ' '
         CALL FTGCVS(Lun,icol,islice,1,1,cnul,cvalue,qbad,istat)
         IF ( istat.NE.0 ) THEN
            ctype2 = '-POS'
         ELSE
            ltmp = LENACT(cvalue)
            ctype2 = cvalue(ltmp-3:ltmp)
            CALL UPC(cvalue)
            IF ( cvalue(1:2).EQ.'RA' ) iflip=iflip+1
         END IF
C
         istat = 0
         CALL FTGCNN(Lun, .FALSE., 'CD1_1', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dcd11,qbad,istat)
         CALL FTGCNN(Lun, .FALSE., 'CD1_2', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dcd12,qbad,istat)
         dxdel = -SQRT(Dcd11*Dcd11+Dcd12*Dcd12)
         CALL FTGCNN(Lun, .FALSE., 'CD2_1', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dcd21,qbad,istat)
         CALL FTGCNN(Lun, .FALSE., 'CD2_2', ccol, icol, istat)
         CALL FTGCVD(Lun,icol,islice,1,1,dnul,dcd22,qbad,istat)
         dydel = SQRT(Dcd21*Dcd21+Dcd22*Dcd22)
         IF ( istat.EQ.0 ) THEN
            CALL PTBUF('RFWCS--Using matrix.',-1)
            Imat = 1
         END IF
C
         istat = 0
         CALL FTMAHD(Lun, ihsav, iext, istat)
         GOTO 900
      END IF
C
C Read WCS in the extention containing the data.
  300 CONTINUE
      istat = 0
      IF ( Ievent.EQ.0 ) THEN
C Go to primary header record
         CALL FTMAHD(Lun, 1, iext, istat)
      ELSE
         CALL FTMAHD(Lun, Ievent, iext, istat)
      END IF
      CALL RFCQPC(ixcol, iycol)
      IF ( ixcol.EQ.0 .OR. iycol.EQ.0 ) THEN
C Reading an image.
         istat = 0
         CALL FTGKYS(Lun, 'CTYPE1', cvalue, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            ctype1 = '-POS'
         ELSE
            ltmp = LENACT(cvalue)
            ctype1 = cvalue(ltmp-3:ltmp)
            ctmp = cvalue
            CALL UPC(ctmp(:ltmp))
            IF ( ctmp(1:3).EQ.'DEC' ) THEN
               iflip=iflip+1
            ELSE IF ( ctmp(1:2).NE.'RA' ) THEN
               ctype1 = cvalue(:ltmp)
            END IF
         END IF
         CALL FTGKYS(Lun, 'CTYPE2', cvalue, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            ctype2 = '-POS'
         ELSE
            ltmp = LENACT(cvalue)
            ctype2 = cvalue(ltmp-3:ltmp)
            ctmp = cvalue
            CALL UPC(ctmp(:ltmp))
            IF ( ctmp(1:2).EQ.'RA' ) THEN
               iflip=iflip+1
            ELSE IF ( ctmp(1:3).NE.'DEC' ) THEN
               ctype2 = cvalue(:ltmp)
            END IF
         END IF
C Read degrees/pixel
         istat = 0
         CALL FTGKYD(Lun, 'CDELT1', dxdel, ctmp, istat)
         istat = 0
         CALL FTGKYD(Lun, 'CDELT2', dydel, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTGKYD(Lun, 'CD1_1', Dcd11, ctmp, istat)
            CALL FTGKYD(Lun, 'CD1_2', Dcd12, ctmp, istat)
            dxdel = -SQRT(Dcd11*Dcd11+Dcd12*Dcd12)
            CALL FTGKYD(Lun, 'CD2_1', Dcd21, ctmp, istat)
            CALL FTGKYD(Lun, 'CD2_2', Dcd22, ctmp, istat)
            dydel = SQRT(Dcd21*Dcd21+Dcd22*Dcd22)
            IF ( istat.EQ.0 ) THEN
               CALL PTBUF('RFWCS--Using matrix.',-1)
               Imat = 1
            END IF
            CALL FTGKYD(Lun, 'ORIENTAT', drota, ctmp, istat)
            drota = -drota
         END IF
C Read RA/Dec of reference pixel
         istat = 0
         CALL FTGKYD(Lun, 'CRVAL1', dxref, ctmp, istat)
         istat = 0
         CALL FTGKYD(Lun, 'CRVAL2', dyref, ctmp, istat)
C Read pixel location of reference pixel.
         istat = 0
         CALL FTGKYD(Lun, 'CRPIX1', dxpix0, ctmp, istat)
         istat = 0
         CALL FTGKYD(Lun, 'CRPIX2', dypix0, ctmp, istat)
C Rotation
         istat = 0
         CALL FTGKYD(Lun, 'CROTA1', drota, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTGKYD(Lun, 'CROTA2', drota, ctmp, istat)
         END IF
         istat=0
         CALL FTGKYS(Lun, 'CUNIT1', cvalue, ctmp, istat)
         IF ( istat.EQ.0 ) THEN
            CALL UPC(cvalue)
C ctype1='arcsec' is special treatment for Yohkoh data.
            IF ( cvalue(1:6).EQ.'ARCSEC' .OR. ctype1.EQ.'arcsec' ) THEN
               dxdel=dxdel/3600.d0
               dxref=dxref/3600.d0
               Dcd11=Dcd11/3600.d0
               Dcd12=Dcd12/3600.d0
            END IF
         END IF
         istat=0
         CALL FTGKYS(Lun, 'CUNIT2', cvalue, ctmp, istat)
         IF ( istat.EQ.0 ) THEN
            CALL UPC(cvalue)
            IF ( cvalue(1:6).EQ.'ARCSEC' .OR. ctype2.EQ.'arcsec' ) THEN
               dydel=dydel/3600.d0
               dyref=dyref/3600.d0
               Dcd21=Dcd21/3600.d0
               Dcd22=Dcd22/3600.d0
            END IF
         END IF
      ELSE
C Reading a binary table
         istat = 0
         CALL FTKEYN('TCTYP',ixcol,ckey,istat)
         CALL FTGKYS(Lun, ckey, cvalue, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CTYPE',ixcol,ckey,istat)
            CALL FTGKYS(Lun,ckey, cvalue, ctmp, istat)
         END IF
         IF ( istat.NE.0 ) THEN
            ctype1 = '-POS'
         ELSE
            CALL UPC(cvalue)
            IF ( cvalue(1:3).NE.'DEC' ) iflip=iflip+1
            ltmp = LENACT(cvalue)
            ctype1 = cvalue(ltmp-3:ltmp)
         END IF
         istat = 0
         CALL FTKEYN('TCTYP',iycol,ckey,istat)
         CALL FTGKYS(Lun, ckey, cvalue, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CTYPE',iycol,ckey,istat)
            CALL FTGKYS(Lun,ckey, cvalue, ctmp, istat)
         END IF
         IF ( istat.NE.0 ) THEN
            ctype2 = '-POS'
         ELSE
            ltmp = LENACT(cvalue)
            ctype2 = cvalue(ltmp-3:ltmp)
         END IF
C Read degrees/pixel
         istat = 0
         CALL FTKEYN('TCDLT',ixcol,ckey,istat)
         CALL FTGKYD(Lun, ckey, dxdel, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CDELT',ixcol,ckey,istat)
            CALL FTGKYD(Lun, ckey, dxdel, ctmp, istat)
         END IF
         istat = 0
         CALL FTKEYN('TCDLT',iycol,ckey,istat)
         CALL FTGKYD(Lun, ckey, dydel, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CDELT',iycol,ckey,istat)
            CALL FTGKYD(Lun, ckey, dydel, ctmp, istat)
         END IF
C Read RA/Dec of reference pixel
         istat = 0
         CALL FTKEYN('TCRVL',ixcol,ckey,istat)
         CALL FTGKYD(Lun, ckey, dxref, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CRVAL',ixcol,ckey,istat)
            CALL FTGKYD(Lun, ckey, dxref, ctmp, istat)
         END IF
         istat = 0
         CALL FTKEYN('TCRVL',iycol,ckey,istat)
         CALL FTGKYD(Lun, ckey, dyref, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CRVAL',iycol,ckey,istat)
            CALL FTGKYD(Lun, ckey, dyref, ctmp, istat)
         END IF
C Read pixel location of reference pixel.
         istat = 0
         CALL FTKEYN('TCRPX',ixcol,ckey,istat)
         CALL FTGKYD(Lun, ckey, dxpix0, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CRPIX',ixcol,ckey,istat)
            CALL FTGKYD(Lun, ckey, dxpix0, ctmp, istat)
         END IF
         istat = 0
         CALL FTKEYN('TCRPX',iycol,ckey,istat)
         CALL FTGKYD(Lun, ckey, dypix0, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CRPIX',iycol,ckey,istat)
            CALL FTGKYD(Lun, ckey, dypix0, ctmp, istat)
         END IF
C Rotation
         istat = 0
         CALL FTKEYN('TCROT',ixcol,ckey,istat)
         CALL FTGKYD(Lun, ckey, drota, ctmp, istat)
         IF ( istat.NE.0 ) THEN
            istat = 0
            CALL FTKEYN('CROTA',ixcol,ckey,istat)
            CALL FTGKYD(Lun, ckey, drota, ctmp, istat)
            IF ( istat.NE.0 ) THEN
               istat = 0
               CALL FTKEYN('CROTA',iycol,ckey,istat)
               CALL FTGKYD(Lun, ckey, drota, ctmp, istat)
            END IF
         END IF
      END IF
C
  900 CONTINUE
      IF ( iflip.EQ.2 ) THEN
         IF ( imat.NE.0 ) THEN
            CALL PTBUF('RFWCS--Correcting RA/Dec reversal.',-1)
            dtmp=Dxref
            Dxref=Dyref
            Dyref=dtmp
            dtmp=Dcd11
            Dcd11=Dcd21
            Dcd21=dtmp
            dtmp=Dcd12
            Dcd12=Dcd22
            Dcd22=dtmp
         ELSE
            CALL PTBUF(
     &     'RFWCS--Detected RA/Dec are reversed.  IGNORING!',-1)
         END IF
      END IF
C
      istat=0
      CALL FTGKYS(Lun, 'INSTRUME', cvalue, ctmp, istat)
      IF ( cvalue(1:3).EQ.'MDI' ) THEN
C MDI data omits the (X,Y) reference values and measure deltas in arcsec.
         Dxref=0.0d0
         Dyref=0.0d0
         Dxdel=Dxdel/3600.d0
         Dydel=Dydel/3600.d0
      END IF
C
      IF ( Dxpix0.NE.NO .AND. Dxref.NE.NO .AND. Dxdel.NE.NO .AND.
     &     Dypix0.NE.NO .AND. Dyref.NE.NO .AND. Dydel.NE.NO ) THEN
         Iwcs = 1
      ELSE
         CALL PTBUF(' RFWCS:  Failed to read all WCS parameters.', -1)
         Iwcs = 0
      END IF
C
      END
