      SUBROUTINE RGAREA(Rmap, Mxrow, Nrow, Ncol, Areai, Areao)
      INTEGER  Mxrow, Nrow, Ncol
      REAL     Rmap(Mxrow,*)
      REAL     Areai, Areao
C---
C Region support routine.  This routine runs through the current
C map and counts the number of detector pixels included in the inner
C and outer regions.  The map is *not* examined so bad data pixels
C are also counted.
C---
C Areai   O  Number of detector pixels in inner region
C Areao   O  Number of detector pixels in outer region
C---
C 1999-Aug-19 - Loops over detector (not map) pixels [AFT]
C 1997-Mar-18 - Now returns number of detector pixels included [AFT]
C 1993-Aug-16 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   INBOU
C
      REAL     xdeth, xdetl, xpos, ydeth, ydetl, ypos
      REAL     xih, xil, yih, yil
      INTEGER  i, imx, imy, itmp, j
      LOGICAL  qmbad
C
      IF ( Nrow.GT.0 .and. Ncol.GT.0 ) THEN
         qmbad = .TRUE.
      ELSE
         qmbad = .FALSE.
      END IF
      CALL BOUQOB(xdetl, ydetl, xdeth, ydeth)
C Since inner region may be outside the "outer" region, query both.
      CALL BOUQIB(xil, yil, xih, yih)
      xdetl = MIN(xdetl, xil)
      xdeth = MAX(xdeth, xih)
      ydetl = MIN(ydetl, yil)
      ydeth = MAX(ydeth, yih)
C
      Areai = 0.0
      Areao = 0.0
      DO i = NINT(xdetl), NINT(xdeth)
         DO j = NINT(ydetl), NINT(ydeth)
            xpos = REAL(i)
            ypos = REAL(j)
            IF ( qmbad ) THEN
               CALL POS_DT_IM(xpos,ypos,imx,imy)
               IF ( 0.LT.imx .AND. imx.LE.Nrow .AND.
     &              0.LT.imy .AND. imy.LE.Ncol ) THEN
                  IF ( Rmap(imx,imy).EQ.NO ) THEN
                     GOTO 190
                  END if
               END IF
            END IF
            itmp = INBOU(xpos,ypos)
            IF ( itmp.GT.0 ) THEN
               Areai = Areai + 1
            ELSE IF ( itmp.LT.0 ) THEN
               Areao = Areao + 1
            END IF
C
  190       CONTINUE
         END DO
      END DO
C
      RETURN
      END
