      SUBROUTINE RGDRAW(Itype, Regp, Npar, Istyle)
      INTEGER   Itype, Npar, Istyle
      REAL      Regp(Npar)
C---
C Subroutine to display current region using specified line-style.
C---
C Itype   I    Type of region (=1 Regp, =2 circle)
C Regp    I    Region parameters
C Npar    I    Number of parameters in Regp
C Istyle  I    Line style for Regp.
C---
C 1992-Apr-06 - New routine [AFT]
C---
      REAL      xp(5), yp(5)
      REAL      ang, radius, rtd
      INTEGER   i, ici, icisav, ilw, jm
      DATA      rtd/57.2957795/
C
      CALL PGQCI(icisav)
      CALL SSGCLW(ici, ilw)
      CALL PGSCI(ici)
      CALL PGSLS(Istyle)
      IF ( Itype.EQ.1 ) THEN
C
C Set up an array defining the rectangle.
         xp(1) = Regp(1)
         xp(2) = Regp(1)
         xp(3) = Regp(3)
         xp(4) = Regp(3)
         xp(5) = Regp(1)
         yp(1) = Regp(2)
         yp(2) = Regp(4)
         yp(3) = Regp(4)
         yp(4) = Regp(2)
         yp(5) = Regp(2)
C Plot Rect.
         CALL PGLINE(5,xp,yp)
      ELSE IF ( Itype.EQ.2 ) THEN
C Circle:
         xp(1) = Regp(1)
         yp(1) = Regp(2)
         radius = Regp(3)
C Make sure we draw only the outline of the circle.
         CALL PGSFS(2)
         CALL PGCIRC(xp(1), yp(1), radius)
      ELSE IF ( Itype.EQ.3 ) THEN
C
C Find the corners of the rotated box.
         xp(1) =Regp(1)+Regp(5)*Regp(3)-Regp(6)*Regp(4)
         yp(1) =Regp(2)+Regp(6)*Regp(3)+Regp(5)*Regp(4)

         xp(2) =Regp(1)-Regp(5)*Regp(3)-Regp(6)*Regp(4)
         yp(2) =Regp(2)-Regp(6)*Regp(3)+Regp(5)*Regp(4)

         xp(3) =Regp(1)-Regp(5)*Regp(3)+Regp(6)*Regp(4)
         yp(3) =Regp(2)-Regp(6)*Regp(3)-Regp(5)*Regp(4)

         xp(4) =Regp(1)+Regp(5)*Regp(3)+Regp(6)*Regp(4)
         yp(4) =Regp(2)+Regp(6)*Regp(3)-Regp(5)*Regp(4)

         xp(5) =Regp(1)+Regp(5)*Regp(3)-Regp(6)*Regp(4)
         yp(5) =Regp(2)+Regp(6)*Regp(3)+Regp(5)*Regp(4)
C And plot.
         CALL PGLINE(5,xp,yp)
      ELSE IF ( Itype.EQ.4 ) THEN
C Ellipse
         xp(1) = Regp(1)
         yp(1) = Regp(2)
         ang = rtd*ATAN2(regp(6), regp(5))
C Make sure we draw only the outline of the circle.
         CALL PGSFS(2)
         CALL PLELIP(xp(1), yp(1), Regp(3), Regp(4), ang)
      ELSE IF ( Itype.EQ.5 ) THEN
         IF ( Npar.LE.4 ) THEN
            write(*,*) 'Polygon too small.'
         ELSE
            xp(1)=Regp(1)
            yp(1)=Regp(2)
            DO i=1,Npar/2-1
               xp(2) = Regp(2*i+1)
               yp(2) = Regp(2*i+2)
               CALL PGLINE(2,xp,yp)
               xp(1)=xp(2)
               yp(1)=yp(2)
            END DO
            xp(2)=Regp(1)
            yp(2)=Regp(2)
            CALL PGLINE(2,xp,yp)
         END IF
      END IF
C
      CALL PGSLS(1)
      CALL PGUPDT
      CALL PGSCI(icisav)
C
      END
