      SUBROUTINE RGGET(Qplot, Mxpar, Itype, Regp, Npar, Qfail)
      INTEGER   Itype, Mxpar, Npar
      REAL      Regp(Npar)
      LOGICAL   Qplot, Qfail
C---
C LEXTRCT routine to define bounds. User either defines a centroid
C and an edge size, two opposite vertices of the box or specifies that the
C whole map is to be used.
C---
C Qplot   I    Plotting device flag
C Mxpar   I
C Itype     O  Type of bounds (1..5)
C Regp      O  Parameters for region
C Npar      O
C Qfail     O  =.TRUE. if failed to create a new region
C---
C 2000-08-25 - Update [AFT]
C---
      INCLUDE 'mapdef.inc'
      INCLUDE 'posdef.inc'
C
      CHARACTER cprom*72, ctmp*32
      CHARACTER cbuf*64
      CHARACTER cdef(5)*4
      REAL      radius, rtd, rx1, rx2, ry1, ry2
      REAL      tmp1, tmp2, tmp3
      INTEGER   ier, lbuf, ltmp
      LOGICAL   pfail
C
      SAVE cbuf, radius, rtd
      DATA cbuf/'S'/, radius/10.0/, rtd/57.2957795/
      DATA cdef/'Rect','Circ','Box','El','Poly'/
C
C Initialize failure flag
C
      Qfail = .FALSE.
 100  CONTINUE
C
C Explain situation to user
C
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.LE.0 ) THEN
         CALL PTBUF(' To define a:', -1)
         CALL PTBUF('   Square (centroid and width)      - type S', -1)
         CALL PTBUF('   Rectangle (two corners)          - type R', -1)
         CALL PTBUF('   Circle (center and radius)       - type C', -1)
         CALL PTBUF('   Box (center,width,height,angle)  - type B', -1)
         CALL PTBUF('   Ellip (center,width,height,angle)- type E', -1)
         CALL PTBUF('   Total image                      - type T', -1)
         CALL PTBUF(' ', 1)
         cbuf = cdef(Itype)
         cprom = 'Your choice (' // cbuf(1:1) // ')?'
         CALL GTBUF(cprom,ier)
         IF ( ier.NE.0 ) THEN
            Qfail = .TRUE.
            GOTO 999
         END IF
      END IF
      CALL GTCHAR(cbuf,lbuf)
      IF ( lbuf.LE.0 ) THEN
         cbuf = cdef(itype)
         lbuf = 1
      END IF
      CALL UPC(cbuf(1:1))
C
      IF ( cbuf(1:1).EQ.'B' ) THEN
C Box, enter center, width, height, angle.
         CALL ASKPOS(Qplot,pfail)
         IF ( pfail ) GOTO 100
C
         tmp1 = 2*regp(3)
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,111) 'Full', tmp1
 111        FORMAT(A4,' Width (',F6.0,'):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(cbuf, lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL RGGTDI(cbuf, lbuf, tmp1, ier)
         END IF
C
         tmp2 = 2*regp(4)
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,121) 'Full', tmp2
 121        FORMAT(A4,' Height (',F6.0,'):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(cbuf, lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL RGGTDI(cbuf, lbuf, tmp2, ier)
         END IF
C
         tmp3 = rtd*ATAN2(regp(6),regp(5))
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,131) tmp3
 131        FORMAT('Angle (',F8.3,' degrees):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL RGGTAN(tmp3, ier)
         Itype = 3
         regp(1) = Xdet
         regp(2) = ydet
         regp(3) = tmp1/2.
         regp(4) = tmp2/2.
         regp(5) = COS(tmp3/rtd)
         regp(6) = SIN(tmp3/rtd)
         CALL LIMSB(1)
C
      ELSE IF ( cbuf(1:1).EQ.'E' ) THEN
C Ellipse, enter center, width, height, angle.
         CALL ASKPOS(Qplot,pfail)
         IF ( pfail ) GOTO 100
C
         tmp1 = regp(3)
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,111) 'Half', tmp1
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(cbuf, lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL RGGTDI(cbuf, lbuf, tmp1, ier)
         END IF
C
         tmp2 = regp(4)
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,121) 'Half', tmp2
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(cbuf, lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL RGGTDI(cbuf, lbuf, tmp2, ier)
         END IF
C
         tmp3 = rtd*ATAN2(regp(6),regp(5))
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,131) tmp3
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL RGGTAN(tmp3, ier)
         Itype = 4
         regp(1) = Xdet
         regp(2) = ydet
         regp(3) = tmp1
         regp(4) = tmp2
         regp(5) = COS(tmp3/rtd)
         regp(6) = SIN(tmp3/rtd)
         CALL LIMSB(1)
C
      ELSE IF ( cbuf(1:1).EQ.'C' ) THEN
C Circle, enter center and radius
         CALL ASKPOS(Qplot,pfail)
         IF ( pfail ) GOTO 100
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,141) radius
 141        FORMAT('Radius (in detector bins): (',F6.0,')')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(cbuf, lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL RGGTDI(cbuf, lbuf, radius, ier)
         END IF
C
C Calculate box vertices in detector coordinates
C
         Itype = 2
         regp(1) = Xdet
         regp(2) = Ydet
         regp(3) = radius
         regp(4) = radius*radius
         CALL LIMSB(1)
C
      ELSE IF ( cbuf(1:1).EQ.'R' ) THEN
C Rectangle, enter two opposite corners.
 150     CONTINUE
         Xdet = regp(1)
         Ydet = regp(2)
         CALL ASKPOS(Qplot,pfail)
         IF ( pfail ) GOTO 100
         rx1 = Xdet
         ry1 = Ydet
         IF ( Qplot ) THEN
            CALL PGPOINT(1,Xdet,Ydet,3)
         END IF
C
         Xdet = regp(3)
         Ydet = regp(4)
         CALL ASKPOS(Qplot,pfail)
         IF ( pfail ) GOTO 150
         rx2 = Xdet
         ry2 = Ydet
C
C This allows user to enter any two corners in any order
C
         Itype = 1
         regp(1) = MIN(rx1,rx2)
         regp(2) = MIN(ry1,ry2)
         regp(3) = MAX(rx1,rx2)
         regp(4) = MAX(ry1,ry2)
         CALL LIMSB(1)
C
      ELSE IF ( cbuf(1:1).EQ.'S' ) THEN
C Square, enter center and radius
         CALL ASKPOS(Qplot,pfail)
         IF ( pfail ) GOTO 100
C
         CALL GTPEEK(ctmp,ltmp)
         IF ( ltmp.LE.0 ) THEN
            WRITE(cprom,201) radius
 201        FORMAT('Box half length in detector bins (',F8.1,'):')
            CALL GTBUF(cprom,ier)
            IF ( ier.NE.0 ) GOTO 100
         END IF
         CALL GTCHAR(cbuf, lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL RGGTDI(cbuf, lbuf, radius, ier)
         END IF
C
C Calculate box vertices in detector coordinates
C
         Itype = 1
         regp(1) = Xdet - radius
         regp(2) = Ydet - radius
         regp(3) = Xdet + radius
         regp(4) = Ydet + radius
         CALL LIMSB(1)
C
C Define total image as a box
C
      ELSE IF ( cbuf(1:1).EQ.'T' ) THEN
C
         Itype = 1
         CALL POS_MAP_DET(1,1,regp(1),regp(2))
         regp(1) = regp(1) - Ifac/2.
         regp(2) = regp(2) - Ifac/2.
         CALL POS_MAP_DET(Nrow,Ncol,regp(3),regp(4))
         regp(3) = regp(3) + Ifac/2.
         regp(4) = regp(4) + Ifac/2.
         CALL LIMSB(1)
      ELSE IF ( cbuf(1:1).EQ.'P' ) THEN
C Polygon
         CALL PTBUF('Type - to exit.',-1)
         Itype = 5
         Npar=0
  410    CONTINUE
         CALL ASKPOS(Qplot,pfail)
C If we fail to read a point, then user must be done entering.
         IF ( pfail ) GOTO 420
         regp(Npar+1) = Xdet
         regp(Npar+2) = Ydet
         Npar=Npar+2
         CALL GTPEEK(ctmp,ltmp)
         CALL UPC(ctmp)
         IF ( ltmp.EQ.0 .OR.
     &      ctmp(1:1).EQ. 'C' .OR. ctmp(1:1).EQ.'P' ) GOTO 410
C Flush the - symbol.
         IF ( ltmp.GT.0 ) CALL GTCHAR(ctmp,ltmp)
C Done.  Make sure we have at least a triangle.
  420    CONTINUE
         IF ( Npar.GT.4 ) THEN
            CALL LIMSB(1)
         ELSE
            Qfail = .TRUE.
            Itype = 0
         END IF
      ELSE
C Not a valid character.
         GOTO 100
C
      END IF
C
C Draw region.
C
  900 CONTINUE
      IF ( Qplot ) CALL RGDRAW(Itype, regp, Npar, 1)
C
  999 CONTINUE
C
      END
C***
      SUBROUTINE RGGTAN(Angle, Ier)
      INTEGER   Ier
      REAL      Angle
C---
C Allows user to specify 10_wcs to get an angle 10 degrees from North
C even if image is rotated.
C---
C Angle  I/O  The angle from the top of the image
C Ier      O  =0 if user entered a valid number
C---
C 2000-08-23 - New routine [AFT]
C---
      INCLUDE 'posdef.inc'
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      REAL      FPNUM
      INTEGER   LENACT
C
      CHARACTER cbuf*256
      CHARACTER ctmp*16
      INTEGER   iunder, lbuf, ltmp
C
      CALL GTCHAR(cbuf, lbuf)
      IF ( lbuf.GT.0 ) THEN
         Angle = 0.0
         iunder = INDEX(Cbuf, '_')
         IF ( iunder.GT.0 ) THEN
            ctmp = Cbuf(iunder+1:Lbuf)
            CALL UPC(ctmp)
            ltmp = LENACT(ctmp)
            IF( ctmp.EQ.'WCS' ) THEN
C Relative to WCS (world) coordinates
               IF ( Imat.NE.0 ) THEN
                  Angle = -57.29578*ATAN2(-dcd12,dcd11)
      write(*,*) 'Angle=',angle
               ELSE IF ( drota.NE.NO ) THEN
                  Angle = drota
               ELSE
                  WRITE(*,*) 'Unknown image rotation.'
               END IF
            ELSE
               WRITE(*,*) 'Unknown units, using angle from up.'
            END IF
            lbuf = iunder - 1
         END IF

         Angle = Angle + FPNUM(cbuf, lbuf, Ier)
      END IF
C
      RETURN
      END
C***
      SUBROUTINE RGGTDI(Cbuf, Lbuf, Pixels, Ier)
      CHARACTER Cbuf*(*)
      INTEGER   Lbuf, Ier
      REAL      Pixels
C---
C Allows users to specify a distance in pixels, or world units such
C as _sec, _m, _d, or _sig.
C---
C Cbuf    I
C Lbuf    I/O
C Pixels  I/O  The distance in pixels
C Ier       O  =0 if user entered a valid number
C---
C 2000-08-23 - New routine [AFT]
C---
      INCLUDE 'posdef.inc'
      REAL      FPNUM
      INTEGER   LENACT
C
      CHARACTER ctmp*256
      REAL      scale, tmp
      INTEGER   iunder, ltmp
C
      scale = 1.0
      iunder = INDEX(Cbuf, '_')
      IF ( iunder.GT.0 ) THEN
         ctmp = Cbuf(iunder+1:Lbuf)
         CALL UPC(ctmp)
         ltmp = LENACT(ctmp)
         IF( (ltmp.EQ.1.AND.ctmp.EQ.'S') .OR. ctmp.EQ.'SEC' ) THEN
C arcseconds
            scale = 1./(3600.*ABS(Dxdel))
         ELSE IF ( ctmp.EQ.'M' .OR. ctmp.EQ.'MIN' ) THEN
C arcmintes
            scale = 1./(60.*ABS(Dxdel))
         ELSE IF ( ctmp.EQ.'D' ) THEN
C degrees
            scale = 1./ABS(Dxdel)
         ELSE IF ( ctmp.EQ.'SIG' ) THEN
C PSF_sigma
            CALL GTFWAT(tmp)
            IF ( tmp.LE.0.0 ) THEN
               WRITE(*,*) 'RGGET--Please SET PSF SIGMA to be '//
     &         'non-zero at the LEXTRCT> prompt.'
            ELSE
               CALL PSFSIG(Xdet, Ydet, scale)
            END IF
         ELSE
            WRITE(*,*) 'Unknown units, using pixels.'
         END IF
         lbuf = iunder - 1
      END IF
      Pixels = scale*FPNUM(cbuf, lbuf, Ier)
C
      RETURN
      END
