      SUBROUTINE RPROF(Rmap, Tdata, Back, Tback, Mxrow, Nrow, Ncol,
     &         Cmd, Mxcmd)
      INTEGER   Mxrow, Nrow, Ncol
      REAL      Rmap(Mxrow,*), Back(Mxrow,*)
      REAL      Tdata, Tback
      INTEGER   Mxcmd
      CHARACTER Cmd(Mxcmd)*(*)
C---
C LEXTRCT subroutine to plot the azimuthally-summed radial profile of map
C data.
C---
C Rmap    I    The data array
C Tdata   I    Integration time for data map,
C Back    I    Background map
C Tback   I    Integration time for background map.
C Mxrow   I    Maximum number of rows in the arrays.
C Nrow    I    Actual number of rows in map arrays.
C Ncol    I    Actual number of columns in map arrays.
C Cmd       O  PLT command array
C Mxcmd   I    Maximum size of command array
C
C Global:
C  Xdet, Ydet     position in detector coordinates
C---
C 1997-May-30 - Use analytic expression for <radius> [AFT]
C 1993-Sep-01 - Greatly changed/enhanced to encircled energies. [AFT]
C modified  kaa   10/10/85
C original version  tam
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INTEGER   MXRING, IBACK
      PARAMETER (MXRING=1000, IBACK=92)
      REAL      FPNUM, GETVIG, RMEAN
      INTEGER   LENACT
C
      CHARACTER cprom*72, ctmp*72
      CHARACTER cans*10, cdef
      SAVE      cans
      DOUBLE PRECISION dalla(MXRING), dsuma(MXRING)
      DOUBLE PRECISION dsump(MXRING), dsumv(MXRING), dsumx(MXRING)
      DOUBLE PRECISION dtota, dfpow, dtmp, dtotp, dtotv
      REAL      yplt(MXRING,7)
      REAL      angle, bave, begdeg, bfac, bcnts
      REAL      dist, enddeg, error, fcir, frac
      REAL      rcrit, renorm, rmax, slop, tmp, weight, width
      SAVE      width
      REAL      rpixel, xhalf, xoff, xpos, yoff, ypos
      INTEGER   iery(5)
      INTEGER   i, ibada, ibadv, ibin, idelta, idig, ieeer, ier
      INTEGER   imxs, imxe, imys, imye, iscat, itmp, ixmap, iymap
      INTEGER   j, lans, ltmp, maxd, nbr, ncmd, nocnt
      INTEGER   nrings
      SAVE      nrings
      LOGICAL   qczero, qdoang, qfail, qnew, qplot
C
      DATA cans/'N'/
      DATA width/0.0/, rmax/0.0/
      DATA begdeg, enddeg/0.0, 360.0/
C
C Compute error on encircled energy plot?
      ieeer = 0
      frac =0.00
C
C Find center position for azim
C
      CALL PDSEL('IM',qnew,qplot)
 130  CALL ASKPOS(qplot,qfail)
      IF ( qfail ) GOTO 999
C
C Write center of azim to terminal
C
      WRITE (ctmp,131) Xdet, Ydet
 131  FORMAT (' Center = (',F8.1,',',F8.1,')')
      ncmd = 1
      Cmd(ncmd) = 'LAB 1 Jus Rig VPOS .85 .86 "'//ctmp
      ncmd = 2
      Cmd(ncmd)='LAB 2 Jus Rig VPos .85 .82 "Ifac = '
      ltmp = LENACT(Cmd(ncmd))
      CALL CRAMIF(Ifac, 5, Cmd(ncmd), ltmp)
C
C Request width of rings to be used in azimuthal summing
C
  150 CONTINUE
C First time through set bin width to Ifac
      IF ( width.LE.0.0 .OR. rmax.LE.0.0 ) THEN
         width = Ifac
         rmax = 100.
      END IF
      WRITE (cprom,151) width
 151  FORMAT ('Width of rings in detector units (',1PG9.3,'):')
      CALL GTBUF(cprom,ier)
      IF ( ier.NE.0 ) GOTO 130
      CALL GTREAL(width,ier)
      IF ( width.LE.0.0 ) THEN
         CALL PTBUF('** Illegal ring width  **',-1)
         GOTO 150
      END IF
C
C Request number of rings to be used in azimuthal summing
C
 200  WRITE (cprom,201) rmax
 201  FORMAT ('Maximum radius in detector units (',F9.0,'):')
      CALL GTBUF(cprom,ier)
      IF ( ier.NE.0 ) GOTO 150
      CALL GTREAL(rmax, ier)
      IF ( rmax.LE.0.0 ) THEN
         CALL PTBUF('** Illegal radius **',-1)
         GOTO 200
      END IF
      CALL GTREAL(frac, ier)
      nrings = rmax/width
      IF ( nrings.GT.MXRING ) THEN
         WRITE (*,*) 'Number of rings reset to', MXRING
         nrings = MXRING
      END IF
C
C Request the azimuthal range for inclusion in the azim
C
      CALL PTBUF('Azimuth is measured from due right,'//
     &   ' anticlockwise, in degrees:',-1)
 250  WRITE (cprom, 251) begdeg, enddeg
 251  FORMAT('Enter range of azimuth to include (',
     &      1PG14.7,',',1PG14.7,'):')
      CALL GTBUF(cprom,ier)
      IF ( ier.NE.0 ) GOTO 200
      CALL GTREAL(begdeg,ier)
      CALL GTREAL(enddeg,ier)
      IF ( (begdeg.LT.0.0 .OR. begdeg.GT.360.0) .OR.
     &     (enddeg.LT.0.0 .OR. enddeg.GT.360.0) .OR. (begdeg.EQ.enddeg)
     &     ) THEN
         CALL PTBUF('** Illegal azimuth limits **',-1)
         GOTO 250
      END IF
C
      IF ( begdeg.NE.0.0 .OR. enddeg.NE.360.0 ) THEN
         qdoang = .TRUE.
         ncmd = ncmd + 1
         Cmd(ncmd) = 'LAB 4 Jus Rig VPos .85 .74 "Angles ='
         ltmp = LENACT(Cmd(ncmd))
         CALL CRAMFF(begdeg, 5, 1, Cmd(ncmd), ltmp)
         ltmp = ltmp + 1
         CALL CRAMFF(enddeg, 5, 1, Cmd(ncmd), ltmp)
      ELSE
         qdoang = .FALSE.
      END IF
C
      IF ( enddeg.GT.begdeg ) THEN
         qczero = .FALSE.
      ELSE
         qczero = .TRUE.
      END IF
C---
C
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.LE.0 ) THEN
         cdef = cans
         cprom = 'Should errors be based on scatter (' // cdef // ')?'
         CALL GTBUF(cprom,ier)
         IF ( ier.NE.0 ) GOTO 250
      END IF
      CALL GTCHAR(cans,lans)
      CALL UPC(cans)
      IF ( lans.LE.0 ) cans = cdef
      IF ( cans.EQ.'Y' ) THEN
         iscat = 1
      ELSE
         iscat = 0
      END IF
C---
C
C Work out the limits on bin numbers to loop through (to save time)
C
      CALL POS_DT_IM(Xdet,Ydet,ixmap,iymap)
      ixmap = MIN(MAX(1,ixmap),Nrow)
      iymap = MIN(MAX(1,iymap),Ncol)
      idelta = NINT(FLOAT(nrings)*width/Ifac)
      imxs = MAX(1,    ixmap - idelta)
      imxe = MIN(Nrow, ixmap + idelta)
      imys = MAX(1,    iymap - idelta)
      imye = MIN(Ncol, iymap + idelta)
C
C Initialize arrays
C
      DO i = 1, nrings
         dsump(i) = 0.0D0
         dsumv(i) = 0.0D0
         dsuma(i) = 0.0D0
         dalla(i) = 0.0D0
         dsumx(i) = 0.0D0
      END DO
C
C Initialize some counters
C
      nocnt = 0
      ibadv = 0
      ibada = 0
      IF ( Tback.NE.0.0 ) THEN
         bfac = Tdata/Tback
      ELSE
         bfac = 0.0
      END IF
      bcnts = 0.0
      write(*,*) 'bfac=',bfac
C
C Do azimuthal summing - note use of vignetting corrections
C and the ignoring of data set to the no-data flag.
C
      rpixel = Ifac
      DO 700 j = imys, imye
         DO 650 i = imxs, imxe
C Ignore bins containing bad data.
            IF ( Rmap(i,j).EQ.NO ) THEN
               nocnt = nocnt + 1
               GOTO 650
            END IF
            CALL POS_MAP_DET(i, j, xpos, ypos)
C Compute distance to each corner of the current pixel and average.
            xoff = xpos - Xdet
            yoff = ypos - Ydet
C            dist = (SQRT((xoff-Ifac/2.)**2+(yoff-Ifac/2.)**2) +
C     :              SQRT((xoff-Ifac/2.)**2+(yoff+Ifac/2.)**2) +
C     :              SQRT((xoff+Ifac/2.)**2+(yoff-Ifac/2.)**2) +
C     :              SQRT((xoff+Ifac/2.)**2+(yoff+Ifac/2.)**2) )/4.
C            IF ( dist.LT.0.5 ) THEN
C               ibin = 1
C            ELSE
C               ibin = 1 + NINT((dist-0.5)/width)
C            END IF
            dist = rmean(xoff, yoff, rpixel)
            ibin = 1 + INT(dist/width)
            IF ( ibin.GT.nrings ) GOTO 650
C Count number of pixels that are suppose to be included in this ring.
            dalla(ibin) = dalla(ibin) + 1.0
C
            IF ( qdoang ) THEN
               CALL GETANG(xpos,ypos,Xdet,Ydet,angle)
C
C This a fix for the case where the current bin is the bin that the AZIM is
C centred on. In this case GETANG returns an angle of NO degrees. If this
C is not within the requested azimuthal limits then the bin is excluded from
C the azim. Therefore in this case I set the angle equal to BEGDEG.
C
               IF ( angle.EQ.NO ) THEN
                  angle = begdeg
               END IF
C
C Here we have to check whether the bin lies within the requested azimuthal
C range. For a range which doesn't cross zero this is simple. For a range
C which DOES cross zero we have to check that the bin lies at an angle
C either greater than the start angle or less than the end angle
C
               IF ( (qczero .AND. (angle.LT.begdeg.AND.angle.GE.enddeg))
     &    .OR. (.NOT.qczero .AND. (angle.LT.begdeg.OR. angle.GE.enddeg))
     &             ) then
                  ibada = ibada + 1
                  GOTO 650
               END IF
            END IF
            tmp = GETVIG(xpos,ypos)
            IF ( tmp.GT.0.0 ) THEN
               weight = 1./tmp
               IF ( Tback.NE.0.0 ) THEN
                  IF ( Back(i,j).NE.NO ) THEN
                     bcnts = Back(i,j)
                  ELSE
                     WRITE (*, 631) xpos,ypos
 631                 FORMAT(' Bad background at ',I4,1X,I4)
                     GOTO 650
                  END IF
               END IF
               dtmp = weight*(Rmap(i,j) - bfac*bcnts)
               dsump(ibin) = dsump(ibin) + dtmp
               IF ( iscat.NE.0 ) THEN
                  dsumv(ibin) = dsumv(ibin) + dtmp*dtmp
               ELSE
C Assume Photon statistics (Needs to be checked!)
                  dsumv(ibin) = dsumv(ibin) + weight*weight*
     &               (Rmap(i,j) + bfac*bfac*bcnts)
               END IF
               dsuma(ibin) = dsuma(ibin) + 1.0
               dsumx(ibin) = dsumx(ibin) + dist
            ELSE
               WRITE (*, 641) xpos,ypos,tmp
 641           FORMAT(' Bad vignetting at ',I4,1X,I4,1PG10.4)
               ibadv = ibadv + 1
            END IF
 650     CONTINUE
 700  CONTINUE
C
C Report failures in vignetting correction and number of no-data
C flags encountered
C
      IF ( nocnt.NE.0 ) THEN
         WRITE (*,*)
     &          'Number of map bins with no-data flag set:', nocnt
      END IF
      IF ( ibada.NE.0 ) THEN
         WRITE (*,*)
     &          'Number of map bins with excluded angles:', ibada
      END IF
      IF ( ibadv.NE.0 ) THEN
         WRITE (*,*)
     &          'Number of map bins with invalid vignetting correction:'
     &         , ibadv
      END IF
C
C If we have restricted the angular range, then we have a problem for
C small radii in that a pixel is either in the range or not.  In the
C continous case we know that only a fraction of the circle (fcir).
C Thus we compute the fraction of the pixels that are in the included
C angle range, and then renormalize using fcir.
C
      maxd = 0
      fcir = ( enddeg - begdeg )/360.
      IF ( fcir.LT.0.0 ) fcir = 1.0 + fcir
C Rcrit is the smallest value of the radius that could fall off the
C edge of the array.
      rcrit = Nrow*Ifac - Xdet
      rcrit = MIN(rcrit, Ncol*Ifac - Ydet)
      rcrit = MIN(rcrit, Xdet - 1)
      rcrit = MIN(rcrit, Ydet - 1)
      IF ( rcrit.LT.rmax .AND. qdoang ) THEN
         WRITE(*,711) rcrit
  711    FORMAT(' Warning--Rings with R > ',1PG9.3,
     &      ' partly fall off the edge of the',/,
     &' detector.  These rings will not be corrected for pixelization.')
      END IF
      dtotp = 0.0D0
      dtota = 0.0D0
      DO i=1,nrings
         IF ( dsuma(i).GT.0. ) THEN
            maxd = i
            IF ( (i-0.5)*width.LT.rcrit ) THEN
               renorm = fcir*dalla(i)/dsuma(i)
            ELSE
C If part of the ring falls off the edge of the detector, then fcir
C should only include the fraction of the circle that lies on the
C detector.  This is rather tedious to compute.  Here we assume that
C the radius is much larger than the pixel size, hence no further
C corrections are needed.
               renorm = 1.0
            END IF
            dsump(i) = dsump(i)*renorm
            dsuma(i) = dsuma(i)*renorm
            dsumx(i) = dsumx(i)*renorm
            IF ( iscat.EQ.0 .AND. dsumv(i).EQ.0.0 ) THEN
C Use one photon approximation
               dsumv(i) = 1.0*renorm*renorm
            ELSE
               dsumv(i) = dsumv(i)*renorm*renorm
            END IF
            dtotp = dtotp + dsump(i)
            dtota = dtota + dsuma(i)
C            WRITE(*,*) i,dsump(i),dsuma(i),renorm
         END IF
      END DO
C
C Trap case of no pixels in region.
C
      IF ( dtota.LE.0.0D0 ) THEN
         CALL PTBUF('**  No pixels **',-1)
         GOTO 999
      END IF
      IF ( maxd.NE.nrings ) THEN
         CALL PTBUF(
     &     'Outermost rings with zero counts have been removed.',-1)
         nrings = maxd
      END IF
C
C If there is no background map then estimate the background by using the
C average of the outer nbr rings.  This assumes that the outer nbr rings are
C dominated by background and is not a very broad PSF.
      bave = 0.
      IF ( Tback.NE.0.0 ) THEN
         ncmd = ncmd + 1
         Cmd(ncmd)='LAB 3 Jus Rig VPos .85 .78 "Using Background file"'
      ELSE
C Calculate the background by taking the average in the outer few rings.
         nbr = MAX(3, NINT(0.05*nrings))
         DO i=nrings-nbr+1, nrings
            bave = bave + dsump(i)/dsuma(i)
         END DO
         bave = bave/(nbr*Ifac*Ifac)
C Let user enter a better background value.
         WRITE(cprom,731) bave
 731     FORMAT('Background (',1PG10.3,') cts/dpixel:')
         CALL GTBUF(cprom, ier)
         CALL GTCHAR(ctmp, ltmp)
C Report the actual background used.
         ncmd = ncmd + 1
         IF ( ltmp.NE.0 ) THEN
            bave = FPNUM(ctmp, ltmp, ier)
            Cmd(ncmd) = 'LAB 3 Jus Rig VPos .85 .78 "Back ='
         ELSE
            Cmd(ncmd) = 'LAB 3 Jus Rig VPos .85 .78 "Back (outer'
            ltmp = LENACT(Cmd(ncmd)) + 1
            CALL CRAMI(nbr, Cmd(ncmd), ltmp)
            Cmd(ncmd) = Cmd(ncmd)(:ltmp)//') ='
         END IF
         ltmp = LENACT(Cmd(ncmd))
         CALL CRAMFF(bave, 5, -3, Cmd(ncmd), ltmp)
         dtotp = dtotp - bave*dtota*(Ifac*Ifac)
      END IF
      WRITE (*,*) 'Number of rings used is:', nrings
      IF ( iscat.EQ.0 ) THEN
         CALL PTBUF('Errors based on photon counting statistics.',-1)
      ELSE
         CALL PTBUF('Errors based on scatter.',-1)
      END IF
      WRITE(*,*) 'Total power in psf=', dtotp,' cts'
      WRITE(*,*) 'Total pixels used =', dtota
C
C Area is a count of the number of Map pixels include.  Renorm will convert
C this to either detector pixels or square arc-secs.
C
      renorm = 1.0/(Ifac*Ifac)
C
C Calculate counts/pixel and error bounds.
C
      dfpow = 0.0
      dtotv = 0.0
      DO i = 1, nrings
         yplt(i,1) = (i-0.5)*width
         IF ( dsuma(i).LE.0.0 ) THEN
            yplt(i,2) = NO
            yplt(i,3) = NO
            yplt(i,6) = NO
         ELSE
C
C Convert from counts/map-bin to counts/detector pixel
C
            yplt(i,2) = renorm*dsump(i)/dsuma(i)
            yplt(i,3) = renorm*SQRT(ABS(dsumv(i)))/dsuma(i)
            yplt(i,6) = dsumx(i)/dsuma(i)
         END IF
         yplt(i,7) = dsuma(i)
         dfpow = dfpow + dsump(i) - bave*dsuma(i)*Ifac*Ifac
         yplt(i,4) = dfpow/dtotp
         dtotv = dtotv + dsumv(i)
         yplt(i,5) = SQRT(dtotv)/dtotp
      END DO
C
C Compute half power radius
C
      DO i = 1, nrings-1
         IF ( yplt(i,4).LT.0.50 .AND. yplt(i+1,4).GE.0.50 ) THEN
            slop = (yplt(i+1,4)-yplt(i,4))/(yplt(i+1,1)-yplt(i,1))
            xhalf = yplt(i,1) + (0.5-yplt(i,4))/slop
            error = (yplt(i,5)+yplt(i+1,5))/(2.0*slop)
            WRITE(*,*) 'Half power radius =',xhalf,'+/-',error
            ncmd = ncmd + 1
            Cmd(ncmd)='LAB 5 Jus Rig VPos .85 .18 "Half power radius ='
            ltmp = LENACT(Cmd(ncmd)) + 1
C---
            idig=500
            IF(xhalf.NE.0) idig=INT(LOG10(ABS(xhalf))+500.)
            itmp=500
            IF(error.NE.0) itmp=INT(LOG10(ABS(error))+500.)
            idig=-2-idig+itmp
            CALL CRAMFF(xhalf,6,idig,cmd(ncmd),ltmp)
            IF ( ieeer.NE.0 ) THEN
               cmd(ncmd)(ltmp+1:ltmp+9) =' '//CHAR(IBACK)//'(2233) '
               ltmp=ltmp+9
               CALL CRAMFF(error,3,-2,cmd(ncmd),ltmp)
            END IF
C---
         END IF
         IF ( frac.GT.0.0 ) THEN
            IF ( yplt(i,4).LT.frac .AND. yplt(i+1,4).GE.frac ) THEN
               slop = (yplt(i+1,4)-yplt(i,4))/(yplt(i+1,1)-yplt(i,1))
               xhalf = yplt(i,1) + (frac-yplt(i,4))/slop
               error = (yplt(i,5)+yplt(i+1,5))/(2.0*slop)
               WRITE(*,751) frac,xhalf,error
  751          FORMAT(F10.3,' power radius =',F10.2,'+/-',F10.2)
            END IF
         END IF
      END DO
  320 CONTINUE
      ncmd = ncmd + 1
      Cmd(ncmd) = 'LAB 6 Jus Rig VPos .85 .14 "Total power ='
      ltmp = LENACT(Cmd(ncmd))
      tmp = dtotp
      CALL CRAMFF(tmp,10,1,cmd(ncmd),ltmp)
C
C Plot.
C
      CALL PDSEL('LI',qnew,qplot)
      IF ( qplot ) THEN
         iery(1) = 0
         iery(2) = 1
         iery(3) = 1
         iery(4) = 0
         iery(5) = 0
         Cmd(ncmd+1) = 'LAB G1 Radius (detector)'
         Cmd(ncmd+2) = 'LAB G2 Counts/dpixel'
         Cmd(ncmd+3) = 'LAB G3 Fractional Power'
         Cmd(ncmd+4) = 'LAB G4 Radius'
         Cmd(ncmd+5) = 'LAB G5 Number of pixels'
         Cmd(ncmd+6) = 'LINE ON'
         Cmd(ncmd+7) = 'COL OFF 4 5'
         Cmd(ncmd+8) = 'Plot Vert'
         Cmd(ncmd+9) = 'LOG Y ON 2'
         ncmd = ncmd + 9
C
         IF ( Tback.NE.0.0 ) THEN
C Get background subtracted name
            CALL FLNAME(4, ctmp, ltmp)
         ELSE
C Get data file
            CALL FLNAME(1, ctmp, ltmp)
         ENDIF
         Cmd(ncmd+1) = 'LAB F  '//ctmp
         ncmd = ncmd + 1
         IF ( ieeer.EQ.0 ) THEN
            CMD(ncmd+1) = 'Error OFF 3'
            ncmd = ncmd + 1
         END IF
         IF ( ncmd.GT.MXCMD ) THEN
            WRITE(*,*) 'RPROF:  Programmer error.',ncmd,
     :         ' exceeds size of MXCMD.'
            STOP
         END IF
         CALL PLT(yplt,iery,MXRING,nrings,5,Cmd,ncmd,ier)
      END IF
C
C Tidy up before exiting
C
 999  CONTINUE
C
      END
