      SUBROUTINE SFCNTS(Mxrow, Rmap, Nrow, Ncol, Srad, Brad,
     :   Mxpsf, Xpect, Npsf)
      INTEGER   Mxrow, Nrow, Ncol, Mxpsf, Npsf
      REAL      Rmap(Mxrow, *), Srad, Brad
      REAL      Xpect(-Mxpsf:Mxpsf,-Mxpsf:Mxpsf)
C---
C Counts in a box for all sources in a file.  This differs from the
C first pass estimate in that counts near other sources in the field
C are ignored.
C---
C Mxrow   I
C Aray    I
C Nrow    I
C Ncol    I
C Srad    I
C Brad    I
C Mxpsf   I
C Xpect   I
C Npsf    I/O
C---
C 2006-Jan-20 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXNEAR
      PARAMETER (MXNEAR=20)
      INCLUDE 'posdef.inc'
C
      CHARACTER cfile*256
      CHARACTER ctmp*80
      CHARACTER ccol*16
      DOUBLE PRECISION ddec, dnul, dra
      REAL      cnts, csumi, csumo, psumi, rnul, rsig
      REAL      srat, xpos, xtmp, ypos, ytmp
      INTEGER   inear(MXNEAR), jnear(MXNEAR)
      INTEGER   i, ib2, iblk, ibrad, iccol, icnti, icnto, id2
      INTEGER   idcol, ier, iext, if2, imap, in, ipcol, ira, ircol
      INTEGER   is2, israd, istat, ixcol, iycol
      INTEGER   j, jmap, l, l1, lfile, lhi, llo, ltmp, lunin
      INTEGER   m, m1, mhi, mlo
      INTEGER   nrows, nnear
      LOGICAL   qbad
C---
   11 FORMAT(A)
C---
  100 CONTINUE
      ctmp = ' '
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.LE.0 ) THEN
         CALL GTBUF('Existing SF output file:',ier)
         IF ( ier.NE.0 ) RETURN
      END IF
      CALL GTCHAR(cfile,lfile)
      IF ( lfile.LE.0 ) RETURN
C
      CALL GETLUN(lunin)
      istat = 0
      CALL FTOPEN(lunin, cfile, 1, iblk, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'SFILE--Failed to open file ',cfile(:lfile),
     &      ',  istat=',istat
         CALL FRELUN(lunin)
C Flush the buffer.
         CALL GTREST(cfile, lfile)
         GOTO 100
      END IF
C
C Go to 2nd HDU and look for needed columns.
      istat = 0
      CALL FTMAHD(lunin, 2, iext, istat)
      CALL FTGKYJ(lunin, 'NAXIS2', nrows, ctmp, istat)
      istat = 0
      CALL FTGCNN(lunin, .FALSE., 'X', ccol, ixcol, istat)
      CALL FTGCNN(lunin, .FALSE., 'Y', ccol, iycol, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL FTGCNN(lunin, .FALSE., 'RA',  ccol, ircol, istat)
         CALL FTGCNN(lunin, .FALSE., 'DEC', ccol, idcol, istat)
         ira = 1
      ELSE
         ira = 0
      END IF
      IF ( istat.NE.0 ) THEN
         CALL PTBUF('SFCNTS--Failed to find positions.',-1)
         GOTO 100
      END IF
      ipcol = 0
      iccol = 0
      istat = 0
      CALL FTGCNN(lunin, .FALSE., 'PSF_SIG', ccol, ipcol, istat)
      CALL FTGCNN(lunin, .FALSE., 'COUNTS',  ccol, iccol, istat)
      IF ( istat.NE.0 ) THEN
         CALL PTBUF('SFCNTS--Failed to find cnts/sig.',-1)
         GOTO 100
      END IF
C
      DO i=1,nrows
         istat = 0
         IF ( ira.NE.0 ) THEN
            CALL FTGCVD(lunin,ircol,i,1,1,dnul,dra, qbad,istat)
            CALL FTGCVD(lunin,idcol,i,1,1,dnul,ddec,qbad,istat)
            CALL POS_RA_DT(dra,ddec,xpos,ypos)
         ELSE
            CALL FTGCVE(lunin,ixcol,i,1,1,rnul,xpos,qbad,istat)
            CALL FTGCVE(lunin,iycol,i,1,1,rnul,ypos,qbad,istat)
         END IF
         CALL FTGCVE(lunin,ipcol,i,1,1,rnul,rsig,qbad,istat)
         CALL FTGCVE(lunin,iccol,i,1,1,rnul,cnts,qbad,istat)
C Find the number of sources close enough to cause a problem.
         nnear = 0
         DO j=1,nrows
            CALL FTGCVE(lunin,ixcol,j,1,1,rnul,xtmp,qbad,istat)
            CALL FTGCVE(lunin,iycol,j,1,1,rnul,ytmp,qbad,istat)
            IF( ABS(xpos-xtmp).LT.(srad+brad)*rsig .AND.
     &          ABS(ypos-ytmp).LT.(srad+brad)*rsig .AND. i.NE.j ) THEN
               IF ( nnear.GE.MXNEAR ) THEN
                  CALL PTBUF('sfcnts--MXNEAR is too small.',-1)
                  GOTO 900
               END IF
               nnear = nnear+1
               CALL POS_DT_IM(xtmp,ytmp,imap,jmap)
               inear(nnear) = imap
               jnear(nnear) = jmap
            END IF
         END DO
         israd = MAX(1, NINT(srad*rsig/Ifac))
         is2 = MAX(1, NINT((srad*rsig)**2/(Ifac*Ifac)))
         ibrad = MAX(israd+1,MAX(1, NINT(brad*rsig/Ifac)))
         ib2 = MAX(2,NINT((brad*rsig)**2/(Ifac*Ifac)))
         Npsf = ibrad
         CALL PSFSET(Ifac, xpos, ypos, Mxpsf, Npsf, Xpect)
         CALL POS_DT_IM(xpos,ypos,imap,jmap)
         llo = -Npsf - (MIN(imap-Npsf,1)-1)
         lhi =  Npsf - (MAX(imap+Npsf,nrow)-nrow)
         psumi = 0.0
         icnti = 0
         csumi = 0.0
         icnto = 0
         csumo = 0.0
         DO l=llo, lhi
            l1 = imap + l
            mlo = -Npsf - (MIN(jmap-Npsf,1)-1)
            mhi =  Npsf - (MAX(jmap+Npsf,ncol)-ncol)
            DO 290 m=mlo, mhi
               m1 = jmap + m
C Toss pixels close to nearby sources
               DO in=1, nnear
                  if2=(l1-inear(in))**2+(m1-jnear(in))**2
                  IF ( if2.LE.is2 ) GOTO 290
               END DO
               id2 = l*l + m*m
               IF ( Rmap(l1,m1).NE.NO .AND. id2.LE.ib2 ) THEN
                  IF ( id2.LE.is2 ) THEN
                     icnti = icnti + 1
                     csumi = csumi + Rmap(l1,m1)
                     psumi = psumi + Xpect(l,m)
                  ELSE
                     icnto = icnto + 1
                     csumo = csumo + Rmap(l1,m1)
                  END IF
               END IF
  290       CONTINUE
         END DO
         srat = (csumi - csumo*icnti/real(icnto))/psumi
       write(*,*) i,nnear,cnts,srat-cnts,csumi,icnti,csumo,icnto,psumi
         CALL FTPCLE(lunin,iccol,i,1,1,srat,istat)
      END DO
C
  900 CONTINUE
      CALL FTCLOS(lunin, istat)
      CALL FRELUN(lunin)
C
      RETURN
      END
