      SUBROUTINE SFILE(Qplot, Mxrow, Aray, Nrow, Ncol, Cfree,
     &   Brad, Mxpar, Ido1, Tdata, Icomp, Pval, Plim, Nterm)
      LOGICAL   Qplot
      INTEGER   Mxrow, Nrow, Ncol, Mxpar, Ido1
      CHARACTER Cfree*(*)
      INTEGER   Icomp(*), Nterm
      REAL      Aray(*), Brad, Tdata
      REAL      Pval(Mxpar), Plim(3,Mxpar)
C---
C Estimate position and fluxes for all sources in a file.
C---
C Qplot   I
C Mxrow   I
C Aray    I
C Nrow    I
C Ncol    I
C Cfree   I    pass to sfitn
C Brad    I
C Mxpar   I
C Ido1    I    =0 do whole file, =1 just do single value in file.
C Icomp     O
C Pval      O
C Plim      O
C Nterm     O
C---
C 2015-Jun-09 - Stared work to read FITS columns by name instead of position.
C 2002-Feb-22 - [AFT]
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXCOL, MXSOUR
      PARAMETER (MXCOL=17, MXSOUR=30)
      INTEGER   INBOU
      INCLUDE 'posdef.inc'
      INTEGER   LENACT
C
      CHARACTER ctype(MXCOL)*16, cform(MXCOL)*16, cunit(MXCOL)*16
      CHARACTER cfile*256
      CHARACTER ctmp*80, ctry*80
      CHARACTER ccol*16, ckey*16
      DOUBLE PRECISION ddec, dnul, dra, dtmp
      REAL      xmin(2), xmax(2), xsour(MXSOUR), ysour(MXSOUR)
      REAL      r2cur, r2min, rdis2, rmax2, rnul, rsig, tmp
      REAL      xchi, xpos, xtmp, ypos, ytmp
      INTEGER   incol(MXCOL), naxes(99)
      INTEGER   i, ib, ibits, iblk, ibcol, icisav, idcol
      INTEGER   ie, ier, iext, igcnt
      INTEGER   ip, ipcnt, iplas, ira, ircol
      INTEGER   ipsfm, is, isky, ismax, istat, ixl, iyl
      INTEGER   ipcol, iscol, isycol, ithcol, iwcol
      INTEGER   j, jc, lfile, ltmp, lunin, luno, nallow, naxis
      INTEGER   nfield, nfit, npars, nparm, npc, nrows, nsour
      LOGICAL   qbad, qend, qout, qxtend, qsimp
C
      DATA ctype/'BACK','X','SIGX','Y','SIGY','THETA','NORM',
     &   'WVAR', 9*' '/
      DATA cform/ '1E','1E', '1E','1E', '1E',   '1E',  '1E',
     &   '1E',   9*' '/
      DATA cunit/'cts','pixel','pixel','pixel','pixel','deg','cts',
     &   ' ',    9*' '/
C---
      CALL POS_SKY(isky)
  100 CONTINUE
      ctmp = ' '
      CALL GTPEEK(ctmp,ltmp)
      IF ( ltmp.LE.0 ) THEN
         CALL GTBUF(
     &    'Fits file containing sources [outfile, [cols]]:',ier)
         IF ( ier.NE.0 ) RETURN
      END IF
      CALL GTCHAR(cfile,lfile)
      IF ( lfile.LE.0 ) RETURN
C
      CALL GETLUN(lunin)
      istat = 0
      CALL FTOPEN(lunin, cfile, 0, iblk, istat)
      CALL FTGHPR(lunin,99,qsimp,ibits,naxis,naxes,ipcnt,igcnt,qxtend,
     &            istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'SFILE--Failed to open file ',cfile(:lfile),
     &      ',  istat=',istat
         CALL FRELUN(lunin)
C Flush the buffer.
         CALL GTREST(cfile, lfile)
         GOTO 100
      END IF
C FITS file.  Go to 2nd HDU.
      CALL FTMAHD(lunin, 2, iext, istat)
C
      CALL PSQMO(ipsfm)
      IF ( ABS(ipsfm).EQ.1 ) THEN
         nparm = 5
         ctype(3) = 'Y'
         ctype(4) = 'SIG'
         ctype(5) = 'NORM'
         cunit(5) = ' '
         ctype(6) = 'WVAR'
         cunit(6) = ' '
         ixl = 2
         iyl = 3
         npc=4
      ELSE IF ( ABS(ipsfm).EQ.2 ) THEN
         nparm = 7
         ctype(3) = 'SIGX'
         ctype(4) = 'Y'
         ctype(5) = 'SIGY'
         cunit(5) = 'pixel'
         ctype(6) = 'THETA'
         cunit(6) = 'deg'
         ctype(7) = 'NORM'
         cunit(7) = ' '
         ctype(8) = 'WVAR'
         cunit(8) = ' '
         ixl = 2
         iyl = 4
         npc=6
      ELSE IF ( ABS(ipsfm).EQ.3 ) THEN
         nparm = 6
         ctype(3) = 'Y'
         ctype(4) = 'SIG'
         ctype(5) = 'INDEX'
         cunit(5) = ' '
         ctype(6) = 'NORM'
         cunit(6) = ' '
         ctype(7) = 'WVAR'
         cunit(7) = ' '
         ixl = 2
         iyl = 3
         npc=5
      END IF
C Can only have 120 parameters, so nallow is max number of sources allowed.
      nallow=(120-1)/npc
C
      qout=.FALSE.
      IF ( ido1.EQ.0 ) THEN
C Only create output file if doing more than one source.
         CALL GETLUN(luno)
         CALL AFNEW(luno, istat)
         IF ( istat.NE.0 ) THEN
            qout = .FALSE.
            CALL PTBUF('SFILE--Failed to open output file.',-1)
            CALL FRELUN(luno)
            istat = 0
            CALL FTCLOS(luno, istat)
            CALL FRELUN(luno)
         ELSE
            qout = .TRUE.
C Find the columns that the user wants copied to the output file.
            nfield = nparm+1
            DO 180 i=nparm+2,MXCOL
               incol(i) = 0
               CALL GTCHAR(ctmp,ltmp)
               IF ( ltmp.LE.0 ) GOTO 190
               IF ( ctmp(1:1).EQ.'+' ) THEN
C Append blank to avoid an incorrect (IMO) compiler warning.
                  ctry = ctmp(2:ltmp)//' '
                  CALL UPC(ctry)
                  IF ( ctry(1:2).EQ.'RA' ) THEN
                     nfield = nfield + 1
                     incol(nfield) = -1
                     ctype(nfield) = 'RA'
                     cform(nfield) = '1D'
                     cunit(nfield) = 'deg'
                  ELSE IF ( ctry(1:3).EQ.'DEC' ) THEN
                     nfield = nfield + 1
                     incol(nfield) = -2
                     ctype(nfield) = 'DEC'
                     cform(nfield) = '1D'
                     cunit(nfield) = 'deg'
                  ELSE IF ( ctry(1:4).EQ.'XERR' ) THEN
                     nfield = nfield + 1
                     incol(nfield) = -3
                     ctype(nfield) = 'XERR'
                     cform(nfield) = '1E'
                     cunit(nfield) = 'pixel'
                  ELSE IF ( ctry(1:4).EQ.'YERR' ) THEN
                     nfield = nfield + 1
                     incol(nfield) = -4
                     ctype(nfield) = 'YERR'
                     cform(nfield) = '1E'
                     cunit(nfield) = 'pixel'
                  ELSE
                     WRITE(*,*) 'Unable to figure out ',ctry(:ltmp-1)
                  END IF
                  GOTO 180
               END IF
               istat = 0
               CALL FTGCNN(lunin, .FALSE., ctmp,  ccol, ircol, istat)
               IF ( istat.NE.0 ) THEN
                  WRITE(*,*) 'Unable to find column ',ctmp(:ltmp)
                  GOTO 190
               END IF
               nfield = nfield + 1
               incol(nfield) = ircol
               ctype(nfield) = ccol
C Read other column info
               CALL FTKEYN('TFORM',ircol,ckey,istat)
               CALL FTGKYS(lunin,ckey,cform(nfield),ctmp,istat)
               CALL UPC(cform(nfield))
               IF ( INDEX(cform(nfield),'D').EQ.0 ) THEN
C If input not D format then force it to be E.
                  cform(nfield) = '1E'
               END IF
C
               cunit(nfield) = ' '
               istat = 0
               CALL FTKEYN('TUNIT',ircol,ckey,istat)
               CALL FTGKYS(lunin,ckey,cunit(nfield),ctmp,istat)
  180       CONTINUE
  190       CONTINUE
C Create the data extension
            istat = 0
            CALL FTCRHD(luno, istat)
            CALL FTPHBN(luno, 0, nfield, ctype, cform, cunit,
     &         'SRCLIST', 0, istat)
            IF ( istat.NE.0 ) THEN
               WRITE(*,*) 'Unable to create header, istat=',istat
               GOTO 100
            END IF
            CALL FTPKYE(luno, 'LIVETIME',Tdata,5,'[s] Live time',istat)
            CALL PSQMOC(ctmp)
            CALL FTPKYS(luno,'PSF_MOD', ctmp, 'PSF model',istat)
            CALL FTPKYS(luno,'FREE', Cfree,'free parameters',istat)
            CALL WFWCS(luno, ixl, iyl, Ier)
            CALL BOUSTR(ctmp)
            ltmp = LENACT(ctmp)
            CALL FTPCOM(luno, ctmp(:ltmp), istat)
C
         END IF
      END IF
C
      istat = 0
      CALL FTMAHD(lunin, 2, iext, istat)
      CALL FTGKYJ(lunin, 'NAXIS2', nrows, ctmp, istat)
      ira = 1
      CALL FTGCNN(lunin, .FALSE., 'RA',  ccol, ircol, istat)
      CALL FTGCNN(lunin, .FALSE., 'DEC', ccol, idcol, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL FTGCNN(lunin, .FALSE., 'RA(ICRS)', ccol, ircol, istat)
         CALL FTGCNN(lunin, .FALSE., 'DE(ICRS)', ccol, idcol, istat)
      END IF
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL FTGCNN(lunin, .FALSE., 'RAJ2000', ccol, ircol, istat)
         CALL FTGCNN(lunin, .FALSE., 'DEJ2000', ccol, idcol, istat)
      END IF
      IF ( istat.NE.0 .OR. isky.EQ.0 ) THEN
         istat = 0
         CALL FTGCNN(lunin, .FALSE., 'X', ccol, ircol, istat)
         CALL FTGCNN(lunin, .FALSE., 'Y', ccol, idcol, istat)
         ira = 0
      END IF
      IF ( istat.NE.0 ) THEN
         CALL PTBUF('SFILE--Failed to find needed columns.',-1)
         GOTO 100
      END IF
C Find column for additional parameters.
      iscol=0
      CALL FTGCNN(lunin, .FALSE., 'SIGX',  ccol, iscol, istat)
      IF ( istat.NE.0 ) THEN
         istat=0
         CALL FTGCNN(lunin, .FALSE., 'SIG',  ccol, iscol, istat)
      END IF
      isycol=0
      istat=0
      CALL FTGCNN(lunin, .FALSE., 'SIGY',  ccol, isycol, istat)
      ithcol=0
      istat=0
      CALL FTGCNN(lunin, .FALSE., 'THETA',  ccol, ithcol, istat)
      istat = 0
      ipcol = 0
      CALL FTGCNN(lunin, .FALSE., 'PSF_SIG', ccol, ipcol, istat)
C
      iwcol=0
      ibcol=0
      istat=0
      CALL FTGCNN(lunin, .FALSE., 'WVAR', ccol, iwcol, istat)
      IF ( istat.EQ.0 ) THEN
         CALL FTGCNN(lunin, .FALSE., 'BACK', ccol, ibcol, istat)
      END IF
C
      IF ( ido1.EQ.0 ) THEN
         ib = 1
         ie = nrows
      ELSE
         CALL ASKPOS(Qplot, qend)
         istat = 0
         r2min = 1e37
         ib = 0
         DO i=1,nrows
            IF ( ira.NE.0 .AND. isky.NE.0 ) THEN
               CALL FTGCVD(lunin,ircol,i,1,1,dnul,dra, qbad,istat)
               CALL FTGCVD(lunin,idcol,i,1,1,dnul,ddec,qbad,istat)
               CALL POS_RA_DT(dra,ddec,xpos,ypos)
            ELSE
               CALL FTGCVE(lunin,ircol,i,1,1,rnul,xpos,qbad,istat)
               CALL FTGCVE(lunin,idcol,i,1,1,rnul,ypos,qbad,istat)
            END IF
            r2cur = (xpos-Xdet)**2 + (ypos-Ydet)**2
            IF ( r2cur.LT.r2min ) THEN
               r2min = r2cur
               ib = i
            END IF
         END DO
         ie = ib
         WRITE(*,*) 'SFILE--Doing star=',ib
      END IF
C
      dnul = NO
      rnul = NO
      IF ( Qplot ) THEN
         CALL PGQCI(icisav)
         CALL PGSFS(2)
      END IF
      DO i=ib,ie
         istat = 0
         IF ( ira.NE.0 .AND. isky.NE.0 ) THEN
            CALL FTGCVD(lunin,ircol,i,1,1,dnul,dra, qbad,istat)
            CALL FTGCVD(lunin,idcol,i,1,1,dnul,ddec,qbad,istat)
            CALL POS_RA_DT(dra,ddec,xpos,ypos)
         ELSE
            CALL FTGCVE(lunin,ircol,i,1,1,rnul,xpos,qbad,istat)
            CALL FTGCVE(lunin,idcol,i,1,1,rnul,ypos,qbad,istat)
         END IF
         IF ( INBOU(xpos, ypos).LE.0 ) THEN
            IF ( qout ) THEN
               istat = 0
               DO j=1,nfield
                  CALL FTPCLE(luno,j, i, 1, 1, NO, istat)
               END DO
            END IF
         ELSE
            CALL PSFSIG(xpos, ypos, rsig)
C            IF ( iscol.GT.0 ) THEN
C               CALL FTGCVE(lunin,iscol,i,1,1,rnul,tmp,qbad,istat)
C               rsig=MIN(tmp,3.*rsig)
C            END IF
            xmin(1) = xpos-Brad*rsig
            xmin(2) = ypos-Brad*rsig
            xmax(1) = xpos+Brad*rsig
            xmax(2) = ypos+Brad*rsig
C
            nsour = 1
            xsour(1) = xpos
            ysour(1) = ypos
            IF ( ibcol.GT.0 .AND. iwcol.GT.0 ) THEN
C If it looks like a FIT output file then initialize the parameter values.
               ip=0
               DO jc=ibcol,iwcol-1
                  ip=ip+1
                  CALL FTGCVE(lunin,jc,i,1,1,rnul,pval(ip),qbad,istat)
                  plim(1,ip)=0.0
               END DO
            END IF
            istat = 0
            DO 290 j=1,nrows
               IF ( i.EQ.j ) GOTO 290
               IF ( ira.NE.0 .AND. isky.NE.0 ) THEN
                  CALL FTGCVD(lunin,ircol,j,1,1,dnul,dra, qbad,istat)
                  CALL FTGCVD(lunin,idcol,j,1,1,dnul,ddec,qbad,istat)
                  CALL POS_RA_DT(dra,ddec,xtmp,ytmp)
               ELSE
                  CALL FTGCVE(lunin,ircol,j,1,1,rnul,xtmp,qbad,istat)
                  CALL FTGCVE(lunin,idcol,j,1,1,rnul,ytmp,qbad,istat)
               END IF
               IF( ABS(xpos-xtmp).LT.(brad+1.5)*rsig .AND.
     &             ABS(ypos-ytmp).LT.(brad+1.5)*rsig ) THEN
                  IF ( nsour.LT.nallow ) THEN
                     nsour = nsour + 1
                  ELSE
C Run out of sources, find the one further away and over write
                     ismax=0
                     rmax2=(xtmp-xsour(1))**2+(ytmp-ysour(1))**2
                     DO is=2,nallow
                        rdis2=(xsour(is)-xsour(1))**2+
     &                        (ysour(is)-ysour(1))**2
                        IF ( rdis2.GT.rmax2 ) THEN
                           ismax=is
                           rmax2=rdis2
                        END IF
                     END DO
                     IF ( ismax.LE.0 ) THEN
C Nothing closer, so forget it
                        GOTO 290
                     ELSE
C Swap with the last point (since last point will be updated below).
                        xsour(ismax)=xsour(nsour)
                        ysour(ismax)=ysour(nsour)
                        ip=iplas
                     END IF
                  END IF
                  xsour(nsour) = xtmp
                  ysour(nsour) = ytmp
                  IF ( ibcol.GT.0 .AND. iwcol.GT.0 ) THEN
C If it looks like a FIT output file then initialize the parameter values.
                     iplas=ip
                     DO jc=ibcol+1,iwcol-1
                        ip=ip+1
                  CALL FTGCVE(lunin,jc,j,1,1,rnul,pval(ip),qbad,istat)
                        plim(1,ip)=-1.0
                     END DO
                  END IF
               END IF
  290       CONTINUE
C
            npars=iwcol-1-ibcol
            CALL SFITN(Qplot,Mxrow,Aray,Nrow,Ncol,Xmin,Xmax,
     &         Cfree,Nsour,Xsour,Ysour,
     &         Mxpar,npars,pval,plim,icomp,nterm,nfit,xchi,ier)
      IF ( xchi.LT.0 ) write(*,*) 'SFILE--xchi=',xchi,
     &         ' at ',xsour(1),ysour(1)
            IF ( qout ) THEN
               istat = 0
               IF ( ier.NE.0 ) THEN
                  istat = 0
                  DO j=1,nparm
                     CALL FTPCLE(luno,j, i, 1, 1, NO, istat)
                  END DO
                  CALL FTPCLE(luno,nparm+1,i,1,1,NO,istat)
               ELSE
                  DO j=1,nparm
                     CALL FTPCLE(luno,j, i, 1, 1, Pval(j), istat)
                  END DO
                  CALL FTPCLE(luno,nparm+1,i,1,1,xchi,istat)
               END IF
               DO j=nparm+2,nfield
                  xtmp = Pval(ixl)
                  ytmp = Pval(iyl)
                  CALL POS_DT_RA(xtmp, ytmp, dra, ddec)
                  IF ( incol(j).GT.0 ) THEN
                     IF ( ctype(j).EQ.'1E' ) THEN
                CALL FTGCVE(lunin,incol(j),i,1,1,rnul,tmp,qbad,istat)
                        CALL FTPCLE(luno,j, i, 1, 1, tmp, istat)
                     ELSE
                CALL FTGCVD(lunin,incol(j),i,1,1,dnul,dtmp,qbad,istat)
                        CALL FTPCLD(luno,j, i, 1, 1, dtmp, istat)
                     END IF
                  ELSE IF ( incol(j).EQ.-1 ) THEN
                     CALL FTPCLD(luno,j, i, 1, 1, dra, istat)
                  ELSE IF ( incol(j).EQ.-2 ) THEN
                     CALL FTPCLD(luno,j, i, 1, 1, ddec, istat)
                  ELSE IF ( incol(j).EQ.-3 ) THEN
                     tmp = xtmp - xsour(1)
                     CALL FTPCLE(luno,j, i, 1, 1, tmp, istat)
                  ELSE IF ( incol(j).EQ.-4 ) THEN
                     tmp = ytmp - ysour(1)
                     CALL FTPCLE(luno,j, i, 1, 1, tmp, istat)
                  END IF
               END DO
      IF ( istat.NE.0) write(*,*) 'istat2=',istat
            END IF
         END IF
      END DO
C
      IF ( Qplot ) THEN
         CALL PGSCI(icisav)
      END IF
C
      IF ( qout ) THEN
         istat=0
         CALL FTMKYJ(luno, 'NAXIS2', nrows, '&', istat)
         CALL FTCLOS(luno, istat)
         CALL FRELUN(luno)
      END IF
C
      istat=0
      CALL FTCLOS(lunin, istat)
      CALL FRELUN(lunin)
C
      RETURN
      END
