      SUBROUTINE SFIND(Qplot, Smin, Smax, Mxcmd, Cmd, Ncmd)
      LOGICAL   Qplot
      REAL      Smin, Smax
      INTEGER   Mxcmd, Ncmd
      CHARACTER Cmd(Mxcmd)*(*)
C---
C Subroutine to intitiate source-finding facilities
C---
C Qplot   I    Plotting active flag
C Smin    I    Image min
C Smax    I    Image max
C Mxcmd   I    Size of Cmd array
C Cmd     I/O  PLT Cmd array
C Ncmd    I/O  Number of valid commands in Cmd
C---
C 1998-Nov-25 - derived from sfind [AFT].
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   MXRAY, MXPSF, MXSOUR
      PARAMETER (MXRAY=2048, MXPSF=128, MXSOUR=10)
      INCLUDE 'mapdef.inc'
      INCLUDE 'posdef.inc'
      INCLUDE 'scrat.inc'
      INTEGER   MXDIM, MXPAR
      PARAMETER (MXDIM=2, MXPAR=120)
C Machine min and max
      REAL      SYSMAX, SYSMIN
      PARAMETER (SYSMAX=1.E32,SYSMIN=-1.E32)
      REAL      FNFIT
      INTEGER   ISNUM, LENACT
C
      CHARACTER chead(1)*64
      CHARACTER clmax(0:2)*8
      CHARACTER cbuf*256, ctmp*256
      CHARACTER cctnam*128, cdisp*32
      CHARACTER cans*20
      CHARACTER cfree*8
      REAL      xmin(2), xmax(2)
      REAL      rtmp(MXRAY,MXRAY)
      EQUIVALENCE (Rscrat, rtmp)
      REAL      box(4), pval(MXPAR+2), plim(3,MXPAR), sfparm(2)
      SAVE      box,    pval,          plim,          sfparm
      REAL      brad, srad
      SAVE      brad, srad
      REAL      xt(2), xsour(MXSOUR), ysour(MXSOUR)
      REAL      ang, rsig, sigx, sigy, tmp, xchi
      REAL      xdet1, xdet2, xdetl, xdeth, xpos, xscal
      REAL      ydet1, ydet2, ydetl, ydeth, ypos, yscal
      INTEGER   iery(MXRAY)
      INTEGER   icomp(2*MXPAR)
      SAVE      icomp
      INTEGER   i, icmd, icol, ier
      INTEGER   im0, imi, imxl, imyl, ipstat
      INTEGER   ir0, iri, ipsfm, itmp, iyoff
      INTEGER   j, k, lans, lbuf, lctnam, ldisp, ltmp
      INTEGER   nfit, nhead, nmx, nmy, npsf, nsav
      INTEGER   imeth, locmax, nsour, nterm
      SAVE      cfree, imeth, locmax, nsour, nterm
      LOGICAL   qend
C
C On some systems, putting arrays in common reduces the size of the
C object module.
      REAL      Bgpix(MXRAY,MXRAY), Excess(MXRAY,MXRAY)
      REAL      Sorc(MXRAY,MXRAY), Sdev(MXRAY,MXRAY)
      REAL      Fmodel(MXRAY,MXRAY)
      REAL      Xpect(-MXPSF:MXPSF,-MXPSF:MXPSF)
      COMMON /MVUEDUM/ Bgpix, Excess, Sorc, Sdev, Xpect, Fmodel
C
      DATA      plim/MXPAR*0.0,MXPAR*0.0,MXPAR*0.0/
      DATA      pval/MXPAR*0.0,0.0,0.0/
      DATA      nterm/0/
      DATA imeth/2/,nmx/0/,nmy/0/,npsf/0/
      DATA sfparm/0.333,0.00/
      DATA brad,srad/6.00,2.50/
      DATA locmax/0/
      DATA clmax/'SOR', 'SDEV', 'SNR'/
      DATA cfree/'PWN'/
C---
      nsav = Ncmd
      CALL SSGTDI(cctnam, lctnam, cdisp, ldisp)
      CALL BOUQOB(xdetl,ydetl,xdeth,ydeth)
C
C Priming prompt
C
  100 CONTINUE
      CALL GTBUF('SF> ',ier)
      CALL GTCHAR(cans,lans)
      IF ( lans.LE.0 ) cans = ' '
      CALL UPC(cans)
C
C Execute choice
C
      IF ( cans(1:1).EQ.'C' ) THEN
         CALL SFCNTS(Mxrow, Rmap, Nrow, Ncol, Srad, Brad,
     &      Mxpsf, xpect, npsf)
      ELSE IF ( cans(1:1).EQ.'E' .OR. cans(1:1).EQ.'Q' ) THEN
C Exit/Quit
         GOTO 999
      ELSE IF ( cans(1:1).EQ.'F' ) THEN
C FFile, F1, Fit
         IF ( cans(1:2).EQ.'FF' ) THEN
C FFile--Fit File
            IF ( ibsub.LE.0 ) THEN
               CALL SFILE(Qplot, Mxrow, Rmap, Nrow, Ncol, cfree,
     &         brad, Mxpar, 0, Tdata, icomp, pval, plim, nterm)
            ELSE
               CALL PTBUF('Using subtracted.',-1)
               CALL SFILE(Qplot, Mxrow, Rbsub, Nrow, Ncol, cfree,
     &         brad, Mxpar, 0, Tdata, icomp, pval, plim, nterm)
            END IF
         ELSE IF ( cans(1:2).EQ.'F1' ) THEN
C F1--Fit 1 point in file
            CALL SFILE(Qplot, Mxrow, Rmap, Nrow, Ncol, cfree,
     &         brad, Mxpar, 1, Tdata, icomp, pval, plim, nterm)
C
            pval(Nterm+1) = 0.0
            pval(Nterm+2) = 0.0
            WRITE(*,*) (pval(k),k=1,nterm)
            ctmp = 'WM tmp.mod'
            CALL MODEL(ctmp, xmin, xmax, MXPAR, ctmp, 0, icmd,
     &        Icomp, Pval, Plim, Nterm)
         ELSE
C Fit
            CALL GTPEEK(ctmp, ltmp)
            IF ( ISNUM(ctmp, ltmp).NE.0 ) THEN
               CALL GTINT(nsour, ier)
            ELSE
               nsour = 1
            END IF
            DO i=1,nsour
               CALL ASKPOS(Qplot, qend)
               IF ( qend ) GOTO 100
               xsour(i) = Xdet
               ysour(i) = Ydet
            END DO
            CALL PSFSIG(xsour(1), ysour(1), rsig)
            xmin(1) = xsour(1)-brad*rsig
            xmin(2) = ysour(1)-brad*rsig
            xmax(1) = xsour(1)+brad*rsig
            xmax(2) = ysour(1)+brad*rsig
           CALL SFITN(Qplot,Mxrow,Rmap,Nrow,Ncol,Xmin,Xmax,cfree,
     &   nsour,xsour,ysour,0,Mxpar,pval,plim,icomp,nterm,nfit,Xchi,ier)
C
            pval(Nterm+1) = xchi
            pval(Nterm+2) = nfit
            WRITE(*,*) (pval(k),k=1,nterm+2)
            ctmp = 'WM tmp.mod'
            CALL MODEL(ctmp, xmin, xmax, MXPAR, ctmp, 0, icmd,
     &        Icomp, Pval, Plim, Nterm)
         END IF
      ELSE IF ( cans(1:1).EQ.'I' ) THEN
C Interrogate a single position.
         CALL ASKPOS(Qplot, qend)
         IF ( .NOT.qend ) THEN
            CALL SFSEL(imeth,.TRUE.,Qplot,MXRAY,MXPSF,brad,srad,
     &      sfparm,box,sorc,sdev,Bgpix,Excess,nmx,nmy,
     &      xpect,npsf)
         END IF
      ELSE IF ( cans(1:1).EQ.'L' ) THEN
C Locate sources
         CALL SFSEL(imeth,.FALSE.,Qplot,MXRAY,MXPSF,brad,srad,
     &      sfparm,box,sorc,sdev,Bgpix,Excess,nmx,nmy,
     &      xpect,npsf)
         IF ( npsf.LT.0 ) GOTO 100
C Produce source list
         CALL SOURCES(Rmap,Mxrow,Nrow,Ncol,Mxray,Mxpsf,Imeth,
     &      locmax,Qplot,Brad,Srad,sfparm,box,Sorc,Sdev,Bgpix,
     &      Excess,Fmodel,nmx,nmy,Xpect,Tdata,Npsf)
      ELSE IF ( cans(1:1).EQ.'N' ) THEN
C New threshold
         IF ( nmx.LE.0 ) THEN
            CALL PTBUF('Must (re)run Locate.',-1)
            GOTO 100
         END IF
         CALL SOURCES(Rmap,Mxrow,Nrow,Ncol,Mxray,Mxpsf,imeth,
     &      locmax,Qplot,Brad,Srad,sfparm,box,Sorc,Sdev,Bgpix,
     &      Excess,Fmodel,nmx,Nmy,Xpect,Tdata,Npsf)
      ELSE IF ( cans(1:1).EQ.'O' ) THEN
C Overplot sources
         CALL SORPLOT(Qplot)
      ELSE IF ( cans(1:1).EQ.'P' ) THEN
C Plot/Fit
         Ncmd = nsav
         CALL GTCHAR(cbuf, lbuf)
         CALL UPC(cbuf)
         IF ( cbuf(1:2).EQ.'PS' ) THEN
            IF ( npsf.LE.0 ) THEN
               CALL PTBUF('SFIND: No PSF available.',-1)
               GOTO 100
            END IF
         ELSE IF ( cbuf(1:1).EQ.'B' .OR. cbuf(1:1).EQ.'S' ) THEN
            IF ( nmx.LE.0 ) THEN
               CALL PTBUF('Must (re)run Locate.',-1)
               GOTO 100
            END IF
         END IF
         DO i=1, MXRAY
            iery(i) = 0
         END DO
         Cmd(Ncmd+1) = 'Gap 0.0 Errors'
         Cmd(Ncmd+2) = 'IMA CCT 3 CB ON'
         Ncmd = Ncmd+2
         CALL POS_MAP_DET(1,1,xdet1,ydet1)
         CALL POS_MAP_DET(2,2,xdet2,ydet2)
         xscal = xdet2 - xdet1
         yscal = ydet2 - ydet1
         IF ( cbuf(1:2).EQ.'PS' ) THEN
            WRITE(Cmd(Ncmd+1), 141) 'XAX',-xscal*Npsf,xscal
            WRITE(Cmd(Ncmd+2), 141) 'YAX',-yscal*Npsf,yscal
  141       FORMAT(A,' LIN ',F10.3,F10.3)
         ELSE IF ( lbuf.LE.0 .OR. cbuf(1:1).EQ.'@' ) THEN
C Replot data
            WRITE(Cmd(Ncmd+1), 141) 'XAX',xdet1,xscal
            WRITE(Cmd(Ncmd+2), 141) 'YAX',ydet1,yscal
         ELSE
C Plot analysis region which can be smaller.
            CALL POS_DT_IM(Box(1),Box(2),imxl,imyl)
            CALL POS_MAP_DET(imxl,imyl,xdet1,ydet1)
            WRITE(Cmd(Ncmd+1), 141) 'XAX',xdet1,xscal
            WRITE(Cmd(Ncmd+2), 141) 'YAX',ydet1,yscal
         END IF
         Ncmd = Ncmd + 2
         Cmd(Ncmd+1) = 'ADJ ON'
         Ncmd = Ncmd + 1
         IF ( lbuf.LE.0 ) THEN
            Ncmd = Ncmd + 1
            WRITE(Cmd(Ncmd), 161) smin,smax
 161        FORMAT('IMAGE MIN ',1PG10.3,' MAX ',G10.3)
            icol = Ncol
            CALL PIMAGE(Rmap, Mxrow, Nrow, icol, Cmd, Mxcmd, Ncmd)
            GOTO 100
         END IF
         IF ( cbuf(1:1).EQ.'B' ) THEN
C Plot Back per pixel
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F Background per dpixel'
            CALL SFMNMX(Mxray, Bgpix, nmx, nmy, Cmd, Ncmd)
            CALL PLT(Bgpix,iery,Mxray,nmx,nmy,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:1).EQ.'E' ) THEN
C Plot Excess (sigma above background)
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F Excess'
            CALL SFMNMX(Mxray, Excess, nmx, nmy, Cmd, Ncmd)
            CALL PLT(Excess,iery,Mxray,nmx,nmy,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:2).EQ.'MO' ) THEN
C Plot Model
            IF ( nmx.LE.0 .OR. nmy.LE.0 ) THEN
               CALL PTBUF('Model array has not been defined.',-1)
               GOTO 100
            END IF
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F Model'
            CALL SFMNMX(Mxray, Fmodel, nmx, nmy, Cmd, Ncmd)
            CALL PLT(Fmodel,iery,Mxray,nmx,nmy,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:2).EQ.'PS' ) THEN
C Plot Psf
            CALL PSGSLI(itmp)
            IF ( itmp.GT.0 ) THEN
               Ncmd=Ncmd+1
               Cmd(Ncmd)= 'LAB T Slice '
               lbuf = 12
               CALL CRAMI(itmp, Cmd(Ncmd), lbuf)
            ELSE
               CALL PSQMO(ipsfm)
               IF ( ABS(ipsfm).NE.2 ) THEN
                  CALL PSFSIG(Xdet, Ydet, rsig)
                  Ncmd=Ncmd+1
                  Cmd(Ncmd)= 'LAB T PSF_SIG='
                  lbuf = 14
                  CALL CRAMFF(rsig, 5, 3, Cmd(Ncmd), lbuf)
               ELSE
                  CALL PSGELL(Xdet, Ydet, sigx, sigy, ang)
                  Ncmd=Ncmd+1
                  WRITE(Cmd(Ncmd),171) sigx,sigy,ang
  171             FORMAT('LAB T sigx=',F10.3,', sigy=',F10.3,
     &               ', ang=',F10.3)
               END IF
            END IF
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F PSF'
            itmp = 2*npsf+1
            CALL SFMNMX(2*Mxpsf+1,Xpect(-Npsf,-Npsf),
     &         itmp,itmp,Cmd,Ncmd)
            CALL PLT(Xpect(-Npsf,-Npsf),iery,2*Mxpsf+1,
     &         itmp,itmp,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:2).EQ.'SD' ) THEN
C Plot SDev (standard deviation)
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F Sdev'
            CALL SFMNMX(Mxray, Sdev, nmx, nmy, Cmd, Ncmd)
            CALL PLT(Sdev,iery,Mxray,nmx,nmy,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:2).EQ.'SN' ) THEN
C Plot SNR
            DO i=1,nmx
               DO j=1,nmy
                  IF ( Sdev(i,j).NE.NO .and. Sdev(i,j).NE.0.0) THEN
                     rtmp(i,j) = sorc(i,j)/sdev(i,j)
                  ELSE
                     rtmp(i,j) = NO
                  END IF
               END DO
            END DO
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F SNR'
            CALL SFMNMX(Mxray, rtmp, nmx, nmy, Cmd, Ncmd)
            CALL PLT(rtmp,iery,Mxray,nmx,nmy,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:1).EQ.'S' ) THEN
C Plot Source (source counts)
            Ncmd=Ncmd+1
            Cmd(Ncmd) = 'LAB F Sorc'
            CALL SFMNMX(Mxray, Sorc, nmx, nmy, Cmd, Ncmd)
            CALL PLT(Sorc,iery,Mxray,nmx,nmy,Cmd,Ncmd,ier)
         ELSE IF ( cbuf(1:1).EQ.'@' ) THEN
C Plot @ model, read and plot the model.
            ctmp = 'MOD '//cbuf
            ltmp = lbuf + 4
            CALL GTREST(cbuf, lbuf)
            IF ( lbuf.GT.0 ) THEN
               ctmp(ltmp+1:) = cbuf
            END IF
            xmin(1) = 0.
            xmin(2) = 0.
            xmax(1) = 2000.
            xmax(2) = 2000.
            icmd = -1
            CALL MODEL(ctmp, xmin, xmax, MXPAR, Cmd, 0, icmd,
     &       icomp, pval, plim, nterm)
            IF ( nterm.LE.0 ) THEN
               CALL PTBUF('No model defined.',-1)
               GOTO 100
            END IF
C
C Evaluate the model.  Note, this could overflow the Rmap array, but
C by design the Back array is next in memory.
            im0 = Mxrow*Ncol
            ir0 = Mxrow*Ncol*2
C*** Initialize the PLT X coordinate
            CALL PLTXCN(1,2,Nrow)
            CALL PLTXCL(1,1,xdet1,xscal)
            CALL PLTXCL(1,2,ydet1,yscal)
            DO i=1, Nrow*Ncol
               CALL PLTXCC(Rmap, i, 1, xt, itmp, iyoff)
               imi = im0 + iyoff
               rmap(imi) = FNFIT(xt, icomp, pval, nterm)
               iri = ir0 + iyoff
               rmap(iri) = rmap(iyoff) - rmap(imi)
            END DO
            WRITE(Cmd(Ncmd+1), 181) 1,1,Nrow,Ncol
            WRITE(Cmd(Ncmd+2), 181) 2,Ncol+1,Nrow,2*Ncol
            WRITE(Cmd(Ncmd+3), 181) 3,2*Ncol+1,Nrow,3*Ncol
  181       FORMAT('DGroup ',I3,'  1 ',4I6)
            Ncmd = Ncmd + 3
            Cmd(Ncmd+1) = 'WIN 2'
            Cmd(Ncmd+2) = 'LOC 0.5 0.5 1.0 1.0'
            Cmd(Ncmd+3) = 'VP .20 .15'
            Cmd(Ncmd+4) = 'YPL 2'
            WRITE(Cmd(Ncmd+5), 141) 'XAX',xdet1,xscal
            WRITE(Cmd(Ncmd+6), 141) 'YAX',ydet1,yscal
            WRITE(Cmd(Ncmd+7), 191) 2,smin,smax,cdisp(:ldisp)
  191       FORMAT('IMAGE ',I2,' CB ON MIN ',1PG10.3,' MAX ',G10.3,2X,A)
            Cmd(Ncmd+8) = 'LAB F Model'
            WRITE(Cmd(Ncmd+9), 231) xdetl, xdeth, ydetl, ydeth
  231       FORMAT('R ',4F9.1)
            Cmd(Ncmd+10) = 'ADJ ON'
            Ncmd = Ncmd + 10
            Cmd(Ncmd+1) = 'WIN 3'
            Cmd(Ncmd+2) = 'LOC 0.0 0.0 0.5 0.5'
            Cmd(Ncmd+3) = 'VP .20 .15'
            Cmd(Ncmd+4) = 'YPL 3'
            WRITE(Cmd(Ncmd+5), 141) 'XAX',xdet1,xscal
            WRITE(Cmd(Ncmd+6), 141) 'YAX',ydet1,yscal
            WRITE(Cmd(Ncmd+7), 191) 3,2*smin-smax,smax,'cct cenw Linear'
            Cmd(Ncmd+8) = 'LAB F Residuals'
            WRITE(Cmd(Ncmd+9), 231) xdetl, xdeth, ydetl, ydeth
            Cmd(Ncmd+10) = 'ADJ ON'
            Cmd(Ncmd+11) = 'IMA cct redshift'
            Ncmd = Ncmd + 11
C
            Cmd(Ncmd+1) = 'WIN 1'
            Cmd(Ncmd+2) = 'LOC 0.0 0.5 0.5 1.0'
            Cmd(Ncmd+3) = 'VP .20 .15'
            Cmd(Ncmd+4) = 'YPL 1'
            Ncmd = Ncmd + 4
            WRITE(Cmd(Ncmd+1), 251)
  251       FORMAT('LAB 23 Jus Cen VE .75 .47 "Parameters"')
            Ncmd = Ncmd + 1
            xpos = 0.55
            ypos = 0.42
            DO i=1, MIN(Nterm,22)
               IF ( i.EQ.12 ) THEN
                  xpos = 0.76
                  ypos = 0.42
               END IF
               Ncmd = Ncmd + 1
               WRITE(Cmd(Ncmd), 271) i,xpos,ypos, Pval(i), Plim(1,i)
  271          FORMAT('LAB  ',I2,' CS 0.9 Jus Lef VE ',F7.3,F7.3,
     &               ' "',1PG10.3,G10.2,'"')
               ypos = ypos - 0.035
            END DO
            icol = 3*Ncol
            Ncmd = Ncmd + 1
            WRITE(Cmd(Ncmd), 161) smin,smax
            CALL PIMAGE(Rmap, Mxrow, Nrow, icol, Cmd, Mxcmd, Ncmd)
C            CALL PLT(Rmap, iery, Mxrow, Nrow, icol, Cmd, Ncmd, ier)
         ELSE
            WRITE(*,*) 'Unknown command=',cbuf(:lbuf)
            GOTO 100
         END IF
      ELSE IF ( cans(1:1).EQ.'S' ) THEN
C Set/SHow
         IF ( cans(2:2).EQ.'E' ) THEN
C SEt
            CALL GTCHAR(cans, lans)
            CALL UPC(cans)
            IF ( cans(1:1).EQ.'B' ) THEN
C SEt Background radius (units detector FWHM)
               CALL GTREAL(tmp, ier)
               IF ( tmp.LT.srad ) THEN
                  WRITE(*,*) 'Must be greater than source radius',srad
               ELSE
                  brad = tmp
               END IF
            ELSE IF ( cans(1:2).EQ.'FR' ) THEN
C SEt FRee
               CALL GTCHAR(ctmp, ier)
               CALL UPC(ctmp)
               cfree=ctmp
            ELSE IF ( cans(1:2).EQ.'FP' ) THEN
C SEt FPixels (fraction of pixels acceptable)
               CALL GTREAL(tmp, ier)
               IF ( tmp.LT.0.0 .OR. tmp.GT.1.0 ) THEN
                  CALL PTBUF('Must be in range [0.0,1.0].',-1)
               ELSE
                  sfparm(1) = tmp
C FPix is used in by the locate command, hence we need to invalidate the
C previous results.
                  nmx=0
               END IF
            ELSE IF ( cans(1:2).EQ.'PT' ) THEN
C SEt PThres (PSF threshold)
               CALL GTREAL(tmp, ier)
               IF ( tmp.LT.0.0 .OR. tmp.GT.1.0 ) THEN
                  CALL PTBUF('Must be in range [0.0,1.0].',-1)
               ELSE
                  sfparm(2) = tmp
               END IF
            ELSE IF ( cans(1:2).EQ.'LM' ) THEN
C SEt LMax (local max method)
               CALL GTCHAR(cans,lans)
               CALL UPC(cans)
               itmp = -1
               DO i=0,2
                  IF ( cans(1:2).EQ.clmax(i)(1:2) ) THEN
                     itmp = i
                  END IF
               END DO
               IF ( itmp.GE.0 ) locmax=itmp
            ELSE IF ( cans(1:1).EQ.'M' ) THEN
               CALL GTCHAR(cbuf, lbuf)
               CALL UPC(cbuf)
               IF ( cbuf(1:1).EQ.'C' ) THEN
C SEt Method Celldetect
                  imeth = 1
               ELSE IF ( cbuf(1:1).EQ.'M' ) THEN
C SEt Method MVUE
                  imeth = 2
               END IF
            ELSE IF ( cans(1:2).EQ.'ST' ) THEN
               CALL GTCHAR(cbuf, lbuf)
               CALL UPC(cbuf)
               IF ( cbuf(1:1).EQ.'M' ) THEN
C SEt STatis Ml
                  ipstat = 1
               ELSE IF ( cbuf(1:1).EQ.'C' ) THEN
C SEt STatis Chi
                  ipstat = 0
               ELSE
                  WRITE(*,*) 'Unknown statistic ',cbuf(:lbuf),'.'
               END IF
               CALL SFITNS(ipstat)
            ELSE IF ( cans(1:1).EQ.'S' ) THEN
C SEt Source radius (units detector FWHW)
               CALL GTREAL(tmp, ier)
               IF ( tmp.LE.0.0 ) THEN
                  CALL PTBUF('Must be greater than 0.0.',-1)
               ELSE IF ( tmp.GT.brad ) THEN
                  WRITE(*,*) 'Must be less than background radius',brad
               ELSE
                  srad = tmp
               END IF
            END IF
         ELSE
C SHow
            cbuf = 'Method '
            IF ( imeth.EQ.1 ) THEN
               cbuf(8:) ='CellDetect'
            ELSE
               cbuf(8:) ='Mvue'
            END IF
            CALL PTBUF(cbuf,20)
C STatistic
            cbuf = 'STatis '
            CALL SFITNQ(ipstat)
            IF ( ipstat.EQ.1 ) THEN
               cbuf(8:) ='ML'
            ELSE
               cbuf(8:) ='Chi'
            END IF
            CALL PTBUF(cbuf,20)
C SHow Brad
            cbuf = 'Brad '
            lbuf = 5
            CALL CRAMFF(brad, 5, 3, cbuf, lbuf)
            cbuf(lbuf+1:) = ' *PSF_SIG'
            lbuf = lbuf + 9
            CALL PTBUF(cbuf,lbuf)
C SHow Srad
            cbuf = 'Srad '
            lbuf = 5
            CALL CRAMFF(srad, 5, 3, cbuf, lbuf)
            cbuf(lbuf+1:) = ' *PSF_SIG'
            lbuf = lbuf + 9
            CALL PTBUF(cbuf,lbuf)
C SHow FRee
            cbuf = 'FRee '//cfree(:LENACT(cfree))
            lbuf = LENACT(cbuf)
            CALL PTBUF(cbuf,lbuf)
C SHow FPix
            cbuf = 'FPix '
            lbuf = 5
            CALL CRAMFF(sfparm(1), 5, 3, cbuf, lbuf)
            CALL PTBUF(cbuf,lbuf)
C SHow PThr
            cbuf = 'PThr '
            lbuf = 5
            CALL CRAMFF(sfparm(2), 5, 3, cbuf, lbuf)
            CALL PTBUF(cbuf,lbuf)
C SHow LMax
            cbuf = 'LMax '//clmax(locmax)
            lbuf = LENACT(cbuf)
            CALL PTBUF(cbuf,lbuf)
         END IF
      ELSE IF ( cans(1:1).EQ.'W' ) THEN
C Write
         CALL GTCHAR(cbuf, lbuf)
         CALL UPC(cbuf)
         nhead = 0
         IF ( cbuf(1:1).EQ.'B' ) THEN
C Write Back per pixel
            CALL WR4MAP(Bgpix,Mxray,nmx,nmy,chead,nhead,ier)
         ELSE IF ( cbuf(1:1).EQ.'E' ) THEN
C Write Excess (sigma above background)
            CALL WR4MAP(Excess,Mxray,nmx,nmy,chead,nhead,ier)
         ELSE IF ( cbuf(1:2).EQ.'MO' ) THEN
C Write MOdel
            CALL WR4MAP(Fmodel,Mxray,nmx,nmy,chead,nhead,ier)
         ELSE IF ( cbuf(1:2).EQ.'PS' ) THEN
C Write Psf
            itmp = 2*npsf+1
            CALL WR4MAP(Xpect(-Npsf,-Npsf),2*Mxpsf+1,itmp,itmp,
     &          chead,nhead,ier)
         ELSE IF ( cbuf(1:2).EQ.'SD' ) THEN
C Write SDev (standard deviation)
            CALL WR4MAP(Sdev,Mxray,nmx,nmy,chead,nhead,ier)
         ELSE IF ( cbuf(1:2).EQ.'SN' ) THEN
C Write SNR
            DO i=1,nmx
               DO j=1,nmy
                  IF ( Sdev(i,j).NE.NO .and. Sdev(i,j).NE.0.0) THEN
                     rtmp(i,j) = sorc(i,j)/sdev(i,j)
                  ELSE
                     rtmp(i,j) = NO
                  END IF
               END DO
            END DO
            CALL WR4MAP(rtmp,Mxray,nmx,nmy,chead,nhead,ier)
         ELSE IF ( cbuf(1:1).EQ.'S' ) THEN
C Plot Source (source counts)
            CALL WR4MAP(Sorc,Mxray,nmx,nmy,chead,nhead,ier)
         ELSE
            WRITE(*,*) 'Not able to write',cbuf(:lbuf)
         END IF
      ELSE IF ( cans(1:1).EQ.'H' .OR. cans(1:1).EQ.'?' ) THEN
C ? Help!
         WRITE(*,321)
 321     FORMAT(' Options are:'/
     &      ' I    : Interrogate a position'/
     &      ' L    : Locate sources'/
     &      ' N    : New source list (from last Locate run)'/
     &      ' P    : Plot [S|B|Ex|Model|Psf|SDev|SNR|Sor|@model]'/
     &      ' Q    : Quit and return to main program'/
     &      ' SE/SH: Set/Show a parameter values'/
     &      ' ?    : Write out this menu')
      END IF
      GOTO 100
C
 999  CONTINUE
      END
C*********
      SUBROUTINE SFMNMX(Mxray, Aray, Nx, Ny, Cmd, Ncmd)
      INTEGER  Mxray, Nx, Ny, Ncmd
      REAL    Aray(Mxray,*)
      CHARACTER Cmd(*)*(*)
C---
C Helper routine for SFIT.
C---
C Mxray
C Aray
C Nx
C Ny
C Cmd   I/O
C Ncmd  I/O
C---
C 2000-07-30 - New [AFT]
C---
C Machine min and max
      REAL      SYSMIN, SYSMAX
      PARAMETER (SYSMIN=-1.E32,SYSMAX=1.E32)
      REAL      smax, smin
C No data flag
      REAL      NO
      PARAMETER (NO=-1.2E-34)
C
      INTEGER   i, j
C---
      smin = +SYSMAX
      smax = -SYSMAX
      DO i=1,nx
         DO j=1,ny
            IF ( Aray(i,j).NE.NO ) THEN
               smin = MIN(smin, Aray(i,j))
               smax = MAX(smax, Aray(i,j))
            END IF
         END DO
      END DO
C
      Ncmd = Ncmd + 1
      WRITE(Cmd(Ncmd), 121) smin,smax
  121 FORMAT('IMAGE MIN ',1PG10.3,' MAX ',G10.3)
      RETURN
      END
