      SUBROUTINE SFSEL(Imeth,Qpoint,Qplot,Mxray,Mxpsf,Brad,Srad,
     &      Sfparm,Box,Sorc,Sdev,Bgpix,Excess,Nmx,Nmy,
     &      Xpect,Npsf)
      LOGICAL   Qpoint, Qplot
      INTEGER   Imeth, Mxray, Mxpsf, Nmx, Nmy, Npsf
      REAL      Srad, Brad, SFparm(2), Box(4)
      REAL      Sorc(Mxray,Mxray), Sdev(Mxray,Mxray)
      REAL      Bgpix(Mxray,Mxray), Excess(Mxray,Mxray)
      REAL      Xpect(-Mxpsf:Mxpsf,-Mxpsf:Mxpsf)
C---
C Selects the source-finding method and runs it.
C---
C Imeth   I    =1 for cell detect, =2 for minimum variance
C Qpoint  I    Single point being tested
C Qplot   I    Plotting active flag
C Mxray   I
C Mxpsf   I
C Brad    I    Radius of background region (in units of Sigma)
C Srad    I    Radius of source region (in units of Sigma)
C Box     I/O  Search box (unchanged if a point search)
C Sorc      O
C Sdev      O
C Bgpix     O
C Excess    O
C Nmx       O
C Nmy       O
C---
C Global:
C Rmap
C Xdet, Ydet
C Ifac
C---
C 2000-07-29 - Allow more than one search method [AFT].
C---
      INCLUDE 'mapdef.inc'
      INCLUDE 'posdef.inc'
C
      REAL      bsav(4), bitmp(4), botmp(4)
      INTEGER   imxh, imxl, imyh, imyl
C
C Find the max size of detection cell and adjust the search box so that
C local background never falls off the edge of the map.
C
      IF ( Qpoint ) THEN
C Save original box
         bsav(1) = Box(1)
         bsav(2) = Box(2)
         bsav(3) = Box(3)
         bsav(4) = Box(4)
         botmp(1) = Xdet
         botmp(2) = Ydet
         botmp(3) = Xdet
         botmp(4) = Ydet
      ELSE
         CALL BOUQOB(botmp(1),botmp(2),botmp(3),botmp(4))
         CALL BOUQIB(bitmp(1),bitmp(2),bitmp(3),bitmp(4))
         botmp(1) = MIN(botmp(1), bitmp(1))
         botmp(2) = MIN(botmp(2), bitmp(2))
         botmp(3) = MAX(botmp(3), bitmp(3))
         botmp(4) = MAX(botmp(4), bitmp(4))
      END IF
C
C Send back the search box to be plotted
      box(1) = botmp(1)
      box(2) = botmp(2)
      box(3) = botmp(3)
      box(4) = botmp(4)
C
C Find corners of analysis box in map coordinates
      CALL POS_DT_IM(Box(1),Box(2),imxl,imyl)
      CALL POS_DT_IM(Box(3),Box(4),imxh,imyh)
      IF ( Qpoint .AND.
     &   imxl.LT.1.OR.Nrow.LT.imxl.OR.imyl.LT.1.OR.Nrow.LT.imyl.OR.
     &   imxh.LT.1.OR.Nrow.LT.imxh.OR.imyh.LT.1.OR.Nrow.LT.imyh ) THEN
         CALL PTBUF('Must select a point on the map.',-1)
         GOTO 900
      END IF
      imxl = MIN(MAX(1,imxl),Nrow)
      imyl = MIN(MAX(1,imyl),Ncol)
      imxh = MIN(MAX(1,imxh),Nrow)
      imyh = MIN(MAX(1,imyh),Ncol)
C
C Make sure that the output will fit in the arrays.
      IF ( .NOT.Qpoint ) THEN
         IF ( imxh-imxl+1.GT.MXRAY ) THEN
            WRITE(*,*) 'Array size of ',imxh-imxl+1,' exceeds',MXRAY
            CALL EDICOM('OFF',3)
            STOP
         END IF
         IF ( imyh-imyl+1.GT.MXRAY ) THEN
            WRITE(*,*) 'Array size of ',imyh-imyl+1,' exceeds',MXRAY
            STOP
         END IF
         Nmx = imxh - imxl + 1
         Nmy = imyh - imyl + 1
      END IF
C
      IF ( Imeth.EQ.1 ) THEN
         CALL CDTECT(Rmap,Mxrow,Nrow,Ncol,Qpoint,
     &    Mxray,Mxpsf,Brad,Srad,Sfparm,box,Sorc,Sdev,Bgpix,Excess,
     &    Nmx,Nmy,Xpect,Npsf)
      ELSE
         CALL SFMVUE(Rmap,Mxrow,Nrow,Ncol,Back,Lback,Qpoint,
     &    Mxray,Mxpsf,Brad,Srad,Sfparm,box,Sorc,Sdev,Bgpix,Excess,
     &    Nmx,Nmy,Xpect,Npsf)
      END IF
C
  900 CONTINUE
      IF ( Qpoint ) THEN
C Restore original Box
         Box(1) =bsav(1)
         Box(2) =bsav(2)
         Box(3) =bsav(3)
         Box(4) =bsav(4)
      END IF
C
      RETURN
      END
