      SUBROUTINE SMOOTH(Rmap,Mxrow,Nrow,Ncol,Imap0,Jmap0,Nx,Ny,Ntimes)
      INTEGER   Mxrow, Nrow, Ncol, Imap0, Jmap0, Nx, Ny, Ntimes
      REAL      Rmap(*)
C---
C LEXTRCT routine to do nearest neighbour smooth of map.
C---
C Rmap    I/O  Original map in, smoothed map out
C Mxrow   I
C Nrow    I
C Ncol    I
C Imap0   I
C Jmap0   I
C Nx      I
C Ny      I
C Ntimes  I    Number of times to smooth
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
C
      INCLUDE 'scrat.inc'
C
      DOUBLE PRECISION dsum
      INTEGER   imapn, jmapn
      INTEGER   i, icen, icnt, ioff, itime, j, j1
C
C Find upper right corner of box
C
      imapn = Nx + Imap0 - 1
      jmapn = Ny + Jmap0 - 1
C
      DO itime=1,Ntimes
         DO j=Jmap0, jmapn
            DO i=Imap0, imapn
               icnt = 0
               dsum = 0.0d0
               icen = (j-1)*Mxrow + i
               DO j1=-1,1
C Make sure the column in on the array
                  IF ( j+j1.GE.1 .AND. j+j1.LE.Ncol ) THEN
                     ioff = (j+j1-1)*Mxrow + i
C Unroll inner loop over rows
                     IF ( i-1.GE.1 .AND. rmap(ioff-1).NE.NO ) THEN
                        dsum = dsum + rmap(ioff-1)
                        icnt = icnt + 1
                     END IF
                     IF ( rmap(ioff).NE.NO) THEN
                        dsum = dsum + rmap(ioff)
                        icnt = icnt + 1
                     END IF
                     IF ( i+1.LE.Nrow .AND. rmap(ioff+1).NE.NO) THEN
                        dsum = dsum + rmap(ioff+1)
                        icnt = icnt + 1
                     END IF
                  END IF
               END DO
               IF ( icnt.GT.0 ) THEN
                  rscrat(icen) = dsum/icnt
               ELSE
                  rscrat(icen) = NO
               END IF
            END DO
         END DO
C---
         DO j=Jmap0, jmapn
            DO i=Imap0, imapn
               icen = (j-1)*Mxrow + i
               IF ( rmap(icen).NE.NO )  rmap(icen) = rscrat(icen)
            END DO
         END DO
      END DO
C
      RETURN
      END
