      SUBROUTINE SOURCES(Rmap,Mxrow,Nrow,Ncol,Mxray,Mxpsf,Imeth,
     &   Locmax,Qplot,Brad,Srad,Sfparm,Box,Sorc,Sdev,Bgpix,
     &   Excess,Fmodel,Nmx,Nmy,Xpect,Tdata, Npsf)
      INTEGER   Mxrow, Nrow, Ncol, Mxray, Mxpsf, Imeth, Locmax
      INTEGER   Nmx, Nmy, Npsf
      LOGICAL   Qplot
      REAL      Rmap(Mxrow, *)
      REAL      Brad, Srad, Sfparm(2), Box(4)
      REAL      Sorc(Mxray,Mxray), Sdev(Mxray,Mxray)
      REAL      Bgpix(Mxray,Mxray), Excess(Mxray,Mxray)
      REAL      Fmodel(Mxray,Mxray)
      REAL      Xpect(-Mxpsf:Mxpsf,-Mxpsf:Mxpsf), Tdata
C---
C This subroutine writes as a source any position which has a best
C estimate s above the detection criterion and is a local maximum
C in s.
C---
C Rmap
C Mxrow
C Nrow
C Ncol
C Mxray   I
C Mxpsf
C Imeth
C Locmax  I    =0 use SOR, =1 use SDEV, =2 use SNR
C Qplot
C Brad
C Srad    I    Radius of source region, only allow one source per region.
C Box
C Sorc
C Sdev
C Bgpix
C Nmx
C Nmy
C Xpect
C Npsf
C---
C 2000-07-29 - Updated [AFT].
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      DOUBLE PRECISION DNO
      PARAMETER (DNO=-1.2D-34)
      INTEGER   MXCOL
      PARAMETER (MXCOL=17)
      INCLUDE 'posdef.inc'
      INTEGER   LENACT
C
      CHARACTER cmeth(2)*16
      CHARACTER clmax(0:2)*8
      CHARACTER cout*256
      CHARACTER cbuf*132
      CHARACTER cprom*72, ctmp*72
      CHARACTER cnam*8, cpre*8
      CHARACTER ctype(MXCOL)*16, cform(MXCOL)*16, cunit(MXCOL)*16
      DOUBLE PRECISION dra, ddec
      REAL      emin, snrmin
      SAVE      emin, snrmin
      REAL      csumi, csumo
      REAL      cthres, epeak
      REAL      pquad, psig, pthres, pxcen, pycen, psumi, tmp
      REAL      rsig, sorcen, srat, xpos, xsum, xtmp, ypos, ysum, ytmp
      INTEGER   istat
      INTEGER   i1, ib2, ib, ibrad, icnti, icnto, id2
      INTEGER   ier, ig2, imxh, imxl
      INTEGER   imap, imyh, imyl, is2, isky, isig, israd, itmp
      INTEGER   j1, jmap, l, l1, lhi, llo, lpre, m, m1, mhi, mlo
      INTEGER   lbuf, luno, nfield, nmpix, ntot
      LOGICAL   qout
      DATA      snrmin/2.8/, emin/5.0/
      DATA cmeth/'Cell Detect','Min Variance'/
      DATA ctype/'NAME','X', 'Y','COUNTS','SNR',
     & 'SEST','SEST_SIG','BGDPIX','PSF_SIG','SRAD','BRAD','PSUMI',
     & 'XCEN','YCEN','EXCESS','RA','DEC'/
      DATA cform/  '8A','1E','1E','1E',    '1E',
     &  '1E',  '1E',    '1E',    '1E',   '1I', '1I',  '1E',
     &  '1E',  '1E',  '1E',   '1D','1D'/
      DATA cunit/' ', 'pixel', 'pixel', ' ', ' ',
     &   ' ', ' ', ' ', 'pixel', 'pixel', 'pixel', ' ',
     &   'pixel', 'pixel',' ','deg','deg'/
      DATA clmax/'SOR', 'SDEV', 'SNR'/
C
   11 FORMAT(A)
C
      DO i1=1,Mxray
         DO j1=1,Mxray
            Fmodel(j1,i1) = 0.0
         END DO
      END DO
      CALL POS_SKY(isky)
C
C Ask for minimum SNR.
C
  100 CONTINUE
      WRITE(cprom,101) snrmin, emin
  101 FORMAT('Minimum SNR for detection (',F10.3,'), emin(',F10.3,')?')
      CALL GTBUF(cprom,ier)
      IF ( ier.NE.0 ) GOTO 900
      CALL GTREAL(snrmin,ier)
      CALL GTREAL(emin,ier)
      IF ( snrmin.EQ.0.0 ) THEN
         CALL PTBUF('Zero is not allowed.',-1)
         GOTO 100
      END IF
C
C Ask for optional filename to save results.
C
      cout = ' '
      CALL GTBUF('Output FITS file name:',ier)
C
      CALL GETLUN(luno)
      CALL AFNEW(luno, istat)
      IF ( istat.EQ.0 ) THEN
         qout = .TRUE.
      ELSE
         qout = .FALSE.
         istat = 0
         CALL FTCLOS(luno, istat)
         CALL FRELUN(luno)
         luno = 0
      END IF
C
      IF ( qout ) THEN
         CALL GTCHAR(cpre, lpre)
         lpre = MIN(lpre,4)
C Create the data extension
         istat = 0
         CALL FTCRHD(luno, istat)
C Write the main header keywords.
         IF ( isky.NE.0 ) THEN
            nfield = 17
         ELSE
            nfield = 15
         END IF
         CALL FTPHBN(luno, 0, nfield, ctype, cform, cunit,
     &            'SRCLIST', 0, istat)
C
         IF ( istat.NE.0 ) THEN
            WRITE(*,*) 'FITSIO istat=',istat
            istat = 0
            CALL FTCLOS(luno, istat)
            CALL FRELUN(luno)
            qout = .FALSE.
         END IF
      END IF
C
      WRITE(*,111) cmeth(Imeth),snrmin,emin
  111 FORMAT(' Method=',A16,', Min_SNR=',F10.3,', Min excess=',F10.2)
      WRITE(*,121) Sfparm(1)
  121 FORMAT(' FPix=',F10.3)
      WRITE(*,131) Brad,Srad
  131 FORMAT(' Brad=',F10.3,' *PSF_sig, Srad=',F10.3,' *PSF_sig')
      CALL GTFWAT(psig)
      CALL GTFWQU(pquad)
      CALL GTFWCN(pxcen, pycen)
      cbuf = 'PSF_sig='
      lbuf = 9
      CALL CRAMFF(psig,5,3,cbuf,lbuf)
      cbuf(lbuf+1:lbuf+5) = ' at ('
      lbuf = lbuf + 5
      CALL CRAMFF(pxcen,5,1,cbuf,lbuf)
      lbuf = lbuf + 1
      CALL CRAMFF(pycen,5,1,cbuf,lbuf)
      cbuf(lbuf+1:lbuf+12) = '), PSF_quad='
      lbuf = lbuf + 12
      CALL CRAMFF(pquad,5,-4,cbuf,lbuf)
      CALL PTBUF(cbuf,lbuf)
      IF ( qout ) THEN
         istat = 0
         CALL FTPKYE(luno, 'LIVETIME',Tdata,5,'[s] Live time',istat)
         CALL FTPKYS(luno, 'METHOD', cmeth(Imeth), 'Method',istat)
         CALL FTPKYS(luno, 'LMAX', clmax(locmax), 'Local Max',istat)
         CALL FTPKYE(luno,'SNRMIN', snrmin, 5, 'Minimum SNR',istat)
         CALL FTPKYE(luno,'EMIN', emin, 5,
     &      'Minimum sigma above background',istat)
         CALL FTPKYE(luno,'FPIXELS', Sfparm(1), 5,
     &      'Minimum acceptable fraction of pixels',istat)
         CALL FTPKYE(luno,'PTHRESH', Sfparm(2), 5,
     &      'PSF threshold',istat)
         CALL FTPKYE(luno,'BRAD', Brad, 5,
     &      'Background radius (in PSF sigma)',istat)
         CALL FTPKYE(luno,'SRAD', Srad, 5,
     &      'Source radius (in PSF sigma)',istat)
         CALL FTPKYE(luno,'PSF_SIG',psig,5,
     &      'PSF sigma at origin [pixels]',istat)
         CALL FTPKYE(luno,'PSF_QUAD', pquad, 5, 'PSF Quad',istat)
         CALL FTPKYE(luno,'PSF_XCEN', pxcen, 5, 'PSF X origin',istat)
         CALL FTPKYE(luno,'PSF_YCEN', pycen, 5, 'PSF Y origin',istat)
         CALL PSQMOC(ctmp)
         CALL FTPKYS(luno,'PSF_MOD', ctmp, 'PSF model',istat)
      END IF
      CALL PSGFIL(cbuf, lbuf)
      IF ( lbuf.GT.0 ) THEN
         WRITE(*,*) 'PSF file=',cbuf(:lbuf)
         IF ( qout ) THEN
            CALL FTPKYS(luno, 'PSFFILE', cbuf(:lbuf), 'PSF file',istat)
         END IF
      END IF
      IF ( qout ) THEN
         CALL WFWCS(luno, 2, 3, Ier)
      END IF
C
      CALL BOUSTR(cbuf)
      lbuf = LENACT(cbuf)
      CALL PTBUF(cbuf,lbuf)
      WRITE(*,151) Ifac, (Box(3)-Box(1))/Ifac + 1,
     &                   (Box(4)-Box(2))/Ifac + 1
  151 FORMAT(' Compression factor: ',I2,', Analysis region: ',
     &           F7.1,' mpix by ',F7.1,' mpix')
      IF ( qout ) THEN
         CALL FTPCOM(luno, cbuf(:lbuf), istat)
         CALL FTPKYJ(luno,'COMP', Ifac, 'Compression',istat)
         itmp = (Box(3)-Box(1))/Ifac + 1
         CALL FTPKYJ(luno,'XSIZE', itmp,
     &      'in map pixels',istat)
         itmp = (Box(4)-Box(2))/Ifac + 1
         CALL FTPKYJ(luno,'YSIZE', itmp,
     &      'in map pixels',istat)
C Leave room in header for keywords to be filled in later.
         CALL FTPKYJ(luno, 'IMSIZE', 0,
     &      'Number of map pixels searched', istat)
      END IF
      WRITE(*,181)
  181 FORMAT(/,'  ** SOURCES **')
C
C Find corners of analysis box in map coordinates
C
      CALL POS_DT_IM(Box(1),Box(2),imxl,imyl)
      imxl = MIN(MAX(1,imxl),Nrow)
      imyl = MIN(MAX(1,imyl),Ncol)
      CALL POS_DT_IM(Box(3),Box(4),imxh,imyh)
      imxh = MIN(MAX(1,imxh),Nrow)
      imyh = MIN(MAX(1,imyh),Ncol)
C
C Check for local maximum, if so output position in detector coordinates
C note that the arrays sorc and sdev are now relative to Box(1), Box(2).
C
      ntot = 0
      nmpix = 0
C Step backwards, to match increasing RA.
      DO imap=imxh, imxl, -1
         DO 400 jmap=imyl, imyh
            i1 = imap - imxl + 1
            j1 = jmap - imyl + 1
            IF ( Rmap(imap,jmap).EQ.NO .OR. Sdev(i1,j1).EQ.NO .OR.
     &           Sdev(i1,j1).LE.0.0 ) GOTO 400
C Count map pixels considered
            nmpix = nmpix + 1
C Note, if snrmin is negative, then this will find negative sources.
C Don't blow up if Sdev=0.0.
            IF ( Sorc(i1,j1)/snrmin.GE.Sdev(i1,j1) ) THEN
               CALL POS_MAP_DET(imap,jmap,xpos,ypos)
               CALL PSFSIG(xpos, ypos, rsig)
C Make sure there are no higher points within isig (~1 sigma) of current.
               isig = MAX(1, NINT(rsig/Ifac))
C Always include the central 3x3 island (r**2.ge.2)
               ig2 = MAX(2, isig*isig)
               IF ( locmax.EQ.0 ) THEN
                  sorcen = Sorc(i1,j1)
               ELSE IF ( locmax.EQ.1 ) THEN
                  sorcen = Sdev(i1,j1)
               ELSE
                  sorcen = Sorc(i1,j1)/Sdev(i1,j1)
               END IF
               llo = -isig - (MIN(imap-isig,1)-1)
               lhi =  isig - (MAX(imap+isig,nrow)-nrow)
C Use excess at center of cell.  (Note, for the old method of computing
C excess, the peak may not be at the center.)
               epeak = excess(i1,j1)
               DO 240 l=llo, lhi
                  IF ( i1+l.LE.0 .OR. i1+l.GT.MXRAY ) GOTO 240
                  mlo = -isig - (MIN(jmap-isig,1)-1)
                  mhi =  isig - (MAX(jmap+isig,ncol)-ncol)
                  DO 230 m=mlo, mhi
                     IF ( j1+m.LE.0 .OR. j1+m.GT.MXRAY ) GOTO 230
                     id2 = l*l + m*m
C                     epeak = MAX(epeak, excess(i1+l,j1+m))
                     IF( id2.NE.0 .AND. id2.LE.ig2 .AND.
     &                   Sdev(i1+l,j1+m).GT.0.0 ) THEN
                        IF ( locmax.EQ.0 ) THEN
                           tmp = Sorc(i1+l,j1+m)
                        ELSE IF ( locmax.EQ.1 ) THEN
                           tmp = Sdev(i1+l,j1+m)
                        ELSE
                           tmp = Sorc(i1+l,j1+m)/Sdev(i1+l,j1+m)
                        END IF
C Again expressed to find negative sources.
                        IF( tmp/sorcen.GT.1.0 )THEN
                           GOTO 400
                        END IF
                     END IF
  230             CONTINUE
  240          CONTINUE
C
C Number of background counts expected in source region.
               IF ( emin.GT.0.0 .AND. epeak.LT.emin ) GOTO 400
C
               IF ( snrmin.GT.0.0 ) THEN
C All tests passed, tweak up position and compute the Cell Detect counts.
                  ntot = ntot + 1
                  israd = MAX(1, NINT(srad*rsig/Ifac))
                  is2 = MAX(1,NINT((srad*rsig)**2/(Ifac*Ifac)))
                  ibrad = MAX(israd+1,MAX(1, NINT(brad*rsig/Ifac)))
                  ib2 = MAX(2,NINT((brad*rsig)**2/(Ifac*Ifac)))
                  Npsf = ibrad
                  CALL PSFSET(Ifac, xpos, ypos, Mxpsf, Npsf, Xpect)
                  icnti = 0
                  icnto = 0
                  csumi = 0.0
                  csumo = 0.0
                  psumi = 0.0
                  xsum = 0.0
                  ysum = 0.0
               cthres=Rmap(imap,jmap)+3.*SQRT(MAX(1.0,Rmap(imap,jmap)))
                  pthres=Sfparm(2)*Xpect(0,0)
                  llo = -Npsf - (MIN(imap-Npsf,1)-1)
                  lhi =  Npsf - (MAX(imap+Npsf,nrow)-nrow)
                  DO l=llo, lhi
                     l1 = imap + l
                     mlo = -Npsf - (MIN(jmap-Npsf,1)-1)
                     mhi =  Npsf - (MAX(jmap+Npsf,ncol)-ncol)
                     DO m=mlo, mhi
                        m1 = jmap + m
                        id2 = l*l + m*m
                        IF ( Rmap(l1,m1).NE.NO .AND. id2.LE.ib2 .AND.
     &         (Xpect(l,m).GE.pthres .OR. Rmap(l1,m1).LE.cthres) ) THEN
                           IF ( id2.LE.is2 ) THEN
                              icnti = icnti + 1
                              csumi = csumi + Rmap(l1,m1)
                              psumi = psumi + Xpect(l,m)
                              xsum = xsum + l*Rmap(l1,m1)
                              ysum = ysum + m*Rmap(l1,m1)
                           ELSE
                              icnto = icnto + 1
                              csumo = csumo + Rmap(l1,m1)
                           END IF
                        END IF
C Since the PSF can extend off the region we are searching, make sure
C we don't overflow the model array boundaries.
                        IF ( i1+l.GT.0 .AND. j1+m.GT.0 .AND.
     &                   i1+l.LE.MXRAY .AND. j1+m.LE.MXRAY ) THEN
                           fmodel(i1+l,j1+m) = fmodel(i1+l,j1+m) +
     &                      Sorc(i1,j1)*Xpect(l,m)
                        END IF
                     END DO
                  END DO
                  xtmp = xpos + Ifac*xsum/csumi
                  ytmp = ypos + Ifac*ysum/csumi
C                  srat = (csumi - Bgpix(i1,j1)*icnti*Ifac*Ifac)/psumi
                  srat = (csumi - csumo*icnti/icnto)/psumi
               END IF
C
C Found a potential source, output the details.
               CALL PTBUF(' ',-1)
               WRITE(*,231) ntot, xpos, ypos,
     &               Sorc(i1,j1)/Sdev(i1,j1), excess(i1,j1)
 231           FORMAT(I6,': Center  : ',F8.1,1X,F8.1,';  SNR= ',F7.2,
     &            ';  Excess=',F7.1)
               IF ( qout ) THEN
                  WRITE(ctmp, 291) ntot+10000
 291              FORMAT(I6)
                  IF ( lpre.GT.0 ) THEN
                     cnam = cpre(:lpre)//ctmp(3:6)
                  ELSE
                     cnam = ctmp(3:6)
                  END IF
                  CALL FTPCLS(luno, 1, ntot, 1, 1, cnam, istat)
                  tmp = Sorc(i1,j1)/Sdev(i1,j1)
                  CALL FTPCLE(luno, 5, ntot, 1, 1, tmp, istat)
                  CALL FTPCLE(luno,13, ntot, 1, 1, xpos, istat)
                  CALL FTPCLE(luno,14, ntot, 1, 1, ypos, istat)
                  CALL FTPCLE(luno,15, ntot, 1, 1, excess(i1,j1), istat)
               END IF
               IF ( snrmin.GT.0.0 ) THEN
                  IF ( isky.NE.0 ) THEN
                     CALL POS_DT_RA(xtmp, ytmp, dra, ddec)
                     WRITE(*,241) xtmp, ytmp, srat, dra, ddec
 241               FORMAT(' Position: ',F8.1,1X,F8.1,'; counts=',F10.1,
     &                '; World=',F10.5,',',F9.5)
                     IF ( qout ) THEN
                        CALL FTPCLE(luno, 2, ntot, 1, 1, xtmp, istat)
                        CALL FTPCLE(luno, 3, ntot, 1, 1, ytmp, istat)
                        CALL FTPCLE(luno, 4, ntot, 1, 1, srat, istat)
                        CALL FTPCLD(luno,16, ntot, 1, 1, dra,  istat)
                        CALL FTPCLD(luno,17, ntot, 1, 1, ddec, istat)
                     END IF
                  ELSE
                     WRITE(*,251) xtmp, ytmp, srat
 251               FORMAT(' Position: ',F8.1,1X,F8.1,'; counts=',F10.1)
                     IF ( qout ) THEN
                        CALL FTPCLE(luno, 2, ntot, 1, 1, xtmp, istat)
                        CALL FTPCLE(luno, 3, ntot, 1, 1, ytmp, istat)
                        CALL FTPCLE(luno, 4, ntot, 1, 1, srat, istat)
                     END IF
                  END IF
               END IF
C
               WRITE(*,261) Sorc(i1,j1), Sdev(i1,j1), Bgpix(i1,j1)
 261           FORMAT(' Sest= ',F10.1,', sig(S)= ',F8.1,', bgdp=',
     &                 F9.3)
               WRITE(*,271) rsig, israd*Ifac, ibrad*Ifac, psumi
 271           FORMAT(' PSF_sig = ',F7.2,', Srad=',I5,
     &            ' dpix, Brad=',I5,' dpix, psumi=',F7.3)
               CALL PTBUF(' ',-1)
               IF ( qout ) THEN
                   CALL FTPCLE(luno, 6, ntot, 1, 1, Sorc(i1,j1), istat)
                   CALL FTPCLE(luno, 7, ntot, 1, 1, Sdev(i1,j1), istat)
                   CALL FTPCLE(luno, 8, ntot, 1, 1,Bgpix(i1,j1), istat)
                   CALL FTPCLE(luno, 9, ntot, 1, 1, rsig, istat)
                   CALL FTPCLI(luno,10, ntot, 1, 1, israd*Ifac, istat)
                   CALL FTPCLI(luno,11, ntot, 1, 1, ibrad*Ifac, istat)
                   CALL FTPCLE(luno,12, ntot, 1, 1, psumi, istat)
               END IF
C And plot it.
               CALL PCROSS(Brad, Srad, xtmp, ytmp, Qplot)
            END IF
 400     CONTINUE
      END DO
C
  900 CONTINUE
C
C Close source output file
      WRITE(*,911) ntot,nmpix
  911 FORMAT(' Sources=',I7,', Total=',I7, ' mpix.')
      IF ( qout ) THEN
C         WRITE(luno,911) ntot,nmpix
         CALL FTMKYJ(luno, 'NAXIS2', Ntot, '&', istat)
         CALL FTMKYJ(luno, 'IMSIZE', nmpix, '&', istat)
         IF ( istat.NE.0 ) THEN
            WRITE(*,*) 'FITSIO istat=',istat
            istat = 0
         END IF
         CALL FTCLOS(luno,istat)
         CALL FRELUN(luno)
      END IF
C
      END
