      SUBROUTINE TMAP(Rmap,Mxrow,Nrow,Ncol,Cname,Lname,Qplot)
      INTEGER   Mxrow, Nrow, Ncol, Lname
      REAL      Rmap(Mxrow,*)
      CHARACTER Cname*(*)
      LOGICAL   Qplot
C---
C Subroutine to write out section of map surrounding a defined point.
C---
C Rmap    I    map data
C Mxrow   I
C Nrow    I
C Ncol    I
C Qplot   I    image plotting device flag
C---
C 1997-Feb-20 - Better scaling [AFT]
C 85/10/16    - kaa
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INTEGER   LENACT
C
      CHARACTER cbuf*198
      CHARACTER cprom*72
      REAL      rmax, rmin, scale, tmp, xtmp, ytmp
      INTEGER   ixloc(2), iyloc(2)
      INTEGER   i, i1, imap, lowi, lowj, nbins, ier
      INTEGER   j, j1, jmap, lbuf, nspace
      LOGICAL   qfail
C
      SAVE nbins
      DATA nbins/19/
C
C Ask for position and convert to map coordinates
C
      CALL ASKPOS(Qplot,qfail)
      IF ( qfail ) GOTO 999
C
      CALL POS_DT_IM(Xdet, Ydet, imap, jmap)
      CALL POS_MAP_DET(imap, jmap, Xdet, Ydet)
C
C Ask for size of map to be written
C
 200  CONTINUE
      CALL GTPEEK(cbuf,lbuf)
      IF ( lbuf.EQ.0 ) THEN
         WRITE (cprom,201) nbins
 201     FORMAT ('Size of map to be printed (< 33) [',I4,']:')
         CALL GTBUF(cprom,ier)
      END IF
      CALL GTINT(nbins,ier)
      IF ( (nbins.LT.1) .OR. (nbins.GT.33) ) THEN
         CALL PTBUF(' ', 1)
         CALL PTBUF(' ** Illegal map size', -1)
         nbins = 17
         GOTO 200
      END IF
C
C Find lower left corner of region to be output
C
      lowi = imap - (nbins-1)/2
      lowj = jmap - (nbins-1)/2
C
C Find Maximum value
C
      rmax = -1.E37
      rmin = +1.E37
      DO i = 1, nbins
         i1 = lowi + i - 1
         IF ( (i1.GT.0) .AND. (i1.LE.Nrow) ) THEN
            DO j = 1, nbins
               j1 = lowj + j - 1
               IF ( (j1.GT.0) .AND. (j1.LE.Ncol) ) THEN
                  IF ( Rmap(i1,j1).NE.NO ) THEN
                     IF ( Rmap(i1,j1).GT.rmax ) THEN
                        rmax = Rmap(i1,j1)
                        ixloc(2) = i1
                        iyloc(2) = j1
                     END IF
                     IF ( Rmap(i1,j1).LT.rmin ) THEN
                        rmin = Rmap(i1,j1)
                        ixloc(1) = i1
                        iyloc(1) = j1
                     END IF
                  END IF
               END IF
            END DO
         END IF
      END DO
C
C Print out map
C
      CALL PTBUF(' ', 1)
      WRITE (cbuf,301) Cname(:Lname)
 301  FORMAT (' Filename     = ',A)
      lbuf = LENACT(cbuf)
      CALL PTBUF(cbuf,lbuf)
      WRITE (cbuf,311) Rmap(imap,jmap), Xdet, Ydet
 311  FORMAT ('  Center value=',1PG10.3,' @(',0PF8.1,1X,F8.1,')')
      lbuf = LENACT(cbuf)
      CALL PTBUF(cbuf,lbuf)
      CALL POS_MAP_DET(ixloc(1), iyloc(1), xtmp, ytmp)
      WRITE (cbuf,321) rmin, xtmp, ytmp
 321  FORMAT (' Minimum value=',1PG10.3,' @(',0PF8.1,1X,F8.1,')')
      lbuf = LENACT(cbuf)
      CALL PTBUF(cbuf,lbuf)
      CALL POS_MAP_DET(ixloc(2), iyloc(2), xtmp, ytmp)
      WRITE (cbuf,331) rmax, xtmp, ytmp
 331  FORMAT (' Maximum value=',1PG10.3,' @(',0PF8.1,1X,F8.1,')')
      lbuf = LENACT(cbuf)
      CALL PTBUF(cbuf,lbuf)
C
      tmp = MAX(ABS(rmin),ABS(rmax))
      IF ( tmp.GT.0.0 .AND. tmp.LT.1.0 ) THEN
         scale = 10.**MIN(30,NINT(2 - LOG10(tmp)))
         IF ( nbins.LE.13 ) scale = scale*100.
         WRITE (cbuf,341) scale
 341     FORMAT (' Multiplying by=',1PG10.3)
         lbuf = LENACT(cbuf)
         CALL PTBUF(cbuf,lbuf)
      ELSE
         scale = 1.0
      END IF
      CALL PTBUF(' ', 1)
C
      IF ( tmp*scale.LE.999. ) THEN
         nspace = 4
      ELSE
         nspace = 6
      END IF
C
C Type map to match PGPLOT display orientation.
      DO j = nbins, 1, -1
         j1 = lowj + j - 1
         cbuf = ' '
         lbuf = 0
         DO i = 1, nbins
            i1 = lowi + i - 1
            IF ( i1.EQ.0 .OR. i1.EQ.Nrow+1 ) THEN
               IF ( j1.LT.0 .OR. j1.GT.Ncol+1 ) THEN
                  cbuf(lbuf+1:lbuf+nspace) = '     '
                  lbuf = lbuf + nspace
               ELSE IF ( j1.EQ.0 .OR. j1.EQ.Ncol+1 ) THEN
C Corner of map
                  cbuf(lbuf+1:lbuf+nspace) = '  +  '
                  lbuf = lbuf + nspace
               ELSE
                  cbuf(lbuf+1:lbuf+nspace) = '  |  '
                  lbuf = lbuf + nspace
               END IF
            ELSE IF ( j1.EQ.0 .OR. j1.EQ.Ncol+1 ) THEN
               IF ( i1.LT.0 .OR. i1.GT.Nrow+1 ) THEN
                  cbuf(lbuf+1:lbuf+nspace) = '     '
                  lbuf = lbuf + nspace
               ELSE IF ( i1.EQ.0 .OR. i1.EQ.Nrow+1 ) THEN
C Corner of map
                  cbuf(lbuf+1:lbuf+nspace) = '  +  '
                  lbuf = lbuf + nspace
               ELSE
                  cbuf(lbuf+1:lbuf+nspace) = '------'
                  lbuf = lbuf + nspace
               END IF
            ELSE IF ( i1.LT.0 .OR. i1.GT.Nrow+1 .OR.
     &                j1.LT.0 .OR. j1.GT.Ncol+1 ) THEN
               cbuf(lbuf+1:lbuf+nspace) = '     '
               lbuf = lbuf + nspace
            ELSE IF ( Rmap(i1,j1).EQ.NO ) THEN
               CALL CRAMFF(Rmap(i1,j1),nspace,0,cbuf,lbuf)
            ELSE
               CALL CRAMIF(NINT(scale*Rmap(i1,j1)),nspace,cbuf,lbuf)
            END IF
         END DO
         IF ( lbuf.GT.LEN(cbuf) ) THEN
            CALL PTBUF('Bug in tmap.f, increase size of cbuf!',-1)
         END IF
         CALL PTBUF(cbuf,lbuf)
      END DO
C
 999  CONTINUE
      END
