      SUBROUTINE TOTCNT(Rmap, Mxrow, Nrow, Ncol, Cnts,Scals,Cntb,Scalb)
      INTEGER   Mxrow, Nrow, Ncol
      REAL      Rmap(Mxrow, *)
      REAL      Cnts, Scals, Cntb, Scalb
C---
C LEXTRCT routine to return number of counts within and size of input box
C---
C Rmap    I
C Mxrow   I
C Nrow    I
C Ncol    I
C Cnts      O  number of counts in source box
C Scals     O  number of detector pixels in source box
C Cntb      O  number of counts in background box
C Scalb     O  number of detector pixels in background box
C
C Global:
C  Ifac           detector to map compression
C---
C original version  tam
C modified   kaa  11/10/85
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INCLUDE 'posdef.inc'
      INTEGER   INBOU
C
      DOUBLE PRECISION dsumi, dsumo
      REAL      xpos, ypos
      INTEGER   i, itmp, j
      INTEGER   ipixs, ipixb
C
      dsumi = 0.0D0
      ipixs = 0
      dsumo = 0.0D0
      ipixb = 0
C
      DO i = 1, Ncol
         DO j = 1, Nrow
            IF ( Rmap(j,i).NE.NO ) THEN
               CALL POS_MAP_DET(j,i,xpos,ypos)
               itmp = INBOU(xpos,ypos)
               IF ( itmp.LT.0 ) THEN
                  dsumo = dsumo + Rmap(j,i)
                  ipixb = ipixb + 1
               ELSE IF ( itmp.GT.0 ) THEN
                  dsumi = dsumi + Rmap(j,i)
                  ipixs = ipixs + 1
               END IF
            END IF
         END DO
      END DO
C
C Convert from map bins to pixels
C
      Scals = ipixs*Ifac*Ifac
      Scalb = ipixb*Ifac*Ifac
      Cnts = dsumi
      Cntb = dsumo
C
      END
