      SUBROUTINE TPLOT(Rate,Mxrate,Nbins,Days,Dts,Dtb,Qphase,Cvalue,
     &      Cmd,Mxcmd,Ncmd)
      INTEGER   Mxrate, Nbins, Mxcmd, Ncmd
      CHARACTER Cvalue*(*)
      DOUBLE PRECISION Days, Dts, Dtb
      REAL      Rate(Mxrate,7)
      LOGICAL   Qphase
      CHARACTER Cmd(Mxcmd)*(*)
C---
C LEXTRCT routine to produce quick-look graph of timing data.
C---
C Rate(*,1)      counts in source box
C Rate(*,2)      counts in background box
C Rate(*,3)      On source efficiency
C Mxrate         defined size of arrays
C Nbins          number of array bins used
C Days
C Dts
C Dtb
C Qphase         phase or light-curve flag
C Cvalue  I    FITS column name
C Cmd
C Mxcmd   I
C Ncmd    I/O
C---
C 1992-May-01 - New version using PLT [AFT].
C---
      REAL      NO
      PARAMETER (NO=-1.2E-34)
      INTEGER   LENACT
C
      CHARACTER cbuf*64
      REAL      rbin, rstart
      INTEGER   iery(5)
      INTEGER   i, lcmd, idef, ier, lbuf
      LOGICAL   qnew, qplot
C
      CALL PDSEL('LI',qnew,qplot)
      IF ( .NOT.qplot ) RETURN
C
C Set up source/background data
C
      rstart = dts
      rbin = Dtb
      Ncmd = Ncmd + 1
      CALL XAXIS(rstart+rbin/2., rbin, Cmd(Ncmd))
      IF ( Qphase ) THEN
         DO i = 1, nbins
            Rate(i,1) = Rate(i,5)
            Rate(i,2) = SQRT(Rate(i,5))
            Rate(i,3) = Rate(i,6)
            Rate(i,4) = SQRT(Rate(i,6))
         END DO
         Cmd(Ncmd+1) = 'LAB G1 Source (counts)'
         Cmd(Ncmd+2) = 'LAB G2 Background (counts)'
         Ncmd = Ncmd + 2
      ELSE
         IF ( INDEX(cvalue,'TIME').GT.0 ) THEN
            Cmd(Ncmd+1) = 'LAB G1 Source (counts/sec)'
            Cmd(Ncmd+2) = 'LAB G2 Background (counts/sec)'
         ELSE
            Cmd(Ncmd+1) = 'LAB G1 Source (counts)'
            Cmd(Ncmd+2) = 'LAB G2 Background (counts)'
         END IF
         Ncmd = ncmd + 2
         DO i = 1, nbins
            IF ( Rate(i,7).GT.0.0 ) THEN
               Rate(i,1) = Rate(i,5)/(Rate(i,7)*dtb)
               Rate(i,2) = SQRT(MAX(1.0,Rate(i,5)))/(Rate(i,7)*dtb)
               Rate(i,3) = Rate(i,6)/(Rate(i,7)*dtb)
               Rate(i,4) = SQRT(MAX(1.0,Rate(i,6)))/(Rate(i,7)*dtb)
            ELSE
               Rate(i,1) = NO
               Rate(i,2) = NO
               Rate(i,3) = NO
               Rate(i,4) = NO
            END IF
         END DO
      END IF
C
      Cmd(Ncmd+1) = 'LAB G3 Source (counts)'
      Cmd(Ncmd+2) = 'LAB G4 Background (counts)'
      Cmd(Ncmd+3) = 'LAB G5 Efficiency'
      Ncmd = Ncmd + 4
      CALL BOUQD(0, idef)
      IF ( idef.EQ.1 ) THEN
C Outer box defined
         Cmd(Ncmd) = 'COL OFF 3 4 5'
      ELSE
C No outer box
         Cmd(Ncmd) = 'COL OFF 2 3 4 5'
      END IF
C
C Define the iery array.
C
      iery(1) = 1
      iery(2) = 1
      iery(3) = -1
      iery(4) = -1
      iery(5) = 0
      Ncmd = Ncmd + 1
      IF ( Qphase ) THEN
         Cmd(Ncmd) = 'LAB X  Phase'
      ELSE
         Cmd(Ncmd) = 'LAB X '//cvalue
         lcmd = LENACT(Cmd(ncmd))
         CALL UPC(cvalue(1:4))
         IF ( INDEX(cvalue,'TIME').GT.0 ) THEN
            CALL OBSLAB(Days, cbuf, lbuf)
            Cmd(Ncmd)(lcmd+1:) = cbuf(:lbuf)
         END IF
      END IF
      Cmd(Ncmd+1) = 'LIN STEP'
      Cmd(Ncmd+2) = 'GAP ERR'
      Ncmd = Ncmd + 2
      IF ( Nbins.GT.50000 ) THEN
         Cmd(Ncmd+1) = 'ERR OFF'
         Ncmd = Ncmd + 1
      END IF
      CALL PLT(Rate,iery,Mxrate,nbins,5,Cmd,Ncmd,ier)
      RETURN
      END
