      SUBROUTINE WRPHA(Lun,Ievent,Cpre,Lpre,Chtype,Cnt,Mxchan,Nchan,
     &   Bscald,Bscalb,Crsp,Tinteg,I2chan)
      CHARACTER Cpre*(*), Chtype*(*)
      INTEGER   Lun, Ievent, Lpre, Mxchan, Nchan
      REAL      Cnt(Mxchan,2), Bscald, Bscalb
      REAL      Tinteg
      CHARACTER Crsp*(*)
      INTEGER*2 i2chan(*)
C Entry WRPHAH
      CHARACTER cadd*(*)
C---
C LEXTRCT routine to write the spectral distribution into an XSPEC
C PHA file.
C---
C Lun     I    Lun of open FITS file (needed to copy header keywords)
C Ievent  I    >0 if file contains events data.
C Cpre    I    Name of output file
C Lpre    I    Active length of Cpre
C Cnt     I    Counts per channel, source and background.
C Mxchan  I    Maximum size of Cnt array
C Nchan   I    number of valid entries in Cnt
C Bscald  I    Background scale for data
C Bscalb  I    Background scale for background.  Can be zero for no back.
C Crsp    I    Name of response file
C Tinteg  I    Integration time
C I2chan    O
C---
C 1997-Feb-27 - Write XSPEC FITS files [AFT]
C---
      INTEGER   MXCOMM, MXHIST
      PARAMETER (MXCOMM=10, MXHIST=20)
      INTEGER   MXGTI
      PARAMETER (MXGTI=20)
      INTEGER   LENACT
C
      CHARACTER cextra(8)*80
      CHARACTER cafile(4)*72
      CHARACTER ccomm(MXCOMM)*72
      CHARACTER chist(MXHIST)*72
      SAVE      chist
      CHARACTER ctmp*256
      CHARACTER cstday*64, csttim*64, cenday*64, centim*64
      CHARACTER cfilt*64, cinst*64, ctele*64
      CHARACTER csour*20
      REAL      errors(1), sysfrc(1)
      REAL      cscale, decnom, equinx
      REAL      ranom, roll
      REAL      xdetl, ydetl, xdeth, ydeth
      INTEGER   neccd(MXGTI)
      INTEGER   i, idtype, ier, iext, ifill, istat
      INTEGER   lextra, ltmp, nbin, ncomm, nextra
      INTEGER   nhist
      SAVE      nhist
      INTEGER*2 i2grp(1), i2qual(1)
      LOGICAL   qerror, qgroup, qsys, qqual
C---
 100  CONTINUE
C
C Ask user for comment lines
C
      CALL GTBUF('Comments for file :',ier)
      IF ( ier.NE.0 ) THEN
         GOTO 999
      END IF
      CALL GTREST(ctmp, ltmp)
      ncomm = 0
      IF ( ltmp.GT.0 ) THEN
         ncomm = ncomm + 1
         ccomm(ncomm) = ctmp(:ltmp)
      END IF
C
C Put box info into a history record.
C
      chist(1) = 'Created by LEXTRCT'
      CALL BOUSTR(ctmp)
C Put region string into record (could be longer than LEN(chist))
      chist(2) = ctmp
      nhist = nhist + 2
C
C Ask for background file name and put in string cafile(1)
C
 180  CONTINUE
      IF ( bscalb.GT.0.0 ) THEN
         cafile(1) = Cpre(:lpre) // 'b'
         CALL XTEND(cafile(1),'sp')
         ltmp = LENACT(cafile(1))
         CALL GTBUF('Background file name ('//cafile(1)(:ltmp)//'):',
     :      ier)
         IF ( ier.NE.0 ) GOTO 100
         CALL GTCHAR(ctmp,ltmp)
         IF ( ltmp.GT.0 ) cafile(1) = ctmp
      ELSE
         cafile(1) = 'none'
      END IF
C
      nextra = 0
C
      cafile(2) = Crsp
      ltmp = LENACT(cafile(2))
      CALL GTBUF('Response file name ('//cafile(2)(:ltmp)//'):',ier)
      IF ( ier.NE.0 ) GOTO 180
      CALL GTCHAR(ctmp,ltmp)
      IF ( ltmp.GT.0 ) cafile(2) = ctmp
C
C No correction file or ARF files
      cafile(3) = 'none'
      cafile(4) = 'none'
C
      istat = 0
      IF ( Ievent.NE.0 ) THEN
C Go to events extension
         CALL FTMAHD(Lun, ABS(Ievent), iext, istat)
      ELSE
C Just read first header set
         CALL FTMAHD(Lun, 1, iext, istat)
      END IF
      cstday = ' '
      istat = 0
      CALL ftgkys(lun, 'DATE-OBS', cstday, ctmp, istat)
      csttim = ' '
      istat = 0
      CALL ftgkys(lun, 'TIME-OBS', csttim, ctmp, istat)
      cenday = ' '
      istat = 0
      CALL ftgkys(lun, 'DATE-END', cenday, ctmp, istat)
      centim = ' '
      istat = 0
      CALL ftgkys(lun, 'TIME-END', centim, ctmp, istat)
      csour = ' '
      istat = 0
      CALL ftgkys(lun, 'OBJECT', csour, ctmp, istat)
      ctele = ' '
      istat = 0
      CALL ftgkys(lun,'TELESCOP', ctele, ctmp, istat)
      cinst = ' '
      istat = 0
      CALL ftgkys(lun,'INSTRUME', cinst, ctmp, istat)
      CALL RFGCCD(ifill, neccd)
      IF ( ifill.GT.0 ) THEN
         nextra = nextra + 1
         cextra(nextra) = 'DETNAM  = '''//cinst(:LENACT(cinst))//'-'
         lextra = LENACT(cextra(nextra))
         DO i=1,10
            IF ( neccd(i).GT.0 ) THEN
               lextra = lextra+1
               cextra(nextra)(lextra:lextra) = CHAR(ICHAR('0')+i-1)
            END IF
         END DO
         lextra = lextra + 1
         cextra(nextra)(lextra:lextra) = ''''
      END IF

      cfilt = ' '

      ranom = 0.0
      istat = 0
      CALL ftgkye (lun,'RA-NOM', ranom, ctmp, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL ftgkye (lun,'RA_NOM', ranom, ctmp, istat)
      END IF
      decnom = 0.0
      istat = 0
      CALL ftgkye (lun,'DEC-NOM', decnom, ctmp, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL ftgkye (lun,'DEC_NOM', decnom, ctmp, istat)
      END IF
      roll = 0.0
      istat = 0
      CALL ftgkye (lun,'ROLL-NOM', roll, ctmp, istat)
      IF ( istat.NE.0 ) THEN
         istat = 0
         CALL ftgkye (lun,'ROLL_NOM', roll, ctmp, istat)
      END IF
      equinx = 0.0
      istat = 0
      CALL ftgkye (lun,'EQUINOX', equinx, ctmp, istat)
C
      qerror = .FALSE.
      qgroup = .FALSE.
      qsys = .FALSE.
      qqual = .FALSE.
      idtype = 1
      cscale = 0.0
      nbin  = nchan
      DO i=1,nchan
         i2chan(i) = i
      END DO
C
      ctmp = Cpre(:Lpre)
      CALL XTEND(ctmp, 'sp')
      istat = 0
      CALL wrftp(ctmp, chist, nhist, ccomm, ncomm,
     &         cstday, csttim, cenday, centim, csour, ctele,
     &         cinst, cfilt, chtype, equinx, ranom, decnom, roll,
     &         cafile, Tinteg, 1.0, Bscald, cscale, nchan, idtype,
     &         i2chan, cnt(1,1), qerror, errors, qsys, sysfrc,
     &         qqual, i2qual,qgroup, i2grp, nextra, cextra, ier, istat)
      IF ( ier.NE.0 ) WRITE(*,*) 'ier, istat=',ier,istat
      ctmp = cafile(1)
      CALL upc(ctmp)
      IF ( ctmp.NE.'NONE' ) THEN
         ctmp = cafile(1)
         cafile(1) = 'none'
         CALL wrftp(ctmp, chist, nhist, ccomm, ncomm,
     &         cstday, csttim, cenday, centim, csour, ctele,
     &         cinst, cfilt, chtype, equinx, ranom, decnom, roll,
     &         cafile, Tinteg, 1.0, Bscalb, cscale, nchan, idtype,
     &         i2chan, cnt(1,2), qerror, errors, qsys, sysfrc,
     &         qqual, i2qual,qgroup, i2grp, nextra, cextra, ier, istat)
      END IF
C
 999  CONTINUE
      RETURN
C*********
      ENTRY WRPHAN()
      nhist = 0
      RETURN
C*********
      ENTRY WRPHAH(cadd)
      IF ( nhist+3.GT.MXHIST ) THEN
         CALL PTBUF(
     &     'WRPHA--Attempt to write too many history records.',-1)
      ELSE
         nhist = nhist + 1
         chist(nhist+2) = cadd
      END IF
      RETURN
      END
