      SUBROUTINE XGRATE(Lun, Ievent, Qplot, Mxcmd, Ncmd, Cmd)
      INTEGER   Lun, Ievent, Mxcmd, Ncmd
      CHARACTER Cmd(Mxcmd)*(*)
      LOGICAL   Qplot
C---
C LEXTRCT to create an XSPEC PHA file using either the counts in
C a box method, or the grating slice.
C---
C Lun     I
C Ievent  I    >0 if file contains events data.
C Qplot
C Mxcmd
C Ncmd
C Cmd
C---
C 1997-11-25 - Effective rewrite [AFT]
C---
      INCLUDE 'scrat.inc'
C
      CHARACTER crsp*256, ctmp*72
      CHARACTER cpre*32
      REAL      angle, rdum, scalb, scals, tinteg
      REAL      ppc, wids, widib, widob
      REAL      xpos, ypos
      INTEGER   iery(2)
      INTEGER   ians, idef, ier, isav, ispec, itmp
      INTEGER   lpre, mxchan, nchan
      LOGICAL   qfail
      DATA crsp/' '/
C
C Initialize the WRPHA history records
      CALL WRPHAN()
C
C Get location of the zero order image
C
  100 CONTINUE
      CALL ASKPOS(Qplot, qfail)
      IF ( qfail ) GOTO 999
      CALL POSDET(xpos, ypos)
      WRITE(ctmp, 141) xpos, ypos
  141 FORMAT ('Center position (',F8.1,',',F8.1,')')
      CALL WRPHAH(ctmp)
C
C Get angle and width.
      CALL GRNEW
      CALL grdat(angle, wids, widib, widob, ppc)
      WRITE(ctmp, 161) ' ',angle, wids, widib, widob
  161 FORMAT(A,'Angle=',F9.2,', S_width=',F9.1,
     &   ', B_in=',F9.1, ', B_out=',F9.1)
      CALL WRPHAH(ctmp)
C
      idef = +1
      CALL YORN('Do you wish to sum +/- orders',idef,ians)
      IF ( ians.GT.0 ) THEN
         ispec = -2
      ELSE
         ispec = -1
      END IF
C
C XGrate uses its own bounds, so don't use lextrct bounds.
      CALL LIMQB(isav)
      CALL LIMSB(0)
      mxchan = MXSR*MXSC/4
      CALL RFDATA(Lun, Ievent, tinteg,
     &   .FALSE., Rscrat, itmp, itmp, itmp, itmp,
     &   ispec,rscrat,mxchan,nchan, .FALSE.,rdum,1,itmp)
      CALL LIMSB(isav)
C
      scals = wids
      scalb = widob-widib
C
      IF ( Qplot ) THEN
C Plot the resulting spectrum.
         iery(1) = 0
         iery(2) = 0
         Ncmd = Ncmd +1
         CALL XAXIS(1.0, 1.0, Cmd(Ncmd))
         Cmd(Ncmd+1) = 'LAB X Position (dpixel)'
         Cmd(Ncmd+2) = 'LAB Y Number of counts'
         Cmd(Ncmd+3) = 'LIN STEP'
         Cmd(Ncmd+4) = 'LOG Y'
         Ncmd = Ncmd + 4
         IF ( scalb.LE.0.0 ) THEN
            Cmd(Ncmd+1) = 'COL OF 2'
            Ncmd = Ncmd + 1
         END IF
         Ncmd = Ncmd + 1
         Cmd(Ncmd) = 'LAB OT Grating Spectrum'
         Ncmd = Ncmd + 1
         WRITE(Cmd(Ncmd), 161) 'LAB T ',angle, wids, widib, widob
         CALL PLT(rscrat,iery,mxchan,nchan,2,Cmd,Ncmd,ier)
      END IF
C
C Ask for PHA filename, open file and write header record
C
      CALL GTBUF('Prefix for PHA file name:',ier)
      IF ( ier.NE.0 ) GOTO 999
      CALL GTCHAR(cpre, lpre)
      IF ( lpre.EQ.0 ) GOTO 999
C
      CALL WRPHA(Lun,Ievent,cpre,lpre,'PHA',rscrat,mxchan,nchan,
     &   scals,scalb,crsp,tinteg,rscrat(1+2*mxchan))
C
 999  CONTINUE
C
      END
