      SUBROUTINE XHISTO(Lun,Ievent,Cmd,Mxcmd,Ncmd)
      INTEGER   Lun, Ievent, Mxcmd, Ncmd
      CHARACTER Cmd(Mxcmd)*(*)
C---
C LEXTRCT routine to plot out the spectral distribution of counts
C within the defined box.
C---
C Lun     I    Lun of open FITS file (needed to copy header keywords)
C Ievent  I    Location of events extension (if any)
C Cmd
C Mxcmd
C Ncmd
C---
C original version  tam
C 15/10/85 - modified   kaa
C 1997-Feb-21 - [AFT]
C---
      INTEGER  LENACT
      INCLUDE 'mapdef.inc'
      INCLUDE 'scrat.inc'
C
      CHARACTER crsp*72, ctmp*72
      CHARACTER cvalue*64
      CHARACTER ckey*16
      CHARACTER cpre*32, chtype*32
      REAL      rdum, tot
C Needs work
      REAL      scalb, scals, tinteg
      INTEGER   iery(2)
      INTEGER   i, ibcol, ier, iocol, istat
      INTEGER   iscol, iscomp, ishi, islim, islo, ismax, ismin, itmp
      INTEGER   lpre, ltmp, nchan
      INTEGER   mxchan
C---
      CALL LIMQS(islim, islo, ishi, iscomp)
C Read entire spectrum but preserve compression.
      CALL LIMSS(0,0,0,iscomp)
      CALL RFCQSR(ismin, ismax)
      mxchan = (ismax - ismin)/iscomp + 1
      mxchan = MIN(mxchan,mxsc*mxsc/5)
      CALL RFDATA(Lun, Ievent, tinteg,
     &   .FALSE.,Rmap,Mxrow,Mxcol,Nrow,Ncol,
     &   +1,Rscrat,mxchan,nchan, .FALSE., rdum, 1, itmp)
C
      tot = 0.0
      DO i = 1, nchan
         tot = tot + Rscrat(i)
      END DO
C
      CALL RFCQSC(iscol, ibcol, iocol)
      istat = 0
      CALL FTKEYN('TTYPE',iscol,ckey,istat)
      cvalue = ' '
      CALL FTGKYS(Lun,ckey,cvalue,ctmp,istat)
C
C Plot spectral distribution
C
      IERY(1) = 0
      IERY(2) = 0
      CALL XAXIS(FLOAT(ismin), 1.0, Cmd(Ncmd+1))
      Cmd(Ncmd+2) = 'ERR Y S 1 2'
      IF (iscomp.EQ.1 ) THEN
         Cmd(Ncmd+3) = 'LAB  X '//cvalue
      ELSE
         WRITE(Cmd(Ncmd+3),161) cvalue(:LENACT(cvalue)),iscomp
  161    FORMAT('LAB  X ',A,'/',I5)
      END IF
      Ncmd = Ncmd + 3
      IF ( ibcol.GT.0 ) THEN
         istat = 0
         CALL FTKEYN('TTYPE',ibcol,ckey,istat)
         CALL FTGKYS(Lun,ckey,cvalue,ctmp,istat)
         ltmp = LENACT(Cmd(Ncmd))
         Cmd(Ncmd)(ltmp+1:) = '-'//cvalue
         IF ( iocol.GT.0 ) THEN
            istat = 0
            CALL FTKEYN('TTYPE',iocol,ckey,istat)
            CALL FTGKYS(Lun,ckey,cvalue,ctmp,istat)
            ltmp = LENACT(Cmd(Ncmd))
            Cmd(Ncmd)(ltmp+1:) = '-'//cvalue
         END IF
      END IF
      Cmd(Ncmd+1) = 'LAB  Y Number of counts'
      Cmd(Ncmd+2) = 'LAB  T Spectral Distribution'
      Cmd(Ncmd+3) = 'LINE STEP'
      Ncmd = Ncmd + 3
      CALL GIFLBL(CTMP)
      Cmd(Ncmd+1) = 'LAB  F '//CTMP
      Ncmd = Ncmd + 1
      CALL PLT(Rscrat,IERY,mxchan,nchan,2,Cmd,Ncmd,ier)
C
      CALL GTBUF('Prefix for PHA file name:',ier)
      IF ( ier.LT.0 ) GOTO 999
      CALL GTCHAR(cpre,lpre)
      IF ( lpre.GT.0 ) THEN
         crsp= 'none'
         CALL RGAREA(Rmap, Mxrow, Nrow, Ncol, scals,scalb)
C Get the name of the spectral column for the spectral file.
         CALL RFCQSC(iscol, ibcol, iocol)
         istat = 0
         CALL FTKEYN('TTYPE',iscol,ckey,istat)
         CALL FTGKYS(Lun,ckey,chtype,ctmp,istat)
         CALL UPC(chtype)
         CALL WRPHAN()
         CALL WRPHA(Lun,Ievent,cpre,lpre,chtype,Rscrat,mxchan,nchan,
     &      scals,scalb,crsp,tinteg,Rscrat(1+mxchan*4))
      END IF
C
 999  CONTINUE
C Restore original spectral limits.
      CALL LIMSS(islim, islo, ishi, iscomp)
      END
