      SUBROUTINE XTMR(Lun,Ievent,Cmd,Mxcmd,Ncmd)
      INTEGER   Lun, Ievent, Mxcmd, Ncmd
      CHARACTER Cmd(Mxcmd)*(*)
C---
C LEXTRCT timing routine. reads in a sort file, corrects for dead time and
C creates a light curve or phase plot and optionally a timing file.
C---
C Lun     I
C Ievent  I
C Cmd
C Mxcmd
C Ncmd
C---
C 1992-May-21 - rewrite [AFT]
C---
      INTEGER   MXHIS, MXVEC
      PARAMETER (MXHIS=4, MXVEC=4)
C
      INCLUDE 'mapdef.inc'
      INCLUDE 'scrat.inc'
      INCLUDE 'time.inc'
C
      CHARACTER chis(MXHIS)*80
      CHARACTER cunit(MXVEC)*16, cname(MXVEC)*16
      CHARACTER cprom*72, ctmp*72
      CHARACTER cvalue*64
      CHARACTER ckey*16
C
      DOUBLE PRECISION dper, dpdot
      SAVE             dper, dpdot
      REAL      bscal(MXVEC)
      REAL      rdum, trate
C
      INTEGER   ier, iext, iicol, ioff, istat, itmp, jer, ker
      INTEGER   itcol
      INTEGER   luntmr, mxrate, nbins, nfield
C
      INTEGER   i4tim
      INTEGER*2 i2tim(2)
      EQUIVALENCE (i2tim(1),i4tim)
      DATA dpdot, dtim0/0.0D0,0.0D0/
C---
C We use 7 columns for each data point
C 1,2  source rate and error
C 3,4  background rate and error
C 5    source counts
C 6    background counts
C 7    efficiency
C
      mxrate = MXSR*MXSC/7
C This is the 1D offset into the scrat array that corresponds to the
C start of the 5 column.
      ioff = 1 + 4*mxrate
C
C Ask for no. of phase bins for plot - if 1 is asked for a light curve is
C calculated
C
      nbins = 1
 120  CONTINUE
      CALL PTBUF('To create pulse phase spectra, input:',-1)
      WRITE (cprom,121) nbins, dper, dtim0, dpdot
 121  FORMAT ('NPHASE(',I5,'), DPER(',F9.4,'), DTIM0(',F10.1,
     &        '), DPDOT(',1PE10.3,')? ')
      CALL GTBUF(cprom,jer)
      IF ( jer.NE.0 ) GOTO 999
      CALL GTINT(nbins,ker)
      CALL GTDBLE(dper,ker)
      CALL GTDBLE(dtim0,ker)
      CALL GTDBLE(dpdot,ker)
      IF ( nbins.GT.1 ) THEN
         IF ( nbins.GT.mxrate ) THEN
            WRITE(*,*) 'Maximum number of phase bins is ',mxrate
            nbins = mxrate
            GOTO 120
         END IF
         IF ( dper.LE.0.0 ) THEN
            CALL PTBUF('Must define a period.',-1)
            GOTO 120
         END IF
         dnu = 1.D0/dper
         dnudot = -dnu*dnu*dpdot
         qphase = .TRUE.
      ELSE
         qphase = .FALSE.
      END IF
C
C Make sure we're looking in the correct extension and locate the name
C of the TIME column.
      CALL FTMAHD(Lun, Ievent, iext, istat)
      CALL RFCQTC(itcol, iicol, itmp, itmp)
      istat = 0
      CALL FTKEYN('TTYPE',itcol,ckey,istat)
      CALL FTGKYS(Lun,ckey,cvalue,ctmp,istat)
      CALL UPC(cvalue)
C---
C Read the timedel keyword into DTB, otherwise default to 10. sec bins.
      dtp = 1.0D0
      dtb = 1.0D0
      istat = 0
      IF ( INDEX(cvalue,'TIME').GT.0 ) THEN
         dtb = 10.0D0
         istat = 0
         CALL ftgkyd(Lun,'TIMEDEL', dtp, ctmp, istat)
         IF ( istat.EQ.0 ) dtb = dtp
      END IF
C---
C If light curve is required then ask for temporal binsize
C
 170  CONTINUE
      IF ( .NOT.qphase ) THEN
         WRITE (cprom,171) dtb, dtp
 171     FORMAT ('DTB(',F12.6,'), DTP(',F12.6,'):')
         CALL GTBUF(cprom,jer)
         IF ( jer.NE.0 ) GOTO 120
         CALL GTDBLE(dtb, ker)
         CALL GTDBLE(dtp, ker)
         IF ( dtb.LE.0.0D0 .OR. dtp.LT.0.0 ) THEN
            CALL PTBUF('DTB must be a positive number.',-1)
            GOTO 170
         END IF
      END IF
C
C Read the FITS event data.
      CALL RFDATA(Lun, Ievent, trate,
     &   .FALSE.,Rmap,Mxrow,Mxcol,Nrow,Ncol,
     &   0,rdum,1,itmp,  .TRUE., Rscrat(ioff), mxrate, nbins)
C
C Draw the resulting plots.
C
      IF ( qphase ) THEN
         dts = 0.0D0
         dtb = 1.D0/nbins
      END IF
      CALL TPLOT(Rscrat,mxrate,nbins,Days,Dts,dtb,qphase,cvalue,
     &      Cmd,Mxcmd,Ncmd)
C
C Write optional TMR file.
      bscal(3) = 1.0
      nfield = 3
      cname(1) = 'SRATE'
      cunit(1) = 'counts'
      cname(2) = 'BRATE'
      cunit(2) = 'counts'
      cname(3) = 'EFFIC'
      cunit(3) = ' '
      CALL GETLUN(luntmr)
      CALL TMRNEW(luntmr, chis, 0, ier)
      IF ( ier.EQ.0 ) THEN
         CALL RGAREA(Rmap, Mxrow, Nrow, Ncol, bscal(1), bscal(2))
         CALL TMRWR(luntmr, 1, Rscrat(ioff), mxrate, nbins, nfield,
     &       cname, cunit, bscal, Days, Dts, dtb, ier)
      END IF
      CALL FRELUN(luntmr)
C
 999  CONTINUE
C
      END
