      SUBROUTINE z2test(Lun, Ievent, Qplot, Mxcmd, Ncmd, Cmd)
      INTEGER   Lun, Ievent, Mxcmd, Ncmd
      CHARACTER Cmd(Mxcmd)*(*)
      LOGICAL   Qplot
C---
C z^2 test.
C---
C 2005-Apr-28 - [AFT]
C---
      INTEGER   MX1, MXMEG
      PARAMETER (MX1=10000, MXMEG=2000000)
      INTEGER   MXNAX
      PARAMETER (MXNAX=99)
      INCLUDE 'scrat.inc'
      INCLUDE 'time.inc'
C
      CHARACTER cprom*80
      CHARACTER ctmp*72
      DOUBLE PRECISION dtimes(MX1)
      DOUBLE PRECISION dcsum, dfreq, dnul, dssum
      DOUBLE PRECISION dte, dtmp, dur, twopi
      REAL      pow(MXMEG,2)
      EQUIVALENCE (Rscrat, pow)
      REAL      fpeak, feqmin, feqdel, gstar
      REAL      perc, pmax, pmin, ppeak, prob, rnorm, tmp
      INTEGER   iery(2)
      INTEGER   i, ier, iext, iflg, iflgst
      INTEGER   iicol, istat, itcol, itmp
      INTEGER   j, k, nharm, nhis, nomeg, npts
      LOGICAL   qbad
C
      DATA twopi/6.28318530717959/
C---
      perc = 0.0754
      nomeg = 1001
      istat = 0
      CALL RFCQTC(itcol, iicol, itmp, itmp)
      CALL GTIBEG(Lun, Ievent, Itcol, dts)
      CALL GTIEND(Lun, dte)
      npts = 10
C
C Directly read FITS file
      CALL FTMAHD(Lun, Ievent, iext, istat)
      CALL FTGKYJ(Lun, 'NAXIS2', npts, ctmp, istat)
      dnul = -1.2e-34
      DO i=1,npts
         CALL FTGCVD(Lun,itcol,i,1,1,dnul,dtimes(i),qbad,istat)
         dtimes(i) = dtimes(i) - dts
      END DO
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'FITIO error=',istat
      END IF
      dur = dte-dts
      write(*,*) 'Duration=',dur,dts,dte
      nharm = 2
      Feqdel = 1./(dur*nharm*3)
C---
C
  200 CONTINUE
      tmp = perc
      WRITE(cprom,201) perc, nomeg
  201 FORMAT ('Central period(',F12.6,'), NOMEG(',I10,')?')
      CALL GTBUF(cprom,ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTREAL(tmp,ier)
      IF ( perc.LE.0. ) GOTO 200
      CALL GTINT(nomeg,ier)
      nomeg = MIN(nomeg,MXMEG)
      IF ( tmp.LT.0.0 ) THEN
         Feqmin = -tmp
      ELSE IF ( tmp.EQ.0.0 ) THEN
         Feqmin = Feqdel
      ELSE
         Feqmin = MAX(Feqdel,1./tmp - nomeg*Feqdel/2.0)
      END IF
C
      rnorm = 2./npts
      WRITE(cprom,221) Feqmin,Feqmin+Feqdel*(nomeg-1.),FeqDel
  221 FORMAT('Searching from',F9.3,' to',F9.3,' in steps of',
     &         1PG10.3,' Hz.')
      CALL ptbuf(cprom, -1)
      fpeak = 0.0
      ppeak = 0.0
      DO i=1, nomeg
         dfreq = Feqmin+(i-1)*Feqdel
         pow(i,1) = dfreq
         pow(i,2) = 0.0
         DO j=1,nharm
            dtmp = twopi*j*dfreq
            dcsum = 0.0d0
            dssum = 0.0d0
            DO k=1,npts
               dcsum = dcsum + COS(dtmp*dtimes(k))
               dssum = dssum + SIN(dtmp*dtimes(k))
            END DO
            pow(i,2) = pow(i,2)+rnorm*(dcsum**2+dssum**2)
         END DO
         IF ( pow(i,2).GT.ppeak ) THEN
            fpeak = dfreq
            ppeak = pow(i,2)
         END IF
      END DO
      tmp = nharm
      CALL GAM(tmp, ppeak/2., 6.0, prob, gstar, iflg, iflgst)
      WRITE(cprom,281) npts,fpeak,ppeak,Prob
  281 FORMAT('npts=',I6,', Freq=',F12.6,
     &   ', Power=',F9.2,', Prob=',1PG10.2)
      CALL ptbuf(cprom, -1)
C---
      DO i=1,2
         iery(i) = 0
      END DO
      cmd(ncmd+1) = 'LAB X Freq (Hz)'
      cmd(ncmd+2) = 'LAB Y PDS'
      cmd(ncmd+3) = 'LIN STEP'
      cmd(ncmd+4) = 'SCR W'
      CALL XAXIS(Feqmin, Feqdel, Cmd(Ncmd+5))
      ncmd = ncmd + 5
      CALL PLT(pow,iery,MXMEG,nomeg,2,cmd,ncmd,ier)
C
      pmin = 0.0
      pmax = 50.
      nhis = 501
 820  WRITE (ctmp,821) pmin, pmax, nhis
 821  FORMAT ('PMIN(',1PG10.3,'), PMAX(',G10.3,'), NHIS(',I5,')?')
      CALL GTBUF(ctmp,ier)
      IF ( ier.LT.0 ) GOTO 200
      CALL GTREAL(pmin,ier)
      CALL GTREAL(pmax,ier)
      CALL GTINT(nhis,ier)
      IF ( pmin.EQ.pmax .OR. nhis.EQ.0 ) GOTO 820
      cmd(2) = 'LAB X Power'
      cmd(3) = 'MOD $chidist'
      cmd(4) = '4 -1'
      cmd(5) = ' '
      itmp = 0
      CALL CRAMI(nomeg, cmd(5), itmp)
      cmd(5)(itmp+1:)=' -1'
C Fake out the FIT ON command
      cmd(6) = 'XAX L 1 1'
      cmd(7) = 'FIT ON 1'
      cmd(8) = 'SCR W'
      ncmd = 8
      CALL PHISTO(pow(1,2),iery(2),MXMEG,nomeg,pmin,pmax,nhis,
     &         mxcmd,cmd,ncmd)
C---
 900  CONTINUE
      RETURN
      END
