C Program used to convert the plt.hlp file into a plt.tex file.
C Not everything is converted, so user must make a final pass
C by hand.
C---
      INTEGER   LENACT
C
      CHARACTER cbuf*132, csav*132
      CHARACTER ctmp*132
      CHARACTER cfile*64, ctopic*64, csub*64
      INTEGER   ier, ifirst, isave, iverb
      INTEGER   lbuf, lfile, lsav, lsub, ltopic
C---
   11 FORMAT(A)
C---
  100 CALL GTBUF('Input file:', ier)
      IF(ier.LT.0) GOTO 900
      CALL GTCHAR(cfile, lfile)
      CALL XTEND(cfile, 'HLP')
      CALL OPENWR(1,cfile,'OLD',' ',' ',0,1,ier)
      IF(ier.NE.0) GOTO 100
      CALL XTEND(cfile, '.TEX')
      CALL OPENWR(2,cfile,'NEW',' ','L',0,0,ier)
      WRITE(2,11) '\documentstyle[11pt]{book}'
      WRITE(2,11) '\oddsidemargin=0.75in'
      WRITE(2,11) '\evensidemargin=0.00in'
      WRITE(2,11) '\textwidth=5.75in'
      WRITE(2,11) '\topmargin=-0.25in'
      WRITE(2,11) '\textheight=9.00in'
      WRITE(2,11) '\topsep=2pt'
      WRITE(2,11)
      WRITE(2,11) '\begin{document}'
C---
      isave=0
      iverb=0
      ifirst=0
      ltopic=0
  200 CONTINUE
      READ(1,11,ERR=900,END=900) cbuf
      lbuf=LENACT(cbuf)
C
      IF(isave.NE.0) THEN
C Check to see how to process the saved string.
         IF(cbuf(1:3).EQ.'   ') THEN
C Must be a option of the current command
            IF(ifirst.EQ.0) WRITE(2,11) '\medskip'
            WRITE(2,11) '\begin{verbatim}'
            iverb=1
            WRITE(2,11) csav(:lsav)
            CALL ENDVER(iverb)
         ELSE
C Potential heading just happened to be the topic name embedded in the
C text.
            IF(iverb.EQ.0) CALL FIXER(csav, lsav, ctmp)
            WRITE(2,11) csav(:lsav)
         END IF
         isave=0
         ifirst=0
      END IF
C
      IF(cbuf(1:2).EQ.'1 ') THEN
C Top level starts a new chapter and remember the topic name.
         ctopic=cbuf(3:lbuf)
         ltopic=lbuf-2
         CALL ENDVER(iverb)
         CALL FIXER(cbuf, lbuf, ctmp)
         WRITE(2,11) '\chapter{'//cbuf(3:lbuf)//'}'
      ELSE IF(cbuf(2:6).EQ.' exam') THEN
C An example subtopic, go to verbatim mode, this is because PLT examples
C are mostly verbatim examples.
         WRITE(2,*)
         WRITE(2,11) '\medskip\noindent'
         IF(INDEX(cbuf(1:lbuf),'s').NE.0) THEN
            WRITE(2,11) '{\em Examples:}'
         ELSE
            WRITE(2,11) '{\em Example:}'
         END IF
      ELSE IF(cbuf(1:2).EQ.'2 ') THEN
         CALL ENDVER(iverb)
         WRITE(2,*)
         CALL FIXER(cbuf, lbuf, ctmp)
         WRITE(2,11) '\section*{'//cbuf(3:lbuf)//'}'
         ifirst=1
      ELSE IF(cbuf(1:2).EQ.'3 ') THEN
C New sub-topic
         csub=cbuf(3:lbuf)
         lsub=lbuf-2
         CALL ENDVER(iverb)
         WRITE(2,11) '\medskip\begin{verbatim}'
         WRITE(2,11) ctopic(:ltopic)//' '//cbuf(3:lbuf)
         WRITE(2,11) '\end{verbatim}'
      ELSE IF(cbuf(1:2).EQ.'4 ') THEN
C New section
         CALL ENDVER(iverb)
         WRITE(2,11) '\medskip\begin{verbatim}'
         WRITE(2,11) ctopic(:ltopic)//' '//csub(:lsub)//
     :         ' '//cbuf(3:lbuf)
         WRITE(2,11) '\end{verbatim}'
      ELSE
         IF(cbuf(:ltopic).EQ.ctopic(:ltopic)) THEN
C Potential new heading.  Most PLT commands are followed by a single
C line showing the syntax of the command.  A syntax line begins with the
C topic name and is followed by a blank line (not 100 percent but good
C enough).  Therefore set flag, to examine the next line.
            csav=cbuf(:lbuf)
            lsav=lbuf
            isave=1
         ELSE
            IF ( cbuf(1:5).EQ.'<PRE>' ) THEN
               CALL ENDVER(iverb)
               WRITE(2,11) '\begin{verbatim}'
               iverb=1
            ELSE IF ( cbuf(1:6).EQ.'</PRE>' ) THEN
               CALL ENDVER(iverb)
            ELSE
C Straight copy of the text, converting to LaTeX syntax where possible.
               IF(iverb.EQ.0) CALL FIXER(cbuf, lbuf, ctmp)
               WRITE(2,11) cbuf(:lbuf)
            END IF
         END IF
      END IF
      GOTO 200
C---
900   CONTINUE
      CALL ENDVER(iverb)
      WRITE(2,11) '\end{document}'
      CLOSE(UNIT=2)
      CALL EDICOM('off',3)
      END
C*********
      SUBROUTINE ENDVER(iverb)
      INTEGER   iverb
C---
   11 FORMAT(A)
C---
      IF(iverb.NE.0) THEN
         WRITE(2,11) '\end{verbatim}'
         iverb=0
      END IF
      RETURN
      END
C*********
      SUBROUTINE FIXER(Cbuf, Lbuf, Ctmp)
      CHARACTER Cbuf*(*), Ctmp*(*)
      INTEGER   Lbuf
C---
C Searches for common strings in the .HLP file and replaces them with
C things that work in LaTeX.
C---
C Iverb    I/O  verbatim mode
C Ctmp     I/O  scratch array
C----
      INTEGER   MXCH
      PARAMETER (MXCH=13)
      INTEGER   LENACT
C
      CHARACTER cold(MXCH)*6, cnew(MXCH)*20, crep*20
      INTEGER   lold(MXCH)
      INTEGER   iquote, ip, j, lo, lrep, ltmp
      DATA lold/  1,    1,    1,    1,      5,           5,
     :               4,     2,     2,     3,     1,    1,     2/
      DATA cold/  '#', '_',  '^',  '$', 'Delta',     'chi^2',
     :          'i.e.',  'x-',  'y-',  'x,y',  '<',  '>',   '>='/
      DATA cnew/ '\#', '\_', '\^', '\$', '$\Delta$', '$\chi^2$',
     :    '{\it i.e.}','$x$-','$y$-','$x,y$','$<$','$>$','$\geq$'/
C---
      ltmp=0
      iquote=0
      ip=0
  110 CONTINUE
         ip=ip+1
         crep=Cbuf(ip:ip)
         lrep=1
         IF(Cbuf(ip:ip).EQ.'"') THEN
            IF(iquote.EQ.0) THEN
               iquote=1
               crep='{\tt '
               lrep=5
            ELSE
               iquote=0
               crep='}'
               lrep=1
            END IF
         ELSE
            IF(iquote.EQ.0) THEN
C Don't alter text inside a \verb@...@ string
               DO 160 j=1,MXCH
                  lo=lold(j)
                  IF(Cbuf(ip:ip+lo-1).EQ.cold(j)(1:lo)) THEN
                     crep=cnew(j)
                     lrep=LENACT(crep)
                     ip=ip+lo-1
                  END IF
  160          CONTINUE
            ELSE
C Change ' ' to '~' inside a \verb@...@ string
               IF(Cbuf(ip:ip).EQ.' ') THEN
                  crep='~'
                  lrep=1
               ELSE IF(Cbuf(ip:ip).EQ.'#') THEN
                  crep='\#'
                  lrep=2
               ELSE IF(Cbuf(ip:ip).EQ.'$') THEN
                  crep='\$'
                  lrep=2
               END IF
            END IF
         END IF
         Ctmp(ltmp+1:ltmp+lrep)=crep(:lrep)
         ltmp=ltmp+lrep
      IF(ip.LT.Lbuf) GOTO 110
      Cbuf=Ctmp
      Lbuf=ltmp
      RETURN
      END
