# XANADU users stuff (for csh/tcsh users)
# You must define XANTOP and EXT before calling this routine.

# If user has defined XANADU but not XANTOP then apply fix.
if ( -z "$XANTOP" ) then
   setenv XANTOP $XANADU
endif

# If there is a local initu file, then source it.
if ( -f $XANTOP/local/tools/initu.csh ) then
    source $XANTOP/local/tools/initu.csh
endif

# Define the location of the XANADU system dependent tree.
if ( -z "$XANSYS" ) then
   setenv XANSYS $XANTOP/$EXT
endif

# Define the location of the HTML reader to read XANADU help.
if ( -z "$XANHTML" ) then
   if ( -n "$OPERA_DIR" ) then
      setenv XANHTML opera
   else
      setenv XANHTML firefox
   endif
endif

# If PGPLOT_DIR has not been defined, then define it.
if ( -z "$PGPLOT_DIR" ) then
   setenv PGPLOT_DIR $XANSYS/lib
endif

# If PGPLOT_FONT has not been defined, then define it.
if ( -z "$PGPLOT_FONT" ) then
   setenv PGPLOT_FONT $PGPLOT_DIR/grfont.dat
endif

# If $XANSYS/bin is not already in $PATH then add it.
if ( "`echo $PATH | grep $XANSYS/bin`" == "" ) then
   setenv PATH $XANSYS/bin:$PATH
endif
