# XANADU users stuff (for sh/bash/ksh users)
# You must define XANTOP and EXT before calling this routine.

# If user has defined XANADU but not XANTOP then apply fix.
if test -z "$XANTOP" ; then
   XANTOP=$XANADU
   export XANTOP
fi

# If there is a local initu file, then . it.
if test -f $XANTOP/local/tools/initu.sh ; then
    . $XANTOP/local/tools/initu.sh
fi

# Define the location of the XANADU system dependent tree.
if test -z "$XANSYS" ; then
   XANSYS=$XANTOP/$EXT
   export XANSYS
fi

# Define the location of the HTML reader to read XANADU help.
if test -z "$XANHTML" ; then
   if test -n "$OPERA_DIR" ; then
      XANHTML=opera
   else
      XANHTML=firefox
   fi
   export XANHTML
fi

# If PGPLOT_DIR has not been defined, then define it.
if test -z "$PGPLOT_DIR" ; then
   PGPLOT_DIR=$XANSYS/lib
   export PGPLOT_DIR
fi

# If PGPLOT_FONT has not been defined, then define it.
if test -z "$PGPLOT_FONT" ; then
   PGPLOT_FONT=$PGPLOT_DIR/grfont.dat
   export PGPLOT_FONT
fi

# If $XANSYS/bin is not already in $PATH then add it.
if test "`echo $PATH | grep $XANSYS/bin`" = "" ; then
   PATH=$XANSYS/bin:$PATH
   export PATH
fi
