      SUBROUTINE fdtmjd(cday, dmjd)
      CHARACTER cday*(*)
      DOUBLE PRECISION dmjd
C---
C Converts a FITS date string into MJD.  Currently supports following
C formats:
C yyyy-mm-dd
C yyyy-mm-ddThh:mm:ss
C yyyy-mmm-dd (where mm is a month string, e.g., JAN, MAY)
C dd/mm/yy
C dd/mmm/yy
C dd/mmm/yyyy
C---
C cday    I    Date string read from FITS file
C dmjd      O  MJD
C---
C 1997-10-17 - Allow string names for months [AFT]
C 1996-12-12 - [AFT]
C---
      REAL      FPNUM
      INTEGER   ISNUM, LENACT
C
      CHARACTER cmon(12)*3
      CHARACTER ctmp*40
      INTEGER   i, icnt, iday, ier, imon, iyear, j, lday, ltmp
      DATA      cmon/'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN',
     &               'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'/
C---
      lday = LENACT(cday)
      ltmp = 0
      icnt = 0
      IF ( INDEX(cday,'/').NE.0 ) THEN
         DO i=1,lday
            IF ( cday(i:i).EQ.'/' ) THEN
               IF ( icnt.EQ.0 ) THEN
                  iday = FPNUM(ctmp, ltmp, ier)
               ELSE
C If month is a number then read it
                  IF ( ISNUM(ctmp,ltmp).NE.0 ) THEN
                     imon = FPNUM(ctmp, ltmp, ier)
                  ELSE
C else convert string to a month number
                     CALL UPC(ctmp(:ltmp))
                     DO j=1,12
                        IF ( ctmp(1:3).EQ.cmon(j) ) THEN
                           imon = j
                        END IF
                     END DO
                  END IF
               END IF
               icnt = icnt + 1
               ltmp = 0
            ELSE
               ltmp = ltmp + 1
               ctmp(ltmp:ltmp) = cday(i:i)
            END IF
         END DO
         iyear = FPNUM(ctmp, ltmp, ier)
         IF ( iyear.LE.99 ) iyear = 1900 + iyear
      ELSE IF ( INDEX(cday,'-').NE.0 ) THEN
         DO i=1,lday
            IF ( cday(i:i).EQ.'-' ) THEN
               IF ( icnt.EQ.0 ) THEN
                  iyear = FPNUM(ctmp, ltmp, ier)
               ELSE
C If month is a number then read it
                  IF ( ISNUM(ctmp,ltmp).NE.0 ) THEN
                     imon = FPNUM(ctmp, ltmp, ier)
                  ELSE
C else convert string to a month number
                     CALL UPC(ctmp(:ltmp))
                     DO j=1,12
                        IF ( ctmp(1:3).EQ.cmon(j) ) THEN
                           imon = j
                        END IF
                     END DO
                  END IF
               END IF
               icnt = icnt + 1
               ltmp = 0
            ELSE
               ltmp = ltmp + 1
               ctmp(ltmp:ltmp) = cday(i:i)
            END IF
         END DO
         iday = FPNUM(ctmp, ltmp, ier)
      END IF

      IF ( icnt.LE.0 ) THEN
         dmjd = -1.0D0
      ELSE
         CALL sla_CLDJ(iyear, imon, iday, dmjd, ier)
         IF ( ier.NE.0 .AND. ier.NE.3 ) dmjd = -1.0D0
      END IF

      END
