      SUBROUTINE PHISTO(Ydat, Lery, Mx1, Npts, Ymin, Ymax, Nhis,
     &         mxcmd, cmd, Ncmd)
      INTEGER   Lery, Mx1, Npts, Nhis, Mxcmd, Ncmd
      REAL      Ydat(Mx1), Ymin, Ymax
      CHARACTER cmd(Mxcmd)*(*)
C---
C Construct an Nhis bin histogram.
C If Nhis is <0 then the histogram is constructed for
C difference values.
C---
C Ydat    I     The array to be histogramed.
C Lery    I
C Mx1     I     Maximum size of Ydat
C Npts    I     Actual size of Ydat
C Ymin      O   Minimum value
C Ymax      O   Maximun value.
C Nhis    I     Number of bins in histogram.
C Mxcmd   I     Maximum size of CMD
C cmd     I/O   PLT command list
C Ncmd    I/O   Number of valid entries in CMD
C---
      INTEGER   MXHIS
      PARAMETER (MXHIS=1000)
      REAL      WEIGHT
C
      REAL      HIS(MXHIS,2)
      REAL      DT, W, WL
      INTEGER   i, ibin, ier, is, nbin
C---
      is=1
      IF(Nhis.LT.0) is=2
      nbin=MIN(MXHIS,ABS(Nhis))
      DO i=1,nbin
         HIS(i,1)=0.
      END DO
      DT=(Ymax-Ymin)/(nbin-1)
      DO 190 i=is,Npts
         W=WEIGHT(Ydat(i),Mx1,Lery)
         IF(W.LE.0.) GOTO 190
         IF(is.EQ.1) THEN
C Histogram values
            ibin=INT(1.+(Ydat(i)-Ymin)/DT)
         ELSE
C Histogram differences
            WL=WEIGHT(Ydat(i-1),Mx1,Lery)
            IF(WL.LE.0.) GOTO 190
            ibin=NINT(1.+(Ydat(i)-Ydat(i-1)-Ymin)/DT)
         END IF
         ibin = MIN(MAX(1,ibin),nbin)
         HIS(ibin,1)=HIS(ibin,1)+1
  190 CONTINUE
      DO I=1,nbin
         HIS(I,2)=SQRT(MAX(1.,HIS(I,1)))/DT
         HIS(I,1)=HIS(I,1)/DT
      END DO
      Ncmd = Ncmd + 1
      CALL XAXIS(Ymin+dt/2.,DT,cmd(Ncmd))
      cmd(Ncmd+1)='LAB Y Number'
      cmd(Ncmd+2)='ERROR OFF'
      cmd(Ncmd+3)='LIN STEP'
      cmd(Ncmd+4)='LOG Y'
      cmd(Ncmd+5)='COL 2 on 1'
      cmd(Ncmd+6)='R'
      Ncmd = Ncmd+6
      IF ( Ncmd.GT.Mxcmd ) THEN
         WRITE(*,*) 'PHISTO--Mxcmd=',Mxcmd,
     &         ' is too small.  Try',Ncmd,'.'
         STOP
      END IF
      CALL PLT(HIS,1,MXHIS,nbin,1,cmd,Ncmd,ier)
C---
  900 RETURN
      END
