      SUBROUTINE PLTEV(RMAP, MXROW, MXCOL, Z1, Z2, NX, NE)
      INTEGER   MXROW, MXCOL, NX, NE
      REAL      RMAP(MXROW,MXCOL), Z1, Z2
C---
C [ELLIPTICAL VIEW]
C Program to produce a perspective drawing of a single valued
C function defined over elliptical coordinates, in such a way as
C to exhbit the arcs corresponding to constant XI and ETA.
C X=COSH(XI)*COS(ETA)
C Y=SINH(XI)*SIN(ETA)
C---
C (Z1,Z2)      Range of Z values
C RMAP    I    Array to be plotted.
C NX           Number of XI values
C NE           Number (=4*N+1) of ETA values
C---
C 1974-May-17 - Instituto Nacional de Energia Nuclear
C---
      REAL      QU, X1, X2
      INTEGER   NQ
C
      INTEGER   N0
      COMMON /VIS/N0
C---
      NQ=1+(NE-1)/4
      QU=1.57
      X1=0.01
      X2=1.76
      N0=0
      CALL VISES(RMAP,MXROW,MXCOL,Z1,3*(NQ-1),Z2,X1,X2,NX,
     :   3.0*QU,4.0*QU,NQ,-1,1)
      CALL VISES(RMAP,MXROW,MXCOL,Z1,0       ,Z2,X1,X2,NX,
     :      0.0,    QU,NQ, 1, 1)
      N0=0
      CALL VISES(RMAP,MXROW,MXCOL,Z1,2*(NQ-1),Z2,X1,X2,NX,
     :   2.0*QU,3.0*QU,NQ,-1,-1)
      CALL VISES(RMAP,MXROW,MXCOL,Z1,  (NQ-1),Z2,X1,X2,NX,
     :       QU,2.0*QU,NQ, 1,-1)
      CALL PLOT(0.,0.,999)
      RETURN
      END
