      SUBROUTINE PLTPV(RMAP, MXROW, MXCOL, I1, NR, J1, NP,  Z1, Z2)
      INTEGER   MXROW, MXCOL, I1, NR, J1, NP
      REAL      RMAP(MXROW,MXCOL), Z1, Z2
C---
C [POLAR VIEW]
C Program to produce a perspective drawing of a single valued
C function defined in polar coordinates, in such a way as to
C exibit the radial and circumferential arcs.
C---
C (Z1,Z2) Range of function values
C NR      Number of points on one radius
C NP      Number (=4*N+1) of angles
C---
C 1974-May-17 - Instituto Nacional de Energia Nuclear
C---
      REAL      QU, R1, R2
      INTEGER   NQ
C
      INTEGER   N0
      COMMON /VIS/N0
C---
      NQ=1+(NP-1)/4
      QU=1.57078
      R1=0.02
      R2=1.00
      N0=0
      CALL VISPS(RMAP,MXROW,MXCOL,Z1,3*(NQ-1),Z2,R1,R2,NR,
     :      3.0*QU,4.0*QU,NQ,-1,1)
      CALL VISPS(RMAP,MXROW,MXCOL,Z1,0       ,Z2,R1,R2,NR,
     :         0.0,    QU,NQ,1,1)
      N0=0
      CALL VISPS(RMAP,MXROW,MXCOL,Z1,2*(NQ-1),Z2,R1,R2,NR,
     :      2.0*QU,3.0*QU,NQ,-1,-1)
      CALL VISPS(RMAP,MXROW,MXCOL,Z1,  (NQ-1),Z2,R1,R2,NR,
     :      QU,2.0*QU,NQ, 1,-1)
      CALL PLOT(0.,0.,999)
      RETURN
      END
