      SUBROUTINE VISBO(X1,T1,B1,M,X0,T0,B0,N0,X,Y,N,IP,PL)
      REAL      X1(1), T1(1), B1(1), X(1), Y(1)
      REAL      X0(1), T0(1), B0(1)
      INTEGER   M, N0, N, IP
      EXTERNAL  PL
C---
C [BOUNDS]
C---
C X(N)   Array of arguments
C Y(N)   Array of function values
C IP     Direction of pen movement
C PL     Pen movement subroutine
C---
C 1974-May-29 - Instituto Nacional de Energia Nuclear
C---
      REAL      VISLI
      LOGICAL   VISSL
C
      REAL      BB, BE, BO, DB, DT, EB, EP, ET, EX, F, S, TE, TO, TT
      REAL      VB, VT, WY, XD, YD, XI, XX, YI, YY, Z, Z0
      INTEGER   J, J0, J1, JJ, K, KK
      LOGICAL   L, EQ, VV, QS
C
      REAL      U(2), U1, U2
      EQUIVALENCE (U1,U(1)), (U2,U(2))
C
      DATA EP/1.0E-5/
      EQ(XD,YD)=ABS(XD-YD).LE.(0.5E-4)
      QS(XD,YD)=(YD.LT.0.AND.XD.LT.0) .OR. (XD.GT.0.AND.YD.GT.0) .OR.
     1   (XD.EQ.0.AND.YD.EQ.0)
C---
C INITIALIZATION
      IF(N.LE.1) RETURN
      J=(N+1-IP*(N-1))/2
      J1=((M+1)*(1-IP))/2
      CALL PL(X(J),Y(J),.FALSE.)
      IF(N0.LE.1) GOTO 61
      S=FLOAT(IP)
      ET= EP
      EB=-EP
      L=.TRUE.
      K=(1-IP)/2
      J0=(N0+1-IP*(N0-1))/2
      Z=X(J)
      Z0=X0(J0)
      IF(EQ(Z,Z0)) GOTO 32
C      IF(S*(Z-Z0)) 10,32,20
      IF(S*(Z-Z0).GT.0.0) GOTO 20
C---
C If the function is defined while bounds are not, the function
C is visible and must be copied, establishing new bounds.
   10 J1=MAX0(MIN0(J1+IP,M),1)
      CALL PL(X(J),Y(J),.TRUE.)
      X1(J1)=X(J)
      T1(J1)=Y(J)
      B1(J1)=Y(J)
      J=J+IP
      IF(EQ(X(J),Z0)) GOTO 30
C      IF(S*(X(J)-Z0)) 10,30,30
      IF(S*(X(J)-Z0).GE.0.0) GOTO 30
      GOTO 10
C---
C If bounds, but not the function, are defined, they persist.
   20 J1=MAX0(MIN0(J1+IP,M),1)
      X1(J1)=X0(J0)
      T1(J1)=T0(J0)
      B1(J1)=B0(J0)
      J0=J0+IP
      IF(EQ(Z,X0(J0))) GOTO 30
C      IF(S*(Z-X0(J0))) 30,30,20
      IF(S*(Z-X0(J0)).GT.0.0) GOTO 20
C---
C MAIN LOOP
C At a point where either the function or the bounds are
C defined, it may be necessary to obtain the other by linear
C interpolation, unless their points of definition coincide.
   30 IF((J.LT.1).OR.(J.GT.N)) GOTO 50
      IF((J0.LT.1).OR.(J0.GT.N0)) GOTO 60
      Z=X(J)
      Z0=X0(J0)
   32 EX=AMIN1(Z,Z0)
      IF(IP.LT.0) EX=AMAX1(Z,Z0)
      WY=VISLI(EX,X,Y,MAX0(MIN0(J+K,N),2))
      TO=VISLI(EX,X0,T0,MAX0(MIN0(J0+K,N0),2))
      BO=VISLI(EX,X0,B0,MAX0(MIN0(J0+K,N0),2))
      IF(EQ(EX,Z0)) J0=J0+IP
      IF(EQ(EX,Z)) J=J+IP
C---
C Possible intersection between the function and the bounds
C must be recorded so as to describe the new bounds accurately.
C Care is necessary to avoid trivial intersection, or those
C which occur at endpoints.
      TE=AMAX1(WY,TO)
      BE=AMIN1(WY,BO)
      DT=WY-TO
      DB=WY-BO
      VT=ET+DT
      VB=EB+DB
      IF(L) GOTO 46
      JJ=0
      IF(.NOT.QS(DT,ET)) THEN
         VT=DT-ET
         JJ=JJ+1
         U(JJ)=XX-ET*((EX-XX)/(DT-ET))
      END IF
      IF(.NOT.QS(DB,EB)) THEN
         VB=DB-EB
         JJ=JJ+1
         U(JJ)=XX-EB*((EX-XX)/(DB-EB))
      END IF
      DO 43 KK=1,JJ
        IF((KK.EQ.1).AND.(JJ.EQ.1)) XI=U1
        IF((KK.EQ.1).AND.(JJ.EQ.2)) XI=S*AMIN1(S*U1,S*U2)
        IF(KK.EQ.2)  XI=S*AMAX1(S*U1,S*U2)
        F=(XI-XX)/(EX-XX)
        YI=YY+F*(WY-YY)
        CALL PL(XI,YI,((KK.EQ.1).AND.VV))
        IF(EQ(XX,XI).OR.EQ(XI,EX)) GOTO 43
        IF((KK.EQ.2).AND.EQ(U1,U2)) GOTO 43
        J1=MAX0(MIN0(J1+IP,M),1)
        X1(J1)=XI
        T1(J1)=TT+F*(TO-TT)
        B1(J1)=BB+F*(BO-BB)
   43 CONTINUE
      IF((J1.LT.2).OR.(J1.GT.M-1)) GOTO 46
      IF(.NOT.VISSL(EX,TE,X1,T1,J1+K)) GOTO 46
      IF(     VISSL(EX,BE,X1,B1,J1+K)) GOTO 48
   46 J1=MAX0(MIN0(J1+IP,M),1)
   48 X1(J1)=EX
      T1(J1)=TE
      B1(J1)=BE
      VV=(VT.GE.EP) .OR. (-VB.GE.EP)
      CALL PL(EX,WY,VV)
      L=.FALSE.
      ET=DT
      EB=DB
      XX=EX
      YY=WY
      TT=TO
      BB=BO
      GOTO 30
C---
C TERMINATION
C If the function is exhausted before the bounds, copy them.
   50 IF((J0.LT.1).OR.(J0.GT.N0)) GOTO 70
      J1=MAX0(MIN0(J1+IP,M),1)
      X1(J1)=X0(J0)
      T1(J1)=T0(J0)
      B1(J1)=B0(J0)
      J0=J0+IP
      GOTO 50
C---
C If the bounds are exhausted before the function, copy the
C remaining part of the function, which will be visible.
   60 CALL PL(EX,WY,.FALSE.)
   61 IF((J.LT.1).OR.(J.GT.N)) GOTO 70
      CALL PL(X(J),Y(J),.TRUE.)
      J1=MAX0(MIN0(J1+IP,M),1)
      X1(J1)=X(J)
      T1(J1)=Y(J)
      B1(J1)=Y(J)
      J=J+IP
      GOTO 61
C---
C Copy the new bounds over the old ones, shifting them as necessary.
   70 N0=((M+1)*(1-IP))/2+IP*J1
      J1=(J1+1-IP*(J1-1))/2
      DO 71 J0=1,N0
         X0(J0)=X1(J1)
         T0(J0)=T1(J1)
         B0(J0)=B1(J1)
         J1=J1+1
   71 CONTINUE
      RETURN
      END
