      SUBROUTINE VISDC(RMAP, MXROW, MXCOL, I1, NX, J1, NY, NZ,
     &      Z1, Z2, US, VS, L, PL)
      INTEGER   MXROW, MXCOL, I1, NX, J1, NY, NZ, L
      REAL      RMAP(MXROW, MXCOL)
      REAL      Z1, Z2, US, VS
      EXTERNAL  PL
C---
C [DIAGONAL CONTOURED SEQUENCE]
C---
C RMAP    I    Array to be displayed.
C (Z1,Z2) I    Range of RMAP values
C NX,NY   I    Ranges of J and I
C US,VS   I    Total shears in U and V directions
C L       I    Direction of view (1=west, -1=east)
C PL      I    Pen movement subroutine
C---
C 1974-May-16 - Instituto Nacional de Energia Nuclear
C---
      REAL      X(684), Y(684)
      REAL      DUI, DUJ, DVI, DZ, EL, EM, EU, TE, VE, ZS, ZSDZ
      INTEGER   I, I0, IZ, J, J0, K, K0, KMAX, M, MK, MM, N, NA
C
      REAL      U, V, W
      COMMON /VIW/U(684),V(684),W(684)
      INTEGER   N0
      COMMON /VIS/N0
C---
      M=1
      MK=684
      NA=0
      N0=0
      N=L*M
      MM=1
      EL=FLOAT(L)
      EM=FLOAT(M)
      TE=0.5*(EL+1.0)
      ZS=(1.0-VS)/(Z2-Z1)
      DZ=(Z2-Z1)/FLOAT(NZ-1)
      DUI=-(EL*US)/FLOAT(NY-1)
      DUJ=(1.0-US)/FLOAT(NX-1)
      DVI=VS/FLOAT(NY-1)
C---
      I0=(NY+1-M*(NY-3))/2
      J0=(NX+1-L*(NX-1))/2
      K0=((MK+1)*(1-N))/2
C---
   10 K=K0
      I=MAX0(MIN0(I0,NY+1),0)
      J=J0
      EU=TE*US+DUI*FLOAT(I-1)+DUJ*FLOAT(J-1)
      VE=      DVI*FLOAT(I-1)
   20 IF(1.LE.I .AND. I.LE.NY) THEN
         K=MAX0(MIN0(K+N,MK),1)
         U(K)=EU
         V(K)=VE+ZS*(RMAP(J,I)-Z1)
         W(K)=VE
      END IF
      I=I-M
      EU=EU-DUI
      VE=VE-EM*DVI
      IF(1.LE.I .AND. I.LE.NY) THEN
         K=MAX0(MIN0(K+N,MK),1)
         U(K)=EU
         V(K)=VE+ZS*(RMAP(J,I)-Z1)
         W(K)=VE
         J=J+L
         EU=EU+EL*DUJ
         IF(J.GE.1 .AND. J.LE.NX) GOTO 20
      END IF
      KMAX=K
      ZSDZ=ZS*DZ
      DO 60 IZ=1,NZ
         CALL VISRB(X,Y,NA,MK,U,V,KMAX,U,W,KMAX,-1.0)
         CALL VISHO(X,Y,NA,MM,PL)
         MM=-MM
         DO 50 K=1,KMAX
            W(K)=W(K)+ZSDZ
   50    CONTINUE
   60 CONTINUE
C
      I0=I0+M
      IF(I0.GE.0 .AND. I0.LE.NY+1) GOTO 10
      J0=J0+L
      IF(J0.GE.1 .AND. J0.LE.NX) GOTO 10
      RETURN
      END
