      SUBROUTINE VISDO(RMAP1, RMAP2, MXROW, MXCOL, Z1, Z2, NX, NY,
     :         US, VS, L, IS, PL)
      INTEGER   MXROW, MXCOL, NX, NY, L, IS
      REAL      RMAP1(MXROW,MXCOL), RMAP2(MXROW,MXCOL), Z1, Z2, US, VS
      EXTERNAL  PL
C---
C [DOUBLE SURFACE]
C---
C RMAP1, RMAP2  Functions containing the two surfaces
C Z1,Z2  Span of surface values
C NX,NY  Sections of RMAP1 and RMAP2 actually used
C US,VS  Total shears in u and v directions
C L      Direction of view (1=west, -1=east)
C IS     Separation option (1=yes, -1=no)
C PL     Pen motion subroutine
C---
C 1974-May-15 - Instituto Nacional de Energia Nuclear
C---
      INTEGER   MXA
      PARAMETER (MXA=351)
C
      REAL      X1(MXA), T1(MXA), B1(MXA)
      REAL      X2(MXA), T2(MXA), B2(MXA)
      REAL      D(MXA), E(MXA), G(MXA), H(MXA)
      REAL      A(MXA), B(MXA)
      REAL      DUI, DUJ, DVI, EF, EL, EM, EU, TE, VE, ZS
      INTEGER   I, I0, II, J, J0, K, K0, KK
      INTEGER   M, N, N1, N2, NA, ND, NG
C
      INTEGER   MXU
      PARAMETER (MXU=201)
      REAL      U(MXU), V1(MXU), V2(MXU)
C      COMMON /VIW/U(MXU), V1(MXU), V2(MXU)
C---
      M=1
      N1=0
      N2=0
      N=L*M
      EF=1.0-VS
      EL=FLOAT(L)
      EM=FLOAT(M)
      ZS=EF/(Z2-Z1)
      TE=0.5*(EL+1.0)
      DUI=-(EL*US)/FLOAT(NY-1)
      DUJ=(1.0-US)/FLOAT(NX-1)
      DVI=VS/FLOAT(NY-1)
      I0=(NY+1-M*(NY-3))/2
      J0=(NX+1-L*(NX-1))/2
      K0=((MXU+1)*(1-N))/2
C
   10 K=K0
      I=MAX0(MIN0(I0,NY+1),0)
      J=J0
      EU=TE*US+DUI*FLOAT(I-1)+DUJ*FLOAT(J-1)
      VE=      DVI*FLOAT(I-1)
   20 IF(1.LE.I .AND. I.LE.NY) THEN
         K=MAX0(MIN0(K+N,MXU),1)
         U(K)=EU
         V1(K)=VE+ZS*(RMAP1(J,I)-Z1)
         V2(K)=VE+ZS*(RMAP2(J,I)-Z1)
      END IF
      I=I-M
      EU=EU-DUI
      VE=VE-EM*DVI
      IF(1.LE.I .AND. I.LE.NY) THEN
         K=MAX0(MIN0(K+N,MXU),1)
         U(K)=EU
         V1(K)=VE+ZS*(RMAP1(J,I)-Z1)
         V2(K)=VE+ZS*(RMAP2(J,I)-Z1)
         J=J+L
         EU=EU+EL*DUJ
         IF((J.GE.1).AND.(J.LE.NX)) GOTO 20
      END IF
C
      IF(L.LT.0) THEN
         KK=MXU-K+1
         CALL VISRB(A,B,NA,MXA,U(K),V1(K),KK,U(K),V2(K),KK,1.0)
         CALL VISRB(G,H,NG,MXA,U(K),V1(K),KK,U(K),V2(K),KK,-1.0)
      ELSE
         CALL VISRB(A,B,NA,MXA,U,V1,K,U,V2,K,1.0)
         CALL VISRB(G,H,NG,MXA,U,V1,K,U,V2,K,-1.0)
      END IF
C
      IF(IS.GE.0) THEN
         DO 36 II=1,NA
            B(II)=EF*B(II)+VS
   36    CONTINUE
         DO 38 II=1,NG
            H(II)=EF*H(II)
   38    CONTINUE
      END IF
C
      CALL VISRB(D,E,ND,MXA,A,B,NA,X1,T1,N1,1.0)
      CALL VISHH(X2,T2,B2,N2,D,E,ND,1,PL)
      CALL VISRB(D,E,ND,MXA,G,H,NG,X2,B2,N2,-1.0)
      CALL VISHH(X1,T1,B1,N1,D,E,ND,-1,PL)
      I0=I0+M
      IF((I0.GE.0).AND.(I0.LE.NY+1)) GOTO 10
      J0=J0+L
      IF((J0.GE.1).AND.(J0.LE.NX)) GOTO 10
      RETURN
      END
