      SUBROUTINE VISDS(RMAP, MXROW, MXCOL, I1, NX, J1, NY,
     &      Z1, Z2, US, VS, L, PL)
      INTEGER   MXROW, MXCOL, I1, NX, J1, NY, L
      REAL      RMAP(MXROW, MXCOL)
      REAL      Z1, Z2, US, VS
      EXTERNAL  PL
C---
C [DIAGONAL SEQUENCE]
C---
C RMAP(J,I) Function values
C (Z1,Z2)   Span of RMAP values
C NX,NY     Ranges of J and I
C US,VS     Total shears in U and V directions
C L         Direction of view (1=WEST, -1=EAST)
C PL        Pen movement subroutine
C---
C 1974-Mar-17 - Instituto Nacional de Energia Nuclear
C---
C
      REAL      DUI, DUJ, DVI, EL, EM, EU, TE, VE, ZS
      INTEGER   I, I0, J, J0, K, K0, M, MK, MM, N
C
C Dimension of U,V should be 2*MIN(NX,NY)+1
      REAL      U, V
      COMMON /VIW/U(1026),V(1026)
C---
      M=1
      MK=1026
      N=L*M
      MM=1
      EL=FLOAT(L)
      EM=FLOAT(M)
      TE=0.5*(EL+1.0)
      ZS=(1.0-VS)/(Z2-Z1)
      DUI=-(EL*US)/FLOAT(NY-J1)
      DUJ=(1.0-US)/FLOAT(NX-I1)
      DVI=VS/FLOAT(NY-J1)
      I0=(NY+1-M*(NY-3))/2
      J0=(NX+1-L*(NX-1))/2
      K0=((MK+1)*(1-N))/2
   10 K=K0
      I=MAX0(MIN0(I0,NY+1),I1-1)
      J=MAX(J0,J1)
      EU=TE*US+DUI*FLOAT(I-1)+DUJ*FLOAT(J-1)
      VE=      DVI*FLOAT(I-1)
   20 IF(I1.LE.I .AND. I.LE.NY) THEN
         K=MAX0(MIN0(K+N,MK),1)
         U(K)=EU
         V(K)=VE+ZS*(RMAP(J,I)-Z1)
      END IF
      I=I-M
      EU=EU-DUI
      VE=VE-EM*DVI
      IF(I1.LE.I .AND. I.LE.NY) THEN
         K=MAX0(MIN0(K+N,MK),1)
         U(K)=EU
         V(K)=VE+ZS*(RMAP(J,I)-Z1)
         J=J+L
         EU=EU+EL*DUJ
         IF((J.GE.1).AND.(J.LE.NX)) GOTO 20
      END IF
      IF(L.GT.0) CALL VISHO(U,V,K,MM,PL)
      IF(L.LT.0) CALL VISHO(U(K),V(K),MK-K+1,MM,PL)
      MM=-MM
      I0=I0+M
C
      IF((I0.GE.I1-1).AND.(I0.LE.NY+1)) GOTO 10
      J0=J0+L
      IF( J1.LE.J0 .AND. J0.LE.NX ) GOTO 10
      RETURN
      END
