      SUBROUTINE VISRB(X, Y, J, M, X1, Y1, N1, X2, Y2, N2, S)
      REAL      X(1), Y(1), X1(1), Y1(1), X2(1), Y2(1), S
      INTEGER   J, M, N1, N2
C---
C [RESTRICTED BOUND]
C The bound is restricted to the interval where the first
C function is defined.
C---
C X(M),Y(M)  Arrays for the bound of two functions
C J         (output) actual dimension of X,Y
C X1(N1),Y1(N1) first function
C X2(N2),Y2(N2) second function
C S        Type of bound (S=1.0,upper; S=-1.0,lower)
C---
C 1974-May-15 - Instituto Nacional de Energia Nuclear
C---
      LOGICAL   EQ, VISSL
      REAL      VISLI
C
      REAL      D, E, U, W, W1, W2, WW, XD, YD, Z, Z1, Z2
      INTEGER   J1, J2
      LOGICAL   L
C
      EQ(XD,YD)=ABS(YD-XD).LE.1.0E-5
C---
      L=.TRUE.
      J=0
      J1=1
      J2=1
      Z1=X1(J1)
      Z2=X2(J2)
      IF(N1.LE.1) RETURN
      IF(N2.LE.1) GOTO 60
      IF(EQ(Z1,Z2)) GOTO 32
C      IF(Z1-Z2) 10,32,20
      IF(Z1-Z2.GT.0.0) GOTO 20
      IF(Z1-Z2.EQ.0.0) GOTO 32
   10 J=MIN0(J+1,M)
      X(J)=Z1
      Y(J)=Y1(J1)
      J1=J1+1
      Z1=X1(J1)
      IF(EQ(Z1,Z2)) GOTO 32
C      IF(Z1-Z2) 10,32,32
      IF(Z1-Z2.GE.0.0) GOTO 32
      GOTO 10
C
   20 J2=J2+1
      Z2=X2(J2)
      IF(EQ(Z1,Z2)) GOTO 32
C      IF(Z1-Z2) 32,32,20
      IF(Z1-Z2.LE.0) GOTO 32
      GOTO 20
C
   30 IF(J1.GT.N1) RETURN
      IF(J2.GT.N2) GOTO 60
      Z1=X1(J1)
      Z2=X2(J2)
   32 Z=AMIN1(Z1,Z2)
      W1=VISLI(Z,X1,Y1,MAX0(J1,2))
      W2=VISLI(Z,X2,Y2,MAX0(J2,2))
      IF(EQ(Z,Z1)) J1=J1+1
      IF(EQ(Z,Z2)) J2=J2+1
      W=S*AMAX1(S*W1,S*W2)
      D=W1-W2
      IF(L.OR.(J.LE.1)) GOTO 42
      IF((EQ(D,0.0)).OR.(EQ(E,0.0))) GOTO 41
      IF(SIGN(1.0,D).EQ.SIGN(1.0,E)) GOTO 41
      J=MIN0(J+1,M)
      X(J)=U-E*((Z-U)/(D-E))
      Y(J)=WW+(X(J)-U)*((W1-WW)/(Z-U))
   41 IF(VISSL(Z,W,X,Y,J)) GOTO 43
   42 J=MIN0(J+1,M)
   43 X(J)=Z
      Y(J)=W
      L=.FALSE.
      E=D
      U=Z
      WW=W1
      GOTO 30
C
   60 IF(J1.GT.N1) RETURN
      J=MIN0(J+1,M)
      X(J)=X1(J1)
      Y(J)=Y1(J1)
      J1=J1+1
      GOTO 60
      END
