      SUBROUTINE VISRS(RMAP, MXROW, MXCOL, I1, NX, J1, NY, TH,
     &      Z1, Z2, L, PL)
      INTEGER   MXROW, MXCOL, I1, NX, J1, NY, L
      REAL      RMAP(MXROW, MXCOL)
      REAL      TH, Z1, Z2
      EXTERNAL  PL
C---
C [ROTATED SEQUENCE]
C---
C RMAP(J,I)  Function values
C (Z1,Z2)  Span of Z values
C NX,NY    Ranges of J and I
C TH       Angle of rotation (degrees clockwise)
C PL       Pen motion subroutine
C L        Direction of view (1=west, -1=east)
C M        Direction of view (1=south,-1=north)
C---
C 1974-Mar-24 - Instituto Nacional de Energia Nuclear
C---
C
      REAL      CO, DUI, DUJ, DVI, DVJ, EL, EM, EU
      REAL      SCAL, SF, SI, U0, V0, VE, ZS
      INTEGER   I, I0, J, J0, K, K0, M, MK, MM, N
C
      REAL      U, V
      COMMON /VIW/U(1026),V(1026)
C---
      M=1
      MK=1026
      IF(TH.LT. 0.) L=-1
      IF(TH.GE. 0.) L=1
      N=L*M
      MM=1
      SCAL=3.14159/180.
      SI=SIN(TH*SCAL)
      CO=COS(TH*SCAL)
      EL=FLOAT(L)
      EM=FLOAT(M)
      ZS=0.7/(Z2-Z1)
      SF=1.0/(ABS(CO)+ABS(SI))
      U0=0.25*(EL+1.0)*(1.0-SF*(CO-SI))
      V0=0.15*(EL-1.0)*SF*SI
      DUI=-(SF*SI)/FLOAT(NY-1)
      DUJ= (SF*CO)/FLOAT(NX-1)
      DVI= (0.3*SF*CO)/FLOAT(NY-1)
      DVJ= (0.3*SF*SI)/FLOAT(NX-1)
      I0=(NY+1-M*(NY-3))/2
      J0=(NX+1-L*(NX-1))/2
      K0=((MK+1)*(1-N))/2
   10 K=K0
      I=MAX0(MIN0(I0,NY+1),0)
      J=J0
      EU=U0+DUI*FLOAT(I-1)+DUJ*FLOAT(J-1)
      VE=V0+DVI*FLOAT(I-1)+DVJ*FLOAT(J-1)
   20 IF((I.LT.1).OR.(I.GT.NY)) GOTO 22
      K=MAX0(MIN0(K+N,MK),1)
      U(K)=EU
      V(K)=VE+ZS*(RMAP(J,I)-Z1)
   22 I=I-M
      EU=EU-EM*DUI
      VE=VE-EM*DVI
      IF((I.LT.1).OR.(I.GT.NY)) GOTO 30
      K=MAX0(MIN0(K+N,MK),1)
      U(K)=EU
      V(K)=VE+ZS*(RMAP(J,I)-Z1)
      J=J+L
      EU=EU+EL*DUJ
      VE=VE+EL*DVJ
      IF((J.GE.1).AND.(J.LE.NX)) GOTO 20
   30 IF(L.GT.0) CALL VISHO(U,V,K,MM,PL)
      IF(L.LT.0) CALL VISHO(U(K),V(K),MK-K+1,MM,PL)
      MM=-MM
      I0=I0+M
      IF((I0.GE.0).AND.(I0.LE.NY+1)) GOTO 10
      J0=J0+L
      IF((J0.GE.1).AND.(J0.LE.NX)) GOTO 10
      RETURN
      END
