C I2CONV  (FUN)  Convert I*2 from IBM byte order to processor byte order
C I4CONV  (FUN)  Convert I*4 from IBM byte order to processor byte order
C*********
      FUNCTION I2CONV(i2data)
      INTEGER*2 I2CONV
      INTEGER*2 i2data
C---
C Convert an INTEGER*2 from IBM byte order to processor byte order.
C---
C i2data      I    The number to be converted
C---
      INTEGER*2 i2loc,    i2swap,    i2tmp
      INTEGER*1 i1loc(2), i1swap(2), i1tmp(2)
      EQUIVALENCE (i1loc,i2loc), (i1swap, i2swap), (i1tmp, i2tmp)
C---
      i2tmp = 1
      IF ( i1tmp(1).EQ.1 ) THEN
         i2loc = i2data
         i1swap(1) = i1loc(2)
         i1swap(2) = i1loc(1)
      ELSE
         i2swap = i2data
      END IF
      I2CONV = i2swap
      RETURN
      END
C*********
      FUNCTION I4CONV(I2data)
      INTEGER*4 I4CONV
      INTEGER*2 I2data(2)
C---
C Convert an INTEGER*4 from IBM byte order to processor byte order.
C---
C I4data  I    The number to be converted
C---
      INTEGER*2 I2CONV
      INTEGER*4 i4swap, i4tmp
      INTEGER*2 i2swap(2), i2tmp(2)
      EQUIVALENCE (i2swap, i4swap), (i2tmp, i4tmp)
C---
      i4tmp = 1
      IF ( i2tmp(1).EQ.1 ) THEN
C Swap bytes
         i2swap(2) = I2CONV(i2data(1))
         i2swap(1) = I2CONV(i2data(2))
      ELSE
C No swap needed
         i2swap(1) = i2data(1)
         i2swap(2) = i2data(2)
      END IF
      I4CONV = i4swap
      RETURN
      END
