      SUBROUTINE GETLUN(Lun)
      INTEGER   Lun
C---
C Returns a free Logical Unit Number.  Note, units 1-9 should be
C avoided, since many programs use these units without warning.
C---
C 2005-Apr-26 - add iuse array to avoid cfitsio conflicts [AFT]
C---
C Lun       O  An unopened logical unit number.
C---
      INTEGER   i
      LOGICAL   qopen
      INTEGER   iuse(99)
      SAVE      iuse
      DATA      iuse/99*0/
C---
      DO i=99, 10, -1
         IF ( iuse(i).EQ.0 ) THEN
            INQUIRE(UNIT=i, OPENED=qopen)
            IF(.NOT.qopen) THEN
               iuse(i) = 1
               Lun= i
               RETURN
            END IF
         END IF
      END DO
      WRITE(*,*) 'GETLUN--Out of units.'
      RETURN
C---
      ENTRY FRELUN(Lun)
C---
C Release a Logical Unit Number.
C---
C Lun       I    The logical unit number
C---
C 2005-Apr-26 - reset iuse [AFT]
C 1989-Feb-13 - Latest mod [AFT]
C---
      iuse(Lun) = 0
      RETURN
C---
      ENTRY DMPLUN
C---
C This is a debuggin routine.  Call just before exiting to see what
C units are still allocated.
C---
      DO i=99, 10, -1
         IF ( iuse(i).NE.0 ) THEN
            WRITE(*,*) 'DMPLUN--lun',i,' has not been closed.'
         END IF
      END DO
      RETURN
      END
