      SUBROUTINE GTBUF(Cprom,Ier)
      CHARACTER Cprom*(*)
      INTEGER   Ier
C Entry GTCHAR, GTPEEK, GTREST
      CHARACTER Ctoken*(*)
      INTEGER   Ltoken
C Entry GTDBLE
      DOUBLE PRECISION Dnum
C Entry GTINT
      INTEGER   Inum
C Entry GTLEV
      INTEGER   Lev
C Entry GTMODE
      INTEGER   Inmode
C Entry GTREAL
      REAL      Rnum
C Entry LDBUF1
      CHARACTER Cmd1*(*)
      INTEGER   Ierld
C Entry STWARN
      INTEGER   Ldwarn
C Entry XGETIN
      CHARACTER Cext1*(*)
C Entry XSETIN
      CHARACTER Cext2*(*)
C---
C When first called this routine tries to read a string from the
C command line.  If no string was given or on future calls, this
C routine will prompt the user for input.
C---
C Special first characters (must be first character on line)
C !     Ignore the entire line (comment line)
C $     Spawn to operating system
C @file Open next level of indirect file and read buffer from there.
C @     Force buffer to be read from terminal (even when reading a file).
C Special character can appear anywhere in line.
C !     (not enclosed in ") means rest of line is a comment.
C---
C CPROM     I    Used to prompt the user.
C IER         O  =0 no error, =-1 if user entered an EOF.
C---
C Requires:         for:
C ALF.FOR           ALF, FPNUM, ISNUM, ALFSKS
C LENACT.FOR        LENACT
C LOGGER.FOR        LOGGER
C SCRIPT.FOR        SCRIPT
C XTEND.FOR         XTEND
C XWRCMD            XWRCMD
C SYS.$(EXT)        RDFORN, SPAWN, PROMPT
C---
C 1999-05-20 - Changed calling sequence to QLINE [AFT]
C 1991-Feb-11 - Add LDBUF1 entry [AFT]
C 1990-Dec-04 - Remove GTPROM, add STWARN [AFT]
C 1990-Feb-02 - Added parameters to indirect files [AFT]
C 1989-Dec-13 - Added command recall [AFT]
C 1989-Jul-06 - System independent indirect command files [AFT]
C---
C Implementation of indirect file parameters:  MXARGS determines the
C maximum total number of parameters used at all indirect levels.  The
C total number of characters in all parameter strings is determined
C by LEN(CARGS).  Since some levels may use no parameters and others
C many, a two level pointer system is used.  ISTACK(1,LEVEL) determines
C the offset into IPOS when reading commands at depth of LEVEL.
C ISTACK(2,LEVEL) is the number of valid parameters at that level.
C Let IOFF=ISTACK(1,LEVEL) then IPOS(1,IOFF+IPAR) gives the start
C position in CARGS for parameter number IPAR.  IPOS(2,IOFF+IPAR) is
C the end position.
C---
      INCLUDE 'edicmn.inc'
C
      INTEGER MXLEV
      PARAMETER (MXLEV=15)
      INTEGER MXPREV
      PARAMETER (MXPREV=20)
      INTEGER MXARGS
      PARAMETER (MXARGS=32)
      DOUBLE PRECISION DPNUM
      REAL FPNUM
      INTEGER LENACT, ISNUM
C
      CHARACTER cprev(MXPREV)*132, cargs*500
      SAVE      cprev, cargs
      CHARACTER cbuf*256, cload*132
      SAVE      cbuf, cload
      CHARACTER cnam*255, ctmp*255, ctok*128
      CHARACTER cdef*10
      SAVE      cdef
      DOUBLE PRECISION dtmp
      REAL      rbuf(2)
      REAL      tmp
      INTEGER   lunsav(MXLEV), istack(2,0:MXLEV), ipos(2,0:MXARGS)
      SAVE      lunsav, istack, ipos
      INTEGER   i, ibas, ic, ie
      INTEGER   ios, ipar, iper, iq, is, itmp, itmprd, iwrlog
      INTEGER   lnam, lprom, ltok, ltmp, luntry
      INTEGER   idfile, idspawn, icnt, iecho, ifirst
      SAVE      idfile, idspawn, icnt, iecho, ifirst
      INTEGER   iload, irdcom, istopl
      SAVE      iload, irdcom, istopl
      INTEGER   kp, lbuf, laspos, ldlev, level, mode, nargs, nload
      SAVE      kp, lbuf, laspos, ldlev, level, mode, nargs, nload
      CHARACTER c4tmp*4
C
      DATA cdef/'XCO'/
      DATA idfile/0/, idspawn/0/, iecho/1/, ifirst/1/
      DATA iload/0/, irdcom/1/, istopl/ - 1/
      DATA ldlev/0/, level/0/
      DATA mode/0/, nload/0/
C---
 11   FORMAT (A)
C---
C First time through, search for foreign arguments.
      lprom = LENACT(Cprom)
      IF ( ifirst.NE.0 ) THEN
C Fill recall buffer with blanks, ignoring any commands the user
C has previously loaded.
         DO i = nload + 1, MXPREV
            cprev(i) = ' '
         END DO
C Start at level zero
         nargs = 0
C No arguments at any level
         DO i = 0, MXLEV
            istack(1,i) = 0
            istack(2,i) = 0
         END DO
C No character data in argument stack
         ipos(1,0) = 0
         ipos(2,0) = 0
         laspos = ipos(2,0)
C User has not entered any commands (yet)
         icnt = 0
C Archive centers like to disable people
         CALL TRLOG('SPAWN_DISABLE',13,cbuf,lbuf)
         IF ( lbuf.GT.0 ) idspawn = 1
         CALL TRLOG('GTBUF_DISABLE',13,cbuf,lbuf)
         IF ( lbuf.GT.0 ) THEN
            CALL UPC(cbuf(:lbuf))
            IF ( INDEX(cbuf(:lbuf),'S').GT.0 ) idspawn = 1
            IF ( INDEX(cbuf(:lbuf),'I').GT.0 ) idfile = 1
         END IF
C Has user setup a private command line editing string?
         CALL TRLOG('GTBUF_EDIT',10,cbuf,lbuf)
         CALL EDICOM(cbuf,lbuf)
      ENDIF
      itmprd = 0
C---
 100  CONTINUE
         ios = 0
         Ier = 0
         kp = 0
         IF ( ldlev.GT.0 ) THEN
            IF ( level.LT.ldlev ) ldlev = 0
            IF ( level.LE.istopl ) THEN
C Stop flag is set and we have returned to the original level.  Stop
C and report condition to user.
               istopl = -1
               Ier = 1
               GOTO 400
            ENDIF
         ENDIF
C---
C This is the code to do the primary read.
         iwrlog = 0
         IF ( level.LE.0 ) THEN
C Read an interactive response
            IF ( irdcom.NE.0 ) THEN
C First time try the command line
               irdcom = 0
               CALL RDFORN(cbuf,lbuf)
               IF ( lbuf.GT.0 ) THEN
                  ios = 0
                  GOTO 120
C If nothing on the command line, and there is no prompt, then exit quietly.
C (This allows the main program to flush the command line read.)
               ELSEIF ( lprom.EQ.0 ) THEN
                  GOTO 400
               ENDIF
            ENDIF
C User must actually type something
            IF ( Icedit.NE.0 ) THEN
C either with the super-duper single character IO
               CALL QLINE(Cprom,lprom,cprev,icnt,MXPREV,
     &            cbuf,lbuf,ios)
C or the gnu readline
C               CALL FREADLINE(Cprom, lprom, cbuf, lbuf, ios)
            ELSE
C or with standard Fortran IO.
               CALL PROMPT(Cprom,0)
               READ (*,'(A)',IOSTAT=ios) cbuf
               lbuf = LENACT(cbuf)
            ENDIF
C Write LOG file
 120        WRITE (ctmp,'(A,1X,A)') Cprom(:lprom), cbuf(:lbuf)
            ltmp = 0
            CALL LOGGER(5,rbuf,0,ctmp,ltmp)
C---
C Load the command recall stack.  (Saving commands with load flag set
C could mess up the counting.)
            IF ( lbuf.GT.0 .AND. nload.LE.0 ) THEN
C Only push non-blank commands onto the stack
               icnt = icnt + 1
               cprev(MOD(icnt-1,MXPREV) + 1) = cbuf
            ENDIF
         ELSEIF ( lunsav(level).GT.0 ) THEN
C Read from indirect command file
            READ (lunsav(level),'(A)',IOSTAT=ios) cbuf
            lbuf = LENACT(cbuf)
            IF ( ios.EQ.0 .AND. iecho.NE.0 .AND. ldlev.EQ.0 ) iwrlog = 1
         ELSEIF ( lunsav(level).LT.0 ) THEN
C Read the LDBUF1 command.
            level = level - 1
            cbuf = cload
            lbuf = LENACT(cbuf)
            iload = 0
         ENDIF
C---
C Use /* to denote EOF
         IF ( cbuf(1:2).EQ.'/*' ) ios = -1
         IF ( ios.NE.0 ) THEN
            lbuf = 0
            IF ( level.GT.0 ) THEN
               IF ( lunsav(level).GT.0 ) THEN
                  CLOSE (UNIT=lunsav(level))
                  CALL FRELUN(lunsav(level))
                  nargs = nargs - istack(2,level)
                  laspos = ipos(2,nargs)
               ENDIF
               istack(2,level) = 0
               level = level - 1
               GOTO 100
            ELSE
               Ier = -1
               IF ( level.LT.0 ) THEN
C User has entered an EOF and hence is unable to correct an error that
C occurred while reading an indirect file.  Log this response and
C unwind the indirect file stack.
                  CALL XWRCMD(level,Cprom,lprom,'/*',2)
                  level = ABS(level)
                  itmp = level
                  DO i = 1, itmp
                     IF ( lunsav(level).GT.0 ) THEN
                        CLOSE (UNIT=lunsav(level))
                        CALL FRELUN(lunsav(level))
                        nargs = nargs - istack(2,level)
                     ENDIF
                     istack(2,level) = 0
                     level = level - 1
                  END DO
                  laspos = ipos(2,nargs)
               ENDIF
            ENDIF
         ELSE
C---
C If the first character is '!' then ignore the complete line.
            IF ( mode.EQ.0 .AND. cbuf(1:1).EQ.'!' ) GOTO 100
C Otherwise, strip off comments, this is done by scaning the input
C line looking for a ! not enclosed in ".
 140        CONTINUE
            iq = 0
            iper = 0
            ic = lbuf
            DO i = 1, ic
               IF ( iq.NE.0 ) THEN
C- Odd number of " marks.
                  IF ( cbuf(i:i).EQ.'"' ) iq = 0
C- Even number of " marks.
               ELSEIF ( cbuf(i:i).EQ.'"' ) THEN
                  iq = 1
               ELSEIF ( cbuf(i:i).EQ.'!' ) THEN
                  lbuf = i - 1
                  lbuf = LENACT(cbuf(:lbuf))
                  GOTO 180
               ELSEIF ( cbuf(i:i).EQ.'%' ) THEN
                  IF ( iper.EQ.0 ) iper = i
               ENDIF
            END DO
C---
C Got an GTBUF command, deal with it
 180        CONTINUE
            IF ( iper.NE.0 ) THEN
               ltok = INDEX(cbuf(iper+1:),'%') + 1
               IF ( ltok.LE.0 ) GOTO 340
               ctok = cbuf(iper:iper+ltok-1)
               kp = iper + ltok - 1
               CALL UPC(ctok)
               IF ( ctok(1:3).EQ.'%ED' ) THEN
C %EDit% for command line editing
                  CALL EDICOM(cbuf(kp+1:),lbuf-kp)
                  GOTO 100
               ELSEIF ( ctok(1:2).EQ.'%E' ) THEN
C %Echo% to control the printing of command read from indirect files.
                  CALL ALF(cbuf,lbuf,kp,ctok,ltok)
                  IF ( ltok.GT.0 ) THEN
                     CALL UPC(ctok)
                     IF ( ctok(1:2).EQ.'OF' ) THEN
                        iecho = 0
                     ELSE
                        iecho = 1
                     ENDIF
                  ENDIF
                  GOTO 100
               ELSEIF ( ctok(1:2).EQ.'%L' ) THEN
C %Log%
                  CALL ALF(cbuf,lbuf,kp,ctok,ltok)
                  ctmp = ctok(1:3)
                  CALL UPC(ctmp(1:3))
                  IF ( ltok.GE.3 .AND. ctmp(1:3).EQ.'%OF' ) THEN
                     CALL LOGGER(4,rbuf,itmp,'KEEP',4)
                  ELSE
                     rbuf(1) = 0.0
                     itmp = 1
                     CALL LOGGER(3,rbuf,itmp,ctok,ltok)
                  ENDIF
                  GOTO 100
               ELSEIF ( ctok(1:2).EQ.'%R' ) THEN
C %Recall%ALL
                  CALL ALF(cbuf,lbuf,kp,ctok,ltok)
                  IF ( ltok.LE.0 ) GOTO 100
                  CALL UPC(ctok)
                  IF ( ctok(1:1).EQ.'A' ) THEN
                     IF ( icnt.LE.MXPREV ) THEN
                        itmp = 0
                        ibas = 0
                     ELSE
                        itmp = MOD(icnt-1,MXPREV) + 1
                        ibas = icnt - MXPREV
                     ENDIF
                     DO i = 1, MIN(icnt,MXPREV)
                        itmp = itmp + 1
                        IF ( itmp.GT.MXPREV ) itmp = 1
                        ibas = ibas + 1
                        WRITE (*,311) ibas, cprev(itmp)
     &                             (:LENACT(cprev(itmp)))
 311                    FORMAT (1X,I5,': ',A)
                     END DO
                     GOTO 100
                  ENDIF
               ELSEIF ( ctok(1:2).EQ.'%S' ) THEN
C %Script%
                  CALL ALF(cbuf,lbuf,kp,ctok,ltok)
                  ctmp = ctok(1:3)
                  CALL UPC(ctmp(1:3))
                  IF ( ltok.GE.3 .AND. ctmp(1:3).EQ.'%OF' ) THEN
                     CALL SCRIPT(4,tmp,itmp,'KEEP',4)
                  ELSE
                     rbuf(1) = 0.0
                     itmp = 1
                     CALL SCRIPT(3,tmp,itmp,ctok,ltok)
                  ENDIF
                  GOTO 100
               ELSEIF ( ctok(1:2).EQ.'%V' ) THEN
C %Version%
                  WRITE (*,321) 'GTBUF version: 2006-08-30'
  321             FORMAT (1X,A)
                  GOTO 100
               ELSEIF ( ISNUM(ctok(2:),ltok-2).NE.0 ) THEN
C %N% argument substitution.
                  ipar = FPNUM(ctok(2:),ltok-2,itmp)
                  IF ( ipar.GT.0 .AND. ipar.LE.istack(2,level) ) THEN
                     itmp = istack(1,level) + ipar
                     is = ipos(1,itmp)
                     ie = ipos(2,itmp)
                     ctmp = cargs(is:ie)//cbuf(iper+ltok:)
                  ELSE
                     ctmp = cbuf(iper+ltok:)
                  ENDIF
                  cbuf(iper:) = ctmp
                  iper = INDEX(cbuf(iper:),'%')
                  lbuf = LENACT(cbuf)
                  IF ( iper.GT.0 ) GOTO 140
               ENDIF
            ENDIF
C---
            IF ( nload.LE.0 .AND. ldlev.EQ.0 ) THEN
C If not generated by a load, write response to LOG and SCRIPT files.
               CALL XWRCMD(level,Cprom,lprom,cbuf,lbuf)
            ENDIF
            IF ( iwrlog.NE.0 ) THEN
C Echo response to screen and LOG file.
               WRITE (ctmp,331) Cprom(:lprom), cbuf(:lbuf)
  331          FORMAT ('!',A,1X,A)
               ltmp = LENACT(ctmp)
               CALL LOGGER(5,rbuf,0,ctmp,ltmp)
               WRITE (*,11) ctmp(:ltmp)
            ENDIF
C---
C- Check for special characters in first column.
 340        IF ( mode.EQ.0 ) THEN
               IF ( cbuf(1:1).EQ.'$' ) THEN
C $ to spawn
                  IF ( idspawn.EQ.0 ) THEN
                     lbuf = lbuf - 1
                     WRITE (*,321) 'Spawning...'
                     c4tmp = 'SAV'
                     CALL EDICOM(c4tmp,3)
                     CALL SPAWN(cbuf(2:),lbuf,Ier)
                     c4tmp = 'RES'
                     CALL EDICOM(c4tmp,3)
                  ELSE
                     WRITE (*,321) 'Spawning has been disabled.'
                  ENDIF
                  GOTO 100
               ELSEIF ( cbuf(1:1).EQ.'@' ) THEN
                  IF ( idfile.GT.0 ) THEN
                     WRITE (*,321)
     &  'Reading indirect files has been disabled.'
                     GOTO 100
                  END IF
C @ open indirect command file.
                  IF ( lbuf.EQ.1 ) THEN
C (no file name means read next line from terminal)
                     level = -level
                     itmprd = 1
                     GOTO 100
                  ENDIF
                  IF ( level.GE.MXLEV ) THEN
                     WRITE (*,361) MXLEV
 361                 FORMAT (1X,'GTBUF--Too many indirect levels.  ',
     &                    'Max depth is',I6,'.')
                     Ier = 1
                     GOTO 400
                  ENDIF
                  kp = 1
                  CALL ALF(cbuf,lbuf,kp,cnam,lnam)
                  CALL GETLUN(luntry)
                  IF ( LENACT(cdef).GT.0 ) CALL XTEND(cnam,cdef)
C Search current directory
                  CALL OPENWR(luntry,cnam,'OLD',' ',' ',0,1,ios)
 370              CONTINUE
                  IF ( ios.EQ.0 ) THEN
                     level = ABS(level) + 1
                     lunsav(level) = luntry
                     istack(1,level) = istack(1,level-1)
     &                        + istack(2,level-1)
                     istack(2,level) = 0
                     IF ( kp.LT.lbuf ) THEN
 380                    CONTINUE
                        CALL ALF(cbuf,lbuf,kp,ctmp,ltmp)
                        IF ( nargs.GE.MXARGS ) THEN
                           WRITE (*,381) MXARGS, ctmp(:ltmp)
 381                    FORMAT (' GTBUF--Maximum number of arguments is'
     &                          ,I5,'.'/' GTBUF--No room for "',A,'".')
                           GOTO 410
                        ENDIF
                        IF ( laspos+ltmp.GT.LEN(cargs) ) THEN
                           WRITE (*,391) ctmp(:ltmp)
 391                       FORMAT (
     &                      ' GTBUF--Arguments too long.  No room for "'
     &                      ,A,'".')
                           GOTO 410
                        ENDIF
                        istack(2,level) = istack(2,level) + 1
                        nargs = nargs + 1
                        ipos(1,nargs) = laspos + 1
                        ipos(2,nargs) = laspos + ltmp
                        cargs(laspos+1:laspos+ltmp) = ctmp
                        laspos = ipos(2,nargs)
                        IF ( kp.LT.lbuf ) GOTO 380
                     ENDIF
C Don't start reading indirect file on first call.
 410                 IF ( ifirst.EQ.0 .OR. lprom.GT.0 ) GOTO 100
                     lbuf = 0
                     GOTO 400
                  ENDIF
C Search user defined directory (if it exists)
                  CALL TRLOG('MY_XCOMS',8,ctmp,ltmp)
                  IF ( ltmp.GT.0 ) THEN
                     ctmp(ltmp+1:) = cnam
                     CALL OPENWR(luntry,ctmp,'OLD',' ',' ',0,1,ios)
                     IF ( ios.EQ.0 ) GOTO 370
                  ENDIF
C Search system directory
                  ctmp = cnam
                  CALL PTEND('$XANTOP','xanlib/xcoms',ctmp)
                  CALL OPENWR(luntry,ctmp,'OLD',' ',' ',0,1,ios)
                  IF ( ios.EQ.0 ) GOTO 370
C Nowhere to be found
                  CALL FRELUN(luntry)
                  WRITE (*,411) cnam(:LENACT(cnam)), ios
 411              FORMAT (' GTBUF--Unable to open ',A,', IOS=',I5)
                  IF ( ifirst.NE.0 .AND. lprom.EQ.0 ) GOTO 400
C Unable to open file, then just ahead and reprompt the user.
                  GOTO 100
               ENDIF
            ENDIF
C---
C Skip leading blanks.
            CALL ALFSKS(cbuf,lbuf,kp)
         ENDIF
C---
C GTREST should return preceeding blanks (to make SELECT work)
C hence, we must reset KP=0.
 400  CONTINUE
      ifirst = 0
      kp = 0
      IF ( itmprd.NE.0 ) level = ABS(level)
      RETURN
C---
C*********
      ENTRY GTCHAR(Ctoken,Ltoken)
C---
C Return the next token as a character string.
C---
      CALL ALF(cbuf,lbuf,kp,Ctoken,Ltoken)
      RETURN
C*********
      ENTRY GTDBLE(Dnum,Ier)
C---
C Return the next token as a DOUBLE PRECISION number.
C---
      CALL ALF(cbuf,lbuf,kp,ctok,ltok)
      Ier = 0
      IF ( ltok.GT.0 ) THEN
         dtmp = DPNUM(ctok,ltok,Ier)
         IF ( Ier.EQ.0 ) THEN
            Dnum = dtmp
         ELSE
            Ier = 1
         ENDIF
      ENDIF
      RETURN
C*********
      ENTRY GTDEST()
C---
C "Destroys" the GTBUF object.  This is useful if you are going to use
C some non-GTBUF IO or want to super cleanly exit a program.
C---
      level = ABS(level)
      itmp = level
      DO i = 1, itmp
         IF ( lunsav(level).GT.0 ) THEN
            CLOSE (UNIT=lunsav(level))
            CALL FRELUN(lunsav(level))
            nargs = nargs - istack(2,level)
         ENDIF
         istack(2,level) = 0
         level = level - 1
      END DO
      laspos = ipos(2,nargs)
      RETURN
C*********
      ENTRY GTINT(Inum,Ier)
C---
C Return the next token as an integer number.
C---
      CALL ALF(cbuf,lbuf,kp,ctok,ltok)
      Ier = 0
      IF ( ltok.GT.0 ) THEN
C Note, since REAL*4 has fewer digits than INTEGER*4 this routine does
C not preserve all the INTEGER digits.  If these digits are needed the
C user should call GTDBLE and then convert that value to INTEGER.
         tmp = FPNUM(ctok,ltok,Ier)
         IF ( Ier.EQ.0 ) THEN
            Inum = NINT(tmp)
         ELSE
            Ier = 1
         ENDIF
      ENDIF
      RETURN
C*********
      ENTRY GTLEV(Lev)
C---
C Return the current level of indirectness.  This assumes that the
C GTBUF parser has already been called.  In order to allow PLT to
C be called by routines that do not use the GTBUF parser, set the
C 'already been called' flag now.
C---
      Lev = level
      ifirst = 0
      RETURN
C*********
      ENTRY GTMODE(Inmode)
C---
C Toggle the mode to INMODE.  Note, original mode is returned in
C INMODE.
C---
      itmp = mode
      mode = Inmode
      Inmode = itmp
      RETURN
C*********
      ENTRY GTREAL(Rnum,Ier)
C---
C Return the next token as a real number.
C---
      CALL ALF(cbuf,lbuf,kp,ctok,ltok)
      Ier = 0
      IF ( ltok.GT.0 ) THEN
         tmp = FPNUM(ctok,ltok,Ier)
         IF ( Ier.EQ.0 ) THEN
            Rnum = tmp
         ELSE
            Ier = 1
         ENDIF
      ENDIF
      RETURN
C*********
      ENTRY GTPEEK(Ctoken,Ltoken)
C---
C Peek at the next token, i.e., return the token but do not advance
C the character pointer.
C---
      CALL ALFSKS(cbuf,lbuf,kp)
      IF ( kp.GE.lbuf ) THEN
         Ctoken = ' '
         Ltoken = 0
      ELSE
         Ctoken(1:1) = cbuf(kp+1:kp+1)
         Ltoken = 1
         IF ( cbuf(kp+2:kp+2).NE.' ' .AND. cbuf(kp+2:kp+2).NE.',' ) THEN
            Ctoken(2:2) = cbuf(kp+2:kp+2)
            Ltoken = 2
         ENDIF
      ENDIF
      RETURN
C*********
      ENTRY GTREST(Ctoken,Ltoken)
C---
C Get rest of string, excluding comments.
C---
      IF ( kp.LT.lbuf ) THEN
         Ctoken = cbuf(kp+1:lbuf)
         Ltoken = MAX(lbuf-kp,0)
      ELSE
         Ctoken = ' '
         Ltoken = 0
      ENDIF
      kp = lbuf
      RETURN
C*********
      ENTRY GTSECO
C---
C Someone called XINIRD.  This will keep GTBUF from also reading the
C command line.
C---
      ifirst = 0
      RETURN
C*********
      ENTRY LDBUF1(Cmd1,Ierld)
C---
C Load a single command without touching the command recall stack.
C---
C CMD1    I
C IERLD     O
C---
      IF ( level.GE.MXLEV ) THEN
         WRITE (*,361) MXLEV
         Ierld = 1
      ELSE IF ( iload.NE.0 ) THEN
         WRITE (*,821)
  821    FORMAT ('LDBUF1--A command has already been loaded.')
      ELSE
C Push command stack
         level = level + 1
C Flag to read from the CLOAD array
         lunsav(level) = -1
C Save command
         cload = Cmd1
C Note that CLOAD is in use
         iload = 1
C Note the current stack level (so caller can be notified when command
C is completed).
         IF ( ldlev.EQ.0 ) ldlev = level
C No (detected) errors
         Ierld = 0
      ENDIF
      RETURN
C*********
      ENTRY STWARN(Ldwarn)
C---
C This entry point should be used just before LDBUF loads any commands.
C If LDWARN>0 then will return an error when it is unable to read from
C the LDBUF command array, that has been loaded after STWARN has been
C called.  Using LDWARN=0 returns GTBUF to its normal state where it
C will automatically prompt the terminal for input.
C---
C LDWARN  I    Warning flag value
C---
      IF ( Ldwarn.GT.0 ) THEN
         istopl = level
      ELSE
         istopl = -1
      ENDIF
      RETURN
C*********
      ENTRY XGETIN(Cext1)
C---
C Return the default extension for indirect files.
C---
      Cext1 = cdef
      RETURN
C*********
      ENTRY XNEWCM
C---
C This routine should be used when the software wishes to force
C the next few lines to be read from the terminal.
C---
      level = -ABS(level)
      RETURN
C*********
      ENTRY XRMVCM
C---
C Return control to the current indirect file (if it exists).
C---
      level = ABS(level)
      RETURN
C*********
      ENTRY XSETIN(Cext2)
C---
C Set the default extension for indirect files.
C---
      cdef = Cext2
      RETURN
C*********
      ENTRY GTBUFNOTSTAND
C---
C  Dummy entry so that PLT can be identical in FTOOLS and XANADU
C  When all XANADU program run with XPI, the version of GTBUF in
C  XPI can be dropped in here with no additional changes
C---
      RETURN
C---
      END
