      SUBROUTINE LOGGER(Ifunc, Rbuf, Nbuf, Cbuf, Lbuf)
      INTEGER   Ifunc, Nbuf, Lbuf
      REAL      Rbuf(*)
      CHARACTER Cbuf*(*)
C---
C Device driver for the LOG file.
C---
C 1990-Sep-16 - [AFT]
C---
      INTEGER   LENACT
C
      CHARACTER cdefnm*64, ctmp*255
      CHARACTER cacc*10
      CHARACTER cstat*8
      INTEGER   ier, itmp, lunloc, i
      SAVE      lunloc, cdefnm
      DATA      lunloc/0/, cdefnm/'log.log'/
C---
   11 FORMAT(A)
C---
      GOTO( 10, 20, 30, 40, 50, 60) Ifunc
  900 WRITE(*,901) Ifunc
  901 FORMAT('Unimplemented function in LOGGER device driver:',I5)
      Nbuf = -1
      RETURN
C
C--- Ifunc = 1, Set default file name-----------------------------------
C
   10 CONTINUE
      IF(LENACT(Cbuf).NE.0) THEN
         cdefnm=Cbuf
      END IF
      RETURN
C
C--- Ifunc = 2, Get default name and unit number -----------------------
C
   20 CONTINUE
      Rbuf(1)=lunloc
      Nbuf=1
      IF(lunloc.EQ.0) THEN
         Cbuf=cdefnm
      ELSE
         INQUIRE(UNIT=lunloc,NAME=Cbuf)
      END IF
      Lbuf=LENACT(Cbuf)
      RETURN
C
C--- Ifunc = 3, Open the file ------------------------------------------
C
   30 CONTINUE
      IF(Lbuf.GT.0) THEN
         ctmp=Cbuf
         CALL XTEND(ctmp,'log')
      ELSE
         ctmp=cdefnm
      END IF
C
C If already open, close current file, and open a new version.
      IF(lunloc.NE.0) CLOSE(UNIT=lunloc)
C User can force the selection of a logical unit number.
      lunloc=Rbuf(1)
      IF(lunloc.NE.0) THEN
         CLOSE(UNIT=lunloc)
      ELSE
         CALL GETLUN(lunloc)
      END IF
C
      IF(ctmp(1:1).EQ.'+') THEN
         itmp=2
         cacc='E'
         cstat='UNKNOWN'
      ELSE
         itmp=1
         cacc=' '
         cstat='NEW'
      END IF
C
      CALL OPENWR(lunloc, ctmp(itmp:), cstat, cacc, 'L', 0, 0, ier)
      IF(ier.EQ.0) THEN
         Nbuf=0
         Rbuf(1)=lunloc
      ELSE
C Clean up after error.
         IF(Rbuf(1).EQ.0.) THEN
            CALL FRELUN(lunloc)
         END IF
         lunloc=0
C Report error to calling program.
         Nbuf=-1
         Rbuf(1)=0.0
      END IF
      RETURN
C
C--- Ifunc = 4, Close the file -----------------------------------------
C
   40 CONTINUE
      IF(lunloc.NE.0) THEN
         IF ( Lbuf.GT.0 ) THEN
            IF ( Cbuf(1:1).EQ.'d' .OR. Cbuf(1:1).EQ.'D' ) THEN
               ctmp='DELETE'
            ELSE
               ctmp='KEEP'
            END IF
            CLOSE(UNIT=lunloc, STATUS=ctmp)
         ELSE
            CLOSE(UNIT=lunloc)
         END IF
         CALL FRELUN(lunloc)
         lunloc=0
      END IF
      RETURN
C
C--- Ifunc = 5, Write a string to the file (if active) -----------------
C
   50 CONTINUE
      IF(lunloc.NE.0) THEN
         itmp=Lbuf
         IF(itmp.EQ.0) itmp=LENACT(Cbuf)
         WRITE(lunloc,11,IOSTAT=ier) Cbuf(:itmp)
      END IF
      RETURN
C
C--- Ifunc = 6, return the file name
C
 60   CONTINUE
      IF(lunloc.NE.0) THEN
         INQUIRE(UNIT=lunloc, NAME=Cbuf)
      END IF
      RETURN
      END

