      INTEGER FUNCTION IPHASE(Dtim, Dtim0, Dnu, Dnudot, Nphase)
      DOUBLE PRECISION Dtim, Dtim0, Dnu, Dnudot
      INTEGER   Nphase
C---
C Computes phase bin.
C---
C Dtim    I    Current time.
C Dtim0   I    Time of Phase 0.
C Dnu     I    Pulse frequency (cycles/sec).
C Dnudot  I    Change in pulse frequency.
C Nphase  I    Number of phase bins.
C---
C T=Dtim-Dtim0
C PHASE=Dnu*T+Dnudot*T*T/2.
C---
      DOUBLE PRECISION dtmp
C---
      IF ( Nphase.GT.1 ) THEN
         dtmp = Dtim-Dtim0
         dtmp = dtmp*Dnu+Dnudot*dtmp*dtmp/2.D0
         dtmp = MOD(dtmp,1.D0)
         IF ( dtmp.LT.0. ) dtmp = 1.+dtmp
         IPHASE = INT(dtmp*Nphase)+1
      ELSE
         IPHASE=1
      END IF
C---
      RETURN
      END
C*********
      REAL FUNCTION FNPHAS(Dtim, Dtim0, Dnu, Dnudot)
      DOUBLE PRECISION Dtim, Dtim0, Dnu, Dnudot
C---
C Dtim
C Dtim0
C Dnu
C Dnudot
C---
      DOUBLE PRECISION dtmp
C---
      dtmp = Dtim-Dtim0
      dtmp = dtmp*Dnu+Dnudot*dtmp*dtmp/2.D0
C      dtmp=MOD(dtmp,1.D0)
C      IF(dtmp.LT.0.) dtmp=1.+dtmp
      FNPHAS = dtmp
      RETURN
      END
