      SUBROUTINE MJDOBS(Lun, Days, Dsec, Ier)
      INTEGER   Lun, Ier
      DOUBLE PRECISION Days, Dsec
C---
C Get Observation start day.  First tries MJD-OBS in current HDU,
C then DATE-OBS, finally looks for MJD-OBS in primary HDU.
C---
C Lun    I     LUN for opened FITS file
C Days      O  MJD
C Ier       O  <>0 if start date was found.
C---
C 1999-Jul-29 - extracted from lextrct - [AFT]
C---
      CHARACTER ctmp*64, cvalue*64
      CHARACTER ckey*16
      INTEGER   iext, ihsav, itmp
C---
      Days = 0.D0
      Ier = 0
      CALL FTGKYD(Lun, 'MJD-OBS',  Days, ctmp, Ier)
      IF ( Ier.NE.0 ) THEN
         Ier = 0
         CALL FTGKYS(Lun, 'DATE-OBS',  cvalue, ctmp, Ier)
         IF ( Ier.NE.0 ) THEN
            Ier=0
            CALL FTGKYS(Lun, 'DATE_OBS',  cvalue, ctmp, Ier)
         END IF
         IF ( Ier.EQ.0 ) THEN
            CALL FDTMJD(cvalue, Days)
            itmp = INDEX(cvalue,'T')
            IF ( itmp.GT.0 ) THEN
               CALL FTMSEC(cvalue(itmp+1:), dsec)
            END IF
         ELSE
C If we failed to read in the current header then try the primary header.
C First, save the current header position.
            Ier = 0
            CALL FTGHDN(Lun, ihsav)
C Go to primary header
            CALL FTMAHD(Lun, 1, iext, Ier)
C and try again
            CALL FTGKYD(Lun, 'MJD-OBS',  Days, ctmp, Ier)
            IF ( Ier.NE.0 ) THEN
               Ier = 0
               CALL FTGKYS(Lun, 'DATE-OBS',  cvalue, ctmp, Ier)
               IF ( Ier.EQ.0 ) THEN
                  CALL FDTMJD(cvalue, Days)
                  itmp = INDEX(cvalue,'T')
                  IF ( itmp.GT.0 ) THEN
                     CALL FTMSEC(cvalue(itmp+1:), dsec)
                  END IF
               END IF
            END IF
C Restore pointer to previous header location
            itmp = 0
            CALL FTMAHD(Lun, ihsav, iext, itmp)
         END IF
      END IF
C---
      RETURN
      END
