      SUBROUTINE MJDREF(Lun, Dmjd0, Ier)
      INTEGER   Lun, Ier
      DOUBLE PRECISION Dmjd0
C---
C Get the reference date as an MJD.
C---
C Lun    I     Lun for opened FITS file
C Dmjd0     O  MJD reference date
C Ier       O  <>0 if start date was found.
C---
C 1999-Jul-29 - extracted from lextrct - [AFT]
C---
      CHARACTER ctmp*64, cvalue*64
      CHARACTER ckey*16
      DOUBLE PRECISION dfrac
      INTEGER   iext, ihsav, itmp
C---
C Check for OGIP standard form of reference day
      Ier = 0
      Dmjd0 = 0.0D0
      dfrac = 0.0D0
      CALL FTGKYD(Lun, 'MJDREF',  Dmjd0, ctmp, Ier)
      IF ( Ier.NE.0 ) THEN
         Ier = 0
         CALL FTGKYD(Lun, 'MJDREFI',  Dmjd0, ctmp, Ier)
         CALL FTGKYD(Lun, 'MJDREFF',  dfrac, ctmp, Ier)
C Check for ROSAT specific version
         IF ( Ier.NE.0 ) THEN
            Ier = 0
            CALL FTGKYD(Lun, 'XS-MJDRD', Dmjd0, ctmp, Ier)
            CALL FTGKYD(Lun, 'XS-MJDRF', dfrac, ctmp, Ier)
         END IF
      END IF
C Cannot find reference date in current header, try primary header.
      IF ( Ier.NE.0 ) THEN
         CALL FTGHDN(Lun, ihsav)
C Go to primary header
         Ier = 0
         CALL FTMAHD(Lun, 1, iext, Ier)
         Ier = 0
         CALL FTGKYD(Lun, 'MJDREF',  Dmjd0, ctmp, Ier)
         dfrac = 0.0D0
         IF ( Ier.NE.0 ) THEN
            Ier = 0
            CALL FTGKYD(Lun, 'MJDREFI',  Dmjd0, ctmp, Ier)
            CALL FTGKYD(Lun, 'MJDREFF',  dfrac, ctmp, Ier)
         END IF
C Restore pointer to previous header location
         itmp = 0
         CALL FTMAHD(Lun, ihsav, iext, itmp)
      END IF
C Add in the fractional day (if one was read).
      dmjd0 = dmjd0 + dfrac
C---
      RETURN
      END
