      SUBROUTINE TMRNEW(Lun, Chis, Nhis, Ier)
      INTEGER   Lun, Nhis, Ier
      CHARACTER Chis(*)*(*)
C---
C Open a new TMR file.
C---
C Lun     I    LUN to be used.
C Chis    I    History array.
C Nhis    I    Number of history records in CHIS array.
C Ier       O  =-1 ^Z pressed, =0 file written, =1 no file made.
C---
C 1992-Sep-14 - From WRTMR [AFT]
C---
      CHARACTER cnam*80
      CHARACTER cdoc*64
      INTEGER   naxes(2)
      INTEGER   i, ibits, iblock, istat
      INTEGER   ldoc, lnam, naxis
      LOGICAL   qsimp, qxtend
C---
  100 CONTINUE
      CALL GTBUF('Please enter TMR file name now:',ier)
      IF ( ier.LT.0 ) GOTO 900
      CALL GTCHAR(cnam,lnam)
      IF ( lnam.LE.0 ) THEN
         ier = 1
         GOTO 900
      END IF
      CALL XTEND(cnam,'tmr')
      CALL CONC(cnam)
      iblock = 1
      istat = 0
      CALL FTINIT(lun,cnam,iblock,istat)
      IF ( istat.NE.0 ) THEN
         WRITE (*,*) 'Open status=',istat
         GOTO 100
      END IF
      qsimp = .TRUE.
      ibits = 8
      naxis = 0
      qxtend = .TRUE.
      CALL FTPHPR(lun,qsimp,ibits,naxis,naxes,0,1,qxtend,istat)
C
      WRITE ( *,* ) 'Please enter comments, blank line to exit.'
  130 CONTINUE
      CALL GTBUF(' ', ier)
      IF( ier.LT.0 ) GOTO 100
      CALL GTREST(cdoc,ldoc)
      IF ( ldoc.GT.0 ) THEN
         CALL FTPCOM(LUN, CDOC, istat)
         GOTO 130
      END IF
C
      IF ( Nhis.GT.0 ) THEN
         DO i=1,Nhis
            CALL FTPHIS(LUN, Chis(i), istat)
         END DO
      END IF
C
C Write a null data record.
      CALL FTPDEF(lun,ibits,naxis,naxes,0,1,istat)
C Now create the next header unit.
      CALL FTCRHD(lun,istat)
      IF ( istat.EQ.0 ) THEN
         WRITE(*,*) 'Created header.'
      ELSE
         WRITE(*,*) 'Creating header, istat=',istat
      END IF
      Ier = 0
C---
  900 CONTINUE
      RETURN
      END
C*********
      SUBROUTINE TMRWR(Lun, Idtype, Y, Mx1, Npts, Ncols, Ctype, Cunit,
     &      Bscal, Dmjd, Dts, Dtb, Ier)
      INTEGER   Lun, Idtype, Mx1, Npts, Ncols, Ier
      REAL      Y(Mx1,*), Bscal(*)
      DOUBLE PRECISION Dmjd, Dts, Dtb
      CHARACTER Ctype(Ncols)*(*), Cunit(Ncols)*(*)
C---
C Writes data into a FITS TMR file.
C---
C Lun     I
C Idtype  I    =1 counts, =2 counts/sec
C Y       I
C Mx1     I
C Npts    I
C Ncols   I    Number of columns to write
C Ctype   I
C Cunit   I
C Bscal   I    Background scale for each column
C Dmjd    I
C Dts,Dtb I    Data Time Start, Data Time per Bin.
C Ier       O  =0 file written, <>0 FITSIO status return
C---
C 1992-Sep-14 - From WRTMR [AFT]
C---
      INTEGER   MXCOL
      PARAMETER (MXCOL=10)
C
      CHARACTER cform(MXCOL)*16
      CHARACTER cext*16, ckey*16
      INTEGER   i, istat, j
C
      DO i=1,Ncols
         cform(i) = 'E'
      END DO
      cext = 'TMR'
      istat = 0
      CALL FTPHBN(lun,npts,Ncols,ctype,cform,cunit,cext,1,istat)
      CALL FTPKYD(lun,'MJD-OBS',Dmjd,10,'MJD of start of obs.',istat)
      CALL FTPKYD(lun,'DTS',Dts,10,'Start time',istat)
      CALL FTPKYD(lun,'TIMEDEL',Dtb,10,'Bin size',istat)
C
      istat = 0
      DO i=1,ncols
C Construct keyword name
         CALL FTKEYN('BACKSC',i,ckey,istat)
         CALL FTPKYE(lun,ckey,Bscal(i),6,'Background scale',istat)
      END DO
C
      CALL FTBDEF(lun,Ncols,cform,0,npts,istat)
      DO i=1,npts
         DO j=1,Ncols
            IF ( Idtype.EQ.1 ) THEN
               CALL FTPCLE(lun,j,i,1,1,Y(i,j),istat)
            ELSE
               CALL FTPCLE(lun,j,i,1,1,SNGL(Y(i,j)*Dtb),istat)
            END IF
         END DO
      END DO
C
      CALL FTCLOS(lun,istat)
      Ier = istat
      RETURN
      END
