      SUBROUTINE WRMAP(Isize, I2map, Mxfb, Nx, Ny, Chead, Nhead, Ier)
      INTEGER   Isize, Mxfb, Nx, Ny, Nhead, Ier
      CHARACTER Chead(*)*80
      INTEGER*2 I2map(*)
C---
C Writes out a map file, either REAL or INTEGER.
C---
C Isize   I    =2 for I*2, =4 for real data.
C I2map   I    Real/Integer map.
C Mxfb    I    First physical dimension of I2map.
C Nx      I    Number of rows in I2map in actual use.
C Ny      I    Number of columns in I2map in actual use.
C Chead   I    Array of 80 byte FITS header lines.
C Nhead   I    Number of valid lines in Chead.
C Ier       O  Error flag.
C---
      CHARACTER cnam*128
      INTEGER   naxes(2)
      INTEGER   i, ibits, iblock, igcnt, ipcnt, istat
      INTEGER   lnam, lun, naxis
      LOGICAL   qsimp, qxtend
C---
      CALL GTPEEK(cnam, lnam)
C
      CALL GETLUN(lun)
 100  CONTINUE
      IF ( lnam.LE.0 ) THEN
         WRITE (*,101) Nx, Ny
 101     FORMAT (' To create',I5,' by',I5,' map, please enter')
         cnam = ' '
         CALL GTBUF('Fits file name:',ier)
         IF ( ier.NE.0 ) GOTO 900
      END IF
      CALL GTCHAR(cnam, lnam)
      IF ( lnam.LE.0 ) GOTO 900
C
      CALL XTEND(cnam,'fit')
      iblock = 1
      istat = 0
      CALL FTINIT(lun, cnam, iblock, istat)
      IF ( istat.NE.0 ) THEN
         WRITE(*,*) 'FITSIO error =',istat
         lnam = 0
         GOTO 100
      END IF
      qsimp  = .TRUE.
      IF ( Isize.EQ.2 ) THEN
         ibits  =  16
      ELSE
         ibits  = -32
      END IF
      naxis  = 2
      naxes(1) = Nx
      naxes(2) = Ny
      ipcnt = 0
      igcnt = 1
      qxtend = .FALSE.
      CALL FTPHPR(lun,qsimp,ibits,naxis,naxes,
     &               ipcnt,igcnt,qxtend,istat)
      CALL FTPDEF(lun,ibits,naxis,naxes,ipcnt,igcnt,istat)
C Standard header keywords
      CALL FTPKYS(lun,'ORIGIN','XANADU',
     &         'X-ray ANalysis And Data Utilization software',istat)
C Now write the extra user supplied header records.
      DO i=1,Nhead
         CALL FTPREC(lun, Chead(i), istat)
      END DO
      IF ( istat.NE.0 ) WRITE(*,*) 'wrmap: FITSIO status=',istat
C---
      ier=0
      IF ( Isize.EQ.2 ) THEN
         CALL FTP2DI(lun,0,Mxfb,Nx,Ny,I2map,ier)
      ELSE
         CALL FTP2DE(lun,0,Mxfb,Nx,Ny,I2map,ier)
      END IF
      CALL FTCLOS(lun, istat)
      Ier = 0
C---
 900  CLOSE (UNIT=lun)
      CALL FRELUN(lun)
      RETURN
      END
